Windows OEM Preinstallation Kit

Microsoft Windows
Windows flag

OEM Preinstallation Kit (OPK) User's Guide

banner1 banner2

The OPK helps you preinstall, customize, and deploy:

Windows XP Home Edition, Service Pack 1
Windows XP Professional, Service Pack 1
Windows XP 64-Bit Edition, Service Pack 1
Windows .NET Standard Server
Windows .NET Enterprise Server
Windows .NET Datacenter Server
Windows .NET Web Server

This documentation contains information on Windows XP 64-Bit Edition and the 64-bit versions of the Windows .NET Server family, which are available only in English, French, German, and Japanese.

Visit the Microsoft System Builder OEM Web site or the Microsoft Royalty OEM Web site.

© 1985-2002 Microsoft Corporation. All rights reserved. Terms of Use.


Printing the Documentation

Using the Print command of the HTML Help viewer, you can print a single topic or all subtopics of a heading.

To print topics from this documentation

  1. Select a topic or heading (book) in the Contents tab.
  2. Click the Print button in the toolbar and follow the messages.

    —OR—

    3. Right-click the selected book, click Print, and follow the messages.


Welcome

banner

Introduction

Original equipment manufacturers (OEMs) who build new computers from individual hardware components can use the tools in this kit to preinstall and configure all operating systems in the Windows XP and Windows .NET Server family:

  • Windows XP Home Edition
  • Windows XP Professional
  • Windows XP 64-Bit Edition
  • Windows .NET Standard Server
  • Windows .NET Enterprise Server
  • Windows .NET Datacenter Server
  • Windows .NET Web Server

The availability of particular Windows operating systems depends on the type of OEM license agreement. Availability also depends on language.

OEM Preinstallation Kit Goals

The goals of this guide are to:

  • Ensure a consistent user experience of the core functionality of the Windows operating system.
  • Enable you to brand and customize any Windows product.
  • Enable you to preinstall applications and device drivers that are not part of the operating system.
  • Reduce illegal software piracy.
  • Provide flexible methodology and tools to help optimize your manufacturing process, whether you build 10 or 10,000 computers per month.

Preinstallation Requirements

It is important that you read this guide to ensure that you understand how to use the tools, and to ensure that you are aware of the preinstallation requirements that apply to your license agreement.

As a manufacturer who distributes Windows with new computers, you are required to preinstall the OEM-specific version of the Windows operating system. Do not preinstall a retail version of Windows XP or the Windows .NET Server family. You must also run Sysprep.exe, one of the OPK tools, to enable Windows Welcome or Mini-Setup, which prompts the end user to read the Microsoft End-User License Agreement and configure the computer.

For a complete summary of requirements, see the topics in the Preinstallation Requirements and Customization Guidelines section. The remainder of the Windows OPK User's Guide explains how to use the OPK tools and customize Windows to fulfill the specific needs of your customers.

The Windows Preinstallation Reference (Ref.chm) documents the syntax of the various answer files that you use when preinstalling Windows. The set of permitted OEM customizations corresponds to only a subset of the answer file entries documented in the Windows Preinstallation Reference.


New Features in the OEM Preinstallation Kit (OPK)

The tools and installation methodology in the Windows XP and Windows .NET Server OPK are based on the Microsoft Windows 2000 OPK. This section highlights new features and compares the Windows XP SP1 and Windows .NET Server OPK with the original release of the Windows XP OPK, the Windows 2000 OPK, and the Windows Millennium Edition OPK.

What's New in the OPK for Windows XP SP1 and the Windows .NET Server Family

The OPK is identical for Windows XP SP1 and the Windows .NET Server family. The tools in this version of the OPK can be used to preinstall the original release of the Windows XP operating system, in addition to Windows XP SP1 and the Windows .NET Server family.

This version of the OPK has the following differences from the original Windows XP OPK:

Changes to the OPK Tools

The user interface of Setup Manager and Sysprep is edited for improved clarity, but the basic functionality of the tools has not changed. For pictures of the screens in Setup Manager, see the Step-by-Step Guide to OEM Preinstallation of Windows XP white paper on the Windows OPK CD.

Setup Manager no longer has context-sensitive help. For a list of settings written out by each screen, see either the Step-by-Step Guide to OEM Preinstallation of Windows XP white paper or Setup Manager Settings.

With the Windows XP SP1 Setup Manager, you can edit and modify configuration sets created with the original Windows XP Setup Manager.

The sysprep -clean command is enhanced; it removes "phantom" device nodes from Device Manager.

In Windows .NET Server family products, Diskpart has an additional command: inactive. On basic master boot record (MBR) disks, this command marks the system partition or boot partition with focus as inactive. The computer starts from the next option specified in the BIOS such as the CD-ROM drive or a Pre-Boot eXecution Environment (PXE)-based boot environment (such as Remote Installation Services (RIS)) when you restart the computer. This command is not available in the version of Diskpart available in Windows XP SP1.

You can use the Powercfg tool to control power settings and configure computers to default to Hibernate or Standby modes. For more information, see Powercfg Command-Line Options.

Windows Preinstallation Environment (WinPE)

You can use the BuildOptionalComponents.vbs script to add support for optional component packages to WinPE. The packages include Windows Script Host (WSH), HTML Applications (HTA), and ActiveX Data Objects (ADO) to allow database connectivity from WinPE to a Microsoft SQL Server. For more information, see Adding Optional Component Packages to WinPE.

WinPE no longer has any dependencies on the file system or the geometry of the underlying media, so it is no longer necessary to patch the boot sector when placing WinPE on a hard disk. For more information, see Creating Bootable WinPE Media.

Removing Access to Windows Components

On Windows XP, you may remove visible entry points to Internet Explorer, Outlook Express, Windows Media Player, or Windows Messenger. These visible entry points can be removed either as part of an unattended Setup or post-Setup through the use of the Sysprep or Factory tools.

You may install third-party applications that launch in place of Internet Explorer, Outlook Express, Windows Media Player, or Windows Messenger, as enabled by Windows registry settings and other documented mechanisms.

For more information, see Removing Access to Windows Components.

Changes to Desktop Cleanup

At periodic intervals, the Desktop Cleanup wizard enables the end user to place unused Windows desktop icons and folders into the "Unused Desktop Shortcuts" folder on the desktop. Desktop cleanup no longer takes place during the first boot of the operating system. Instead, the initial desktop cleanup now occurs 14 days after the end-user first-run experience.

Changes to the OPK Documentation

The Windows OPK User's Guide is completely revised for this release. Significant changes are summarized here.

The content in Preinstallation Requirements and Customization Guidelines is clarified when necessary, and updated to reflect product changes in Windows XP SP1 and the Windows .NET Server family.

In response to feedback from royalty OEMs and system builders, these sections in the Windows OPK User's Guide are revised:

  • Planning and Preparation
  • Preinstalling the Operating System
  • Configuring Windows Welcome

These individual topics are new:

  • Comparison of Preinstallation Methods
  • Using a Network to Preinstall Windows
  • Configuring the Network for Preinstallation
  • Preinstalling Multi-Language User Interface (MUI)
  • Sysprep and Windows Product Activation FAQ
  • Winbom.ini and Factory.exe
  • Troubleshooting FAQ

These white papers are new:

  • Step-by-Step Guide to OEM Preinstallation of Windows XP
  • Building Custom Windows Welcome Pages in Microsoft Windows XP
  • Hard Disk-based Recovery Solutions for System Builders
  • Benchmarking On Windows XP
  • Fast System Startup for PCs Running Windows XP
  • Kernel Enhancements for Windows XP
  • Windows XP Native Processor Performance Control
  • Using the Mass Storage Device Installation Tool (MSDInst.exe)

All white papers are located in the \Docs\Whitepapers folder on the Windows OPK CD.

For more detailed information about what is new in Unattend.txt, Sysprep.inf, Oobeinfo.ini, and the Windows Welcome APIs, see Changes in Answer Files and Syntax Changes in Windows Welcome Files.

What Was New for the Original Release of the Window XP OPK

The following features first appeared in the original release of the Windows XP OPK:

Windows Preinstallation Environment (WinPE)

The Windows OPK CD is a bootable copy of the 32-bit version of Windows Preinstallation Environment (WinPE). This basic operating system is based on the Windows XP kernel and contains the minimal functionality that you need to run and automate Windows Setup.

WinPE lets you create and format disk partitions, and gives you access to both NTFS file system partitions (with some constraints) and your internal network. The environment supports all mass-storage devices that use Windows 2000 or Windows XP drivers, and you can incorporate additional drivers as new devices become available.

To prevent its use as a pirated operating system, the Windows Preinstallation Environment (WinPE) restarts automatically after 24 hours of continuous use.

Incorporating WinPE into your factory preinstallation process lets you port your existing MS-DOS-based tools to a subset of the 32-bit Windows APIs, so you can maintain these applications more easily in a standard development environment, such as Microsoft Visual Studio. These hardware diagnostics and other preinstallation utilities can then use the same signed Windows XP drivers in the computers that you manufacture, and you will no longer need to request 16-bit drivers from independent hardware vendors (IHVs).

You can create a 64-bit version of WinPE from the Windows XP 64-bit edition CD, so you can use the same manufacturing processes throughout your factory for preinstalling the Windows XP and the Windows .NET Server family.

The OPK includes a collection of scripts and utilities that enable you to build a version of WinPE customized and tuned for your factory environment. You can also reduce the size of WinPE by removing unnecessary files. While WinPE is too large to fit on a floppy disk, you can place your customized version of WinPE on any bootable media, including a CD-ROM or a Remote Installation Server (RIS). Royalty OEMs can use WinPE as part of their recovery media solution.

Windows Welcome

The visual appearance of Windows Welcome in Windows XP has changed. The design no longer contains a left status pane. The dimensions of the OEM logo (oemlogo.gif) are now 255 x 40 pixels. The logo can be in 16-bit color and it can contain transparency, so you have greater design flexibility.

New Sysprep Functionality

We have expanded the functionality of Sysprep to extend the lifespan of preinstallation images. When you run Sysprep in Factory mode, you can more easily install new or updated Plug and Play and mass storage device drivers that were not included in the original image. See [PnPDriverUpdate] in the Winbom.ini reference for more information.

Sysprep also supports additional networking options, such as building a master installation, forced system shutdown, and improved system cleanup. Using Setup Manager, you can encrypt administrator passwords to be stored in answer files such as Unattend.txt and Sysprep.inf. You can also use Sysprep to reduce the number of images you maintain for different computers with multiprocessors.

See Winbom.ini and Factory.exe for detailed information on how Factory.exe processes Winbom.ini entries.

Using Sysprep in Factory Mode to Generate Sysprep.inf or Oobeinfo.ini

You can use entries in Winbom.ini to change the contents of Sysprep.inf or Oobeinfo.ini. For an example, see [UpdateSystem] in the Winbom.ini reference.

Preinstalling 64-bit Versions of Windows

At this point, no third-party imaging tools exist for the 64-bit platform. To preinstall Windows XP 64-Bit Edition or the 64-bit versions of the Windows .NET Server family, you must use the Windows Preinstallation Environment (WinPE) or the CD-boot method. You can place the Winnt.sif file on a floppy disk, or you can create and use a CD containing both the Windows installation files and Winnt.sif. For more information, see Preinstalling 64-bit Editions of Windows.

Branding Changes

Because of code changes within the Windows kernel, it is no longer possible to incorporate an OEM logo into the Windows splash screen.

Items Removed from the Windows OEM Preinstallation Kit (OPK)

The following items are no longer included in the Windows OPK:

  • Sysdiff.exe
  • Ehib.exe
  • Pnpids.exe

Documentation Changes

The OPK documentation is now in HTML Help format. Here you can find the OEM Preinstallation Kit (OPK) User's Guide integrated with a comprehensive Reference, containing the information formerly located in Unattend.doc. Benefits of this change include:

  • Full-text search and a keyword index that make it easier to find information.
  • Links that make it easier to see the relationship between various pieces of information.
  • Later production deadlines allow the information in the documentation to be more accurate.
  • Royalty OEMs and system builders both receive the same set of information.

One consequence of this change is that the OPK no longer includes a printed copy of the Windows OPK User's Guide. If you still want to read information in print format, right-click a page or book in the Table of Contents and select Print to print that section of information.

What Was New, Specifically for Users of the Windows Millennium Edition OPK

The Windows XP and Windows .NET Server OPK is different from the Windows Millennium Edition OPK in the following ways:

Sysprep

Sysprep is analogous to Preptool. As in a Windows Millennium Edition preinstallation, you can restart a computer an indefinite number of times in audit mode. Audit mode is explicitly identified in the Windows user interface. Before you deliver the computer to the customer, you must use Sysprep a final time to prepare the computer for delivery to the customer.

Windows Welcome Improvements

Windows Welcome, otherwise known as the Microsoft out-of-box experience (OOBE), was a core part of the customer experience for Windows Millennium Edition. In this release of Windows, Windows Welcome is part of both Windows XP Home Edition and Windows XP Professional.

If you customized Windows Welcome for Windows Millennium Edition, you should be able to port your code to Windows XP with minimal work. For more information about Windows Welcome customizations, see Configuring Windows Welcome. To investigate what changes you may need to make in the code for any custom pages that you created previously for Windows Welcome, see What's New in Windows Welcome, Oobeinfo.ini, and Windows Welcome APIs.

OEM Versions of Run and RunOnce Commands

Functionality equivalent to the Windows Millennium Edition tool Oemrun is now controlled by the [OEMRun] and [OEMRunOnce] sections in Winbom.ini, used by sysprep -factory. Commands called in the [OEMRun] section are processed asynchronously. Commands called in the [OEMRunOnce] section are processed synchronously, so each command must finish before the next command is run.

We recommend using [OEMRunOnce] to stage or attach applications, speeding up your factory preinstallation process and making it easier to implement build-to-order configurations. [OEMRunOnce] is also useful for running your in-house quality-assurance tools on the destination computer.

What Was New, Specifically for Users of the Windows 2000 OPK

The Windows XP and Windows .NET Server OPK is different from the Windows 2000 OPK in the following ways:

Sysprep Command Line Options

Sysprep.exe supports the following additional command-line options:

  • -activated
  • -audit
  • -bmsd
  • -clean
  • -factory
  • -mini
  • -reseal

In Windows 2000, the last step in the preinstallation process was to run the command sysprep. For Windows XP and the Windows .NET Server family, if you run the command sysprep -factory, you must run the command sysprep -reseal as the last step in your preinstallation process.

You can use this version of Sysprep only on installations of Windows XP or the Windows .NET Server family. You cannot run this version of Sysprep on a Windows 2000 installation.


Accessibility Features and Options

The OEM Preinstallation Kit (OPK) User's Guide includes features that make the software accessible to a wider range of users, including those who have limited dexterity, low vision, or other disabilities.

Some of the content in this topic may not be applicable to some languages.

To expand a section, select it, and then press ENTER.

To print this topic, press F6, and then press CTRL+P.

Keyboard Shortcuts in Help

CTRL + TAB
To move among the Contents, Index, Search, and Favorites tabs

ENTER or RIGHT ARROW
To expand a group of topics

ENTER or LEFT ARROW
To collapse a group of topics

UP ARROW or DOWN ARROW
To select the previous or next group of topics

HOME
To select the first group of topics

END
To select the last group of topics

F6
To switch between the Table of Contents and the Help topic panes

TAB or SHIFT+TAB
To move forward or backward from one hyperlink to the next within a topic

ENTER
To perform the action for the selected hyperlink

ALT+O
To display the Options menu

ALT+O, and then press T
To hide or show the pane with the Contents, Index, Search, and Favorites tabs

ALT+O, and then press B
To display the previously viewed topic

ALT+O, and then press F
To display the next topic in a previously displayed sequence of topics

ALT+O, and then press H
To return to the specified home page

ALT+O, and then press S
To stop the Help window from opening a Help topic (useful if you want to stop a Web page from downloading)

ALT+O, and then press R
To refresh the topic (useful if you have linked to a Web page)

ALT+O, and then press I
To open the Internet Options dialog box for Microsoft Internet Explorer, where you can change accessibility settings

ALT+O, and then press P
To print all topics in a book or a selected topic only

ALT+O, and then press O
To turn search highlighting on or off

ALT+F4
To close the Help window

CTRL+TAB
To switch to the next tab

ALT+C
To switch to the Contents tab

ALT+N
To switch to the Index tab

ALT+S
To switch to the Search tab

ALT+I
To switch to the Favorites tab

ENTER
To open a selected book or Help topic

DOWN ARROW
To select the next book or Help topic

UP ARROW
To select the previous book or Help topic

SHIFT+F10
To display a shortcut menu

UP ARROW or DOWN ARROW
To scroll toward the beginning or end of a Help topic

PAGE UP or PAGE DOWN
To scroll toward the beginning or end of a Help topic in large increments

HOME or END
To go to the beginning or end of a Help topic

CTRL+P
To print the current Help topic

CTRL+A
To select the entire Help topic

CTRL+C
To copy the selected items to the Clipboard

Keyboard Shortcuts in Setup Manager

ALT
To make access keys visible

ESC
To cancel Setup Manager

ALT+F4
To close the Setup Manager window

UP ARROW or DOWN ARROW
To move among option buttons in Setup Manager; or, when a menu or submenu is open, to select the next or previous command

TAB or SHIFT+TAB
To move forward or backward to the next option or option group

SPACEBAR
To perform the action for the selected button or command; to check or clear the selected check box

CTRL+TAB or CTRL+SHIFT+TAB
To go forward or backward through the Setup Manager pages

ENTER
To perform the action for the selected button or command

ALT+SPACEBAR
To display the window shortcut menu (Control menu)

CTRL+ESC
To display the Start menu

Arrow keys
To move between options in an open drop-down list, or between options in a group of options

ALT+ the letter underlined in an option
To select an option, or to select or clear a check box

ALT+DOWN ARROW
To open a selected drop-down list

ESC
To close a selected drop-down list, or to cancel a command and close a dialog box

HOME
To move to the beginning of an entry in a text box

END
To move to the end of an entry in a text box

LEFT ARROW or RIGHT ARROW
To move one character to the left or right

CTRL+LEFT ARROW
To move one word to the left

CTRL+RIGHT ARROW
To move one word to the right

SHIFT+LEFT ARROW
To select or cancel one character to the left

SHIFT+RIGHT ARROW
To select or cancel one character to the right

CTRL+SHIFT+LEFT ARROW
To select or cancel one word to the left

CTRL+SHIFT+RIGHT ARROW
To select or cancel one word to the right

SHIFT+HOME
To select from the insertion point to the beginning of the entry

SHIFT+END
To select from the insertion point to the end of the entry

PRINT SCREEN
To copy a picture of the screen to the Clipboard

ALT+PRINT SCREEN
To copy a picture of the selected window to the Clipboard

CTRL+Z or ALT+BACKSPACE
To undo

CTRL+SHIFT+Y
To copy item

CTRL+SHIFT+V
To paste item

CTRL+X or SHIFT+DELETE
To cut

CTRL+C or CTRL+INSERT
To copy

CTRL+V or SHIFT+INSERT
To paste

Size and Format Options

You can use your own stylesheet to format HTML pages in a customized way. This change will apply to Internet Explorer and to the Windows OPK User's Guide or any other HTML document.

To use your own style sheet

  1. Create a stylesheet (.css) file that specifies the styles, fonts, and formats you want to use.
  2. In the Windows OPK User's Guide, click Options, and then click Internet Options.
  3. On the General tab, click Accessibility.
  4. Select the Format documents using my style sheet check box.
  5. Click Browse and browse to the location of your style sheet. Double-click the style sheet name to enter it into the box, and then click OK.


Preinstallation Requirements and Customization Guidelines

Microsoft Licensing, Inc., a subsidiary of Microsoft Corporation, licenses its original equipment manufacturer (OEM) customers with the right to acquire and preinstall software according to the terms of its license agreements.

Microsoft Licensing uses two different types of license agreements: a signed contract with royalty OEMs and a Microsoft OEM System Builder Agreement with each multiple-license pack distributed to system builders. Unless explicitly stated otherwise, the general term "OEM" in this Windows OPK User's Guide includes both royalty OEMs and system builders.

As a manufacturer of new computer systems preinstalled with Microsoft Windows, you must implement the requirements explicitly described for each type of license agreement in OEM Licensing Requirements.

Most requirements are the same for both royalty OEMs and system builders. See Differences Between System Builders and Royalty OEMs for a summary of the differences between the two types of license agreements.

Important

  • Microsoft Licensing, Inc. reserves the right to change the preinstallation requirements with respect to future releases at any time. For information about changes to these requirements, see your current license agreement or speak with your account manager.

Customization Guidelines

You may customize Windows only as described by these specifications:

  • Customization Guidelines
  • Branding Opportunities
  • First-Run Experience
  • Hardware Device Drivers
  • Help and Support Center
  • Internet Access and ISP Offers
  • Internet Explorer and Outlook Express
  • Preinstalled Applications
  • Activation, Registration, and Product Key
  • Windows Media Player
  • Windows Messenger
  • Windows Software Components
  • Windows Start Menu and Desktop
  • Windows Desktop Default Settings
  • Control Panel Extensions

Important

  • Do not modify in any way or delete any aspect of the Microsoft Windows software. This requirement includes, without limitation, any features, shortcuts, icons, wizards, folders, subfolders, files, device drivers, or components of the Windows software, except as specifically described in the topics listed on this page, or as permitted in your separate license agreement.
  • Do not add content to any folders installed by the Windows software, except as specifically described in the topics listed on this page.
  • All rights to modify or customize Windows not expressly set forth in your OEM License Agreement, this Windows OPK User's Guide, or any other written document signed by Microsoft Licensing, Inc. are reserved.


OEM Licensing Requirements

Microsoft Licensing uses two different types of license agreements: one for system builders and one for royalty OEMs. For a summary of the differences between the two types of license agreements, see Differences Between System Builders and Royalty OEMs.

Important

  • Unless explicitly stated otherwise, the general term "OEM" in this Windows OPK User's Guide includes both system builders and royalty OEMs.

The following requirements apply equally to royalty OEMs and system builders.

OPK Intellectual Property

Unless otherwise stated in this section, do not redistribute any tools or documentation files included in the OPK to any third party without express written permission from Microsoft.

You may distribute the white paper Building Custom Windows Welcome Pages in Microsoft Windows XP and associated sample files to any business partners who need information about building an ISP sign-up offer. This white paper and sample files are in Isp.zip, located in the \Samples\Oobe subdirectory on the Windows OPK CD

You may distribute the white paper Web Publishing and Online Print Ordering Wizards to any business partners who need information about building an extension to one of these wizards. This white paper is found in the \Docs\Whitepapers subdirectory on the Windows OPK CD.

Any business partners building applications or content to plug into Help and Support Center can obtain the PC Health SDK (https://oem.microsoft.com/directoem/510659.asp) from the Microsoft Royalty OEM Web site. For access to this Web site, contact your account manager.

Independent hardware vendors (IHVs) can find relevant information in the Microsoft Windows Device Driver Kit (DDK) and at these Web sites:

  • Microsoft Windows Hardware Quality Labs (http://www.microsoft.com/hwtest/)
  • Microsoft Windows Logo Program (http://www.microsoft.com//winlogo/)
  • Microsoft Windows Platform Development (http://www.microsoft.com/hwdev/)

The Preinstallation Process

Preinstall only genuine Microsoft products. If you are a system builder, acquire Microsoft software from an authorized distributor. If you are a royalty OEM, obtain "golden master" copies of the software and print documentation files, and use a Microsoft authorized replicator to manufacture your Windows recovery media and print book.

The OPK is designed to help you preinstall Windows on new computers that do not contain a previous operating system. Do not use these tools when upgrading computers to a newer version of the operating system.

Do not use the tools included in the OPK to preinstall a non-Microsoft operating system, unless explicitly authorized in writing to do so by Microsoft Licensing, Inc. You may use Windows Preinstallation Environment (WinPE) as part of your manufacturing process when preinstalling other licensed Microsoft operating systems, such as Windows 2000.

At the end of your preinstallation process, you must use the Sysprep tool to prepare the computer for the customer. Sysprep:

  • Regenerates a unique local computer security ID (SID).
  • Resets the calendar for Windows Product Activation (WPA).
  • Resets Windows Welcome or Mini-Setup to the beginning, so that the end user can read the End-User License Agreement (EULA).

For more information, see Using Sysprep.

Customer Support Requirements

Under the terms of your OEM license agreement, you are responsible for providing post-sale technical support to your customers. To incorporate the minimally required support information into Windows, you must change the required entries in the Oeminfo.ini file and place the file in the %WINDIR%\System32 folder. Entries in this file display your company name and contact information in System properties and your Internet URL from the Hardware Support icon.

Important

  • Do not list Microsoft or a Microsoft telephone number for support information, either electronically on the preinstalled computer or in printed materials distributed with the computer, unless explicitly authorized in writing to do so by Microsoft Licensing, Inc.

You must localize the required [Support Information] section in Oeminfo.ini for each language in which you ship your product. Microsoft includes only a U.S. English sample in this OPK.

For more information, see Adding Your Company Information and Logo to System Properties.

Requirements for Step by Step Interactive

You must install Microsoft Step by Step Interactive (SBSI) training if it is available for the version of Windows that you are preinstalling. SBSI is not available for Windows XP 64-Bit Edition or the Windows .NET Server family.

Supported languages:

Windows XP Home Edition | Windows XP Professional
English German French Spanish Japanese Dutch Swedish Italian Portuguese (Brazil) Korean Traditional Chinese Simplified Chinese | English German French Spanish Japanese Italian

If Step by Step Interactive is not available in a particular language, such as Danish, then Help and Support Center does not include any references to SBSI in that language version of Windows XP.

For more information, see Installing Step by Step Interactive in Windows XP.

Requirements for Customizing Windows

Do not modify or delete any aspect of the Microsoft Windows software. This requirement includes, without limitation, any features, shortcuts, icons, wizards, folders, subfolders, files, device drivers, or components of the Windows software, except as specifically described in the Windows OPK User's Guide.

You may customize the operating system only as explicitly described in the Windows OPK User's Guide and summarized in the Customization Guidelines section of this guide, or as permitted in your separate license agreement.

The following requirements apply immediately upon the start of any Windows software:

  • Do not modify or obscure the sequence or appearance of any screens displayed by the Microsoft Windows software as delivered by Microsoft.
  • Do not configure any application, content, or services on the destination computer to be automatically initialized, enabled, or run, except for hardware diagnostics or anti-virus software.
  • Do not populate the Startup folder, System.dat, or User.dat files in any manner or make other modifications that cause any application or content to run or load automatically when Windows starts, other than antivirus software or hardware diagnostics.
  • Only antivirus software or hardware diagnostics may display any user interface. That user interface must be necessary to configure the antivirus software or preinstalled hardware devices, such as network adapters, sound cards, or printers.

Starting other applications before the end user reaches the Windows desktop has a negative effect on the end user's first-run experience of their new computer.

On 64-bit hardware, place only components required for system boot, installation, or recovery in the EFI system partition.

Required Hardware Components

If you ship a legacy or Plug and Play version of any CD-ROM drive, network adapter, or sound card, you must turn on detection for at least one device within the class being shipped. Turning on detection ensures that the software components associated with that device are installed.

For any of the following hardware provided on a preinstalled computer, you must install the following related software components.

Hardware | Component
CD-ROM drive | CD Player
Sound card | Audio compression, sample sounds, Sound Recorder, sound schemes, and Volume Control for Windows XP Home Edition and Windows XP Professional. Audio compression and Volume Control for Windows .NET Standard Server, Windows .NET Enterprise Server, and Windows .NET Datacenter Server.

Microsoft Brand Identity

Do not remove, replace, or modify the Windows Startup Screen Logo.

Do not remove, replace, or modify any other product logos or trademarks included in the Windows product.

Anti-Piracy Support

You are required to attach a Certificate of Authenticity (COA) sticker permanently to the front, back, or side of each computer in an easily accessible location. If the system is a laptop, you may alternatively affix the COA sticker to the bottom of the chassis.

For Windows XP Home Edition or Windows XP Professional, you must ensure that these screens appear during Windows Welcome:

  • End-User License Agreement (EULA)
  • Product Key

For the Windows .NET Server family, you must ensure that these screens appear during Mini-Setup:

  • End-User License Agreement (EULA)
  • User name/company information (under "Personalize Your Software")
  • Product Key

Do not modify or append any text to the online End-User License Agreement (EULA) without express written permission from Microsoft Licensing, Inc.

For current information on Microsoft anti-piracy policies, see the Protecting Against Software Piracy Web site at http://www.microsoft.com/piracy/.

For specific information on how to tell if a Windows product is genuine, see http://www.microsoft.com/piracy/howtotell/.

Required End-User Deliverables (Royalty OEMs)

Royalty OEMs must obtain all approved end-user deliverables, as provided by Microsoft Licensing, Inc., from Microsoft authorized replicators. No OEM has the right to place Microsoft intellectual property on any form of media without the express written consent of Microsoft Licensing, Inc.

You must include a print manual, if available from an authorized replicator, unless otherwise specified in your license agreement.

You must use a Microsoft authorized replicator to duplicate any Microsoft software or print publications.

Required End-User Deliverables (System Builders)

System builders must acquire Windows software, user manuals, and COA stickers from a Microsoft authorized distributor. No OEM has the right to place Microsoft intellectual property on any form of media without the express written consent of Microsoft Licensing, Inc.

Distribute a printed Microsoft manual and a Windows product CD with each preinstalled copy of Windows.

Customizing a Preinstalled Version of Windows

After fulfilling these requirements, you may customize your preinstallation as listed in Customization Guidelines.


Customization Guidelines

After satisfying the requirements specified in OEM Licensing Requirements, you may customize your preinstalled version of Windows as described by these specifications.

  • Branding Opportunities
  • First-Run Experience
  • Hardware Device Drivers
  • Help and Support Center
  • Internet Access and ISP Offers
  • Internet Explorer and Outlook Express
  • Preinstalled Applications
  • Activation, Registration, and Product Key
  • Windows Media Player
  • Windows Messenger
  • Windows Software Components
  • Windows Start Menu and Desktop
  • Windows Desktop Default Settings
  • Control Panel Extensions

Unless explicitly stated otherwise, the customization guidelines listed here are available to both system builders and royalty OEMs. For more information, see Differences Between System Builders and Royalty OEMs.


Customization Guidelines: Branding Opportunities

You are required to include your company name and technical support information in System Properties. In addition, you may also promote your company's brand in any of the following locations, in accordance with your license agreement:

  • You may add your OEM logo to System Properties. For more information, see Adding Your Company Information and Logo to System Properties.
  • You may add your OEM logo to the Start menu, where that image is a link to HTML pages or an application installed on the hard disk of the computer. For more information, see Customizing the Start Menu and the OEM Link.
  • In Windows Welcome, you may add your logo to all Windows Welcome screens. You may also add your company name to the Start and Finish pages of Windows Welcome. For more information, see Branding Windows Welcome.
  • You may replace the default Windows desktop wallpaper with wallpaper that contains your OEM logo. The wallpaper color or design must not, in any way, obscure the Microsoft Windows desktop icons, Start button, or Start menu. For more information, see Customizing the Desktop Background.

Any trade names, trademarks, logos, or brands displayed in connection with any of these components are limited to those owned by the OEM under which the computer is manufactured and distributed.


Customization Guidelines: First-Run Experience

The first-run experience is known as Windows Welcome in Windows XP Home Edition or Windows XP Professional, and Mini-Setup in the Windows .NET Server family and Windows XP 64-Bit Edition.

Note

  • You can configure Windows XP Professional to use Mini-Setup instead of the default Windows Welcome by using the sysprep -mini command, as described in Sysprep Command-Line Options. You cannot change the first-run experience for Windows XP Home Edition; this product always presents Windows Welcome as its first-run experience.

See Requirements for Customizing Windows for additional information about the requirements that apply during basic input/output system (BIOS) processing or immediately thereafter, until the computer displays the Windows desktop and the Start menu.

Windows Welcome

With Windows XP Home Edition and Windows XP Professional, the end user completes the Windows installation by using Windows Welcome. You may add your logo to the upper section of all Windows Welcome screens. You may also add your company name to the Start and Finish pages of Windows Welcome.

The following standard pages prompt the end user for acceptance or input. Some pages are optional; you can control whether optional pages appear by using Setup Manager to modify Oobeinfo.ini. In addition, you can prepopulate answers on behalf of the end user by modifying the Oobeinfo.ini file.

Page | Required or Optional |  | Look-and-Feel Customization Options
 | Home Edition | Professional
USB Keyboard and Mouse Detection | Optional, off by default | Optional, off by default | May modify or replace existing error pages (Nousbkbd.htm, Nousbms.htm, Nousbkm.htm).
Welcome | Required | Required | May add company name, using Setup Manager. May add up to four lines of text.
Mouse Tutorial | Optional, off by default | Optional, off by default | May use, modify, or replace sample tutorial. Your tutorial must meet the specified requirements.
Input Method Editor (IME) Tutorial (Asian languages only) | Optional, off by default | Optional, off by default | May build custom tutorial from scratch. Your tutorial must meet the specified requirements.
Hardware Tutorial | Optional, off by default | Optional, off by default | May build custom tutorial from scratch. Your tutorial must meet the specified requirements.
Regional and Keyboard Settings Layout | Optional, off by default | Optional, off by default | None
Time Zone | Optional, off by default | Optional, off by default | None
End-User License Agreement (EULA) | Required | Required | May include an OEM-specific EULA, in addition to the Microsoft EULA.
Product Key | Required, unless entered by OEM on behalf of the end user | Required, unless entered by OEM on behalf of the end user | None
Computer Name | Required | Required | None
Administrator Password | Not present | Optional, on by default | None
Join a Domain | Not present | Optional, on by default | None
Network Configuration | Required | Required | None
Product Registration with Microsoft | Required | Required | May add telephone number field to first page. May add up to two pages for extended OEM registration.
Registration Data Posted to OEM Server | Optional, off by default | Optional, off by default | This option requires that you configure your own server and register that server with Microsoft Global Network. May modify text on registration page (reg1.htm) to encourage people to register with you. Must add a link to your OEM privacy policy.
ISP Sign-up | Optional, on by default | Optional, on by default | None
OEM-specific ISP Offers | Optional, off by default | Optional, off by default | May build HTML pages for your sign-up offers and incorporate those pages into Windows Welcome. Your offers must meet the specified requirements.
User Accounts | Optional, on by default | Optional, on by default, does not appear if the computer is joined to a domain | None
Finish | Required | Required | May add company name, using Setup Manager. May add up to four lines of text.

We recommend that you either preconfigure the regional and keyboard settings or display that page to the end user. Do not ship computers that:

  • Are not preconfigured.

    —OR—

  • Do not have the regional and keyboard settings screen enabled.

You may use a wave editor to lengthen the duration of Title.wma.

For specific requirements and more information on modifying the content of the pages displayed to end users in Windows Welcome, see Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.

All Custom Pages

Microsoft Agent is present on all default Windows Welcome screens. When adding additional HTML pages as described above, OEMs are encouraged to include the Microsoft Agent.

The Microsoft Agent character integrates Windows Welcome with Help and Support Center and is designed for cross-cultural appeal. The Qmark character is exclusively for use in Windows Welcome: it is not available for use in other Windows programs that use Microsoft Agent, and you may not use other Windows-installed Microsoft Agent characters in Windows Welcome. If you want to replace the Microsoft Agent character with your own character, you must receive approval from Microsoft and the character must fulfill specific requirements.

The character must:

  • Use the animations that already exist in Windows Welcome.
  • Closely match the look and feel of the new visual style of the Windows shell.
  • Add to the user experience, not subtract. OEMs may not delete existing Agent scripts, unless the scripts are obviously irrelevant.
  • Follow the existing menu model.
  • Identify itself as a custom character. Any trade names, trademarks, logos, or brands used in connection with the Agent shall be limited to those under which the PC model is manufactured and marketed. For example, "I'm <charactername> from <OEM name>."

You may add text-to-speech functionality to your custom Agent character.

Custom Tutorials

You may create a custom mouse, IME, and hardware tutorials, provided that:

  • They are written in HTML.
  • They do not start any programs or download code for execution.
  • The last page in each tutorial contains a call that returns control back to Windows Welcome.
  • You indicate your choice to use your own tutorial(s) by selecting the relevant option in Setup Manager. Any trade names, trademarks, logos, or brands displayed in connection with such tutorials are limited to those owned by the OEM and under which the computer is manufactured and distributed.

The IME tutorial is available only for the Japanese, Traditional Chinese, Simplified Chinese, and Korean versions of Windows.

For more information, see Adding Custom Tutorials and Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.

Internet Access

You may integrate an OEM ISP sign-up offer into Windows Welcome. For specific information on requirements, see Customization Guidelines: Internet Access and ISP Offers. For more information, see Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.

OEM EULA

You may include an OEM-specific End-User License Agreement (EULA), in addition to the Microsoft EULA.

  • The Windows XP EULA appears first.
  • The OEM EULA clearly states that it applies only to the additional OEM or third-party software or hardware provided by the OEM, and that it does not apply to the Windows software.
  • The end user must be able to accept or reject each EULA separately.
  • Nothing in the OEM EULA supersedes or conflicts with the Windows XP EULA.
  • The OEM EULA must be only text. The EULA cannot automatically start any software or provide links to any other content.
  • You may modify the sentence: "You must also accept this agreement to continue to use this computer." by inserting your company name before the word "computer."
  • The OEM agrees to indemnify and defend Microsoft Corporation and Microsoft Licensing, Inc. from and against any and all actions, causes of action, damages, or costs and expenses, including reasonable attorneys' fees, for any claims that arise from the inclusion of the OEM EULA.

Mini-Setup

Mini-Setup is the first-run experience for Windows XP 64-Bit Edition and Windows .NET Server family. You can configure Windows XP Professional to use Mini-Setup instead of the default Windows Welcome.

Mini-Setup Experience

The end user completes the Windows installation by using Mini-Setup. The following standard pages prompt the end user for acceptance or input.

Page | Required or Optional
Welcome to Windows Setup Wizard | Required
EULA | Required
Product Key | Required
Regional and Language Options | Optional
Personalize Your Software | Required
Computer Name and Administrator Password | Optional
Date and Time Settings | Optional
Networking Settings | Optional
Workgroup or Computer Domain | Optional
Completing the Windows Setup Wizard | Required

Optional information appears unless you prepopulate answers for the end user in the Sysprep.inf file that you use when running Sysprep to prepare the computer for delivery to the customer. For more information, see Using Sysprep.

Using Mini-Setup on Windows XP Professional

If the computer hardware supports a minimum 800 x 600-pixel screen resolution and the default screen resolution is set to a smaller number (for example, 640 x 480 pixels), then Windows Welcome reconfigures the computer to use an 800 x 600-pixel screen resolution.

If the computer hardware does not support a minimum 800 x 600-pixel screen resolution, Windows XP Home Edition and Windows XP Professional uses Mini-Setup by default rather than Windows Welcome. You can configure Windows XP to use Windows Welcome with scroll bars if the hardware does not support the minimum required screen resolution.

It is possible to configure Windows XP Professional to use Mini-Setup rather than the default Windows Welcome by using the sysprep -mini command. Microsoft recommends that you do not configure Windows XP Professional to use Mini-Setup on computers that you distribute to customers. You cannot use the OPK tools to configure Windows XP Home Edition to use Mini-Setup.

For more information, see The End-User First-Run Experience.


Customization Guidelines: Hardware Device Drivers

Do not modify the Microsoft-supplied .inf files in the \%WINDIR%\Inf directory on the destination computer, with the following exceptions:

  • You can add a separate set of .inf files for detection during setup.
  • You can modify .inf files if you need to change a text string or add new device information.

    However, you must not comment out or remove sections of the .inf files in the \%WINDIR%\Inf directory, unless you are using the Infinst.exe tool. Otherwise, the end user may encounter problems when adding new devices to the computer.

    Caution

    • If you modify .inf files, you risk creating problems with future product releases. Plug and Play architecture has no version checking, and existing .inf files are replaced automatically.

For more information about including new or updated Plug and Play device drivers with Windows Setup, see Preinstalling Hardware Devices.

For information about driver development and specifications, see the Microsoft Windows Device Driver Kit (DDK), which you can order from the Microsoft DDK Web site (http://www.microsoft.com/ddk/). You can also read the DDK documentation in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, and then select Driver Development Kit.

Signed Device Drivers

For performance and stability, Microsoft strongly recommends that you use only signed drivers for new or updated drivers. Signed drivers have been tested to ensure that:

  • They are compatible with Windows XP.
  • The drivers and all supporting files are logo-compliant and the .inf files are properly written.

A fully assembled computer must use signed drivers to display the Designed for Microsoft Windows logo, subject to a valid license for this logo.

For the most current list of supported hardware, see the Hardware Compatibility List (HCL) (http://www.microsoft.com/hcl/).

For further information about Windows logo requirements and driver signing, see the following Web sites:

  • Designed for Microsoft Windows Logo Program (http://www.microsoft.com/winlogo/)
  • Windows Platform Development Web site (http://www.microsoft.com/hwdev/)
  • Windows Hardware Quality Labs Web site (http://www.microsoft.com/hwtest/)
  • Certified for Windows Program Web site (http://msdn.microsoft.com/certification/)


Customization Guidelines: Help and Support Center

Under the terms of your OEM license agreement, you are responsible for providing post-sale technical support to your customers. To incorporate the minimally required support information into Windows, you must change the required entries in the Oeminfo.ini file and place the file in the %WINDIR%\System32 folder. Include your company name, a telephone number, and hours of operation in the Oeminfo.ini file; including a URL is highly recommended. Your company name and contact information displays in System Properties, and your URL is available by selecting the Hardware Support icon. For more information, see Adding Your Company Information and Logo to System Properties.

Help and Support Center Customizations for All OEMs

  • Support Overview Page: The Support Overview page in Help and Support Center automatically includes the company logo, name, computer model, and support information that you provide in the OPK Setup Manager.
  • System Restore: You may change the checkpoint and the maximum size of the data store used by System Restore.

Additional Help and Support Center Page Customizations for Royalty OEMs

  • You may add co-branding, customized colors, images, backgrounds, and fonts to various parts of the Help and Support Center page, including the navigation bar and default pages.
  • You may add custom pages to the Help and Support Center page content, provided that they are properly indexed to the Help and Support Center taxonomy.
  • You may add customized taxonomies to the defaults provided.
  • You may add your own customized content to the main Help and Support Center page, provided that the existing taxonomy is not changed.
  • You may add elements to the navigation bar, provided that they appear after all required default elements.

Important

  • You must use a .cab to install the files used in the customizations for royalty OEMs, and the .cab must be signed by Microsoft. For more information, see the white paper Windows XP Help and Support Center Customization Guide, located on the Windows OPK CD.

Optional Support Tools

You may include the support tools, found in the \Support\Tools\Support.cab on the Windows product CD, on the computers that you manufacture. Your support staff can use these tools to assist end users.


Customization Guidelines: Internet Access and ISP Offers

You may choose how to offer Internet service to the user, using one of the following ISP sign-up options:

  • Use the MSN Internet Access ISP sign-up offer, as integrated into Windows Welcome.
  • Display a list of one or more custom OEM ISP sign-up offers, either in Windows Welcome, from the OEM link on the Start menu, or both.
  • Preconfigure Internet settings at the factory.

    To preconfigure the user's Internet account, you collect end-user information when the order is placed, such as the name and billing information. Use that information to determine an e-mail name and POP address, and then activate this unique account. Configure the settings for the new Internet account when the computer is built in the factory. For more information, see Configuring Internet Settings at the Factory.

  • Do not include ISP sign-up in Windows Welcome.

Custom OEM ISP Sign-Up Offers

You may provide one or more custom options for ISP sign-up, provided that:

  • The ISP sign-up offer is in HTML.
  • This code is used only to sign up an end user for ISP service or to enable the end user to select a default browser and e-mail client. It does not start any programs during or following Windows Welcome.
  • You present dynamic offers ISP sign-up by dialing out from Windows Welcome, but only for sign-up activity. The code for the ISP sign-up program must be installed on the hard disk. Do not download executable applications during Windows Welcome.
  • The first page in the OEM ISP sign-up offer must also contain options enabling users to:
    • Re-establish an existing Internet account by entering ISP settings manually or using the Microsoft Internet Referral Service.
    • Create a new Internet account after completing Windows Welcome.

    The appearance and prominence of these options must be equivalent to any OEM ISP offers that are also listed on this page.

  • ISP sign-up offers may also be included in applicable locations in the Start menu, such as the Most Frequently Used (MFU) list of programs, the OEM link, the Online Services folder, the Windows desktop, or All Programs.
  • If the ISP sign-up offer is part of the first-run experience on Windows XP, the last page in the OEM ISP offer must contain a call that returns control back to Windows Welcome. ISP sign-up offers may not run automatically as an executable application after the Finish page in Windows Welcome.
  • If ISP sign-up fails for an ISP sign-up offer presented during Windows Welcome, you must return control back to Windows Welcome.
  • If an OEM ISP sign-up offer is the default option in the desktop ISP sign-up that launches when an end user attempts to connect to the Internet, you must provide a way for users to navigate from that offer to the New Connection Wizard.
  • If the user chooses an ISP offer other than MSN, then Microsoft is not responsible for any long-distance telephone charges incurred during ISP sign-up. If the computer is already connected to the Internet through a telephone modem to enable registration or activation, then the ISP sign-up code must terminate that connection and initiate a new phone call to the ISP sign-up server.

For more information, see OEM ISP Sign-up Option; Internet Sign-up After Windows Welcome; and Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.

Internet Sign-Up Reminders

  • You may display up to three Internet sign-up reminders to end users who do not configure their computers for Internet access during Windows Welcome.
  • If the user signs up for broadband Internet service, often a service technician must be dispatched to the end user's location to complete Internet access configuration. In this case, you may provide up to 10 Internet sign-up reminders that ask the user to complete Internet configuration after the service technician has configured the correct wiring.


Customization Guidelines: Internet Explorer and Outlook Express

You may modify the following items in Internet Explorer:

  • Default home page
  • Default run-once page
  • Default search page
  • Default online support page

You may add one OEM toolbar button to the Internet Explorer toolbar.

You may not remove the Microsoft preloaded favorite items in the Favorites list of Internet Explorer. However, you may add one folder at the highest level under Favorites. You cannot place any additional preloaded URLs or Internet Explorer folders at a level higher than this folder.

You may not replace the Internet Explorer graphic that appears in the upper-right corner of the Internet Explorer window and other windows in Windows XP or the Windows .NET Server family.

For more information, see Customizing Microsoft Internet Explorer and Designing Toolbar Icons for Internet Explorer.

Allowing the User to Change the Default Browser or E-mail client in Windows Welcome

On Windows XP, you may provide the end user with the ability to configure a particular browser or e-mail application as the default, provided that:

  • The page(s) where the end user selects the default browser or e-mail application are in HTML.
  • The HTML page(s) do not start any programs or download code for execution, or remove any part of Windows.
  • If part of the first-run experience on Windows XP, the last page in the default browser choice contains a call that returns control back to Windows Welcome.

For more information, see Customization Guidelines: Internet Access and ISP Offers and Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.

Changing the Default Internet Browser or E-mail Client

On Windows XP, you may install and configure an alternative Internet browser as the default browser, where this application is associated with the registered file types of recognized Internet files. You may configure the Internet icon on the Start menu to use this alternative browser, and you may configure the E-mail icon on the Start menu to use an alternative e-mail client. For more information, see the Microsoft Knowledge Base (http://support.microsoft.com/support/kb/articles/q297/8/78.asp, article 297878).

You may configure Windows so that an end user can later reinstate the OEM-specified Internet browser or e-mail client as the default for this functionality.

For more information, see Removing Access to Windows Components.

Removing Visible Entry Points

On Windows XP, you may remove any visible entry points to Internet Explorer as specified in Removing Access to Windows Components.

If you remove the Internet Explorer visible entry points, you may also replace the MSN Explorer shortcut with a shortcut to MSN Internet Access. Do not change the MSN Explorer icon if the MSN Internet Access sign-up offer is available to the end user in Windows Welcome.

You may remove visible entry points to Outlook Express.

For more information, see Removing Access to Windows Components.


Customization Guidelines: Preinstalled Applications

Do not configure any programs to be enabled, run, or initialized automatically — that is, without requiring a deliberate act of the end user — from an icon or folder on the desktop, from the Start menu, or by any other mechanism. This includes, without limitation, any shells, screen savers, welcome scripts, wizards, or other content.

Do not populate the Startup folder, System.dat, or User.dat files in any manner or make other modifications that cause any application or content to run or load automatically when Windows starts, other than antivirus software or hardware diagnostics. Only antivirus software or hardware diagnostics may display any user interface, and that user interface must be necessary to configure the antivirus software or preinstalled hardware devices, such as network adapters, sound cards, or printers.

Shortcuts to all preinstalled applications may appear in the All Programs area of the Start menu.

On the Start menu, you can place up to three shortcuts in the Most Frequently Used (MFU) list of programs. Do not configure the shortcut to remain in the pinned items list above the separator bar on the Start menu. For more information, see Customization Guidelines: Windows Start Menu and Desktop.

You may include icons or shortcuts on the Windows desktop. You may install and display icons, shortcuts, or menu entries for any software anywhere in Windows where a list of such icons, shortcuts, or menu entries for applications is generally displayed. However, for any list of icons, shortcuts, or menu entries specified in Microsoft's documentation as being limited to software that has a particular functionality, you may install only icons, shortcuts, or menu entries for software that provides that type of functionality.

For more information about the process of preinstalling applications, see Preinstalling Applications. You must meet the licensing requirements for any application that you include on the computer, regardless of the method that you use to preinstall the application.


Customization Guidelines: Activation, Registration, and Product Key

Registration

Registration is not the same as Windows Product Activation (WPA). Registration is optional, contains identifying information, and is primarily a marketing tool. Activation is a required anti-piracy measure. No identifying information is transmitted or saved.

Submitting Registration Data to Both Microsoft and the OEM

Windows Welcome includes a page to collect registration information from your customers and then post that information to Microsoft. In addition, OEMs may optionally configure Windows Welcome to post that same registration data to their registration server.

If you, the OEM, choose to configure and maintain your own registration server, the end user may choose to send the data to the OEM, to Microsoft, or to both. No default choice is preconfigured; the end user must specify whether to send the data to the OEM, to Microsoft, or to both. In your registration pages, the end user must be able to make separate decisions about sending information to the OEM and to Microsoft. Do not combine these alternatives into a single choice for the end user.

For more information, see Collecting Registration Data.

Registration Reminders

You may display up to three registration reminders to end users who do not register during Windows Welcome. For more information, see Creating Reminders for Registration.


Customization Guidelines: Windows Media Player

In Windows Media Player, you can:

  • Provide one or more custom visual styles (or "skins").
  • Configure Windows Media Player to use your custom skin as the default.
  • Configure the file associations so that Windows Media Player is the default player for DVDs (DVD AutoPlay).
  • Enable MP3 encoding in Windows Media Player.

A skin is a customized user interface that overlays Windows Media Player when the player runs in compact mode. You may configure a custom skin as the default.

For co-branding opportunities, contact wmpoem@microsoft.com.

For more information, see Customizing Windows Media Player and the Windows Media Player Software Development Kit (http://www.msdn.microsoft.com/windowsmedia/).

On Windows XP, you may remove visible entry points to Windows Media Player. You may configure Windows so that an end user can later reinstate the OEM-specified media player as the default media player. For more information, see Removing Access to Windows Components.


Customization Guidelines: Windows Messenger

You can develop a specific custom tab for Windows Messenger in Microsoft Windows XP.

The Windows Messenger Tab Implementation Guide (msgrtabs.chm), included in the Windows OPK CD, completely describes requirements, design guidelines, and customization instructions.

In general, the design and implementation of a custom tab in Windows Messenger must:

  • Specify and implement a single tab supplying OEM-specific content.
  • Include the OEM's brand, name, or a bitmap indicating that the contents of the tab relate to the computer.
  • Include information about the computer or about the OEM's customer relationships that the customer finds useful and desirable.
  • Use a common Microsoft-provided cascading style sheet to address basic formatting issues in a Windows Messenger tab.
  • Do not use or design a Windows Messenger tab like a standard Web page. The design of a Windows Messenger tab must reflect the small tab size and the intended use of Windows Messenger, which is to communicate real-time information. A Messenger tab cannot scroll horizontally; it can scroll only vertically.
  • Not include within tab content any advertising, pop-up windows, and multimedia, including audio and video files, Flash animations, or QuickTime animations.
  • Ensure that displayed content is appropriate for the general population of end users.

If you want to use .NET Passport and Credential Manager on your site for authentication tasks, use version 1.4 of the .NET Passport SDK.

On Windows XP, you may remove visible entry points to Windows Messenger, as specified in Removing Access to Windows Components.


Customization Guidelines: Windows Software Components

The OPK is designed to help you preinstall Windows on new computers that do not contain a previous operating system. Do not use the preinstallation process to upgrade computers to a later version of the operating system.

Default Settings

Do not change any default settings in Windows, except as specifically described in one of the topics listed in Customization Guidelines or as permitted in your separate license agreement. For a partial list of default settings, see Windows Desktop Default Settings.

Customizing Specific Windows Components

See customization guidelines for Help and Support Center, Internet Explorer and Outlook Express, Windows Media Player, and Windows Messenger for specific guidelines about customizing these Windows software components.

You may install third-party applications that launch in place of Internet Explorer, Outlook Express, Windows Media Player, or Windows Messenger, as enabled by Windows registry settings and other documented mechanisms. The installation program for these third-party applications can register the application(s) by changing items such as the default file associations for particular extensions, URL protocol handlers, MIME handlers, and autoplay handlers, such that the third party applications are invoked (under equivalent circumstances) instead of Internet Explorer, Outlook Express, Windows Media Player, or Windows Messenger. For more information, see Removing Access to Windows Components and Registering Applications with Client Types (http://msdn.microsoft.com/library/en-us/shellcc/platform/shell/programmersguide/shell_adv/RegisteringApps.asp).

Configuring ClearType

If the destination computer is a laptop with an LCD screen or a desktop computer that you know will use a flat panel LCD monitor, you may turn on the ClearType setting. End users' reactions to ClearType depend on their visual perception of color; however, usability research has shown that a majority of users prefer to have ClearType enabled on their LCD screens.

Configuring Power Settings

By default, desktop computers running on AC power do not go into sleep or standby modes. You can use the Powercfg tool to optimize power settings and configure computers to default to Hibernate or Standby modes.

Required Drivers

Do not remove any standard Windows component software from a preinstalled computer. Users expect consistent behavior from all new computers, including all standard utilities and features.

The Driver.cab file includes all of the device drivers that are distributed with Windows, and this file is installed on the user's hard disk as part of Windows Setup. Do not modify this file in any way or delete it from a preinstalled computer.

For information about adding new or updated drivers to Windows Setup, see Preinstalling Hardware Devices.

Files in the i386 Directory

You must include associated files from the i386 folder on the Windows product CD in the %WINDIR%\i386 folder on the hard disk of your destination computer.

To view a full and current listing of the appropriate \i386 files

  1. Place the appropriate Windows product CD in the CD-ROM drive.
  2. Click Start, and then click Run.
  3. In the Open box, type cmd to open a command window.
  4. At the command prompt, change to the CD-ROM drive.
  5. Use the following command to change to the i386 folder:

    cd i386

  6. Use the following command to generate a list of files and save that list in i386list.txt:

    dir /s > c:\i386list.txt

Certain files are required only when upgrading an existing Windows 98, Windows 98 Second Edition, or Windows Millennium Edition operating system to Windows XP. You may remove the following subfolders and their contents from the new computers that you manufacture:

  • %WINDIR%\i386\Win9xmig
  • %WINDIR%\i386\Win9xupg
  • %WINDIR%\i386\Winntupg

You may remove the following files from the new computers that you manufacture. Windows automatically recreates these files if they are needed.

  • Hiberfil.sys
  • Pagefile.sys

You may remove the contents of the %WINDIR%\System32\Dllcache folder before you create an image of the master installation, under these conditions:

  • You must leave the empty Dllcache folder on the system for Windows File Protection to function properly.
  • You must set the SourcePath entry in the [ComputerSettings] section of Winbom.ini equal to the location of the i386 folder on the destination computer. The i386 folder must be located in %WINDIR%.

The %WINDIR%\i386\Lang subfolder and its contents are not required at the root of the distribution share unless you are preconfiguring the base operating system for specific language and locale settings. The \Lang subfolder contains the files needed for Middle East and East Asia bi-directional or double-byte support, including Arabic, Simplified Chinese, Traditional Chinese, Hebrew, Indic, Japanese, Korean, and Thai. All files required to display the character sets of other languages are included in the \i386 folder on the Windows product CD.

For more information about regional and language options, and the files and settings required for end-user configuration, see Preinstalling Windows in More Than One Language.

For more information about reducing the size of a master installation image, see Optimizing Your Images.

Multi-Language Installations

If you have explicit written permission from Microsoft Licensing, Inc., to distribute preinstalled computers that have the capability of letting the end user select the language, you must include a single manual containing all the preinstalled languages. You must provide this manual with one cover and one Certificate of Authenticity (COA). This option is available only to royalty OEMs.

For more information about using this method, contact your account manager and an authorized replicator.

Dual Boot Systems

You may offer to end users the option to launch non-Microsoft operating systems from the BIOS or a non-Microsoft boot-loader or similar program that launches before the start of Windows XP.


Customization Guidelines: Windows Start Menu and Desktop

Start Menu

On the Start menu, you can place shortcuts for up to three preinstalled applications in the Most Frequently Used (MFU) list of programs.

You may add a button to the Start menu. The button must link to an HTML page or executable program file installed on the hard disk. Do not download code for execution directly from this button or the associated HTML pages.

Any trade names, trademarks, logos, or brands displayed in connection with this button are limited to those owned by the OEM under which the computer is manufactured and distributed.

Do not modify the default appearance of the Start menu, except as explicitly specified in this Windows OPK User's Guide. Do not pin the shortcut for any application above the MFU list.

Shortcuts to all preinstalled applications may appear in the All Programs area of the Start menu.

If you install an alternative Internet browser, you may configure the Internet icon on the Start menu to use this alternative browser. If you install an alternative e-mail client, you may configure the E-mail icon on the Start menu to use this alternative e-mail client. For specifications, see Removing Access to Windows Components.

The computer must use one of the themes, other than the Classic theme, that is installed with Windows XP.

For more information, see Customizing the Start Menu and the OEM Link.

Windows Desktop

Do not modify, delete, or obscure in any way the appearance of the default desktop, except as specifically described in this Windows OPK User's Guide. This requirement includes, without limitation, any Windows features, shortcuts, icons, wizards, folders, subfolders, or programs of the Microsoft Windows software.

The following is an exception to this requirement:

  • You may replace the default Windows desktop background with your own background, provided any trade names, trademarks, logos, or brands displayed in connection with such components are limited to those owned by the OEM and under which the computer is manufactured and distributed.

The background color or design must not, in any way, obscure the Microsoft Windows desktop icons, Start button, or Start menu. For more information, see Customizing the Desktop Background.

Any executable file preinstalled by the OEM that changes the Windows Desktop or other elements of the Windows user interface must clearly provide a reasonable description of those changes to the end user before the end user runs the application.

You may include icons or shortcuts on the Windows desktop of any size or shape provided that such shortcuts do not obscure the Microsoft Windows desktop icons, taskbar, or Start menu, or otherwise impair the functionality of the user interface. You may install and display icons, shortcuts, or menu entries for any software anywhere in Windows where a list of such icons, shortcuts, or menu entries for applications is generally displayed. However, for any list of icons, shortcuts, or menu entries specified in Microsoft’s documentation as being limited to software that has a particular functionality, you may install only icons, shortcuts, or menu entries for software that provides that type of functionality.

You may enable Active Desktop to include program shortcuts. Microsoft does not recommend running Active Desktop because it degrades system performance.

Usability testing and customer feedback indicate that a clean Windows desktop, combined with the improved Start menu, create the best end-user PC experience. End users perceive the desktop as their personal working space.

You may use Sysprep in Factory mode to move all items on the Windows desktop, other than the Recycle Bin, to a folder located in %SYSTEMDRIVE%\Program Files. If you clean the Windows desktop at the end of your factory preinstallation process, the Desktop Cleanup wizard runs for the first time 60 days after the end-user first-run experience. Otherwise, the Desktop Cleanup wizard runs for the first time 14 days after the end-user first-run experience. Do not disable or change the schedule of the Desktop Cleanup wizard. For more information, see Customizing Desktop Cleanup.

Online Print Ordering Wizard and Web Publishing Wizard

Two online publishing tools are available from the Windows XP Start menu. The Online Print Ordering Wizard is available from the My Pictures folder, and the Web Publishing Wizard is available from all of My Documents (except My Music). When the end users select either option, they see a list of service providers including MSN and third parties. OEMs may add services to each of these tools, provided that all default service providers are not modified in any way, including the order in which they appear. The set of wizards is extensible, so end users can add any third-party service provider to the list at any time.

The Online Print Ordering Wizard converts digital images sent from a user into photographs. Any OEM custom service must provide this basic level of functionality. As part of your criteria for selecting service partners, we recommend that you also consider the ability of your partner to provide delivery service, rather than requiring that end users pick up their prints at a physical location.

The Web Publishing Wizard lets users publish files to the Web. For example, they can store their digital images online, create online photo albums, share pictures with friends online, transfer pictures to a print vendor (such as the one listed earlier), and transfer pictures back to their desktop. Any OEM custom service must be able to publish and host any of the supported file types.

Pages displayed in the Online Print Ordering Wizard or the Web Publishing Wizard must:

  • Navigate users directly through services.
  • Not contain advertisements.
  • Be similar to the look and feel of those pages offered by default within the wizards and not contain Flash or animated graphics.
  • Allow end users to access the service without launching a browser.
  • Be localized appropriately according to the language of the installed operating system.

To minimize end-user confusion, this offer must be a standalone service, not an aggregation of services.

For consistency with other such offers, we recommended that OEM-added services support Microsoft .NET Passport and the .NET Passport wallet.

Additional technical details, implementation requirements and suggestions, and a list of partners who may be able to provide a high quality implementation for each service are available in the Service Integration for Web Publishing Wizard and Online Photo Printing white paper available on the Windows OPK CD.


Windows Desktop Default Settings

Any end user may change these default settings, but OEMs are not permitted to change these default settings unless otherwise specified in Customization Guidelines or in the separate license agreement. These settings cannot be customized in Setup Manager or during Windows Welcome.

See the Microsoft Windows Web site (http://www.microsoft.com/windows/) for a complete summary of Windows XP and Windows .NET Server features.

Feature | Windows XP Home Edition | Windows XP Professional | Windows .NET Server family
Automatic Updates | On | On | On
Friendly Logon | On. The end user cannot join a domain. | On if the computer belongs to a workgroup. Off if the computer is a member of a domain. | Off. The friendly logon does not support joining a domain.
Device Driver Rollback | On | On | On
Dynamic Update (During Setup) | On | On | On
Enable Guest Logon | On | On if the computer belongs to a workgroup. Off if the computer is a member of a domain. | Off
Fast User Switching | On | On if the computer belongs to a workgroup. Off if the computer is a member of a domain. | Off
Files and Settings Transfer Wizard | On | On | Off
Themed Appearance | Consumer | Professional | Classic
New Start Menu | On | On | Off
New WebView | On | On | On
Simplified Control Panel | On | On | Off
System Restore | On | On | Off
Enhanced User Account Management | On | On | Off
Taskbar Grouping | On | On | On
Locked Taskbar | On | On | Off
Quick Launch | Off | Off | Off
My Pictures and My Music | On | On | Off. However, Windows automatically creates the folders, if necessary.
Internet Connection Firewall | On | On | On
Notification Cleanup | On | On | On
Home Networking Wizard | On | Off | Off
CD Burning | On | On | On
Web Publishing Wizard | On | On | On
NetCrawler | On | Off | Off
Remote Assistance | On | On | On
Game Controllers | On | On | Off

Features Not Included in 64-Bit Versions of Windows

The following features are not available in Windows XP 64-Bit Edition or the 64-bit versions of the Windows .NET Server family:

  • Windows Desktop Themes
  • Speech
  • HyperTerminal
  • CD Burning
  • Compressed folders
  • Fast User Switching
  • Internet Games (All)
  • Internet Connection Sharing
  • MSN Explorer
  • MSN Search Assistant
  • Windows Messenger
  • Netmeeting
  • System Restore
  • Universal Plug and Play
  • Visual Basic 5 Runtime
  • Visual Basic 6 Runtime
  • Visual C++ Runtime
  • Windows Media (Player, Server, Movie Maker)
  • Windows Product Activation
  • Windows Uninstall

Notes

  • On Windows .NET Enterprise Server and Windows .NET Datacenter Server, you cannot use hibernation if the computer uses Terminal Server or if the Physical Address Extension (PAE) kernel supports 3 GB or more of memory.
  • On the 64-bit versions of the Windows .NET Server family, you cannot use hibernation if the computer uses Terminal Server.
  • For more information on the PAE kernel, see the Microsoft Windows Device Driver Kit (DDK), which you can order from the Microsoft DDK Web site (http://www.microsoft.com/ddk/). You can also read the DDK documentation in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, and then select Driver Development Kit.


Control Panel Extensions

Some display hardware configurations may implement features that cannot be exposed through the standard property pages. To make such features easily available, OEMs and IHVs may want to extend the Display Control Panel.

Requirements for Display Control Panel extensions include the following:

  • Existing property pages must remain unchanged. You must not disable, modify, remove, or replace any Microsoft-provided property page (including the Settings tab) except for adding an Advanced Properties button if one does not exist.
  • Custom property pages can be added only under Advanced Properties. The features exposed at the top level are commonly-used features included in every Windows operating system. Because Windows supports multiple types of display devices, you cannot add custom property pages to the top-level property page set in the Display Properties page in Control Panel.
  • Control Panel extensions must interoperate with existing Windows Control Panel elements. In other words, changes made in one control panel element are reflected in the other.
  • Custom property pages must be labeled with an icon in addition to the text name. To prevent conflicts with future operating system or shell releases, custom property pages must contain the page label and either an icon with the company logo or text with the name of the vendor.
  • Control Panel extensions must not initialize if the necessary hardware/driver combination is not present. If the display hardware that ships with the custom Control Panel is not present, the custom Control Panel must not load.

    Likewise, if a custom property page has features that are dependent on proprietary driver extensions (for example, extensions that are not guaranteed to be present in every other display driver), those features must disable themselves, or the property page must not load when the necessary driver is not installed.

  • Only valid modes and refresh rate settings for the installed monitor and adapter are available by default. A Control Panel extension can provide an override capability for refresh rate selection, but a warning must appear when it is enabled.
  • Control Panel state must be stored in the registry. Do not store the state of the Control Panel extension in an .ini file. Any state that is maintained by your Control Panel extension must be stored in the HKEY_CLASSES_ROOT\Software registry key.
  • Control Panel files must be installed using the display driver .inf. The extension dynamic-link libraries (DLLs) that make up the new property page (or pages) must be listed in the [CopyFiles] section of the .inf file. Additionally, the Guide for the Control Panel extension must be in the [AddReg] section of the display driver .inf file to install the .cpl entry in the registry.

For more information on implementing control panel extensions, see "Control Panel Requirements" in the "Display and Print Devices" section of the Microsoft Windows Driver Development Kit.


Microsoft Windows Logo Programs

Microsoft Corporation developed the Designed for Microsoft Windows Logo Program (http://www.microsoft.com/winlogo/) and the Certified for Windows Program (http://msdn.microsoft.com/certification/) to help end users easily identify hardware and software products designed specifically for the Windows operating systems. The goal of the program is to ensure that end users have an optimal experience using the software and hardware products that carry the Designed for Microsoft Windows logo.

Users can combine hardware and software products that carry these logos. They can be assured that the products take advantage of the new technologies available in Microsoft Windows XP and the Windows .NET Server family.

A separate license is required for you to use the Designed for Microsoft Windows and Certified for Microsoft Windows logos. Licensing these logos enables vendors to use the logo on Web sites, product packaging, advertising, collateral, and other marketing materials in connection with products that have passed logo testing and are licensed for the logo. Use the Windows logo only as explicitly specified in the logo license.

Hardware Testing

The hardware-testing organization for the logo program is the Windows Hardware Quality Labs (WHQL), which provides compatibility testing services for Windows 2000, Windows XP, and Windows .NET Server hardware and drivers. Both hardware and software are tested before rights to use the logo are granted.

Hardware developers whose products pass the WHQL testing program also receive a detailed test report, inclusion of tested hardware on the Windows Hardware Compatibility List (HCL), and free distribution of drivers in the Windows Driver Library (WDL).

For the most current list of supported hardware, see the Windows HCL (http://www.microsoft.com/hcl/).

You are encouraged to submit your hardware systems for logo testing and to use components that carry the logo in your systems. For more information, contact:

WHQL
Microsoft Corporation
One Microsoft Way
Redmond, WA 98053-6399 USA
Fax: (425) 703-3872

For more information about hardware, see Windows Platform Development (http://www.microsoft.com/hwdev/).

Software Certification

Software certification requires that the software vendors follow the guidelines listed in the Application Specifications for Windows (http://msdn.microsoft.com/certification/appspec.asp). These applications:

  • Provide a robust, self-repairing installation that helps minimize conflicts among shared components.
  • Facilitate easier software deployment and management for organizations.
  • Correctly maintain user preferences and computer settings to ensure a good "roaming user" experience, support for multiple users per machine, and regeneration of application settings in machine replacement scenarios.
  • Run in a tightly controlled network environment to enable network administrators to secure and control corporate desktops.
  • Provide a consistent user experience and meet accessibility standards to reduce support and training costs.
  • Provide a smooth transition of the application for users that upgrade from Windows 95 or later.
  • Support OnNow power management for a better mobile computing experience.

Applications that comply with the server specification:

  • Provide support for a globally available infrastructure for easier user access and easier administrator management.
  • Facilitate secure access to resources and security for client-server interactions.
  • Reduce service downtime caused by system failures or planned server maintenance and upgrades, by exploiting Cluster services (for applications that comply with Windows .NET Enterprise Server requirements).

For the most up-to-date list of tested software, see the Certified for Windows Program (http://msdn.microsoft.com/certification/).


Differences Between System Builders and Royalty OEMs

The primary differences between the system builder and royalty OEM license agreements are:

  • How the OEM obtains genuine Microsoft software.
  • How the OEM pays for that software.
  • The form of the recovery media.

System builders acquire Windows from a Microsoft-authorized distributor in packages of one or more licenses. Each license comes with a Microsoft Windows product CD, a Certificate of Authenticity (COA), and the end-user booklet. Each installation of Windows must use the unique Product Key located on the COA label that is attached to that particular computer and distributed to the customer.

Royalty OEMs sign a license agreement directly with Microsoft Licensing, Inc. Royalty OEMs receive a "golden master" copy of Windows from Microsoft. The royalty OEM may customize Windows as described in the OPK or their license agreement. These OEMs obtain all customized media, end-user manuals, and bulk quantities of COA stickers from Microsoft-authorized replicators.

Royalty OEMs may provide recovery media for each computer, and that media must be protected so that it can be used only on that particular computer. Both printed books and any recovery media display the OEM name and branding.

System-locked preinstallation (SLP) is an anti-piracy technology that helps prevent the copying of legitimately licensed operating system software onto non-licensed systems. SLP is available only to royalty OEMs.

Specific differences are also explicitly described in the relevant topics in this Windows OPK User's Guide.

Differences in Customer Collateral

Item | Royalty OEMs | System Builders
Source of media | Receive a "golden master" CD from Microsoft, and modifies as permitted by the OPK and the royalty OEM license agreement. Royalty OEMs must use a Microsoft-authorized replicator to duplicate any Microsoft print or online media. | Acquire package of one or more Windows licenses from a Microsoft-authorized distributor.
Recovery media | Acquire from a Microsoft-authorized replicator. | Give the customer the Microsoft-branded CDs from the multiple-license pack, as acquired from the Microsoft-authorized distributor.
COA | Acquire in bulk from a Microsoft-authorized replicator. | Included in multi-license pack.
End-user manual | Receive master files from Microsoft. Royalty OEMs must use a Microsoft-authorized replicator to duplicate any Microsoft print or online media. | Give the customer the Microsoft-branded end-user manual from the multiple-license pack, as acquired from the Microsoft-authorized distributor.

For more information, see OEM Licensing Requirements and Customization Guidelines.


Planning and Preparation

Use the topics in this section to help you decide which methods best align with your manufacturing processes and business goals.

  • Installing the OPK Tools
  • Fundamental Terminology
  • Comparison of Preinstallation Methods
  • Preinstallation Methods FAQ
  • Using a Network to Preinstall Windows
  • Using Images to Preinstall
  • Checklist: Preparing to Build a Master Installation
  • Stages of Windows Setup
  • Windows Product Activation
  • Adding Value: Best Practices

The most effective preinstallation processes for Microsoft Windows XP require a local area network (LAN). If you do not have network connectivity, you must preinstall Windows XP directly from the Windows product CD.

For additional sources of valuable information, see For More Information.


Installing the OPK Tools

The technician computer is where you install the OPK tools and where you do your preinstallation development. This computer belongs to your company; it is not a computer that you distribute to customers.

The technician computer must use one of the following operating systems:

  • Windows XP
  • Windows .NET Server
  • Windows 2000

Do not install the OPK tools on Windows XP 64-Bit Edition, the 64-bit version of Windows .NET Enterprise Server, or the 64-bit version of Windows .NET Datacenter Server.

To install the OPK tools, insert the Windows OPK CD into the technican computer, and then click Setup.exe.

Important

  • Unlike previous releases of Windows, do not use Setup Manager from Deploy.cab on the Windows product CD. That version of the tool is intended for corporate administrators and IT professionals for corporate deployments.

    Instead, use Setup Manager as installed from the Windows OPK CD. This version of the tool is designed for all OEMs that preinstall the Windows XP and Windows .NET Server operating systems onto new computers.

Contents of the Windows OPK

The default location where the OPK setup program installs the OPK tools and documentation is the %SYSTEMDRIVE%\OPKTools folder.

Subdirectory on the technican computer | Contents
Root | Setupmgr.exe; Readme.txt. Default location of the distribution share.
\Cfgsets | Configuration sets created by Setup Manager.
\Docs | Windows OPK User's Guide and Preinstallation Reference.
\Lang | Default location of the Windows product files, which you preinstall onto destination computers.
\Samples | Sample files.
\Wizfiles | Files required by Setup Manager. Do not change or remove these files.

Notes

  • Do not confuse the installed location of the OPK tools (%SYSTEMDRIVE%\OPKTools) with the $OEM$ directory contained in a configuration set. For more information on the $OEM$ directory structure, see Structure and Content of a Configuration Set.
  • Microsoft provides no warranty, either expressed or implied, on the functionality of any sample files. These samples are provided solely as examples.

OPK Tools

The OPK includes the following tools:

  • Setup Manager: A wizard that automates the creation and modification of configuration sets for preinstalling Microsoft operating systems and various applications.
  • Windows Preinstallation Environment (WinPE): A minimal Win32 subsystem used to start computers in preparation for preinstallation. The Windows OPK CD is a bootable WinPE CD.
  • System Preparation (Sysprep): Prepares a computer's hard disk for disk duplication, auditing, and customer delivery. You must run Sysprep to reseal computers before distributing them.
  • Command-line tools: OPK, WinPE, and Windows tools used in preinstallation.

Upgrading the OPK Toolkit from the Original Windows XP OPK

You can use either the Windows XP SP1 OPK or the Windows .NET Server OPK to preinstall the following versions of Windows:

  • Original "gold" release of Windows XP
  • Windows XP SP1
  • Windows .NET Server family

Do not use the original "gold" release of Windows XP OPK to preinstall Windows XP SP1 or the Windows .NET Server family.

Only one version of the OPK tools and documentation can be installed on a technician computer. If you previously installed the OPK from the original "gold" release of Windows XP, you must upgrade those tools to the Windows XP SP1 OPK or the Windows .NET Server OPK; OPK tools from the original "gold" release of Windows XP cannot coexist on the technician computer with Windows XP SP1 or Windows .NET Server OPK.

When you upgrade to the Windows XP SP1 OPK or the Windows .NET Server OPK, no changes are made to any existing configuration sets, located in the \Cfgsets folder.

When you upgrade to the Windows XP SP1 OPK or the Windows .NET Server OPK, no changes are made to any available Windows product files, located in the \Lang folder. You must use the Product page in Setup Manager to load the Windows product files for the newer versions of Windows, such as Windows XP SP1 or members of the Windows .NET Server family.

Upgrading to the Windows XP SP1 OPK or the Windows .NET Server OPK does update the template files that Setup Manager uses when creating a new configuration set. Any new configuration sets created with the Windows XP SP1 or the Windows .NET Server Setup Manager will use the new default values.

Caution

  • If you use the Windows XP SP1 Setup Manager or the Windows .NET Server Setup Manager to edit and then save a configuration set that was originally created using the original "gold" Windows XP Setup Manager, then unchanged default values in answer files contained in that configuration set are updated to the default values used by the Windows XP SP1 Setup Manager or the Windows .NET Server Setup Manager. Thoroughly test any updated configuration sets.

Upgrading Toolkits Installed for Multiple Languages

If you have installed multiple language versions of the OPK from the original "gold" release of Windows XP, you must upgrade each language version of the tools separately.

The first time you upgrade the OPK toolkit, the OPK installation program automatically detects and upgrades the set of tools in the corresponding language. You must upgrade the OPK tools for each additional language separately, by using that language version of the OPK CD.

OPK Documentation

The OPK documentation contains two online books.

  • Windows OPK User's Guide: Contains an overview of the preinstallation process and instructions for using the OPK tools. See the Preinstallation Requirements and Customization Guidelines section for a summary of all licensing requirements.
  • Preinstallation Reference: Syntax for the various answer files that automate the Windows preinstallation process.

For instructions on printing some or all of the OPK documentation, see Printing the Documentation.

The OPK also contains a collection of white papers, located in the \Docs\Whitepapers folder on the Windows OPK CD


Fundamental Terminology

These terms are used throughout the OEM Preinstallation Kit (OPK) User's Guide. For the definitions of additional terms, see Glossary.

build-to-order
Manufacturing and customizing a computer according to customer specifications after receiving the order from the customer.
build-to-plan
Manufacturing a specified number of computers according to a given specification, and then distributing the manufactured computers to customers.
configuration set
A file and folder structure that contains the necessary configuration settings that control the preinstallation process and define the manufacturers' custom information.
configure-to-order
To manufacture a computer according to a customer's specification by customizing a pre-existing image of a master installation.
destination computer
The computer on which you preinstall Windows that will be distributed to customers. You can either run Setup on the destination computer or copy a master installation onto a destination computer.
end user
The person who ultimately receives the computer manufactured by the OEM.
image
A collection of files and folders (sometimes compressed into one file) that duplicates the original file and folder structure of an operating system. In addition to the base operating system, an image often contains other files added by the OEM or corporation.
master computer
A fully-assembled computer containing a master installation.
master installation
A customized installation of Windows that an OEM plans to duplicate onto one or more destination computers.
original equipment manufacturer (OEM)
A company that typically purchases computer components from other manufacturers, uses the components to build a personal computer, preinstalls Windows onto that computer, and then distributes the computer to the public.

Unless explicitly stated otherwise, the general term "OEM" in this Windows OPK User's Guide includes both royalty OEMs and system builders.

preinstallation
The act of installing and configuring Windows XP on new computers that are then distributed to end users.
technician computer
The computer that you install Setup Manager on. Normally, the configuration sets and the distribution share are also located on this computer.


Comparison of Preinstallation Methods

There are many ways to preinstall Windows XP and Windows .NET Server. The licensing agreement, as summarized in Preinstallation Requirements and Customization Guidelines, specifies only the end result of the preinstallation process. How you achieve those results depends on you.

Every manufacturing process has tradeoffs. The right choice for you and your company depends on variables such as:

  • The number and type of computers that you plan to manufacture.
  • Whether your manufacturing model is build-to-plan, build-to-order, or a combination.
  • How much you customize the operating system.
  • How much you automate your processes.
  • The quality checks that you perform on both hardware components and manufactured systems.
  • Expected demand for customer support and the resources that you have available to meet that demand.
  • The existing infrastructure of your company.
  • Your company's growth rate and business goals.

Preinstallation Methods Compared

The following table summarizes and compares the basic methods according to three features:

  • Speed: the time to manufacture and deliver
  • Volume: the number of computers manufactured
  • Customization: the degree of modifications to the preinstalled software
Method | Speed | Volume | Customization
Build-to-Plan: Image of master installation deployed without customization to destination computers. | Fast | Highest | None
Build-to-Order: Image of master installation deployed to destination computers which are started in Factory mode and customized to order. | Fast | High | High
Network Setup: Destination computers start from floppy and run Setup from distribution share. | Slowest | Medium | High
CD Boot: Setup run at the destination computer using the Windows product CD. Manually customize, audit, and reseal the installation. | Slow | Lowest | Lowest

Preinstallation Methods Described

The methods listed here demonstrate the major differences in preinstallation made possible by the OPK tools. You can modify the methods to fit your business needs.

Build-to-Plan

In the classic build-to-plan method, you use imaging to quickly duplicate multiple computers with an identical configuration, without any additional configuration of the destination computers.

The broad outline of this method is:

  1. Build master installation with as many customizations as desired, where these customizations apply across an entire product line or all the computers that you manufacture. Thoroughly test this installation.
  2. Run sysprep -reseal (or click the Reseal button) to shut down.
  3. Store an image of this installation on a network share. This image can be either a snapshot of the complete set of files in the installation (a file-based image), or a single image file created by a third-party imaging tool.
  4. Assemble the hardware for the destination computer.
  5. Start the destination computer with Windows Preinstallation Environment (WinPE).
  6. Connect to the network and copy the image of the master installation onto the destination computer.

This method requires each destination computer to have an installed network adapter.

OEMs who manufacture a large number of computers may automate some or all of this process, or build a customized version of WinPE.

You can modify this process to duplicate the master installation onto separate hard disks, and then later place those hard disks into fully assembled computers.

The potential disadvantages of this method are:

  • The image of the master installation is closely tied to a particular set of drivers and a particular hardware configuration.
  • This method is not very flexible. The time required to build and test a customized image of the operating system generally requires two to three weeks.
  • If you do not start the destination computer in the factory or otherwise test the hardware and installation, your products are more likely to contain problems and cause issues with customer support.

Build-to-Order

This method gives you the most flexibility in your manufacturing environment and enables you to meet the targeted needs of a specific order or a specific customer. However, fully implementing an automated version of this method does require more preparation time.

When adjusted for your specific manufacturing environment, this method significantly decreases the time required to manufacture each computer. For example, if you give your customers a choice from a standardized range of applications, you can stage many or all of these applications in the master installation. In Factory mode (sysprep -factory), complete the installation of the desired applications, and delete the rest. This method is faster than installing each required application in the factory.

Each time you build a computer using this method, you start from a known, tested master installation. When the components change within your manufacturing environment, you need to test only those modifications on top of the known master installation, significantly reducing the testing time required for building and testing a completely new master installation.

The broad outline of this method is:

  1. Build a master installation with as many customizations as desired, where these customizations apply across an entire product line or across all the computers you manufacture. Thoroughly test this installation.
  2. Run sysprep -factory to shut down the operating system, so that the next time the operating system starts, it will be in Factory mode.
  3. Use a third-party tool to make an image of this master installation, and store this image in a network location.
  4. Assemble the hardware for the destination computer.
  5. Start the destination computer using Windows Preinstallation Environment (WinPE).
  6. Configure the hard disk of the destination computer and duplicate the image of the master installation onto the hard disk.
  7. Start the destination computer with the preinstalled operating system. Because of the way you configured the master installation, the destination computer runs in Factory mode.
  8. In Factory mode, use Winbom.ini to automate the installation of additional Plug and Play drivers, additional applications, hot fixes, or other customizations, and test both the hardware and the customized operating system.
  9. Run sysprep -reseal (or click the Reseal button in the Sysprep dialog box) to shut down the destination computer.

You can adapt this approach to use hard-disk disk duplication, where you prepare multiple hard disks ahead of time, assemble the destination computer with the previously prepared hard disk, and customize the installation, as desired.

Network Setup

If you build only a small number of computers and it is not cost-effective for you to build and manage images of the operating system, the Network Setup method can be used to preinstall and still enable customizations to the destination computers. In this case, the master computer is the destination computer.

This method is flexible and comparatively easy to maintain. It requires less time to set up any required infrastructure, but more time to build each computer.

The broad outline of this method is:

  1. Use Setup Manager to create a configuration set on a distribution share.
  2. Assemble the hardware for the destination computer.
  3. Start the destination computer using Windows Preinstallation Environment (WinPE).
  4. Connect to the network and preinstall the operating system from the configuration set.
  5. If you want to test or customize the operating system, run sysprep -factory. Make your customizations in Factory mode.
  6. Run sysprep -reseal (or click the Reseal button) to shut down the computer.

CD Boot

If you do not want to use a network or images in your manufacturing process, use the CD Boot method. Because it is completely manual, this is a slow and inefficient method. For low-volume businesses willing to handcraft each computer, this method enables a high degree of customization. You can place a Winnt.sif file on a floppy disk to automate branding in an unattended Setup.

The broad outline of this method is:

  1. Start the computer using the Windows product CD.
  2. Run Setup to install Windows.
  3. Make customizations and run tests.
  4. Run sysprep -reseal.

For More Information

For more information about the specific steps in implementing these methods, see:

  • Preinstallation Methods FAQ
  • Preinstalling the Operating System
  • Creating a Master Installation
  • Using Sysprep in Factory Mode
  • Creating a Customized Version of WinPE
  • Using Setup Manager
  • Installing Windows from the Windows CD


Preinstallation Methods FAQ

banner

Preinstallation Methods Frequently Asked Questions (FAQ)

What is the bare minimum that I need to do to meet the license requirements?

This procedure lists the steps for minimum compliance. This totally manual method is appropriate only for businesses with very low volume. By not automating anything, you are forced to redo everything over and over.

  1. Acquire a multi-pack of Windows from an authorized distributor.
  2. Create an Oeminfo.ini that contains the required sections and information.
  3. Assemble the hardware for the new computer.
  4. Start the computer with the Windows product CD.
  5. Run the retail version of Windows Setup.
  6. After the computer restarts, answer the questions in Windows Welcome.
  7. After you reach the Windows desktop, manually place the Oeminfo.ini file in the %WINDIR%\System32 folder. When the end user starts the machine, the settings in Oeminfo.ini are applied.
  8. Insert a floppy disk containing Sysprep.exe, Syspref.inf, and Setupcl.exe, and run Sysprep. This reseals the machine and prepares the system to take the end user through Windows Welcome.
  9. Attach the certificate of authenticity (COA) sticker to the computer chassis and deliver the computer to the customer with the end-user manual and the Windows product CD that contains the same product key as the COA sticker.

The user must activate the copy of Windows within the first 30 days after first using the computer.

Advantages

  • Fulfills the bare minimum requirements of the Microsoft OEM System Builder Agreement.
  • Network connectivity unneccessary.

Disadvantages

  • This method takes longer than any other technique.
  • This method is more cumbersome. You must monitor the retail Setup, answer the questions in Windows Welcome or Mini-Setup, and manually run Sysprep from a command prompt.
  • You cannot customize the computer or provide any additional value for your customers.

For more information on licensing requirements, see Preinstallation Requirements and Customization Guidelines.

How can I still keep things as simple as possible and produce more basic systems in less time?

By building and reusing a configuration set.

  1. Acquire a multi-pack of Windows from an authorized distributor.
  2. Install the OPK Tools on the computer that you use as a server within your manufacturing environment.
  3. Run Setup Manager and build a configuration set on this server.
  4. Assemble the hardware for the new computer.
  5. Insert the Windows OPK CD into the new computer, start using the Windows Preinstallation Environment (WinPE), and connect to your network.
  6. At a command prompt, run factory -winpe with the floppy disk containing the Winbom.ini from the configuration set that you built.
  7. After WinPE restarts and the installation finishes, the comnputer automatically starts into Factory Mode.
  8. In Factory mode, test the computer to make sure all hardware peripherals work as expected.
  9. Shut down using the buttons on the Sysprep tool.

    This enables users to accept the End-User License Agreement (EULA) when they start using the computer.

  10. Attach the certificate of authenticity (COA) sticker to the computer chassis and deliver the computer to the customer, along with the end-user manual and the Windows XP product CD that contains the same product key as the COA sticker.

Advantages

  • With a small amount of advance preparation, you can use the same configuration set multiple times.
  • Quicker to get into audit mode.
  • Bypass Windows Welcome/Mini-Setup.
  • Easier to get out of audit mode and reseal the computer for the customer.

Disadvantages

  • Minimal amount of branding.
  • No OEM value-adds.
  • No customer-specific system customizations.

I've started building a business, and want to promote myself a little more. How can the OPK help me with this?

You can customize the logo on System Properties, the logo to Windows Welcome, and the logo on Help and Support Center.

For more information, see Customizing the Windows Experience.

I want to branch out and create different product lines. How can the OPK help me with this?

For example, you may have produced only consumer systems in the past, but now you manufacture computers preinstalled with Windows XP Professional. Alternatively, you may want to manufacture servers in addition to desktop computers.

The solution is to do more in base configuration sets and make master installations more elaborate.

Add one or more of the following to your master installation:

  • More branding
  • System modifications
  • Install apps that all customers will get
  • Screen savers
  • Languages
  • Windows Welcome customizations
  • Internet Explorer
  • Help and Support Center
  • Model-specific customization

Then, use this as your base configuration set and edit the files to create variants for each model in your product line.

Advantages

  • More value-adds for the customer.

Disadvantages

  • Requires more time and testing.

How can I customize my process to meet the needs of a specific customer?

This is the basic "build-to-order" method. It combines some standardization with customer-specific information handcrafted for each customer or order.

  1. For each order, start with the same basic configuration set. In Setup Manager, modify the configuration set for each customer. Add applications and drivers, and prepopulate items such as Windows Welcome settings and the computer name with customer-specific information.
  2. Save each configuration set under a different name for each customer and order. This permits you to recreate the installation later if necessary.
  3. Preinstall using the customized configuration set.
  4. Test the preinstallation before distributing to the customer.

Advantages

  • More value to the customer.

Disadvantages

  • Maintain growing number of configuration sets.
  • Much slower than using the network preinstallation.


Using a Network to Preinstall Windows

Using a network to preinstall Windows XP provides the following advantages:

  • You save time by automating much of your preinstallation process, including:
    • Partitioning and formatting the hard disk.
    • Installing drivers, hotfixes, and service patches automatically from one location.
    • Installing applications
    • Running Sysprep.
    • Copying the I386 directory, OEM logos, and Oeminfo.ini.
  • Using the Factory mode of Sysprep provides greater flexibility and enables the automation of further customizations and testing, which can reduce the number of images you need to maintain.
  • You can add the OEM Link and prepopulate up to three Most Frequently Used (MFU) shortcuts on the Start menu.

Minimum Network Requirements

Networks used in preinstallation can range from large networks with domain controllers, routers, and Fast Ethernet to two computers connected by a crossover (null modem) cable. Your network can use domains or workgroups, but the OPK tools support only the TCP/IP and NetBIOS over TCP/IP protocols. All network adapters (NICs) must be compatible with Windows XP. For the most current list of supported hardware, see the Hardware Compatibility List (HCL) (http://www.microsoft.com/hcl/).

For preinstallation purposes, there are three basic types of networks:

  • DHCP server-based: A network that includes master, technician, and destination computers, and a DHCP server, which can be either a router or a computer running Windows 2000 Server or Windows .NET Server. This option gives you the maximum preinstallation flexibility.
  • Simple DHCP: A network that includes a technician computer with two NICs and a destination computer. With this configuration, you can use Internet Connection Sharing (ICS), which acts as a simple DHCP server.
  • Peer-to-peer: A network that includes only a technician computer with a NIC connected by a crossover (null modem) cable to a destination computer with a NIC.


Using Images to Preinstall

The fastest way to preinstall Windows XP in volume is to use imaging, otherwise known as disk-cloning. Imaging software is not included in the Windows OPK, but you may choose to use third-party disk-duplicating software or hardware. Imaging software performs sector-based duplication, which is faster than the file-based approach used by standard file copy methods.

Image-based preinstallations are best when building computers with similar hardware. In particular, the hardware abstraction layer (HAL) of the master installation must be identical to the HAL on the destination computer.

The basic imaging procedure is:

  1. Use the OPK tools to create a master installation of Windows.
  2. Start the installation and run Sysprep with the appropriate command-line options.
  3. Use the imaging software to create an image of the master installation.
  4. Transfer the image to your destination computers either across your network, manually using a custom WinPE CD, or by transferring the image to a hard disk and installing the hard disk in the destination computer.


Checklist: Preparing to Build a Master Installation

Before beginning the preinstallation process, answer these questions:

  • Do you have CD-ROMs for each product and language that you install?
  • Are any settings not configurable using Setup Manager?
  • How many master installations/images do you need?
  • What are the installation file names, location, and command-line options required for all device drivers?
  • What are the file names, locations, and command-line options required for all applications that you plan to preinstall?
  • What Windows Welcome customizations do you plan to make and where are the files located?
  • Does your hard disk duplication equipment support long file names?

For more information, see Preinstallation Requirements and Customization Guidelines.

Branding, Customizations to the Look-and-Feel of the Operating System

Item | For more information
Logo for System Properties | Adding Your Company Information and Logo to System Properties
Logo for Start Menu | Customizing the Start Menu and the OEM Link
Logo for Windows Welcome | Branding Windows Welcome
Logo for Help and Support Center | Including Your Information in Help and Support Center
Internet Explorer toolbar buttons | Designing Toolbar Icons for Internet Explorer

Windows Welcome Customizations

Windows Welcome is a series of full screen, HTML-based pages that offers to end users an easy and streamlined way of starting a new personal computer with Windows XP Home Edition or Windows XP Professional and connecting it to the World Wide Web.

For detailed information on how to customize files for Windows Welcome configuration, see Configuring Windows Welcome.

Item | For more information
Custom error page USB keyboard or mouse check | Turning on the USB Check
Custom hardware, mouse, or IEM tutorial (IME tutorials are only available for the Japanese, Traditional Chinese, Simplified Chinese, and Korean versions of Windows.) | Adding Custom Tutorials
Registration reminders | Creating Reminders for Users Who Skip Registration
Customized or modified Windows Welcome Pages | Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD
Default browser | Customization Guidelines: Internet Explorer and Outlook Express
Custom regional and keyboard settings and time zones | Changing Windows Welcome on All Computers

Hardware

Item | For more information
Drivers for all peripheral devices, common printers preinstalled | Preinstalling Hardware Devices
All drivers are signed | Use Signed Drivers
Drive format and partitioning | Comparing the NTFS and FAT32/FAT File Systems

Installed Software

Item | For more information
Language packs | Preinstalling Windows in More Than One Language
In-house applications | Either used only in the factory (for example, hardware diagnostics) or shipped to the customer (your value-added applications). Remember to remove any test applications that you use only within the factory.
Third party applications or screen savers | Preinstalling Applications
Service Packs or hotfixes to the operating system | Technical Support

Help and Support Center Customizations

Item | For more information
Custom Help files | Customization Guidelines: Help and Support Center
Custom Help Taxonomy | Customization Guidelines: Help and Support Center and Windows XP Help and Support Center Customization Guide on the Windows OPK CD
Look and Feel for Help and Support Center | Windows XP Help and Support Center Customization Guide on the Windows OPK CD
Support Automation applications | PC Health SDK (https://oem.microsoft.com/directoem/510659.asp) from the Microsoft Direct OEM Web site. For access to this Web site, contact your account manager.

Information

Item | For more information
Customer support contact information, including telephone number and URL | Adding Your Company Information and Logo to System Properties
Internet Explorer Favorites, Start page, Run Once page, Search, and Help | Customizing Microsoft Internet Explorer
Items to place in the Most Frequently Used list of Programs | Customizing the Start Menu and the OEM Link
Items to place in OEM Link on Start Menu | Customizing the Start Menu and the OEM Link

Infrastructure

Item | For more information
Configuring server to receive registration information | Collecting Registration Data
Privacy policy | Example: Microsoft Windows Registration Privacy Statement

Other Customizations

Item | For more information
Product key/activation | Prepopulating the Product Key and Preactivating Windows
Windows Media Player | Customizing Windows Media Player
Registration reminders | Creating Reminders for Users Who Skip Registration
Customized or modified Windows Welcome pages | Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD


Stages of Windows Setup

Use the retail Windows Setup to install the operating system on a computer that has the same hardware configuration as the computers that you plan to preinstall with Windows and distribute to your customers. Running Setup helps you understand more about the actual setup process and gives you the opportunity to uncover any hardware-related installation problems before you begin preinstallation.

During Setup, Windows is installed in three stages:

  1. File copy. Setup copies the Windows program files and any additional files that you specify from the distribution folder to the computer's hard disk.
  2. Text-mode Setup. Setup determines the basic hardware in the computer (such as CPU and motherboard type, hard disk controllers, file systems, and memory), installs the base operating system necessary to continue with Setup, and creates any folders that you specify.
  3. GUI-mode Setup. Setup configures the computer's hardware (audio, video, and so on), configures the network settings, prompts you to provide an Administrator password, and gives you the ability to personalize the installation.

At the conclusion of the three phases of Setup, the operating system is completely installed.

The end user's first-run experience (either Windows Welcome or Mini-Setup) is a subset of the GUI-mode Setup. The first-run experience prompts for user-specific information, redetects new hardware, and regenerates System IDs. After any additional customization or testing within your factory, you must run Sysprep to reset the first-run experience for the end user.

Flowchart of the stages of Windows Setup.


Windows Product Activation

Windows Product Activation (WPA) reduces Windows piracy by ensuring compliance with the software's End-User License Agreement (EULA). Software piracy damages consumers, manufacturers, and software publishers alike when consumers are provided incomplete software and documentation packages, and no customer support.

Product activation ensures compliance with the EULA, which for the Windows operating system states that a licensed copy of Windows can be installed only on one computer. It significantly reduces piracy of Windows, while requiring a minimum of additional steps by the legal end user or computer manufacturer.

Product activation works by matching the Product Key with the individual computer on which the software is installed. It does this by validating the Product Key, and checks that it has not been used with more than the licensed number of computers.

An end user has 30 days from the initial startup to activate their installation. The end user can activate their installation by using the Internet or the telephone. The computer manufacturer can also prepopulate the unique Product Key from the certificate of authenticity (COA) label on the specific computer, and activate the computer on behalf of the end user.

After Windows activates, activation is not inititated unless the end user makes significant hardware changes to the computer. If significant hardware changes are detected, the end user must reactivate the computer so that the license can be reconfirmed.

Important

  • For security reasons, Microsoft does not disclose the actual hardware components used during activation or those which, when changed, require the software to be activated again.
  • The average consumer hardware upgrade should not cause the end user to reactivate.

How Activation Works

Product activation begins with the system combining the Product Key and a non-unique hardware identifier to create an installation ID. The end user then sends the installation ID to a Microsoft Licensing clearinghouse, either automatically using an Internet connection on the computer or by telephoning a Microsoft customer service center. The Microsoft Licensing clearinghouse checks that this Product Key has not been used on more than the number of computers specified by the EULA.

If this check passes, the Microsoft Licensing clearinghouse sends the computer a confirmation ID, which activates this installation of Windows on that particular computer. If the check fails, however, the installation of Windows is not activated. When activation fails, the end user is given the opportunity to contact a customer service representative and request to transfer the license associated with the Product Key to another computer.

Note

  • Registration is not the same as Windows Product Activation. Registration is optional, contains identifying information, and is primarily a marketing tool. Activation is a required anti-piracy measure. No identifying information is transmitted or saved.

Activation and Preinstallation

You can use Sysprep for a maximum of three times to reset the clock for Windows Product Activation. After the third time, the clock can no longer be reset.

For more information about the role that activation plays in the preinstallation process, see:

  • Prepopulating the Product Key and Preactivating Windows
  • Sysprep and Windows Product Activation Frequently Asked Questions (FAQ)


Adding Value: Best Practices

The following ideas are best practices for adding value to the computers that you manufacture. Depending on the nature of your business, they may or may not apply.

Improve the User Experience with Better Packaging

  • Make the user experience as easy as possible with better packaging of the product. Usability research shows that new users find it difficult to sort through the reading material normally included. Give them one assembly poster to follow, with clear instructions.
  • Avoid including multiple reference sheets with names such as Start Here, Read Me First, Getting Started, and so on. Package everything else in separate bundles. Users are confused by multiple manuals, especially for peripherals.
  • Include information on the computer's configuration. Write it to Oeminfo.ini, or print it. If taped inside the cover, support technicians can use the information if the computer is returned for service.
  • Place the Certificate of Authenticity (COA) sticker on the front of the computer, so that the customer can easily refer to it when typing the Product Key.

Prevent Hardware Problems

  • Always use signed drivers. Signed drivers reduce driver-related problems, provide a better end-user experience, and reduce your support costs and total cost of ownership for customers.
  • When possible, preinstall drivers for printers and other included peripherals. Usability research at Microsoft shows that new users do not understand why they are prompted for a driver before Windows Welcome, or even why they cannot use their printer until they load a driver.
  • Likewise, choose high-quality hardware to help reduce your support costs and reduce your customers' total cost of ownership. Make sure that you communicate this choice through your marketing efforts.
  • To prevent end users from inadvertently deleting driver folders located at the root of the drive, you can place drivers under the \$OEM$\$$ folder (for example: $OEM$\$$\PnP\Audio).

Prevent Viruses and Security Threats

  • If your technician computer or the computer containing your master installation connects to the Internet, you expose it to the possibility of virus infection or a security threat such as a Trojan horse. To prevent this, avoid connecting to the Internet from the master computer. Instead, download updates to a separate system or network share, and install the updates on a test system for validation. Scan the system or share for viruses before including the updates in the master installation.

Optimize Hard Disk and Operating System Configurations

  • Create a single NTFS partition. Customers do not understand why their hard disk has less space than expected because of a second OEM partition. For information on the benefits of NTFS, see Comparing the NTFS and FAT32/FAT File Systems.
  • Focus on performance by using the Bootvis tool. Run your preinstallation images through Bootvis to ensure that they are optimized for maximum performance. You can obtain Bootvis from the "Downloads" section of the Windows Platform Development Web site (http://www.microsoft.com/hwdev/platform/performance/fastboot).
  • Carefully test your configurations and resist last-minute changes that cannot be thoroughly tested.
  • Install the most recent Windows service pack for the version of Windows installed on the computer.

Provide Incentives for User Registration and Privacy Protection

  • Provide incentives for users to register with Microsoft. If you collect registration information from your customers during Windows Welcome, include a privacy statement that informs the user about how you manage and protect the security of the data. For a sample statement, see Example: Microsoft Windows Registration Privacy Statement.

Reduce Customer Support Calls with Customizations

  • Add checks for custom hardware and audio speakers to Windows Welcome.
  • Reuse data collected in Windows Welcome with custom pages. For example, registration data can be reused in the ISP sign-up. For more information, see Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.
  • Add your support content to Help and Support Center. Use the Remote Assistance, System Restore, and Support Automation features. See Customization Guidelines: Help and Support Center, Windows XP Help and Support Center Customization Guide on the Windows OPK CD, and PC Health SDK (https://oem.microsoft.com/directoem/510659.asp) from the Microsoft Direct OEM Web site. For access to this Web site, contact your account manager.
  • To improve the Windows Welcome user experience, you may add up to four lines of text to the Welcome and Finish pages (Welcome.htm, Fini.htm). This text must appear after any text already on the page.

Employ Smart Practices for Technical Support

  • Provide excellent technical support. This is an area where you can clearly outperform your competitors.
  • Use Remote Desktop to provide "hands-on" technical support. Customers will appreciate your ability to resolve technical support issues immediately. Make sure that you inform customers that they have complete control of your access to their computer.

Customize for a Specific Customer

  • When building to a specific order, use information about the customer collected during the ordering process to preconfigure the Internet settings and to preconfigure settings in Unattend.txt, Winbom.ini, or Windows Welcome/Mini-Setup.
  • Automatically activate the system on behalf of the end user. For more information, see Prepopulating the Product Key and Preactivating Windows.
  • Preinstall applications if possible, and use applications that meet Windows Logo requirements.

Make Security a Priority

  • Encourage your customers to run Windows as a non-administrator to help protect their computers from malicious attacks that can destroy or corrupt data and system files. If you create user accounts, make sure that you create non-administrator accounts for end users.
  • Security breaches can occur if you use a common, non-blank administrator password for all computers provided to end users. Before running Sysprep, we recommend that you use an automation process to set the administrator password to blank. End users can then specify their own administrator passwords upon receiving the computer.

Implement Ease-of-Use Suggestions

  • You can improve readability for end users by enabling ClearType. To enable ClearType, in the [ComputerSettings] section of the Winbom.ini file, set FontSmoothing to On.
  • For more ideas on improving ease of use and thus distinguishing your product from your competitors' products, see the white papers located at the Ease of Use/PC Quality Roundtable Web site (http://http://www.eouroundtable.com).


Preinstalling the Operating System

The tools in the OEM Preinstallation Kit (OPK) enable you to preinstall and configure Windows on multiple computers in a factory environment. The basic process is the same for all versions of Windows XP and the Windows .NET Server family with only minor differences specific to each product.

  • Planning and Preparation
  • Using Setup Manager
  • Preinstalling with a Network
  • Creating a Master Installation
  • Preinstalling Without a Network
  • Customizing and Testing the Destination Computer
  • Preinstalling Service Packs and Hotfixes

Your preinstallation process may vary slightly depending on the specific version of Windows, the type of computer that you are building, or other constraints on your manufacturing infrastructure. For more information, see:

  • Preinstalling 64-Bit Editions of Windows
  • Configuring the Windows .NET Server Family

Preinstallation Requirements

Before you preinstall Windows on new computers, make sure that you fully agree to, and comply with, the business and legal requirements of Microsoft. For a complete description of these requirements, review your license agreement and read all the information in the Preinstallation Requirements and Customization Guidelines section of this Windows OPK User's Guide.

The last step in your manufacturing process must be to run the System Preparation tool (Sysprep) on the destination computer before it is distributed to customers, so that Windows Welcome or Mini-Setup runs the first time the end user starts the computer. Either the OEM or the reseller can complete the Windows installation by running Sysprep.

Windows 2000 Preinstallation Techniques

For backward compatibility, you can continue to use the techniques available to you in Windows 2000. However, these techniques will increase your manufacturing time and are not as flexible as the methodology designed for Windows XP. For more information, see Legacy Preinstallation Techniques.


Using Setup Manager

Use Setup Manager to create answer files and distribution shares, or to modify the files contained in a configuration set.

If you use a network for preinstallation, then use Setup Manager to create the Unattend.txt answer file, a distribution share, and one or more configuration sets. If you do not use a network, use Setup Manager to create the Winnt.sif answer file.

Using Setup Manager With a Network to Preinstall Windows

The recommended location for configuration sets is directly on the technician computer, which you then make available on the local area network as the distribution share. For more information, see Structure and Content of the Distribution Share.

Create only one configuration set for each computer type that you preinstall and manufacture. You can then use the set repeatedly as you preinstall Windows. You can modify the baseline configuration set to accommodate differences in preinstalled applications and other variations.

You do not need to specify all of your customizations when using Setup Manager. Instead, you can create a configuration set in Setup Manager and then manually edit one of the preinstallation text files in the configuration set (such as Unattend.txt, Sysprep.inf, Oobeinfo.ini, or Winbom.ini). If you later open that configuration set in Setup Manager, the tool displays your changed settings. For more information, see Structure and Content of a Configuration Set. For a detailed listing of the settings that Setup Manager writes, see Setup Manager Settings.

Setup Manager does not affect the system files of the technician computer on which the tool runs. Setup Manager manages the directory structure that contains the configuration set but does not actually run Windows Setup.

To run Setup Manager, you must use Windows 2000, Windows XP (32-bit version), or the Windows .NET Server family (32-bit versions).

Important

  • Unlike previous releases of Windows, do not install Setup Manager from Deploy.cab on the Windows product CD. That version of the tool is intended for corporate administrators and information technology professionals.

    Use Setup Manager only from the Windows OPK CD. This version of the tool is designed for all OEMs that preinstall the Windows XP operating system onto new computers.

  • Use Setup Manager to create a configuration set for preinstalling 64-bit editions of Windows. However, you can run the Setup Manager tool only on a 32-bit version of Windows, such as Windows 2000 Professional or Windows XP Professional (32-bit version).
  • Because the user name and password that you select to connect to the distribution share are in plain text, it is recommended that you grant this account only the minimum rights needed to make the connection.

For more information on the specific steps of creating the configuration set, see Creating a Configuration Set. Also see the Step-by-Step Guide to OEM Preinstallation of Windows XP white paper on the Windows OPK CD.

Using Setup Manager Without a Network to Preinstall Windows

Without a network, the only way to preinstall Windows is the CD-boot method, which uses an answer file called Winnt.sif. You can create this answer file with Setup Manager.

To create Winnt.sif

  1. Remove or rename the Oem.tag file in the \opktools\wizfiles directory.
  2. Run Setup Manager and follow the prompts.
  3. Save the results as Winnt.sif.

For more information, see Preinstalling Without a Network.


Preinstalling with a Network

Using a network to preinstall is the most flexible and efficient method available. With a network, you can:

  • Create configuration sets.
  • Quickly deploy images of master installations.
  • Boot destination computers with WinPE and connect automatically to master computers.
  • Use the Factory mode of Sysprep to perform further customizations to the destination computer before Sysprep -reseal.

This section contains these topics:

  • Configuring the Network for Preinstallation
  • Creating a Master Installation
  • Using WinPE in Your Manufacturing Process
  • Creating a Configuration Set
  • Configuring the Hard Disk
  • Using Winnt32.exe to Run Setup
  • Optimizing Your Images
  • The Disk-Duplicating Method
  • Setting the Administrator Password
  • Preinstalling Windows in More Than One Language


Configuring the Network for Preinstallation

To use a network for preinstallation, you must share the folders containing the OPK tools and applications to preinstall, and ensure that all computers used in preinstallation have valid IP addresses, either by using DHCP or by assigning static IP addresses.

Important

  • If you use static IP addresses, you will not be able to use the Factory mode of Sysprep to preinstall anything. Factory mode requires DHCP to establish connectivity.

For the preinstallation to work properly, you must share the OPKTools and application folders, and then create user accounts for accessing them. You may want to use opkuser and a password for the OPKTools folder containing your configuration sets, and use appuser and a password for the applications folder used for preinstalling applications.

To share a folder, right-click it, click Sharing and Security, and then click Share this folder.

Creating User Accounts for Preinstallation

The procedures for creating user accounts differ depending upon whether you use domains or workgroups.

To create new user accounts in Windows XP Professional (when joined to a domain)

  1. On the Start menu, click Control Panel, click Performance and Maintenance, click Administrative Tools, and then double-click Computer Management.
  2. Double-click Local Users and Groups, right-click Users, and select New User.
  3. Type a new user name and password that you will use during the application preinstallation phase.

To create new user accounts in Windows XP Professional (in a workgroup) or Windows XP Home Edition

  1. On the Start menu, click Control Panel, click User Accounts, and then click Create a new account.
  2. On the Name the new account page, type a name, and then click Next.
  3. On the Pick an account type page, select Computer administrator, and then click Create Account.

Configuring DHCP Addresses for a Network Preinstallation

All computers in a network environment using DHCP automatically receive IP addresses, and DHCP is enabled by default.

For networks without a DHCP server, Internet Connection Sharing (ICS) can be used as a DHCP server. The technician computer must have two network interface cards (NICs), the destination computer must have a NIC, and the NICs must be on the Hardware Compatibility List (HCL) (http://www.microsoft.com/hcl/).

To configure DHCP addresses for a network preinstallation using ICS

  1. On the desktop of the technician computer, right-click My Network Places, and then click Properties.
  2. Right-click the network adapter that will not connect to the destination computer, and then click Properties.
  3. On the Advanced tab, select the Allow other network users to connect through this computer's Internet connection check box.
  4. Click OK. A message box displays stating that your LAN adapter's IP address will be changed to 192.168.0.1.
  5. Click Yes. Your computer is now configured for ICS.

Configuring a Static Address for Peer-to-Peer Preinstallation

To complete a preinstallation in a peer-to-peer network scenario, you must modify the TCP/IP information manually in the Winbom.ini file to connect the computers using a crossover cable or a hub and two standard network cables.

Note

  • A crossover cable is a cable that is used to interconnect two computers by crossing over (reversing) most of their respective pin contacts. A crossover cable is also known as a null modem cable.

All computers must be in the same workgroup. The technician computer automatically receives an IP address if it is located in the workgroup. If, for some reason, the technician computer does not automatically receive an IP address, you can assign a static IP address manually.

Important

  • If you assign a static IP address, applications will not be preinstalled, even if specified in the Winbom.ini file, because the network configuration only works while WinPE is running. In particular, Step by Step Interactive (SBSI) will not be installed, and it is a requirement of the OEM licensing agreement that SBSI be installed. For this reason, it is highly recommended that you use DHCP to automatically assign IP addresses. For instructions on installing SBSI manually, see Installing Step by Step Interactive in Windows XP.

To assign static IP addresses manually

  1. On the Start menu of the technician computer, click Control Panel, click Network and Internet Connections, and then click Network Connections.
  2. Right-click the connection, and then click Properties.
  3. Select Internet Protocol (TCP/IP), click Properties, click Use the following IP address, and enter this static IP address information:
    IP Address = 169.172.0.1
Subnet Mask = 255.255.0.0
  4. Click OK twice to close the dialog boxes and save the settings.
  5. On the master computer, open the Winbom.ini file on the floppy disk by using Notepad.
  6. Add these parameters and values to the [WinPE.net] section:
    [WinPE.net]
startnet = yes
ipconfig = 169.172.0.2
subnetmask = 255.255.0.0
  7. Save the Winbom.ini file.
  8. Insert the floppy disk that was created by Setup Manager into the master computer's floppy disk drive.
  9. Insert the Windows OPK CD in the master computer's CD-ROM drive and reboot the master computer. If prompted, press any key to boot from the CD.

By using the Winbom.ini file in the master installation, Windows will connect to the technician computer and begin the preinstallation. The hard drive on the master computer will be repartitioned and reformatted. When the installation is complete, the master computer will restart in Audit mode. Remove the floppy disk when the computer begins to restart.


Creating a Master Installation

The first step in the network-based preinstallation process is to create a master installation, which provides you with maximum control over the preinstallation process and the flexibility that you need to customize the Windows operating system on the destination computers.

After creating a master installation, you can then create an image of the installation for quick deployment over your network to destination computers. For more infomation, see Using Images to Preinstall.

Components of a Master Installation

The second component of a master installation is the collection of all your desired customizations to the operating system. When the source files for all these customizations are organized into a directory structure, the complete set of files is called a configuration set. A configuration set can include details of the operating system configuration, branding graphics, language packs, applications, and hardware device drivers. Setup Manager helps you create and manage configuration sets.

To create a master installation, start the computer from WinPE and install the configuration set.

Notes

  • Installing a configuration set from WinPE may require extra time because Setup copies the i386 directory as part of the installation. The OEM license agreement requires that you include a complete copy of the i386 directory on destination computers.
  • The files are copied to the C:\i386 directory by default. If you include the SourcePath entry to the [ComputerSettings] section of Winbom.ini, then the i386 directory is placed in the location specified by SourcePath. For example:
    [ComputerSettings]
SourcePath = %WINDIR%

Relationship of the Master Installation to the Master Computer and the Destination Computer

The master installation may be located on the hard disk on a fully assembled computer. In this case, the master installation is sometimes described as the master computer.

If you distribute the master computer directly to customers, then the master computer and the destination computer are the same.

For more information, see:

  • Fundamental Terminology
  • Checklist: Preparing to Build a Master Installation
  • Creating a Configuration Set
  • Structure and Content of a Configuration Set
  • Using WinPE in Your Manufacturing Process
  • Preinstallation Requirements and Customization Guidelines

Flowchart of building a master installation.


Using WinPE in Your Manufacturing Process

A basic method for using the Windows Preinstallation Environment (WinPE) is:

  1. Start the newly-assembled computer with WinPE.
  2. Run any relevant hardware diagnostic applications.
  3. Configure the hard disk.
  4. Deploy the operating system to the computer using one of these methods:
    • Copying an image from the network.

      –OR–

    • Running Winnt32 from the command prompt in WinPE and installing the operating system.
  5. Restart into the installed operating system by using Sysprep in Factory mode, or seal the operating system by using Sysprep and shut down the computer.

For more information, see Windows Preinstallation Environment (WinPE) Features.

Starting the computer by using WinPE

The Windows OPK CD is a bootable copy of WinPE (32-bit edition). This default version of WinPE on the Windows OPK CD starts and runs the command factory -winpe.

The default version of Startnet.cmd is located in StartOPK.chm. If you build a custom version of WinPE, you can modify Startnet.cmd to contain commands specific to your manufacturing environment.

To start a computer by using WinPE on a CD

  1. Insert the WinPE CD into the computer.
  2. Configure the computer's basic input/output system (BIOS) to start from the CD before starting from the local hard disk.
  3. Start the computer, pressing any key to start from the CD if the computer contains a formatted local hard disk.

When the Factory tool starts, it first locates a Winbom.ini file by searching these locations in this order:

  1. The path and file name specified by the registry key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Factory\Winbom.
  2. The root of all removable media drives that are not CD-ROM drives, such as a floppy disk drive.
  3. The root of all CD-ROM drives.
  4. The location of Factory.exe, usually the %SYSTEMDRIVE%\Sysprep folder.
  5. The root of %SYSTEMDRIVE%.

After locating a Winbom.ini file, the Factory tool reads the value of the WinbomType entry in the [Factory] section.

If the value of WinbomType is not appropriate in this context, the Winbom.ini file is ignored and the Factory tool continues searching for a Winbom.ini file. If the value of WinbomType is appropriate in this context, the Factory tool reads the value of the NewWinbom entry in the [Factory] section. If a value is specified for NewWinbom, and a Winbom.ini file is located at that location, the Factory tool examines that Winbom.ini file for a NewWinbom entry.

This cycle continues for a maximum of 10 times or until the Factory tool locates a Winbom.ini file that does not contain a NewWinbom entry, whichever occurs first. The Factory tool then continues to run, using the settings in the last identified Winbom.ini file.

After locating the intended Winbom.ini file, the computer connects to the network as specified in the [WinPE.Net] section. Plug and Play installs only the network adapter, and then the Factory tool installs networking services and binds the network protocols.

Note

  • Instead of using the Windows OPK CD, you can also create a custom version of WinPE for your factory preinstallation requirements, as described in Creating a Customized Version of WinPE.

Running Hardware Diagnostic Applications

Because the Windows XP kernel can dynamically load and unload device drivers when WinPE is running, the Windows NT driver for a particular device can be loaded. After the driver loads and initializes, it scans the hardware to find its device. With the driver loaded successfully, you can usually assume that the corresponding hardware is working correctly.

Your test suite can use the drivers provided by the hardware manufacturer; you do not need to use a different version of the drivers in your manufacturing environment.

Configuring the Hard Disk and Other Preparatory Tasks

You can format and partition the hard disk in these ways:

  • When the command factory -winpe runs, you can use WinPE to configure the hard disk of the computer as specified in the [DiskConfig] section of the Winbom.ini file.
  • Run Diskpart commands from the command prompt to configure the disk.
  • Run a Diskpart script.
  • Use the Format command-line tool contained in Windows XP.

To ensure that the newly formatted partition is active, use WipeDisk in the Winbom.ini:

[Disk1.config]
WipeDisk = yes
Size1 = *
PartitionType1 = primary
SetActive1 = Yes
FileSystem1 = NTFS
QuickFormat1 = yes

This wipes the existing partition, creates a new partition, and sets it as active. You can change the NTFS line to be FAT32, but Setup will create only a 32 GB bootable FAT32 partition.

Important

  • The drive letters assigned during WinPE are not saved to any registry that persists when you restart. The drive letter assignment when you create partitions is in the order of creation, but the drive letter assignments when you restart are in the default order.

After processing the [DiskConfig] section of Winbom.ini, WinPE processes the [OEMRunOnce] and [OEMRun] section, where you can specify any series of tasks to run.

Preinstalling Windows

After processing the [OEMRunOnce] and [OEMRun] sections, WinPE then installs a configuration set as specified by the [WinPE] section.

Notes

  • Installing a configuration set from WinPE may require a long time because Setup copies the i386 directory as part of the installation. The OEM License Agreement requires that you include a complete copy of the i386 directory on destination computers.
  • The files are copied to the C:\i386 directory by default. If you include the SourcePath entry in the [ComputerSettings] section of Winbom.ini, then the i386 directory is placed in the location specified by SourcePath. For example:
    [ComputerSettings]
SourcePath = %WINDIR%

Finally, WinPE processes the [UpdateSystem] section of the Winbom.ini file, and restarts or shuts down the computer based on the value of the Restart entry in the [WinPE] section.

Flowchart of using WinPE to install the operating system.


Creating a Configuration Set

To preinstall Windows, you must create at least one configuration set unless you preinstall without a network. A configuration set is a directory structure containing all files that you add to your Windows installation, including Windows Welcome customizations, answer files (such as Unattend.txt, Sysprep.inf, Oobeinfo.ini, or Winbom.ini), preinstalled applications, and additional hardware drivers.

Use Setup Manager to create the configuration set. Use the set repeatedly as you preinstall Windows. See Checklist: Preparing to Build a Master Installation to make sure that you do not forget anything that belongs in the configuration set.

A configuration set typically resides on a computer to which your destination computers or master computer can connect.

Notes

  • In general, it is easiest to store the configuration sets and distribution share on the technician computer.
  • An answer file used by itself to preinstall, such as in the remote installation or CD Boot methods, is not a configuration set.

You can use the same configuration set for different computer models with the same microprocessor architecture, provided that the set contains the necessary drivers for all models. If a hardware component changes, you can place its driver in the configuration set rather than changing the answer file.

For more information, see:

  • Structure and Content of a Configuration Set
  • Structure and Content of the Distribution Share

Modifying and Reusing Configuration Sets

Configuration sets can be modified and reused in network-based preinstalls to accommodate differences in preinstalled applications and other variations. You can create and save a configuration set with Setup Manager, and then edit the answer files in the configuration set. If you later open that configuration set in Setup Manager, it displays the changed settings.

For example, you can manually modify the [DiskConfig] section in Winbom.ini to configure and partition one or more physical hard disks when the Factory tool is running under the Windows Preinstallation Environment (WinPE). The default is one NTFS partition. For more information, see Configuring the Hard Disk.

Note

  • If you plan to create many variations on the configuration set for different computers, provide generic answers to Setup Manager questions. These answers limit the number of changes that you need to make in subsequent configuration sets.

Another example of reusing a configuration set is to preinstall different language settings on computers with the same microprocessor architecture. Create a generic configuration set with Setup Manager, and then modify only the [RegionalSettings] section of Unattend.txt or Sysprep.inf with the new language settings. Include the /copysource:lang option in the Winnt32 command (or the /rx:lang option in the Winnt command) to copy all files in the \i386\Lang directory to the hard disk.

For more information, see Preinstalling Windows in More Than One Language.

Effects of Upgrading the OPK Tools

When you upgrade to the Windows XP SP1 OPK or the Windows .NET Server OPK, no changes are made to any existing configuration sets, located in the \Cfgsets folder.

When you upgrade to the Windows XP SP1 OPK or the Windows .NET Server OPK, no changes are made to any available Windows product files, located in the \Lang folder. You must use the Product page in Setup Manager to load the Windows product files for the newer versions of Windows, such as Windows XP SP1 or members of the Windows .NET Server family.

Upgrading to the Windows XP SP1 OPK or the Windows .NET Server OPK does update the template files that Setup Manager uses when creating a new configuration set. Any new configuration sets created with the Windows XP SP1 or the Windows .NET Server Setup Manager will use the new default values.

Caution

  • If you use the Windows XP SP1 Setup Manager or the Windows .NET Server Setup Manager to edit and then save a configuration set that was originally created using the original "gold" Windows XP Setup Manager, then unchanged default values in answer files contained in that configuration set are updated to the default values used by the Windows XP SP1 Setup Manager or the Windows .NET Server Setup Manager. Thoroughly test any updated configuration sets.

For more information, see Upgrading the OPK Toolkit from the Original Windows XP OPK.


Structure and Content of a Configuration Set

Windows XP and the Windows .NET Server family include new tools for creating and customizing configuration sets for each make and model of computer that you manufacture. After you install the OPK tools on the technician computer, you can run Setup Manager and create new configuration sets, or edit the content of existing configuration sets.

For more information, see Creating a Configuration Set and Structure and Content of the Distribution Share.

Tips

  • In general, it is easier to locate the configuration sets and distribution share on the same computer where you install the OPK tools and run Setup Manager.
  • If you want to place a shortcut to the application on the Most Frequently Used (MFU) list of programs on the Start menu, add the path to the shortcut file (.lnk) to the [StartMenuMFUlist] section of Winbom.ini.

Content

The configuration sets can contain all of the system files, drivers, .ini files, and customized settings that you need to install on the destination computers, including:

  • Oeminfo.ini
  • Standard drivers
  • Standard applications
  • Hardware diagnostics
  • Logo for System Properties
  • Oobeinfo.ini
  • Windows Welcome logo
  • Windows Welcome custom files
  • ISP offers
  • Internet Explorer customized settings
  • Internet Settings (.ins) file
  • Unattend.txt
  • Winbom.ini
  • Base operating system customizations

Structure

Setup Manager stores the configuration sets that you create in %SYSTEMDRIVE%\OPKTools\cfgsets\model_name. The files within a configuration set follow this basic structure:

model_name\
$OEM$\
$$\
System32\
OOBE\
Oobeinfo.ini
Oeminfo.ini
Oemlogo.bmp
$Progs\
Internet Explorer\
Custom\
iecustomize.inf
$Docs\
Install Wizard (Internet Communications Settings)
cfgbatch.txt
OEM.tag
unattend.txt
winbom.ini

Important

  • The $OEM$ folder and its contents are deleted after Setup finishes.
  • The $Progs and $Docs folders are not created automatically by Setup Manager. If you want to include these folders in your configuration set, you must add them manually.
  • If you use Winnt.exe to run Setup, or if you use MS-DOS in your manufacturing process, you must use 8.3 folder names for the configuration set folder and for any destination folders that you create during the preinstallation process.

\$OEM$

The \$OEM$ subfolder contains any additional folders that are needed to fulfill the Microsoft OEM requirements and all the additional files required to complete the preinstallation.

Note

  • If you use the OemFilesPath entry in the answer file, you can create the \$OEM$ folder outside the configuration set.

The \$OEM$ folder can include the optional file Cmdlines.txt, which contains a list of commands to run during GUI-mode Setup. These commands can, for example, run an .inf file, an application setup command, or another executable file.

For more information on Cmdlines.txt, see Preinstalling Applications Using Legacy Techniques.

If you have any other folders that you wish to copy to the system drive, you can copy them during preinstallation. For example, you may want to copy a folder containing additional device drivers.

To copy a folder to the system drive

  1. In the \$OEM$ subfolder of the distribution share, create a subfolder called \$1. This folder maps to %SYSTEMDRIVE%, the destination drive for the Windows installation.
  2. Copy the folder and files you want to place on the system drive into the \$1 folder.
  3. In the [Unattended] section of Unattend.txt, set the value of OemPreinstall to Yes.

Important

  • If you use the \$OEM$ folder to preinstall any additional files to the system, set OemPreinstall = Yes.

\$OEM$\$$

This folder contains the system files (either new files or replacements for retail files) that are copied to the various subfolders when Windows is installed. If you create subfolders within this folder, the structure of this folder must match the structure of a standard Windows installation, where \$OEM$\$$ matches \%WINDIR%, \$OEM$\$$\System32 matches \%WINDIR%\System32, and so on. Each subfolder must contain the files that Setup copies to the corresponding system folder on the destination computer.

\$OEM$\$$\System32

This subfolder contains files for Setup to copy to the C:\%WINDIR%\System32 folder.

\$OEM$\$$\System32\OOBE

This subfolder contains the files that you need to run the Windows Welcome .ini file.

\$OEM$\$Progs

This folder contains programs that you want to add to %PROGRAM FILES% during Setup.

\$OEM$\$Progs\Internet Explorer

This folder contains the \Custom folder, which contains the settings file you created to customize Internet Explorer on the computer.

For more information, see Customizing Microsoft Internet Explorer, .

\$OEM$\$Docs

This folder contains any files or user information that you want to add to %Documents and Settings% during Setup.


Structure and Content of the Distribution Share

The distribution share contains all the configuration sets that you have created, plus the source files for every Windows product that you plan to preinstall. The Windows source files are located in language-specific subdirectories of %SYSTEMDRIVE%\OPKTools\Lang.

For more information, see Creating a Configuration Set and Structure and Content of the Configuration Set.

Note

  • In general, it is easier to locate the configuration sets and distribution share on the same computer where you install the OPK tools and run Setup Manager.

Important

  • The $OEM$ folder on the local computer is deleted after Setup finishes.
  • If you use Winnt.exe to run Setup, or if you use MS-DOS in your manufacturing process, you must use 8.3 directory names for the configuration set directory and for any destination directories that you create during the preinstallation process.
  • File sharing is disabled by default in Windows XP Service Pack 1. To connect to a distribution share, you must first enable file sharing.
  • When you create a distribution folder on a server running Windows .NET, Windows sets default permissions of read-only for the group Everyone. If you intend to write to the distribution share remotely, you must add additional read-write permissions for the users who need access.


Configuring the Hard Disk

You can automate the configuration of hard disks during preinstallation.

The NTFS file system is the recommended disk format for 32-bit editions of Windows XP and the Windows .NET Server family. NTFS has all the basic capabilities of FAT, and it provides major advantages over the FAT and FAT32 file systems.

WinPE and Disk Configuration

If the first step in your preinstallation process is to boot the computer using WinPE, you can use the [DiskConfig] section in the Winbom.ini file to configure and partition the disk. This section scripts various DiskPart commands.

Important

  • The drive letters assigned during WinPE are not saved to any registry that persists when you restart. The drive letter assignment when you create partitions is in the order of creation, but the drive letter assignments when you restart will be in the default order.
  • When you use the [DiskConfig] section, always set WipeDisk and SetActiveN to Yes. This ensures that all partitions are erased and the partition named by N is active.

For more information, see Using WinPE in Your Manufacturing Process.

Extending NTFS Partitions

You can use any of these answer files to extend NTFS partitions on the destination computer automatically during the preinstallation process:

Answer File | Section/Entry | When the partition is extended
Unattend.txt | [Unattended] ExtendOEMPartition | Unattended Setup
Winbom.ini | [ComputerSettings] ExtendPartition | Next boot of the computer, after Factory mode of Sysprep
Sysprep.inf | [Unattended] ExtendOEMPartition | Mini-Setup

Partitions can be extended to a specified size or to fill the available space.

Converting FAT/FAT32 Partitions to NTFS

If your manufacturing process requires FAT32, use the Oformat command-line tool to format the hard disk so that it is optimally configured for NTFS. Use the Convert command-line tool to convert the file system to NTFS. As soon as the file system is converted, you cannot convert it back to FAT32. For more information, see Converting FAT/FAT32 Partitions to NTFS.

With the hard disk formatted, use the DiskPart tool to script additional hard disk configurations, such as partitioning and drive-letter assignments.

FAT32 Conversion Scenarios

If you do not configure the hard disk to use NTFS as part of unattended Setup, then the preferred method is to run Convert before final Sysprep. Add the Convert /fs:ntfs command to the [OEMRunOnce] section of Winbom.ini, as in this example:

[OEMRunOnce]
Command0 = "Convert /fs:ntfs"

This ensures that the conversion takes place in Factory mode and not during the end-user first-run experience.

Another method of FAT32 conversion is to add the Convert /fs:ntfs command to the [GUIRunOnce] section of Sysyprep.inf, as in this example:

[GuiRunOnce]
Command0 = "Convert /fs:ntfs"

After Sysprep -reseal is run, the conversion occurs when the end-user turns the computer on, during the first-run experience.


Comparing the NTFS and FAT32/FAT File Systems

banner

Comparing the NTFS and FAT/FAT32 File Systems

The NTFS file system (NTFS) is the recommended disk format for 32-bit editions of Windows XP and the Windows .NET Server family. NTFS has all of the basic capabilities of FAT, and it provides these advantages over the FAT and FAT32 file systems:

  • Easier recovery from system resets or crashes
  • Support for large hard disks
  • Stricter control over access to private files
  • Improved disk utilities, including encryption, file and folder-level compression, and disk defragmentation

Important

  • On end-user computers, Microsoft does not test or support FAT32 on volumes larger than 32 GB. Microsoft supports OEMs who use FAT32 volumes larger than 32 GB as part of their manufacturing processes, as long as such volumes are converted to NTFS before the computer leaves the factory. For more information, see Converting FAT32/FAT Partitions to NTFS.

Performance

Disk subsystem performance is an important factor in overall system performance. In Windows XP and the Windows .NET Server family, the NTFS and FAT file systems have intrinsically similar system performance characteristics, except NTFS performance is better on larger volumes.

Many people believe that NTFS is slower than FAT. However, this is typically caused by poor configuration of the NTFS file system in the tests. A correctly configured NTFS system performs similarly to the FAT file system. NTFS performance benchmarks are higher on Windows XP and the Windows .NET Server family when compared to previous releases of Windows.

File System Specifications

Description | NTFS | FAT32 | FAT
Maximum file size | 244 - 64K bytes | 232 - 1 bytes | 232 - 1 bytes
Minimum partition size | 10 MB (Recommended minimum is 500 MB); can’t use on floppy disks | 512 MB | Floppy disk size
Maximum partition size | 2 TB (terabytes) | 2 TB (terabytes) Windows XP can format a FAT32 partition of 32 GB maximum Windows XP can read FAT32 partitions of any size | 4 GB
Minimum volume size | 1 MB | 65,535 clusters | 4,085 clusters
Maximum volume size | 232 clusters | Windows 2000: Can format a maximum of 32 GB; can mount and convert larger volumes Windows Me: A maximum of 228 - 12 clusters Windows 98 and Windows 95: 4,177,918 clusters | 2 GB If, during Windows XP Setup, you choose to format the disk to use FAT and your partition is greater than 2 GB, Setup automatically formats the disk as FAT32.
Files per volume | 232 - 1 | 228 | 2316
Directory size | No limit | 216 - 2 physical directory entries | 216 - 2 physical directory entries; special limits on root directory
Security | User-level security File-level security Folder-level security Share-level security | Share-level security | Share-level security

Cluster Size

The cluster size depends on the operating system, not the file system.

Operating system(s) | Cluster size
Windows XP, the Windows .NET Server family, Windows 2000, and Windows NT | A power of 2 between 512 bytes and 65,536 bytes, inclusive
Windows Me, Windows 98, and Windows 95 | A power of 2 between 512 bytes and 32,768 bytes, inclusive

Compatibility of the file system with various Microsoft operating systems

Windows XP, Windows 2000, and Windows NT 4.0 are the only operating systems that can read and access data from local volumes formatted with the NTFS file system. If you configure a computer to dual boot with Windows XP and another operating system, make sure that the file system that you choose is usable by both operating systems.

Support for NTFS, FAT32, and FAT in Microsoft Operating Systems

Operating System | NTFS | FAT32 | FAT
Windows XP | X | X | X
Windows .NET Server family | X | X | X
Windows 2000 | X | X | X
Windows Me |  | X | X
Windows NT 4.0 with Service Pack 4 (or later) | X |  | X
Windows NT 3.5 Windows NT 4.0 with Service Pack 1, Service Pack 2, or Service Pack 3 |  |  | X
Windows 98 Windows 98 SE |  | X | X
OS/2 |  | X | X
Windows 95 |  | X | X
Windows 3.1 |  |  | X
MS-DOS |  |  | X


Converting FAT/FAT32 Partitions to NTFS

The recommended file system for Windows XP and the Windows .NET Server family is the NTFS file system. However, your manufacturing processes may rely on Windows 9.x or MS-DOS, requiring you to format hard disks with the FAT32 or FAT file system.

You can preserve this process and still give your customers the benefits of NTFS by converting FAT32 or FAT volumes to NTFS.

For Windows XP and the Windows .NET Server family, the FAT-to-NTFS conversion takes approximately two minutes, and the performance of the converted NTFS volume is identical to a natively-formatted NTFS volume.

For information on the differences between NTFS, FAT32, and FAT file systems, see Comparing the NTFS and FAT32/FAT File Systems.

Method 1: Converting to NTFS During Unattended Setup

In the [Unattended] section of the Unattend.txt file, set FileSystem equal to ConvertNTFS. This value causes Setup to convert the hard disk automatically, immediately before GUI-mode Setup starts.

[Unattended]
FileSystem = ConvertNTFS

Note

  • FileSystem is not a valid entry in Sysprep.inf.

Method 2: Converting to NTFS after Setup is Complete

After you install Windows XP or Windows .NET Standard Server, Windows .NET Enterprise Server, or Windows 2000 Datacenter Server, start the computer. At a command prompt, type:

Convert Drive /FS:NTFS


Extending an NTFS Partition

When installing Windows, you may find it necessary to extend the partition of the destination computer. When used in an answer file, the ExtendOemPartition entry in the [Unattended] section of Unattend.txt causes Setup to extend the destination partition into the adjacent unpartitioned space on the disk.

Set ExtendOemPartition to a number other than 1 to indicate a specific disk size for extending the hard disk in addition to the current space used. This is useful if you want to configure more than one partition on the hard disk.

Important

  • You can use ExtendOemPartition in both the Unattend.txt and Sysprep.inf answer files. When used in Sysprep.inf for imaged computers, the destination computer's hard disk must be the same size or larger than the master computer's hard disk.
  • You can extend only NTFS file system partitions. If the destination partition that you plan to extend is FAT or FAT32, set the FileSystem entry in the [Unattended] section of Unattend.txt to ConvertNTFS in Unattend.txt to convert the partition during text-mode Setup.
  • Setup does not extend FAT32 and FAT partitions, and Sysprep cannot convert a volume from FAT32 or FAT to NTFS.

Extending an NTFS Partition in Build-to-Plan Manufacturing

For example, if you want to extend the partition of a computer on which the Sysprep utility is run automatically, you can:

  1. Keep the size of the master image as small as possible by creating a partition on the master computer that is large enough to accommodate the Windows installation and any other core utilities in the master image.
  2. Add this entry to the [Unattended] section in your Sysprep.inf:
    ExtendOemPartition = 1
  3. In the Unattend.txt you use to generate the master image, include this entry:
    [GuiRunOnce]
...<commands used for configuration or application installation>
Commandn-1 = "Convert c:\ /fs:ntfs"
Commandn = "%SYSTEMDRIVE%\sysprep\sysprep -quiet"

    After the unattended Setup finishes on the master computer, Sysprep runs the commands specified in [GuiRunOnce] to install applications or configure the system. When the Convert command is run, a registry entry is set that instructs the operating system to convert drive C during reboot. After Setup converts the drive, Sysprep runs and shuts down the computer.

  4. Generate the image.

When you place the master image on a destination computer, drive C is converted when the computer starts. The computer then restarts and starts Windows Welcome or Mini-Setup. During the first-run experience, Windows extends drive C to the rest of the unpartitioned space on the hard disk in an almost instantaneous process. The computer then restarts one last time, after which the end user can log on and begin using Windows.


Using Winnt32.exe to Run Setup

You can run Winnt32.exe from a command prompt to start Windows Setup on a computer that is running any of these operating systems:

  • Windows XP
  • Windows 2000
  • Windows NT
  • Windows Millennium Edition
  • Windows 98
  • Windows 95

For a complete list of the Winnt32.exe command-line options, see Winnt32.exe Command-Line Options.

To install Windows from a network share, start the computer by using the WinPE CD (or one of the operating systems in the preceding list), and then connect to the distribution share. Placing the distribution share and the configuration set on the network adds considerable flexibility to the preinstallation process.

To run Setup using Winnt32.exe

  1. On the technician computer, create an Unattend.txt file to include in a configuration set built with Setup Manager.
  2. Start the destination computer with one of the previously listed operating systems.
  3. Click Start, click Run, and then type:

    path_to_winn32\winnt32 /unattend:filename

    path_to_winnt32
    Specifies the path to the location of Winnt32.exe. For example, \\server\share\Lang\Eng\sku\pro\x86\I386.
    filename
    Specifies the name of the answer file, usually Unattend.txt.

For more information on building a version of WinPE customized to meet your manufacturing needs, see Creating a Customized Version of WinPE.

After Setup finishes, preinstall applications, audit the system, and run Sysprep to convert the system to a customer-ready state. For more information, see Preinstalling Applications, Auditing Destination Computers, and Using Sysprep.

Notes

  • To ensure a clean installation, do not install Windows XP or the Windows .NET Server family as an upgrade.
  • Another network-based system for preinstalling Windows XP and the Windows .NET Server family is Remote Installation Server, which is discussed in the Microsoft Windows .NET Server Resource Kit.


Optimizing Your Images

These suggestions may help you to reduce the size of your image and decrease the time required to image your master installation onto the destination computers.

  • Use the Windows Preinstallation Environment (WinPE) instead of MS-DOS to start the destination computer.

    In WinPE, you can complete any preliminary steps in your manufacturing process, such as flashing the BIOS, preparing the hard disk, and running hardware diagnostics, without restating the computer. Using WinPE may enable you to reorganize the sequence of steps in your manufacturing process, reduce the number of required reboots, and save time in manufacturing.

  • Use in-box drivers whenever possible to minimize the number of driver files copied to every destination computer.
  • If you include additional drivers, use a common set of drivers that is used across multiple product lines. Install this common set on all computers as part of the master installation, reducing the time required to locate and install a specific custom driver before you deliver the destination computer to the customer.
  • Limit the number of devices listed in the [SysprepMassStorage] section of Sysprep.inf.

    If you include a blank [SysprepMassStorage] section in the Sysprep.inf file and if you set BuildMassStorageSection = Yes in the [Sysprep] section, Sysprep automatically generates the entries in [SysprepMassStorage] from the Plug and Play hardware IDs specified in Machine.inf, Scsi.inf, Pnpscsi.inf, and Mshdc.inf.

  • Minimize the number of additional applications that you install.
  • If a particular application is included on most of your computers, consider including a staged version of the application in the master installation. To stage an application means having all the files available locally. In this case, the application setup is required only to make the relevant changes in the registry, eliminating time-consuming file copying. If you do not want to include this application on the destination computer, you can detach (or delete) the files.

    The CD Boot method does not support staged applications.

    For more information, see Preinstalling Applications.

  • Use the Diskpart and Format command-line tools to create a single NTFS partition at the beginning of the preinstallation process. Using Diskpart removes a reboot between fdisk and format, which is required in MS-DOS.
  • Use a small image to install Windows on a small partition, and then use ExtendOemPartition if you install to an NTFS file system partition.
  • Delete Hiberfil.sys and Pagefile.sys from the master installation before creating the image. Use the command del /a:sh hiberfil.sys to delete Hiberfil.sys. Windows automatically recreates these files if necessary.

    Note

    • The Pagefile.sys file is as large as the available RAM on the computer. Make sure that at least this much free space exists on the %SYSTEMDRIVE% partition on the destination computer so that Mini-Setup can properly regenerate the file.
  • Delete the contents of the %WINDIR%\System32\Dllcache folder before you create an image of the master installation. You must leave the empty Dllcache folder on the system for Windows File Protection (WFP) to function properly.

    If you delete the contents of the %WINDIR%\System32\Dllcache folder, set the SourcePath entry in the [ComputerSettings] section of Winbom.ini equal to the location of the i386 folder on the destination computer. The i386 folder must be located in %WINDIR%.

  • To delete files from an image, you must have tools that can edit the image or access the disk to delete the files. You cannot delete files from a Windows installation while that installation of Windows is running.
  • For more information on imaging and disk duplication, see The Disk-Duplicating Method.


The Disk-Duplicating Method

The disk-duplicating method is recommended for most preinstallation environments because it involves the least effort from your production line. In this method, you duplicate the disk after running Sysprep. You must have special equipment or software for duplicating hard disks.

Because you must copy a full installation of Windows, the master computer and destination computers must have compatible hardware abstraction layers (HALs). For example, if the master computer is Advanced Configuration Power Interface (ACPI)-based, then the destination computer must also use ACPI. However, the processors and RAM do not need to be the same.

To preinstall to multiple computers, simply preinstall one computer, and then remove and duplicate the hard disk of that computer.

You can use the disk-duplicating method with all three Setup methods: Winnt32.exe, Winnt.exe, and CD Boot.

To use the disk-duplicating method with Winnt32.exe

  1. Choose a computer to use as the master computer.
  2. Start the master computer from your existing Windows installation (Windows NT, Windows 2000, Windows XP, or the Windows .NET Server family), and connect to the preinstallation distribution folder.
  3. At the command prompt, change to the distribution folder, and type:

    winnt32 /unattend:Unattend.txt /s:install_source /tempdrive:system_partition

    where:

    Unattend.txt
    Specifies the answer file used for unattended Setup. It provides answers to some or all of the messages that the end user normally responds to during Setup. Using an answer file is optional when creating the master image.
    install_source
    Specifies the location of the Windows files. Specify multiple /s options if you want to install from multiple sources simultaneously.
    system_partition
    Specifies the drive letter for the desired destination of Windows.
  4. After Setup, customize the system and install any additional applications.

    For more information about installing applications and customizing your installation, see Customizing and Testing the Destination Computer and Preinstalling Applications.

  5. Optionally, you can run a third-party auditing utility to ensure that the master computer operates properly.

    For more information on auditing, see Auditing Destination Computers.

  6. Run Sysprep to convert the computer to a duplication-ready state.

    For more information on Sysprep, see Using Sysprep.

  7. Remove the hard disk that you plan to duplicate from the computer. Copy the contents of the hard disk to destination disks by using disk-duplicating equipment or software.
  8. Install the duplicated hard disks into the destination computers.

To use the disk-duplicating method with Winnt.exe

  1. Choose a computer to use as the master computer. This computer’s HAL must be compatible with the HALs on the destination computers.
  2. Start the master computer, and connect to the preinstallation distribution folder.

    This connection is typically made with an MS-DOS boot disk that has real-mode drivers and network support.

  3. At the command prompt, change to the distribution folder, and type:

    winnt /u:Unattend.txt /s:install_source

    where:

    Unattend.txt
    Specifies the answer file used for unattended Setup. It provides answers to some or all of the messages that the end user normally responds to during Setup. Using an answer file is optional when creating the master image.
    install_source
    Specifies the location of the Windows files. Specify multiple /s options if you want to install from multiple sources simultaneously.

    Note

    • Install Windows on the primary drive.
  4. After Setup, customize the system and install any applications.

    For more information on installing applications and customizing your installation, see Customizing and Testing the Destination Computer and Preinstalling Applications.

  5. Optionally, you can run your own auditing utilities to ensure that the master computer operates properly.

    For more information on auditing, see Auditing Destination Computers.

  6. Use Sysprep to convert the computer to a duplication-ready state.

    For more information about using Sysprep, see Using Sysprep.

  7. Remove the hard disk from the computer, and copy the disk by using disk-duplicating equipment or software.
  8. Install the duplicated hard disks into the destination computers.

To use the disk-duplicating method with CD Boot

  1. Choose a computer to use as the master computer.
  2. Configure the boot order in the BIOS with the CD-ROM drive as the first device, the hard disk as the second device, and the floppy disk drive as the third device.
  3. Start the master computer from the CD-ROM.

    Setup starts automatically.

  4. When the blue screen appears, insert the floppy disk that contains the Winnt.sif file. This file contains the unattended Setup information.
  5. After Setup, remove the floppy disk.

Before you distribute the preinstalled computers, you may want to perform optional auditing.

For more information on the auditing process, see Auditing Destination Computers.

Reducing Image Fragmentation

To help ensure that your base image has as little fragmentation as possible before it is copied to destination computers, defragment the disk containing the master installation before creating the system image.

Selecting Software Imaging Tools

There are a variety of imaging tools that you can use to create your Windows image. To help ensure the greatest success when using these tools with Windows, make sure that your imaging tools meet these requirements:

  • Access NTFS file system (NTFS) file system partitions.
  • Support long file names.
  • Open packages to add or remove files (such as new or updated drivers) without recreating the entire package.


Setting the Administrator Password

In the [GuiUnattended] section of the Unattend.txt file, you can set the Administrator password by using the AdminPassword entry:

AdminPassword
Value: "password" | *

The password may contain as many as 127 characters. Passwords are case-sensitive and must be enclosed in quotes. Use Setup Manager to encrypt the password. If the value is *, Setup sets the Administrator password as blank (or NULL). It is recommended that you make the Administrator password blank for computers that are distributed to end users.

Important

  • Using a common, non-blank administrator password for all computers provided to end users may present a security breach. Before you run Sysprep, you could use an automation process to set the Administrator password to blank. End users can then specify their own administrator passwords.

When you set the Administrator password, remember that:

  • If you specify a password by using AdminPassword, that password is used when you automatically log on. After the installation finishes, the password is deleted from the copy of the answer file left on the computer.
  • If AdminPassword = * (is blank) and AutoLogon = Yes, the computer logs on only once, regardless of the value given for AutoLogonCount. However, if AdminPassword = password, the computer logs on repeatedly and the non-blank password is saved in the registry.
  • The computer automatically logs on the number of times specified for AutoLogonCount only when AdminPassword = password.
  • If you use Setup Manager to encrypt the password, AutoLogon does not work.
  • Enclose all passwords in quotation marks to ensure that any special characters are not processed. For example, the # character is processed as a comment token during text-mode Setup.


Preinstalling Windows in More Than One Language

From any language version of Setup Manager you can:

  • Configure and preinstall any available language version of Windows.
  • Create a new configuration set based on a configuration set created in another language.

If your OEM license includes the rights to ship the Windows Multilingual User Interface (MUI) Pack, you can install this software so that different end users can view different languages on the same computer. For more information, see the Microsoft Global Software Development Web site (http://www.microsoft.com/globaldev/).

To preinstall Windows in a language other than the language of your OPK tools

  1. Install your native-language version of the OPK. This enables you to use the OPK tools and documentation that are in your own language.
  2. Create configuration sets for your native version.
  3. Insert the OPK CD for the additional language you want to install.
  4. When you are prompted to install support for the additional language, click Yes. This will not overwrite or replace the native language version that you already installed.

    The following folder and files are automatically added to your OPKTools\Lang structure:

    • OPKTools\Lang\<language>\tools\x86\factory.exe
    • OPKTools\Lang\<language>\tools\x86\netcfg.exe
    • OPKTools\Lang\<language>\tools\x86\setupcl.exe
    • OPKTools\Lang\<language>\tools\x86\sysprep.exe
    • OPKTools\Lang\<language>\tools\ia64\efinvr.exe
    • OPKTools\Lang\<language>\tools\ia64\factory.exe
    • OPKTools\Lang\<language>\tools\ia64\netcfg.exe
    • OPKTools\Lang\<language>\tools\ia64\setupcl.exe
    • OPKTools\Lang\<language>\tools\ia64\sysprep.exe
    • OPKTools\Lang\<language>\wizfiles\install.ins
    • OPKTools\Lang\<language>\wizfiles\unattend.txt
  5. Using Setup Manager, create a new configuration set.
  6. On the Target Language page, select the language that you want to add.
  7. On the Product Page, click Add, browse to the language version you want to add, and click OK.

For more information on how multiple language versions are managed on the technician computer, see Structure and Content of the Distribution Share.

After you build and test a configuration set for one language, you can reuse the configuration set for other languages.

  • Complete the steps outlined for installing Windows in another language.
  • Create your base configuration set in one language. Use the Cfgbatch.txt file created by this configuration set for your other languages.
  • From a command line, run Setup Manager with the batch command-line option:
    setupmgr /b:filename

    where filename is the full path and name of the configuration batch file (Cfgbatch.txt).

  • In each language version of Cfgbatch.txt, change the LANG entry to the appropriate entry for the language folder where the Cfgbatch.txt file resides.

    This is only required when a batch file is used with a command-line option for Setup Manager.

For more information on running Setup Manager from a command line, see Setup Manager Command-Line Options.


Preinstalling Multi-Language User Interface (MUI)

banner

Preinstalling the Multi-Language User Interface (MUI) Pack

The Multi-Language User Interface (MUI) Pack is a set of language-specific resource files that you can add to the English version of Windows. MUI enables the user interface language of the operating system to be changed according to the preferences of individual users to one of the 33 supported languages. This enables large corporations to roll out the same worldwide image with a single installation. Local users can then select the user interface language or it can be set by Group Policy for Organizational Units.

MUI also enables users of different languages to share the same workstation, or roaming users to take their localized user interface from one workstation to another. For instance, one user might choose to see system menus, dialog boxes and other text in Japanese, while another user logging onto the same system might prefer to see the corresponding text in French.

There are two ways to preinstall the Windows XP/2000 MUI in unattended mode:

  • As part of base English Windows Setup.
  • After base English Windows Setup is complete.

Preinstalling as part of Base English Windows Setup

Because MUI is distributed on several CD ROMs, unattended installation must use a distribution share. All of the MUI files must first be copied to the distribution share. The [GUIRunOnce] section in Unattend.txt must specify the execution of Muisetup.exe, the program that installs the user interface languages. Third, Winnt32.exe must be run with certain options specified to ensure correct installation of the files.

MUI installation involves the configuration of language groups, locales (user, system, and input), and user interface languages. In order for particular locales and user interface languages to be installed correctly, the appropriate language groups must be installed. The locales that you install must be compatible with each another and correspond to the default user interface language. Valid language group/locale/user interface language combinations are listed in [RegionalSettings].

Note

  • If you do not install the language groups necessary for the locales/languages and user interface languages that you specify, Setup may display dialog boxes prompting for paths to the required files. Although installation will succeed, it may require user interaction.

Creating the Distribution Share

Unattended installation of MUI requires that you copy all of the language resource files from the MUI CDs to a distribution share. The files should be placed in a temporary directory under the root directory. In the example, the files are contained in a temporary directory named MUITEMP.

\installation source
     \MUITEMP
        ...all MultiLanguage files

During the file copy stage of the installation, the MUITEMP directory is copied to %WINDIR% on the distribution drive. During the final stage of installation, this temporary directory is removed.

Creating the Answer File

For MUI there are two important sections in Unattend.txt: [RegionalSettings] and [GUIRunOnce].

The [Regional Settings] section specifies values for the language group and locales (user locale, system locale, and input locales) to be installed on the system. Values are specified through use of appropriate ID numbers.

For single-user systems, we recommend that you set the locales to the same value as the default user interface language (specified when running Muisetup.exe). For example, if German is set as the default user interface language, one of the German locales should be specified.

For shared workstations, and in Terminal Server environments, we recommend that the default user interface language and the system locale are set to English (the administrative language of the MultiLanguage Version). The user locale can be set according to individual preference/requirements or, if specified through the Language entry, kept the same as the system locale.

The language group necessary for the locales that you specify must be installed. For example, if the locales are set to Arabic, and Arabic is going to be the default language for menus and dialog boxes, the Arabic language group must be specified in the [RegionalSettings] section:

[RegionalSettings]
LanguageGroup = 13
Language = 0401

—OR—

[RegionalSettings]
LanguageGroup = 13
SystemLocale = 0401
UserLocale = 0401
InputLocale = 0409:00000409,0401:00000401

The [GUIRunOnce] section contains a list of commands to be executed the first time a user logs on to the computer after GUI-mode Setup completes. Each line enclosed in quotation marks specifies a command to be executed by the GUIRunOnce registry entry.

Use this section to execute the Muisetup program with appropriate parameters and values. Note that the path to Muisetup.exe includes the temporary directory created in the installation source. The second line of the sample entry removes this temporary directory from the drive after installation:

[GuiRunOnce]
"%WINDIR%\MUITEMP\MUISETUP.exe [-i LangID LangID...] [-d LangID] -r -s"
"%WINDIR%\SYSTEM32\CMD.EXE /c RMDIR %WINDIR%\MUITEMP /s /q"

\MUITEMP is the temporary installation folder created during Setup.

Muisetup command-line options

Option | Description
-i | Specifies the user interface language(s) to be installed. Languages should be entered in four-digit hexadecimal LangID values
-d | Specifies the default user interface language (applied to all new user accounts and used in places such as the Winlogon screen).
-r | Specifies that the reboot message is not displayed
-s | Specifies that the installation complete message is not displayed.
-l | (Letter L. Windows XP only) Matches the language of non-Unicode programs with the default user language; this setting is ignored unless /d is used.
-f | (Windows XP only) Matches the default shell user interface font with the default user language; this setting is ignored unless /d and /l are used. Only applicable for Japanese language user interface.

Running Winnt32.exe

The final stage of the unattended MUI installation is to run Winnt32.exe with the correct options.

Specify Unattend.txt with the /unattend option. Use the /copydir option to ensure that the temporary installation directory (MUITEMP) is copied to the destination drive. If the locales and user interface languages you will be installing require the installation of language groups, use the /copysource option to copy the necessary language group files. If you need to copy only one language group, specify lang\[language directory name].

For example:
winnt32.exe /unattend: path to answer file
    /copysource:lang /copydir:MUITEMP /s:path to install source

Preinstalling MUI After Base English Windows Setup is Complete

Creating the Installation Share

Unattended installation of the Windows XP MUI requires that you copy all files from the MUI CDs to a distribution share. The files should be placed in a temporary directory under the $OEM$ directory. In this example, we use a server \\muicore. The directories for the MUI CD contents are:

\\muicore
     \unattend
        \$OEM$
          \muiinst

Create Cmdlines.txt in \\unattend\$OEM$ with this text:

[Commands]
"muiinst\muisetup.exe [/i LangID1 LangID2 ...] [/d LangID] /r /s"

You must use quotation marks in your Cmdlines.txt file. Use the appropriate Language IDs (LANGID) and the MUISetup command-line options to ensure a quiet installation. See the previous section or Muisetup.hlp for a complete description of all the command-line options for Muisetup.exe.

Creating the answer file

For MUI there are two important sections in Unattend.txt: [RegionalSettings] and [GUIRunOnce].

The [Unattended] section header identifies that an unattended installation is running, and is required in the Unattend.txt file. Otherwise, the answer file is ignored.

[Unattended]
    OemPreinstall = Yes
    OemFilesPath = \\muicore\unattend
    OemSkipEula = YES

The [Regional Settings] section specifies values for the language group and locales (user locale, system locale, and input locales) to install on the system. Values are specified with ID numbers, as listed in [RegionalSettings].

The language group necessary for the locales you specify must be installed. For example, if the locales are set to Arabic, and Arabic is going to be the default language for menus and dialog boxes, the Arabic language group must be specified in the [RegionalSettings] section:

[RegionalSettings]
LanguageGroup = "5","8","13"
Language = "0401"

Running Winnt32.exe

The final stage of the unattended MUI installation is to run Winnt32.exe with the correct options, as in this example:

winnt32.exe /unattend:path to answer file /copysource:lang /s:path to install source

If you require the installation of East Asian language and locale support, you must specify /copysource:lang or /rx:lang to copy the necessary language files. If you do not, and the [RegionalSettings] section of your answer file contains East Asian values, Setup ignores the [RegionalSettings] section.


Preinstalling Language Interface Packs

Language Interface Packs (LIPs) for Windows XP work only with the 32-bit English version of Windows XP Professional. LIPs cannot be installed on Windows XP Home Edition or on any Windows XP 64-Bit editions.

A LIP installs support only for a single language. You cannot install more than one language at one time. To install another LIP for Windows XP Professional, you must first uninstall any existing LIP installations.

The LIPs are currently available in:

  • Bulgarian
  • Croatian
  • Estonian
  • Latvian
  • Lithuanian
  • Romanian
  • Thai
  • Slovakian
  • Slovenian

LIPs cannot be installed on a computer that currently has, or has previously had, a Windows XP Multi-Language User Interface Pack (MUI) installed on it.

Preinstallation Methods

All LIPs except Slovakian and Slovenian can be preinstalled with the same method. For information on preinstalling the Slovakian and Slovenian LIPs, see Preinstalling Slovakian or Slovenian LIPs.

To preinstall LIPs

  1. Copy the entire contents of the LIP CD to a subdirectory on your technician computer. For example, create an Updates folder under the OPKTools directory. Under the Updates directory, create a folder called LIP.
  2. Use Setup Manager to create or modify an existing Windows XP Professional configuration set.
  3. Add this command-line information to the Application Preinstall screen of Setup Manager:
    Executable:  msiexec /i
\\server_name\\OpkTools\Updates\LIP\MUISETUP.EXE
Parameters: /q
Executable:  %WINDIR%\mui\fallback\LCID\profupd.exe
Parameters:  /l  LCID_value

When you install Windows XP Professional on a destination computer by using this configuration set, the LIP will be installed in Audit mode automatically and will be enabled on the next reboot of the computer (Audit, Reseal, or Factory boot).

You must use the correct locale ID (LCID) for the language that you install in order for the installation to be successful. The available LCIDs are listed in this table:

LCID | Language
0402 | Bulgarian
041a | Croatian
0425 | Estonian
0426 | Latvian
0427 | Lithuanian
0418 | Romanian
041e | Thai

This method creates this section in Winbom.ini:

[OemRunOnce]
"PackageName1","msiexec /i \\server\\OpkTools\Updates\LIP\MUISETUP.EXE\LIPSetup.msi /q"
"PackageName2","c:\windows\mui\fallback\LCID_value\profupd.exe /l LCID_value"

Preinstalling Slovakian or Slovenian LIPs

To preinstall Slovakian or Slovenian LIPs

  1. Copy the entire contents of the LIP CD to a subdirectory on your technician computer. For example, create an Updates folder under the OPKTools directory. Under the Updates directory, create a folder called LIP.
  2. Use Setup Manager to create or modify an existing Windows XP Professional configuration set.
  3. Add this command line information to the Application Preinstall screen of Setup Manager:
    Executable:  msiexec /i
\\server_name\\OpkTools\Updates\LIP\MUISETUP.EXE
Parameters: /l  LCID_value /s /r

When you install Windows XP Professional on a destination computer with this configuration set, the LIP will be installed in Audit mode automatically and will be enabled on the next reboot of the computer (Audit, Reseal, or Factory boot).

You must use the correct LCID for the language that you install in order for the installation to be successful. The available LCIDs are listed in this table:

LCID | Language
0424 | Slovenian
041b | Slovakian

This method creates this section in Winbom.ini:

[OemRunOnce]
"PackageName1","msiexec /i \\server_name\\OpkTools\Updates\LIP\MUISETUP.EXE /l  LCID_value /s /r "


Preinstalling Without a Network

You can perform preinstallations without a network by booting the destination computer with the Windows CD. This CD Boot method is the simplest of all preinstallation methods, but as the table illustrates, it does not provide the benefits gained by using the WinPE-based network methods.

  • Installing Windows from the Windows CD
  • Using Winnt32.exe to Run Setup
  • Using Winnt.exe to Run Setup
  • Automated Branding Without a Network

Comparison of CD Boot and Network Preinstallation Methods

Preinstalling Windows using the CD Boot method is slower and less customizable than booting the computer using WinPE and installing a configuration set, as described in Creating a Master Installation.

CD Boot | Installing a Configuration Set across a Network Connection
Slow. Windows Setup must read from the CD-ROM drive without caching. | Fast, especially if the computer has a fast network card (NIC) or CD-ROM drive.
LAN or other network connection is not required. | LAN or other network connection is required.
Less advance preparation is required. | More work required to configure the network environment, but the manufacturing environment is more flexible. It is significantly easier to create build-to-order computers.
No special client or boot disk is necessary. | You can start the computer with the Windows Preinstallation Environment (WinPE) located on the Windows OPK CD or a custom WinPE CD.
The only third-party drivers that you can add are mass-storage devices. You must load these drivers by pressing F6 during the first boot of the operating system. | You can add drivers to the hard disk using the path specified in the OemPnPDriversPath entry in Unattend.txt or from a custom WinPE CD.
No access to a configuration set to customize or brand the Windows installation. | Full use of a configuration set. You can update drivers and use the Winbom.ini file to automate preinstalling applications. You can also customize particular files in the Windows installation by placing them in the correct location in the $OEM$ structure.
You cannot automatically partition or format the hard drive if it is not already formatted. | You can automatically partition or format the hard drive before Setup starts by using the [DiskConfig] section in Winbom.ini.
User input may be required for partitioning and formatting the hard disk. | Can be completely unattended.


Installing Windows from the Windows CD

Instead of starting the computer with WinPE and installing a configuration set, you can use the CD Boot method to start Windows Setup on computers that support starting from a CD.

This installation technique requires that:

  • The computer must support the El Torito Bootable CD-ROM Format specification.
  • The answer file is called Winnt.sif and is located on a floppy disk.
  • The answer file contains a [Data] section with MsDosInitiated = 0.
  • When you install Windows on a computer that has multiple hard disks or partitions, you must specify the destination location. Add AutoPartition = 1 to the [Data] section of the Winnt.sif file to specify the location. Setup installs to the first logical partition with sufficient disk space that it finds. Your computer must have a minimum of 1 GB of free space and at least a 2 GB partition.

To start from the Windows CD and install Windows

  1. Create a Winnt.sif file and save it to a floppy disk.
  2. Start the computer from the Windows product CD.

    Windows Setup (Winnt32.exe) begins automatically.

  3. When Setup displays the message that it is examining the hardware configuration, insert the floppy disk that contains the Winnt.sif file.
  4. When the light of the floppy disk drive turns off, remove the floppy disk. Setup begins copying files to the hard disk.
  5. After Setup, preinstall applications and run Sysprep to convert the system to a customer-ready state.

For more information about how to configure this computer and prepare it for customers, see Preinstalling Applications and Using Sysprep.

Note

  • When you start from the Windows CD and run unattended Setup, you cannot use the /udf command-line option with Winnt32.exe.


Using Winnt.exe to Run Setup

You can run Winnt.exe from a command prompt to start Windows Setup on a computer that is running any of these legacy operating systems:

  • MS-DOS
  • Windows 3.1
  • Windows for Workgroups

These operating systems do not support long file names, and all files and folders in the configuration set must be in 8.3 format for Windows Setup (Winnt.exe) to copy the files. To restore any file names in 8.3 format to long file names during Windows Setup, include the $$Rename.txt file in the \$OEM$\$1 folder of the configuration set. For more information, see Converting Short File Names to Long File Names.

For a complete list of the Winnt32.exe command-line options, see Winnt.exe Command-Line Options.

You can also use the Winnt.exe command to install Windows over a network. Each destination computer must start using one of the operating systems listed previously, located on some sort of removable media. For example, you could use an MS-DOS boot disk that also contains network support.

To run Setup using Winnt.exe

  1. Make sure that the drivers needed for the CD-ROM drive are available on the disk or drive and that they are loaded correctly.
  2. On the technician computer, prepare an Unattend.txt file to include in a configuration set built withSetup Manager.
  3. Start the destination computer with one of the previously listed operating systems.
  4. Click Start, click Run, and then type:

    winnt /s:install_source /u:filename

    install_source
    Specifies the location of the Windows files.
    filename
    Specifies the name of the answer file, usually Unattend.txt.

After Setup finishes, you can preinstall applications, audit the system, and run Sysprep to convert the system to a customer-ready state.

For more information, see Preinstalling Applications, Auditing Destination Computers, and Using Sysprep.

Note

  • When you run unattended Setup on a computer that has multiple hard disks or partitions, you must specify the destination location. Use the Winnt /t or Winnt32 /tempdrive command-line option to specify the destination.


Automated Branding Without a Network

It is possible to automate the branding of computers without access to network file shares by using a floppy disk that contains a Winnt.sif file.

To brand new computers with the Winnt.sif floppy disk

  1. Create branding files according to the instructions in Adding Your Company Information and Logo to System Properties.
  2. Create a batch file to copy the branding files, for example:
    c:
cd\
md sysprep
copy a:\sysprep\*.* c:\sysprep
copy a:\Oemlogo.bmp c:\windows\system32
copy a:\Oeminfo.ini c:\windows\system32
copy a:\oobe\oobeinfo.ini c:\windows\system32\oobe
copy a:\oobe\40x255.gif c:\windows\system32\oobe\images
  3. Add the batch file to the floppy disk that contains Winnt.sif.
  4. Add this to Winnt.sif:
    [GuiRunOnce]
Command0 = "a:\yourbatchfile.bat"
  5. Leave the floppy disk in the drive until Windows XP has started to the desktop for the first time. With this method, Sysprep is not automatically launched.
  6. After you finish adding additional files, click Start, click Run, and then type sysprep –reseal.


Customizing and Testing the Destination Computer

Several actions must occur after the preinstallation of the operating system to prepare the destination computer for distribution. Some of these can occur in the factory and some can be delayed until the end user first turns on the computer.

An example of the latter is the use of commands in the [GuiRunOnce] section that must be performed to complete Setup on the destination computer, but can be delayed until the end user starts the computer.

The clock for Windows Product Activation begins its countdown the first time Windows starts. You can use Sysprep for a maximum of three times to reset the clock for Windows Product Activation. After the third time you run Sysprep, the clock can no longer be reset.

  • Preinstalling Applications
  • Prepopulating the Product Key and Preactivating Windows
  • The End-User First-Run Experience
  • Preconfiguring and Automating Mini-Setup
  • Auditing Destination Computers


Prepopulating the Product Key and Preactivating Windows

Due to the requirements of Windows Product Activation (WPA), you cannot prepopulate a generic Product Key for all computers that you manufacture. However, you may do either of these options:

  • Propagate one Product Key across multiple installations, without activating any of these installations. You must run Sysprep to remove this Product Key before delivering the destination computer to the end user.
  • Preconfigure a unique Product Key on a destination computer and activate the Windows installation in the factory. The Product Key that you use to activate the Windows installation must match the Product Key located on the Certificate of Authenticity (COA) sticker attached to that particular computer.

For more information, see Windows Product Activation, and Sysprep and Windows Product Activation Frequently Asked Questions (FAQ).

Using a Single Product Key Within Your Factory

In your preinstallation process, you may duplicate an operating system image that contains a given Product Key to multiple destination computers, subject to these conditions:

  • You do not attempt to activate multiple Windows installations with this Product Key.
  • You must run Sysprep on each destination computer to remove the Product Key before distributing the computer to end users.

The operating system must be configured so that when the end user first starts the operating system, Windows Welcome or Mini-Setup prompts the end user to enter the unique Product Key that corresponds to the COA sticker attached to the computer.

For more information, see:

  • Using Sysprep
  • Sysprep and Windows Product Activation Frequently Asked Questions (FAQ)

Preactivating Windows on Behalf of the Customer

You can deliver a computer to the customer where you have preconfigured the Windows installation with the unique Product Key located on the COA sticker attached to the computer. You may also use the Internet to activate each installation of Windows in your factory.

Preconfiguring the Product Key

If you do not want to enter a Product Key manually, you can preconfigure it with the ProductKey entry of the:

  • [UserData] section of Unattend.txt.
  • [UserData] section of Sysprep.inf.
  • [Version] section of Oobeinfo.ini.

You can edit Unattend.txt manually with a text editor or on the OEM Branding Information page in Setup Manager. You can only edit the ProductKey entry in Oobeinfo.ini manually.

Using the Internet to Activate Windows in the Factory

In a production environment, you can use the Internet to activate a Windows installation.

Important

  • A Product Key is always required.
  • The Product Key that you use to activate the installation must match the number on the COA that accompanies the retail product or that is physically attached to the computer case by the original equipment manufacturer (OEM).
  • Standard licensing agreements specify that you can use a given Product Key to activate only one installation of Windows on one computer. This requirement is enforced by WPA.

To activate the Windows installation automatically during Setup

  1. In Unattend.txt, set the ProductKey entry in the [UserData] section equal to the Product Key on the COA sticker attached to that particular computer.
  2. Set the value of AutoActivate equal to Yes.
  3. Install Windows by using an unattended Setup, as described in Using Winnt32.exe to Run Setup.

The destination computer must have physical access to the Internet. If the Internet connection is through a firewall, you may need to configure the relevant proxy settings manually:

  • Specify your proxy settings in the [Proxy] section of Unattend.txt.
  • In the [Unattended] section, set ActivateProxy equal to Proxy.
  • When you run Sysprep on this destination computer, you must include the -activated command-line option.

Important

  • Setting AutoActivate = Yes does not guarantee a successful activation of the installation of Windows. For example, the activation attempt fails if the computer cannot successfully connect to the Internet.

To preserve a successful activation of the installation, you must run Sysprep with the -activated command-line option. For example:

sysprep -activated -reseal

Important

  • If you do not run Sysprep with the -activated option, Sysprep removes the activation settings and resets the WPA clock.

For more information, see Sysprep and Windows Product Activation Frequently Asked Questions (FAQ), and Sysprep Command-Line Options.


Preinstalling Applications

When selecting software to preinstall on the computers that you manufacture, Microsoft recommends that you choose software that meets the requirements of the Certified for Windows Program (http://msdn.microsoft.com/certification/). For more information on the benefits of this certification, see Microsoft Windows Logo Programs.

The preferred time to preinstall applications on Windows computers is during the Factory mode of Sysprep, using the [OEMRunOnce] section in the Winbom.ini file. This technique is faster and provides greater flexibility in the manufacturing environment.

One way to build these computers is to start with a basic image of the operating system, customized with only company branding and configured to start into Sysprep in Factory mode on the next reboot. For each order, place the basic image on the destination computer, install each application as ordered by the customer, and seal the computer to prepare it for distribution. These applications can be installed by hand or by using the [OEMRunOnce] section in Winbom.ini.

However, if the applications are Windows Installer (.msi) packages, a more efficient way to offer the same degree of customization is to stage all of the applications on the master installation. When you stage an application, all the files are placed on the computer but no changes are made to the registry. After the image of the master installation is placed onto the destination computer, you can either attach (complete the installation) or detach (remove all the files) each application to configure the computer as ordered by the customer. Setup of the attached application is faster because the Setup program does not need to copy the files to the computer. And it is much faster to delete files from a computer than to install an application over a network connection, especially if this application is installed on a majority of the computers that you manufacture.

Example: Preinstalling Commonly-Sold Applications

Fabrikam, Inc. is an OEM that manufactures build-to-order computers. Fabrikam offers three general-productivity applications as standard options. From past sales, Fabrikam knows that 80 percent of its customers order the first application, 70 percent of customers order the second application, and 50 percent of customers order the third application.

Fabrikam builds a configuration set for the base image that it uses for this type of computer. In the Add an Application dialog box in Setup Manager, all three applications are identified as using Windows Installer (.msi) scripts.

Setup Manager produces a Winbom.ini file where the files for three different applications are copied to the master installation, but the applications themselves are not fully installed. The computer is configured to restart in Factory mode of Sysprep.

[OEMRunOnce]
"Connect to network share", "net use R: \\server\share"
"First Application Stage", "Application1.Stage", MSI
"Second Application Stage", "Application2.Stage", MSI
"Third Application Stage", "Application3.Stage", MSI

[Application1.Stage]
InstallType = Stage
StagePath = "C:\App1_Temp"
SetupFile = "Application_One.msi"
SourcePath = "R:\ApplicationOne"

[Application2.Stage]
InstallType = Stage
StagePath = "C:\App2_Temp"
SetupFile = "Application_Two.msi"
SourcePath = "R:\ApplicationTwo"

[Application3.Stage]
InstallType = Stage
StagePath = "C:\App3_Temp"
SetupFile = "Application_Three.msi"
SourcePath = "R:\ApplicationThree"

[Factory]
ResealMode = Factory
Reseal = Yes

Fabrikam makes an image of the master installation. In addition, Fabrikam's technical staff has created a custom tool to generate a customer-specific Winbom.ini file corresponding to each customer order and place the file on a floppy disk.

In the factory, the assembler receives an order and the corresponding floppy disk, copies the master image to the destination computer, and places the floppy disk in the drive. The computer is rebooted on the factory floor and starts in the Factory mode of Sysprep, which processes the customer-specific Winbom.ini file.

For this particular order, this Winbom.ini file causes the first application to be fully installed, and the files for the second and third application are completely removed from the computer. The computer then shuts down and is ready for distribution to the customer.

[OEMRunOnce]
"First Application Attach", "Application1.Attach", MSI
"Second Application Detach", "Application2.Detach", MSI
"Third Application Detach", "Application3.Detach", MSI

[Application1.Attach]
InstallType = Attach
StagePath = "C:\App1_Temp"
SetupFile = "Application_One.msi"

[Application2.Detach]
InstallType = Detach
StagePath = "C:\App2_Temp"

[Application3.Detach]
InstallType = Detach
StagePath = "C:\App3_Temp"

[Factory]
ResealMode = OOBE
Reseal = Shutdown

Using [GuiRunOnce] or Cmdlines.txt to Preinstall Applications

For backward compatibility, you can continue to use the same techniques that you used to preinstall applications in Windows 2000. However, these techniques will increase the time required when the end user starts the computer for the first time, and are not recommended. For more information, see Preinstalling Applications Using Legacy Techniques.

Placing Application Shortcuts on the Start Menu

Shortcuts to all preinstalled applications may appear in the All Programs area of the Start menu.

If you want to place a shortcut to the application on the Most Frequently Used (MFU) list of programs on the Start menu, make sure a path to the shortcut file (.lnk) is listed in the [StartMenuMFUlist] section of Winbom.ini.

Repackaging Applications for Preinstallation

If the application does not have a Windows Installer (.msi) setup package, you can use a third-party tool to repackage applications into the .msi format. The .msi format is preferred because it enables you to:

  • Install the applications during Windows unattended Setup.
  • Help reduce .dll version management issues.

For more information about Windows Installer, see http://www.microsoft.com/windowsxp/home/using/productdoc/en/default.asp?url=/WINDOWSXP/home/using/productdoc/en/sag_WinInstall_Overview.asp

You can also use an application's own built-in installation routine, if the Setup program is able to run in unattended mode (without user intervention) by using a /q (quiet) or /s (silent) command-line option.

The setup command-line options vary among applications. For example, a useful option that some applications use is /l to create a log file to monitor the installation. It is important that you check with the application's vendor for information, instructions, and tools before preinstalling an application.

Note

  • If the setup command line installs an application that uses an InstallShield-based installer, you must add an -SMS switch to the command line. The -SMS must be capitalized. This command-line option ensures that the process created by the installer completes its operation before processing the next entry in the [OEMRunOnce] section.

Important

  • You must fulfill the licensing requirements for any application that you include on the computer, regardless of the method that you use to preinstall the application.
  • If the setup program for an application replaces a current Windows system file with the older system file in its installation package, Windows File Protection is activated and replaces the old system file with the current system file that was installed as part of Windows.


The End-User First-Run Experience

Windows Welcome is the default first-run experience for Windows XP Home Edition and Windows XP Professional; Mini-Setup is the default first-run experience for the Windows .NET Server family and Windows XP 64-Bit Edition. Each first-run experience enables the end user to review the End-User License Agreement (EULA), enter the Product Key for this installation of Windows XP, activate the Product Key for this installation of Windows XP, and configure any user settings that are not already present on the destination computer.

You can configure Windows XP Professional to use Mini-Setup instead of the default Windows Welcome by using the sysprep -mini command, as described in Sysprep Command-Line Options. You cannot change the first-run experience for Windows XP Home Edition; this product always presents Windows Welcome as its first-run experience.

Windows Welcome

The exact sequence of pages that the end user sees in Windows Welcome is controlled by Oobeinfo.ini. For a complete list of pages and how you can customize each one, see Windows Welcome in Customization Guidelines: First-Run Experience and Windows Welcome Sections That You Can Modify.

For more information on how to make these customizations, see Configuring Windows Welcome.

Mini-Setup

All pages in Mini-Setup are presented to the end user, unless you preconfigure the user settings. For a complete list of pages, see Mini-Setup in Customization Guidelines: First-Run Experience.

To make testing easier in your production environment, you can automate Mini-Setup by using Sysprep.inf. However, you cannot use this file to automate Windows Welcome. For more information, see Preconfiguring and Automating Mini-Setup.

It is possible to configure Windows XP Professional to use Mini-Setup instead of the default Windows Welcome by using the sysprep -mini command, as described in Sysprep Command-Line Options. You may configure Windows XP Professional to use Mini-Setup on computers that you distribute to customers.

Note

  • Windows XP Home Edition always uses a workgroup, so Mini-Setup on Windows XP Home Edition does not display the Workgroup or Computer Domain page.

Screen Resolution and Windows XP

If the computer hardware supports a minimum 800 x 600-pixel screen resolution and the default screen resolution is set to 640 x 480 pixels, then Windows Welcome reconfigures the computer to use an 800 x 600-pixel screen resolution.

If the computer hardware does not support a minimum 800 x 600-pixel screen resolution, Windows XP Home Edition and Windows XP Professional use Mini-Setup by default instead of Windows Welcome. Use the ScreenResolutionCheck entry in the [StartupOptions] section of Oobeinfo.ini to configure Windows XP to use Windows Welcome with scroll bars when the hardware does not support the minimum required resolution.


Preconfiguring and Automating Mini-Setup

Mini-Setup is the first-run experience for the Windows .NET Server family and Windows XP 64-Bit Edition. You can configure Windows XP Professional to use Mini-Setup instead of the default Windows Welcome, as described in Sysprep Command-Line Options.

For more information about Windows Welcome and Mini-Setup, see The End-User First-Run Experience.

You can use the Sysprep.inf answer file to prepopulate user configuration information and automate Mini-Setup. By using Sysprep.inf, you can have Mini-Setup ask for a subset of the configuration information, or you can create a completely automated installation that does not ask the user any questions about configuration.

You cannot use Sysprep.inf to automate Windows Welcome.

Note

  • Instead of automating Mini-Setup, you may improve your manufacturing efficiency by using Sysprep to start the computer in Factory mode, which skips the end-user first run experience completely. In Factory mode, you can install additional applications, update drivers, or audit the preinstalled computer. For more information, see Using Sysprep in Factory Mode.

The syntax of Sysprep.inf is similar to the unattended Setup answer file, Unattend.txt. Sysprep.inf supports a subset of the sections and entries supported by Unattend.txt plus a few Sysprep-specific entries. You can use Setup Manager to help create the Sysprep.inf file.

Content of Mini-Setup

If Sysprep.inf is not used, Mini-Setup displays these screens:

  • Welcome to Windows Setup
  • License Agreement
  • Product Key
  • Regional and Language Options
  • Personalize Your Software
  • Computer Name and Administrator Password
  • Date and Time Settings
  • Networking Settings
  • Workgroup or Computer Domain
  • Completing Windows Setup

Important

  • The end user must accept the Microsoft End-User License Agreement (EULA) before the Windows installation is considered complete.

To bypass these pages and have Sysprep completely automate an installation, you can specify, at a minimum, these entries in the Sysprep.inf:

To skip this page | Add this entry to Sysprep.inf
Regional and Language Options | [GuiUnattended] Set OemSkipRegional equal to 1.
Personalize Your Software | [UserData] FullName OrgName
Computer Name and Administrator Password | [UserData] ComputerName [GuiUnattended] AdminPassword
Date and Time Settings | [GuiUnattended] TimeZone
Network Settings | [Networking] [Identification] JoinWorkgroup (join a workgroup) JoinDomain, DomainAdmin, DomainAdminPassword (join a domain)
Network Settings (valid only for Windows .NET Server family) | [LicenseFilePrintData] Set AutoMode to PerServer. Set AutoUsers to a value that is less than or equal to the number of users permitted by your licensing agreement.

Running Additional Commands During Mini-Setup

You can run additional programs or commands at the end of Mini-Setup by providing a Cmdlines.txt file in your Sysprep folder. Commands that make changes to a user's preferences are not replicated to users if run from Cmdlines.txt within Windows Welcome or Mini-Setup.

To run Cmdlines.txt during Mini-Setup

  1. In the distribution folder, create:

    %SYSTEMDRIVE%\Sysprep\i386\$OEM$

  2. Add Cmdlines.txt to the %SYSTEMDRIVE%\Sysprep\i386\$OEM$ folder.
  3. In Sysprep.inf, add:
    [Unattended]
InstallFilesPath = C:\Sysprep\i386
  4. Run Sysprep.

Important

  • InstallFilesPath does not support environment variables (for example, %SYSTEMDRIVE%). Instead, you must use a valid path with an actual drive letter.

For more information on Cmdlines.txt, see Preinstalling Applications Using Legacy Techniques.


Auditing Destination Computers

Auditing is the manual testing of new computers. Audit the computers that you manufacture to verify that a computer is functional before shipment. You can verify that the operating system loads and applications start properly, run a disk defragmenter program, run Chkdsk to check for corrupted hard disk files, verify that all installed devices in Device Manager are properly recognized, and run other auditing or test tools. You can verify that the end user's first-run experience runs as expected, the Welcome screen and OEM Help additions work properly, and information about your company's support options is present in System Properties. You can test the computer or install applications without destroying the pages displayed for the end user’s first-run experience.

The Windows OPK does not provide any auditing tools; instead, use your own auditing tools to examine each computer.

You are responsible for correcting all serious errors detected during initial Setup. If serious errors are detected, GUI-mode Setup prompts you to view the Setup Error Log. If these errors are not corrected, the end user is also prompted during Windows Welcome or Mini-Setup to view the Setup Error Log which lists errors from the original installation as well those found during the end user's first-run experience.

You are also responsible for cleaning up the hard disk before distributing the computer to the end user. When you finish, make sure that you delete any files or folders created by your auditing tools.

After auditing, you must run Sysprep as the final step in your manufacturing process. Sysprep removes system changes made by the auditing tools and returns the computer to a customer-ready state, without causing you to reinstall Windows or any previously installed applications. When the end user receives the computer and starts it for the first time, the computer runs Windows Welcome or Mini-Setup.

You can restart as many times as necessary while auditing the computer.

Important

  • You can use Sysprep for a maximum of three times to reset the clock for Windows Product Activation. After the third time you run Sysprep, the clock can no longer be reset. For more information, see Sysprep and Windows Product Activation Frequently Asked Questions (FAQ).

For more information and complete instructions for using Sysprep, see Using Sysprep.

To audit a destination computer

  1. In the Sysprep window, click the Audit button. This is the equivalent of running sysprep -audit.
  2. Preinstall Windows by completing the steps described in Preinstalling the Operating System. When Setup finishes and the destination computer restarts, the computer runs a fully installed version of Windows.
  3. Create the \Sysprep folder on the %SYSTEMDRIVE% of the destination computer. Copy Sysprep.exe, Setupcl.exe, and Factory.exe into that folder. Also place your custom Sysprep.inf and Winbom.ini files in this same location. (Alternatively, you can place these files on a floppy disk or on the network. All files must have the same path.)
  4. Audit the system by using your auditing tool(s).
  5. When the audit is complete, remove any files or folders placed on the hard disk during the auditing process.

    At the command prompt, move to the folder containing Sysprep.exe, and then type this command:

    sysprep -reseal

    The -reseal option clears the Event Viewer logs and prepares the computer for delivery to the customer.

    You may also include other command-line options, as defined on Sysprep Command-Line Options.

  6. When Sysprep finishes, immediately shut down Windows. The computer is now ready to distribute to the end user.

To audit a destination computer after running sysprep -reseal

Even after you run sysprep -reseal to prepare the destination computer for the end user, you can still access the Windows desktop to audit the system.

If the first-run experience is Windows Welcome:

  • Press CTRL+SHIFT+F3 at the first Windows Welcome screen and accept the End-User License Agreement (EULA). The computer restarts into Factory mode.

    —OR—

  • Edit the Oobeinfo.ini file on the installation and add OEMAuditBoot = 1 entry to the [StartupOptions] section. The computer then restarts into Factory mode.

If the first-run experience is Mini-Setup:

  • Add all entries necessary to fully automate Mini-Setup to the Sysprep.inf file, located in either C:\Sysprep or on a floppy disk. The system will automatically complete Mini-Setup and then reboot. After you audit the computer, you must recopy the Sysprep folder onto the hard disk and re-run sysprep -reseal.

Important

  • When the computer restarts, Windows Welcome or Mini-Setup deletes the %SYSTEMDRIVE%\Sysprep folder and its contents.
  • Do not overwrite any system files or otherwise disturb the preinstalled computer; Sysprep does not detect or restore system files that your auditing tools have changed.

Note

  • Sysprep resets the boot menu timeout to the default value of two seconds when a single operating system is installed and 0 seconds when multiple operating systems are installed, so that the image on which you have run Sysprep will start by default. After Windows Welcome or Mini-Setup runs, the boot menu timeout is set to 30 seconds.

After the computer is restored to a customer-ready state, it is ready to be distributed to the customer along with any of the required Windows materials as specified in your license agreement with Microsoft. Usually, these items include:

  • Windows product CD
  • Certificate of Authenticity (COA)

The sysprep -audit command restarts the computer in Factory mode without generating new security IDs (SIDs) or processing any items in the [OEMRunOnce] section of Winbom.ini.

Use this command-line option only if the computer is already in Factory mode.

For more information, see Sysprep Command-Line Options and Using the Registry to Control Sysprep in Factory Mode.

Important

  • If there is an existing user account named "Owner", Windows Welcome removes it.
  • If you create additional user accounts with the Windows XP User Accounts Control Panel during your testing, Sysprep and Windows Welcome do not remove these accounts when you reseal the computer.
  • When Windows Welcome runs, the Owner account (in Windows XP Home Edition) or Administrator account (in Windows XP Professional) is copied over the default user profile. For this reason, if you add any files to the default user profile before you run Sysprep -reseal, they will no longer exist after Windows Welcome finishes.
  • Before resealing the computer, remove any additional test user accounts that you created by using the Windows XP User Accounts option in Control Panel.
  • To add or remove user accounts, click the Start button, right-click My Computer, click Properties, select the Advanced tab, and then click Settings in the User Profiles section.


Preinstalling Service Packs and Hotfixes

You can add service packs and hotfixes to master installations to reduce the total installation time. Instead of preinstalling Windows and then applying the updates, you can update the core operating system with the updates and preinstall the two products in one step.

This section contains these topics:

  • Installing Service Packs
  • Preinstalling Hotfixes


Installing a Service Pack

This topic describes the two network distribution processes for installing Microsoft Windows Service Packs in your environment.

  • Integrated Installation: Integrating the Service Pack into your Windows preinstallation.
  • Update Installation: Installing the Service Pack to a computer with Windows already preinstalled.

Both of these processes apply only to the Stand-alone Service Pack CD.

There are no special instructions required to preinstall Windows from the Windows Integrated Service Pack CD—that installation process is the same as the one used for preinstalling Windows only, as discussed in the remainder of this guide.

What is a Service Pack?

A Service Pack is a collection of updates that fix issues pertaining to the Windows operating system. It updates all Windows files that have a later version included in the Service Pack. Windows Service Packs are available from either the Stand-alone Service Pack CD or the Windows Integrated Service Pack CD.

Only royalty OEMs receive the Stand-alone Service Pack CD, which contains:

  • Service Pack installation files (in the \i386 folder).
  • Service Pack release information (ReadMeSP.htm).

Both royalty OEMs and system builders receive the Windows Integrated Service Pack CD, which contains:

  • Windows integrated with updated files from the Service Pack (in \i386)

Note

  • System builders: to download only the Service Pack, go to the Microsoft OEM System Builder Web site https://oem.microsoft.com.

Service Pack Fixes and Updates

To assist you with deciding whether to install this Service Pack, Microsoft provides extensive documentation about the Service Pack fixes and updates. For the most current list of affected Service Pack files, see the Microsoft Product Support Services Web site (http://support.microsoft.com/directory/).

The Service Pack fixes and updates focus on these areas:

  • Operating system reliability
  • Application compatibility
  • Windows Setup
  • Security issues

For More Information

For more information on the Windows operating system and this Service Pack, see the Microsoft Windows Service Pack Installation and Rollout Guide (SPDeploy.doc) in \Support on the Stand-alone Service Pack CD and the Windows Integrated Service Pack CD.

Update.exe Installation Program

The Service Pack contains the Update.exe program for installing the Service Pack contents. The Update.exe program offers:

  • One-time Service Pack Installation

    With the new Update.exe program, you no longer need to re-apply the Service Pack after every system state change. For example, Windows includes a file named Driver.cab, which contains all the files potentially installed by Plug and Play (PnP)-class installers. Setup and other components in the system use this file to install the drivers for new devices (for example, a PCMCIA card or a USB keyboard) without requiring access to the original Windows product CD or the network.

    The Service Pack does not update the Driver.cab file itself; instead, the Update.exe program installs an additional .cab file named Sp#.cab, where # represents the Service Pack release. In addition to the Sp#.cab file, the Update.exe program installs a new Drvindex.inf that points to Sp#.cab for all of the updated drivers and points to the Driver.cab file for the remaining drivers.

    Important

    • The SP#.cab file contains only updated versions of drivers that were included in the original Windows Driver.cab file that caused blue screens, data loss, data corruption, or inability to boot in configurations that were not available for testing when Windows released.
    • Microsoft does not provide updated drivers with the Service Packs if:
      • The driver did not originally ship with Windows product.
      • The driver that shipped with Windows does not have as many features as ones released later by the independent hardware vendor (IHV).
      • The driver that shipped with Windows does not cause a critical failure, as defined previously.
    • You may contact the hardware vendor for new or updated drivers that they may have available for Windows. Updated drivers for end users can be found on the Microsoft Windows Update Web site (http://windowsupdate.microsoft.com).
    • To see if drivers approved for the Microsoft Windows Logo are available, see the Hardware Compatibility List (HCL) (http://www.microsoft.com/hcl/).
    • Because Microsoft may not own the rights to the code for a particular driver, we cannot always guarantee that an update is available in a Service Pack, but we will make every effort to work with the driver vendor to provide an updated driver for the previously described conditions.
  • Integration installation support

    The Update.exe program supports a new installation that integrates the Service Pack with the Windows preinstallation. You no longer need to perform separate installations of the operating system and the Service Pack. For more information about this installation method, see The Integrated Installation.

  • Logging

    The Update.exe program creates a log file in %SYSTEMDRIVE% named Svcpack.log. This log file contains:

    • The command line that initiated the Update.exe program.
    • A list of the files that the Update.exe program copied to the computer.
    • A list of the files that did not require updating and which the Update.exe program skipped.
  • Compressed backup data

    To help reduce disk space consumption, after the Update.exe program completes the file installation and registry updates and all of the Service Pack backup data is present, the program creates the $NTServicePackUninstall$ folder to store the uninstall information. The Update.exe program compresses this information on NTFS partitions only. Then, if the Service Pack is uninstalled, the Update.exe program can easily decompress the backup data from this folder. After the Update.exe program has successfully restored the system to its original pre-Service Pack state, it deletes the entire set of files. For more information, see Uninstalling the Service Pack.

  • Consolidated standard (56-bit) and high (128-bit) encryption

    You no longer need to install a different Service Pack version for each level of encryption. By utilizing the encrypted installer, a single Service Pack can contain both standard (56-bit) and high (128-bit) encryption files. When you install the Service Pack, Setup determines the encryption level—either standard or high encryption—of your current operating system and automatically installs the Service Pack with the same encryption level. By default, Setup installs the standard (56-bit) encryption files.

Command-Line Options for the Update.exe Program

Command-Line Option | Description
-f | Force other applications to close at shutdown
-n | Do not back up files for uninstall
-o | Overwrite OEM files without prompting
-q | Quiet mode—no user interaction required
-s:folder_name | Integrated installation mode—to a distribution server location
-u | Unattended Setup mode
-z | Do not restart the computer when the installation completes

Note

  • If you use the -q or -u option to run Update.exe in quiet or unattended Setup mode and want to update OEM-supplied files, you must also use the -o switch. If you do not use the -o switch, files such as the hardware abstraction layer (HAL) and disk miniport drivers are not updated.

Before You Install

To help ensure a successful installation of the Service Pack, prepare for the install process by:

  • Choosing an installation method.
  • Identifying installation tools and files.
  • Determining the platform requirements.

Choosing an Installation Method

The Windows Service Pack supports these installation methods:

  • The update installation, which is the standard method used to install Windows NT® Service Packs. If you have previously installed a Windows NT 4.0 Service Pack, you are familiar with the update installation method.
  • The integrated installation, which is a new installation method introduced with this Service Pack. With the integrated method, you can install Windows and the Service Pack simultaneously.

Important

  • These Service Pack installations are included here for those OEMs who choose to update distribution servers that already have Windows on them with the Stand-alone Service Pack CD, rather than recreating the distribution servers with the Windows Integrated Service Pack CD, which provides Windows with the Service Pack already integrated into it.
  • This information may also be beneficial for testing scenarios that your customers may use when updating their Windows 95, Windows 98 or Windows NT 4.0 computers with Windows and the Service Pack.

Identifying Installation Tools and Files

After you select your installation method, determine the tools and files that you need. The Service Pack installations use the same tools and files as the Windows preinstallation.

  • Setup Manager Install Setup Manager from the Windows OPK CD.
  • Unattend.txt You can create or modify this answer file by using a text editor or Setup Manager.
  • Cmdlines.txt This file contains a list of the commands that run during Windows GUI-mode Setup.
  • Sysprep.exe This tool enables you to perform legal imaging, disk duplication, automation of Mini-Setup, and auditing.

Updated versions of the preinstallation tools are available:

  • In \Tools\ on the Windows OPK CD.
  • By download from the Microsoft OEM System Builder Web site https://oem.microsoft.com.

Determining the Platform Requirements

If you use the Stand-alone Service Pack CD to install the Service Pack on a computer with Windows already preinstalled, you must consider the upgrade paths supported by update and integrated installations.

Update Installation Platforms

The Service Pack supports update installations on these platforms:

  • Windows XP Home Edition
  • Windows XP Professional
  • Windows XP 64-Bit Edition

The Integrated Installation

This new installation method enables you to create an integrated installation of the Windows operating system and the Service Pack (from the Stand-alone Service Pack CD) on a network distribution share. When you run the Update.exe program in integrated mode (by running update.exe -s), it applies the Service Pack directly to the Windows installation files in your original Windows distribution share. As a result, you do not need to perform separate installations of the operating system and the Service Pack.

While the actual application of the Service Pack is as simple as copying the updated files to the network distribution share, the integration of the Service Pack with Windows Setup involves a number of changes to both the Service Pack files and to Windows itself. During an update installation, processes provided by the operating system modify the files, registry, and catalogs; therefore, this method of installation is dependent upon the operating system. However, during an integrated installation, Windows Setup mechanisms create and store this information.

After the Update.exe program builds the integrated installation, you can preinstall Windows to the destination computers from the network distribution share. During the standard installation process, Windows Setup installs the updated operating system with the Service Pack already applied.

Because Windows Setup (not the Update.exe program) actually installs the integrated Service Pack files on the computer, you can create an integrated installation by using any method—from manual to completely automated—that Windows Setup supports.

For information on using the update installation, see The Update Installation.

Notes

  • Information on integrated Service Pack installations is included here for OEMs who choose to update distribution servers that already have Windows on them with the Stand-alone Service Pack CD, instead of recreating the distribution servers with the Windows Integrated Service Pack CD, which provides Windows with the Service Pack already integrated.
  • This information may also be beneficial to you for testing scenarios that your customers may use when updating their Windows 95, Windows 98 or Windows NT 4.0 computers with Windows and the Service Pack.

Creating an Integrated Installation

This section describes the installation steps for creating an integrated installation of the Windows operating system and the Service Pack (from the Stand-alone Service Pack CD) on a network distribution share. The integrated process installs the Service Pack during Windows Setup.

Important

  • You cannot uninstall Service Packs that have been installed with the integrated installation.

To create an integrated installation of Windows and the Service Pack

  1. Connect to the network or computer on which you want to create the distribution folder.
  2. On the network distribution share, create a distribution folder for the Windows installation files.
  3. Open a command window and from the CD-ROM, run:
    :\i386\Update\Update.exe -s:\<share>

    After Update.exe updates your distribution share with the latest Service Pack files, you can preinstall Windows to the destination computers from the network distribution share in attended or unattended Setup mode. During the standard installation process, Windows Setup installs the updated operating system with the Service Pack already applied.

    When you run the Update.exe program in integrated mode (update.exe -s:), a Svcpack.log file is created in %WINDIR% on the computer that is running the Update.exe program. If you plan to update more than one version of Windows on this computer, it is recommended that you rename the Svcpack.log file after you update each version. Renaming this file ensures that you do not overwrite the current log file when you update additional versions of Windows.

  4. Run Windows Setup.

The Update Installation

During the update installation, the Service Pack (from the Stand-alone Service Pack CD) is applied to a computer with Windows already preinstalled. When you run the Update.exe program, it automatically installs the updated system files and makes the necessary registry changes. After the computer restarts, the installation finishes and the operating system runs with an updated file set.

The Service Pack supports a number of methods for creating the update installation, including:

  • Manually running the Update.exe program with a combination of installation switches.
  • Running a script that starts the Update.exe program.

This Service Pack also supports a variety of distribution media, including CD-ROM, network distribution share, Internet download, and binary patching.

For information on using the integrated installation, see The Integrated Installation.

Creating an Update Installation

This section describes how to install the Service Pack from a network distribution share. This update installation method installs the Service Pack on computers that are already running Windows.

To install only the Service Pack

  1. Connect to the network or computer on which you want to create the distribution folder.
  2. On the network distribution share, create a distribution folder for the Service Pack.
  3. Copy the Service Pack executable file (SP1i386full.exe) from the Stand-alone Service Pack CD to the distribution folder that you created in Step 2.
  4. Expand and extract SP1i386full.exe to the distribution folder created in Step 2. For example:
    sp1i386full.exe /x:\\<server>\<share> /u
  5. Run Update.exe from this distribution folder location. For example:
    \<server>\<share>\<sp#>\i386\Update\Update.exe

Uninstalling the Service Pack

This Service Pack contains an uninstall feature that you can use to restore the computer to its previous state. When you run the Update.exe program to install the Service Pack, a subfolder named $NTServicepackUninstall$ is created in your %WINDIR% folder.

You can uninstall the Service Pack by using Add/Remove Programs in Control Panel or by running the uninstall program from the command prompt.

Important

  • If you install any programs or services that require or have fixes contained in the Service Pack, uninstalling the Service Pack can adversely affect those programs.
  • Do not uninstall the Service Pack if you have installed any applications since the Service Pack was installed.
  • The Service Pack does not contain system updates such as file format, database format, and registry format changes that Setup cannot uninstall.

To uninstall the Service Pack by using Add/Remove Programs

  1. Click Start, point to Settings, and then click Control Panel.
  2. Double-click Add/Remove Programs, click Windows SP1, and then click Add/Remove.
  3. Follow the instructions that appear.

To uninstall the Service Pack from a command prompt

  1. Click Start, and then click Run.
  2. In the Open dialog box, type cmd, and then click OK.
  3. Change the folder to \%SYSTEMROOT%\$NtServicePackUninstall$\spuninst\.
  4. Type Spuninst.exe, and then press Enter.

Important

  • To uninstall the Service Pack, you must use the same drive letter for the hard disk that you used when you installed it. If you change the drive letter for the hard disk, you cannot uninstall the Service Pack.


Preinstalling Hotfixes

This procedure describes how to preinstall hotfixes for Windows XP. This process differs slightly from the implementation for Windows 2000.

To preinstall hotfixes for Windows XP

  1. Rename the hotfix package to a suitable 8.3 file name. Setup does not recognize long file names. For example:
    REN Q308387_WXP_SP1_X86_JPN.EXE Q308387.EXE
  2. Make a temporary directory to hold the extracted contents of the hotfix package. The files within the package will replace the original files in the i386 folder:
    MD C:\TEMP
  3. Extract the files from the hotfix package. For example:
    Q308387.EXE /x
  4. Enter C:\TEMP for the name of the directory.
  5. Open \Opktools\Lang\JPN\SKU\Pro\x86\i386\DOSNET.INF with Notepad and add this information to the file:
    [OptionalSrcDirs]
svcpack
  6. Delete the svpack.in_ and original file(s) that the hotfix is replacing. For example:
    DEL SVCPACK.IN_, DEL AUTOLFN.EX_
  7. Copy the replacement file from the temporary directory to the i386 folder:

    For example:

    COPY C:\TEMP\AUTOLFN.EXE C:\Opktools\Lang\JPN\SKU\Pro\x86\i386\AUTOLFN.EXE
  8. Create a SVCPACK folder in \Opktools\Lang\JPN\SKU\Pro\x86\i386.
  9. Create a new \Opktools\Lang\JPN\SKU\Pro\x86\i386\SVCPACK.INF with this content:

    For example:

    [Version]
Signature = $Windows NT$
BuildNumber = 2600
MajorVersion = 5
MinorVersion = 1

[SetupData]
CatalogSubDir = i386\svcpack

[ProductCatalogsToInstall]
sp1.cat

[SetupHotfixesToRun]
Q308387.exe /q /n /z
  10. Copy SP1.CAT from C:\TEMP\UPDATE to the C:\Opktools\Lang\JPN\SKU\Pro\x86\i386\SVCPACK folder:

    For example:

    COPY C:\TEMP\UPDATE\SP1.CAT C:\Opktools\Lang\JPN\SKU\Pro\x86\i386\SVCPACK\SP1.CAT
  11. Copy Q308387.EXE to the C:\Opktools\Lang\JPN\SKU\Pro\x86\i386\SVCPACK folder:

    For example:

    COPY Q308387.EXE C:\Opktools\Lang\JPN\SKU\Pro\x86\i386\SVCPACK\Q308387.EXE


Configuring the Windows .NET Server Family

The user interface for the Windows .NET Server family is different from Windows XP in these ways:

  • Start Menu Differences in Servers Running Windows .NET
  • Setup sets the screen resolution to 1024 x 768 if both the adapter and monitor can support it. Otherwise, Setup selects 800 x 600. In rare cases, Setup is forced to use 640 x 480.
  • The login screen's background is color-coded to represent the version of Windows. The same color is used for all versions of Windows .NET Server.
  • Desktop Cleanup is turned off by default.

Mini-Setup is the first-run experience for the Windows .NET Server family. For more information, see The End-User First-Run Experience and Pre-Configuring and Automating Mini-Setup.

You are not required to install Step by Step Interactive (SBSI) for the Windows .NET Server family.

For information about configuring a server, consult the following topics.

  • Installing Microsoft Internet Information Services (IIS)
  • Installing Remote Adminstration Tools
  • Installing the Cluster service
  • Installing a Domain Controller

You can add and customize additional server components in the Unattend.txt file. For more information, see:

  • [Components]
  • [InternetServer]
  • [NetOptionalComponents]
  • [NetServices]
  • [SNMP]
  • [TerminalServices]


Start Menu Differences in Servers Running Windows .NET

The user interface of members of the Windows .NET Server family differs from Windows XP Home Edition and Windows XP Professional in these ways:

  • The Start menu is wider.
  • If the current user belongs to the Server Administrators group, an Administrative Tools link appears on the Start menu. This link does not appear for non-administrators.
  • The Windows Catalog link, found by clicking All Programs, points to a page of the catalog that is more adapted to the needs of Server users.
  • Links to the Microsoft Management Console (MMC) and Task Manager are included on the Administrative Tools initial menu.
  • The pin area of the Start menu contains links for Computer Management (Compmgmt.msc), Command Prompt (Cmd.exe), and Windows Explorer (Explorer.exe).
  • The Most Frequently Used (MFU) list contains two pre-populated links: Notepad and Configure Your Server.
  • Control Panel and Administrative Tools are located on the Start menu, as "flyouts" or expansion menus.
  • My Computer is located on the Start menu as a link.
  • Network Connections is located on the Start menu if an existing connection is found.
  • Help and Support, Search, and Run are located on the Start menu.
  • My Documents and My Recent Documents are turned off.
  • My Network Places is turned off.

For more differences between the Windows XP and Windows .NET Server user interface, see Configuring the Windows .NET Server Family.


Installing Microsoft Internet Information Services (IIS)

Windows XP Professional and Windows XP 64-Bit Edition contain Microsoft Internet Information Services 5.1. All members of the Windows .NET Server family contain Internet Information Services 6.0.

Windows XP Home Edition does not contain any Web server software components.

To preinstall Internet Information Services (IIS), you must specify the:

  • Desired values for the various IIS components in the [Components] section of the Unattend.txt file. You must set the iis_www entry to On.
  • Entries for configuring the installation locations in the [InternetServer] section of the Unattend.txt file.

If the [InternetServer] section is empty, IIS is installed in the default location.

Note

  • Some optional components of the Windows .NET Server family require that additional IIS components also be installed. If you configure these optional components as a part of Windows .NET Standard Server, Enterprise Server, or Windows 2000 Datacenter Server unattended Setup, you may want to set preferences for the related IIS components. For a list of IIS interdependencies and a list of components to install, see [Components], [InternetServer], and [NetOptionalComponents].


Installing Remote Administration Tools

The default attended installation of Remote Administration Tools components (formerly known as Server Administration Kit (SAK)) occurs at first logon after Setup. This can be performed automatically with Unattend.txt by using any of these methods:

  • An entry in the [GuiUnattended] section
  • Optional Component Manager
  • A command line in the [GUIRunOnce] section

GUI-Mode Setup Unattended Installation on the Windows .NET Server Family

The default attended behavior at first logon on the Windows .NET Web Server is to run SaInstall.exe and install the Web UI for Remote administration. To control this first logon behavior, Setup processes the ServerWelcome entry in the [GuiUnattended] section in Unattend.txt:

[GuiUnattended]
ServerWelcome = Yes

The default behavior for this is Yes.

On the Windows .NET Web Server, if this parameter is set to Yes, then on first user logon, Sasetup.msi will be run from the hard drive and the Web UI for Web server administration will be added to the Startup program group for the Administrator account, and will be launched.

The default attended behavior on first logon of the Windows .NET Standard Server, Windows .NET Enterprise Server, Microsoft Small Business Server, and Windows .NET Datacenter Server is to run the Configure Your Server Wizard. To control this first logon behavior, Setup processes this parameter in Unattend.txt:

[GuiUnattended]
ServerWelcome = Yes

On Windows .NET Standard Server, Windows .NET Enterprise Server, Microsoft Small Business Server, and Windows .NET Datacenter Server, if this parameter is set to Yes, then on first user logon, the Configure Your Server wizard will run. If this parameter is set to No, then the Configure Your Server Wizard will not run.

Important

  • ServerWelcome is not processed during Sysprep.

Unattended Installation Using Optional Components Manager (OCM)

Optional Components Manager can be run to perform an unattended install of the Web UI for Web server administration (Web UI) components after Setup and after first logon. If OCM is called with Unattend.txt as an argument, OCM will pass this on to the IIS OC dll. The IIS OC dll will parse Unattend.txt for the parameters that define whether the Web UI is installed and the path to the sasetup.exesasetup.msi file.

For example, a command line for the install is:

sysocmgr /i:sysoc.inf /u:unattend.txt/

If there is no media specified, then IIS OC DLL uses the CD-ROM drive. If SaInstall.dll cannot find Sasetup.exesasetup.msi at the specified location, it will return an error to the IIS OCM DLL which will log the error.

Unattended Parameters for controlling IIS OCM

These unattended parameters provide functionality for the Remote Administration Tools on the Windows .NET Server family:

[Components]
iis_webadmin = On | Off

The default behavior for this is On and results in an installation of the Web UI for Web server administration (Remote Administration Tools WebBlade). Selecting this parameter also installs the following components: iis_common, iis_inetmgr, iis_www.

Note

  • This parameter replaced the previous iis_htmla parameter for the Windows 2000 IIS HTMLA Component. The iis_htmla parameter is no longer valid for the Windows .NET Server familiy.

If this parameter is set to Off and the Web UI for Web server administration is already installed, this uninstalls the component.

[InternetServer]
SA_InstallPath = path_to_SaSetup.exeSasetup.msi

If this path is specified, the IIS OCM component uses it to install the Remote Administration Tools without prompting for a CD-ROM or installation media.

Scripted install of Remote Administration Tools components using Sasetup.msi

After Setup, the Web UI for Remote Administration can be installed unattended by running Sasetup.msi with the appropriate command-line options. See the Sasetup documentation for details.

Sasetup can be run automatically after Setup by placing Sasetup.msi in the [GUIRunOnce] section of Unattend.txt. This can be used in conjunction with the AutoLogon = Yes parameter to log in and install the Remote Administration Tools components automatically after Setup.


Installing Cluster Service

banner

Installing the Cluster Service

Enabling the Cluster service in the [Components] section of the Unattend.txt answer file is sufficient to install the necessary files. To make sure that the Cluster service is installed completely, create an [GuiRunOnce] entry for it.

To install the Cluster service

  1. In the [Components] section of the Unattend.txt file, set cluster = on.
  2. In the Unattend.txt file, add the [Cluster] section and all of its entries.
  3. In the [GuiRunOnce] section of the Unattend.txt file, add
    "%WINDIR%\cluster\cluscfg.exe -unattend"

[GuiRunOnce] entries are run after Setup finishes at the user's first logon. Any entries specified in [GuiRunOnce] are saved on the computer and are processed only after rebooting, not during unattended Setup.

For more information about configuring the Cluster service and its requirements, see the Microsoft Windows .NET Server Resource Kit.


Installing a Domain Controller

Dcpromo.exe is the component of the Active Directory Installation Wizard used to create or demote domain controllers on computers running Windows .NET Standard Server, Enterprise Server, or Windows 2000 Datacenter Server.

Note

  • Dcpromo.exe can be run only after GUI-mode Setup has completed and a user has logged on.

To run Dcpromo.exe

  • Open a command window and type:

    dcpromo /answer:answerfile

    —OR—

  • Create a Sysprep.inf that includes:
    [GuiRunOnce]
"dcpromo /answer:answerfile"

    In both cases, answerfile specifies the name of the answer file that contains the domain controller values.

Specify the values used by Dcpromo.exe in the [DCInstall] section of the Unattend.txt answer file during unattended Setup or in a separate answer file that contains only the [DCInstall] section.

Notes

  • If you do not provide an answer file, the Active Directory Installation Wizard prompts for the information necessary to promote the computer to a domain controller.
  • If you do not specify a value for an option in the answer file that you create, the default value is used.

Customizing [DCInstall]

[DCInstall] is an optional section of an answer file that contains entries for installing a domain controller after Setup of Windows .NET Standard Server, Enterprise Server, or Windows 2000 Datacenter Server is finished. You can create an answer file, containing only this section, that runs after Setup is complete and a user has logged on to the computer.

The entries used with [DCInstall] are supported only on Windows .NET Standard Server, Enterprise Server, or Windows 2000 Datacenter Server. This table lists when the various entries are used.

Entry | Applies to:
RebootOnSuccess | All operations (installation and removal)
DatabasePath LogPath SYSVOLPath UserName Password UserDomain | All installations
ReplicaOrNewDomain = Replica ReplicaDomainDNSName | Backup domain controller upgrades and new replica installations
ReplicaOrNewDomain = Domain TreeOrChild = Child ParentDomainDNSName ChildName DomainNetbiosName AutoConfigDNS | Installation of child domains
ReplicaOrNewDomain = Domain TreeOrChild = Tree CreateOrJoin = Join NewDomainDNSName DomainNetbiosName AutoConfigDNS | Installation of a new tree in an existing forest
AdministratorPassword IsLastDCInDomain | Domain controller demotion
ReplicaOrNewDomain = Domain TreeOrChild = Tree CreateOrJoin = Create NewDomainDNSName DNSOnNetwork DomainNetbiosName AutoInstallAndConfigDNS SiteName | Installation of a new tree in a new forest

Notes

  • Passwords may contain as many as 127 characters.
  • You can add and customize additional server components in the answer file. For a list of these components, see Unattend.txt.


Legacy Preinstallation Techniques

The recommended preinstallation process is for you to use the Windows Preinstallation Environment (WinPE) to start a computer and run an unattended Setup using Winnt32.exe and a configuration set.

However, you can start the computer using another operating system, such as MS-DOS. You can also start the computer using the Windows CD.

For more information on these techniques, see:

  • Using Winnt.exe to Run Setup
  • Converting Short File Names to Long File Names
  • Installing Windows from the Product CD

If you want to create an image of only the files contained in the Windows XP operating system, instead of a fully installed operating system, you can use the Syspart method of preinstallation. The most common use of this technique is to use the same image on computers with different HALs.

To preinstall applications, you can continue to use the same techniques that you used in Windows 2000. However, these techniques increase the time required when the end user starts the computer for the first time, and are not recommended. For more information on these techniques, see Preinstalling Applications Using Legacy Techniques.


Converting Short File Names to Long File Names

When you use the standard preinstallation methods based on the Windows Preinstallation Environment (WinPE), you can use long file names for files included in a configuration set. However, if you use Winnt.exe to preinstall the operating system, all files and folders in the $OEM$ directory structure must be in 8.3 format for Setup to copy the files. In addition, you must always use 8.3 file names when copying a set of files from one computer to another with MS-DOS.

Use the $$Rename.txt file to restore these 8.3 names to long file names during Windows Setup. $$Rename.txt must be located in the $OEM$\$1 folder.

Syntax for $$Rename.txt

The syntax for $$Rename.txt:

[Section_name_1]
Short_name_1 = "Long_name_1[$$]"
Short_name_2 = "Long_name_2[$$]"
.
.
Short_name_x = "Long_name_x[$$]"

[Section_name_2]
.
.

Parameters

Section_name_1, Section_name_2, and so on
Paths to the folders that contain the files. A section can be unnamed, or it can have a backslash (\) as its name. The backslash indicates that the section contains the names of the files or subfolders that are in the root of the drive.
Short_name_1, Short_name_2, and so on
Names of the files or subfolders in this folder to rename. Do not enclose the names in quotation marks.
Long_name_1, Long_name_2, and so on
New names of the files or subfolders. Enclose these names in quotation marks if they have spaces or commas.

If Long_name_x is the name of the Profiles directory and has a "$$" appended to the end, Setup merges this directory with the current Profiles directory. For example, if the $$Rename.txt file contained these entries:

[\]
D = "Documents and Settings$$"

then files listed in this section are placed in the "Documents and Settings$$" Profiles directory.


Using the Syspart Method to Preinstall Windows

When you use the Syspart method, you stop the installation of Windows after the file-copy phase of Setup, duplicate the hard disk, and then complete Windows Setup on each destination computer built from the duplicate hard disks. For more information on the Setup process, see Stages of Windows Setup.

The Syspart method requires less time than running Winnt32.exe on every computer. However, because both the text-mode and GUI-mode phases of Setup must run on each destination computer, this legacy technique is more time-consuming than duplicating a fully installed version of Windows onto one or more destination computers, as described in Creating a Master Installation.

Use two hard disks with a primary partition on the clean, newly formatted destination hard disk. The destination hard disk does not need to be installed physically in the master computer; instead, you can access the destination hard disk through a network connection.

Important

  • Winnt.exe does not have the Syspart command-line option. You must use Winnt32.exe.
  • Run the winnt32 /syspart command from a computer already running Windows 2000, Windows XP Home Edition, Windows XP Professional, or the Windows .NET Server family. You cannot use this command-line option on Windows 95, Windows 98, Windows Millennium Edition, or 64-bit editions of Windows.

To create a hardware-independent snapshot of Windows files

  1. Choose a computer to use as the master computer. The master computer must use Windows NT, Windows 2000, Windows XP Home Edition, Windows XP Professional, or the Windows .NET Server family.
  2. Start the master computer and connect to the distribution share.
  3. Start Windows Setup, and then click Start, click Run, and then type:

    Winnt32 /Unattend:Unattend.txt /s:install_source /Syspart:system_drive2 /tempdrive:system_drive2

    Unattend.txt
    Specifies the answer file used for unattended Setup. It provides answers to some or all of the messages that the end user normally responds to during Setup. Using an answer file is optional when creating the master installation.
    install_source
    Specifies the location of the Windows files. Specify multiple /s options if you want to install from multiple sources simultaneously.
    system_drive2
    Specifies the system partition of a second hard disk on which you preinstall Windows and applications.

    Because the /syspart and /tempdrive options reference the same drive, Windows is installed on the primary partition of that hard disk.

    Important

    • The /syspart option for Winnt32.exe is run only from a computer already running Windows 2000, Windows XP Home Edition, Windows XP Professional, or the Windows .NET Server family. You cannot use this command-line option on Windows 95, Windows 98, Windows Millennium Edition, or 64-bit editions of Windows.
    • If you use the /tempdrive option, make sure that you have sufficient free disk space on your second drive to install both Windows and your applications.
  4. After Setup copies files to the hard disk, shut down the computer.
  5. Remove the hard disk from the computer, and then use disk-duplicating equipment or software to make copies of the hard disk.
  6. Install a duplicated hard disk into a destination computer.
  7. Start the destination computer and complete Windows Setup.
  8. Run sysprep -nosidgen to prepare the computer for the end user.

    For more information about Sysprep, see Using Sysprep.

You can also use the Syspart method to create a master installation to duplicate onto computers that use a different hardware abstraction layer (HAL).

To create a HAL-specific snapshot of Windows files

  1. Create a source disk using the Syspart method to copy files.
  2. Make enough copies of this disk to configure and use as the master installation(s) for each type of computer that you preinstall in your factory.
  3. For each type of computer, place a source disk into the hardware-specific master computer. Turn on the computer.

    4. Setup finishes automatically.

  4. Run Sysprep to prepare the computer for the end user.
  5. Duplicate the hardware-specific hard disk and install each duplicate in a computer identical to the master computer.


Preinstalling Applications Using Legacy Techniques

The preferred time to preinstall applications on Windows computers is during Factory mode of Sysprep, using the [OEMRunOnce] section in Winbom.ini. This technique is faster and provides greater flexibility in the manufacturing environment. For more information, see Preinstalling Applications.

For backward compatibility, you can continue to use the same techniques that you used to preinstall applications in Windows 2000. However, these techniques will increase the time required when the end user starts the computer for the first time, and are not recommended.

Preinstalling Applications Using Cmdlines.txt

Use Cmdlines.txt when installing:

  • From the \$OEM$ folder in your configuration set.
  • Applications during GUI-mode Setup.
  • An application designed for installation by one user and you want to replicate user-specific information.

The Cmdlines.txt file contains the commands that GUI-mode Setup runs when installing optional components, such as applications. For example, you can use the commands specified in this file to run an .inf file by using the Rundll32.exe command or to perform some other action. If you plan to use Cmdlines.txt to install an application, place the application that you are installing in the \$OEM$ subfolder of the configuration set.

Note

  • For more information on using Rundll32.exe with .inf files, see the Microsoft Platform SDK in the MSDN Library (http://msdn.microsoft.com/library/).

The syntax for Cmdlines.txt is:

[Commands]
"command_1"
"command_2"
     .
     .
"command_x"

where "command_1", "command_2" and so on are the commands you want to run in order when GUI-mode Setup calls Cmdlines.txt.

All commands must appear in quotation marks.

Limitations of and Usage Notes on Cmdlines.txt

The following limitations apply to Cmdlines.txt:

  • When Cmdlines.txt runs, there is no logged-on user and no network connectivity. All user-specific information is written to the default user registry, and all subsequently created users inherit those registry settings.
  • You must place the files necessary for an application or utility to run in the configuration set.
  • When you install applications by using Cmdlines.txt, install the application in unattended Setup mode so that the user does not need to respond to prompts about the application.
  • You cannot install Windows Installer (.msi) applications using Cmdlines.txt. Use [GuiRunOnce] instead.

Preinstalling Applications Using [GuiRunOnce]

Use [GuiRunOnce] when:

  • You install from any source, including networks, hard disks, or CD-ROM drives.
  • You cannot install the application during GUI-mode Setup.
  • You want to log on as a user and you do not want to replicate those registry settings automatically to future users.
  • The application that you install requires that a user be logged on to the computer.

Note

  • [GuiRunOnce] requires the log-on function to be enabled (use the AutoLogon entry in the [GuiUnattended] section). For more information, see Automating the Logon Process.

The [GuiRunOnce] section of the Unattend.txt file contains a list of commands that run the first time the end user logs on to the computer after GUI-mode Setup runs. Each line enclosed in quotation marks specifies a command, which is stored in [GuiRunOnce] of the Windows registry. For example, enter this line in [GuiRunOnce] to run Sysprep in unattended Setup (quiet) mode.

[GuiRunOnce]
"%SYSTEMDRIVE%\Sysprep\Sysprep -quiet"

If an application requires that the Windows Explorer shell be installed, you may use [GuiRunOnce] to create an automated factory installation that completes Setup, automatically logs on to the computer, installs the application, and then shuts down the computer. You can also use [GuiRunOnce] to control the order in which applications are installed.

Important

  • You cannot use [GuiRunOnce] to enable the execution of shells, other programs, and so on, during the end-user boot, except as noted in Chapter 1 of this guide.

Automating the Logon Process

You can set up the automatic logon process by adding AutoLogon = Yes in the [GuiUnattended] section of the Unattend.txt file (the answer file). Windows then automatically logs on using the Administrator account and password after the first reboot after Setup. The Administrator account password can be blank (or NULL), or you can specify a password in the answer file. The default setting for AutoLogon is No.

Note

  • If the Administrator account password is blank, the computer logs on once. If a password is assigned, the computer logs on repeatedly and Windows saves the password in the registry.

For more information, see Setting the Administrator Password.

Controlling Application Installation

To control how multiple applications are installed, you can create a batch file that contains the individual installation commands and uses the Start command with the /wait command-line option. This method ensures that your applications install sequentially and that each application is fully installed before the next application begins its installation routine. The batch file is then run from the [GuiRunOnce] section of the answer file.

The following steps explain how to:

  • Create the batch file.
  • Install the application.
  • Remove all references to the batch file after installation finishes.

To install applications by using a batch file

  1. Create a batch file containing lines similar to this syntax:

    Start /wait path\Setup [-x ...]
    ...
    Exit

    where:

    path
    Specifies the path to the executable file that starts the installation.
    Setup
    Specifies the name of the executable file that starts the installation.
    x
    Specifies any available unattended (quiet) options appropriate for the application that you want to install.
  2. Copy the batch file to a location that can be accessed during Setup.

    Note

    • You can also copy the batch file to the Sysprep folder of your distribution share. The batch file is then local to the destination computer. After Sysprep runs, the user completes the first-run experience, the computer reboots, and the Sysprep folder and all of its contents are deleted. You do not have to delete the batch file by using another process. For more information, see Using Sysprep.
  3. Using filename.bat as the name of the batch file, include an entry in the [GuiRunOnce] section of the answer file to run the batch file. For example:
    [GuiRunOnce]
Command0() = "%SYSTEMDRIVE%\sysprep\filename.bat"
Command1() = "path-1\Command-1.exe"
Commandn() = "path-n\Command-n.exe"
Commandn+1() = "%SYSTEMDRIVE%\sysprep\sysprep.exe –quiet"

    where:

    path\Command-1.exe and path-n\Command-n.exe
    Specifies fully qualified paths to additional applications, utility installations, configuration tools, or another batch file. These paths must be available during Setup.

This example assumes that the batch file was copied to the Sysprep folder on the local hard disk, although you can place the batch file anywhere that Setup can access during an installation.


Preinstalling 64-Bit Editions of Windows

As of the publication of this Windows OPK User's Guide, no third-party disk-imaging software yet supports GUID partition table (GPT), the disk-partitioning scheme used in Itanium-based computers. For this reason, you cannot use images to preinstall 64-bit versions of Windows. However, you can use the xcopy command, the Windows Preinstallation Environment (WinPE), and the DiskPart utility to preinstall the operating system. Otherwise, you must run Windows Setup on every 64-bit computer.

Important

  • You can install Windows XP 64-Bit Edition only to the C: drive.
  • Windows XP 64-Bit Edition and the 64-bit versions of the Windows .NET Server family are available only in English, French, German, and Japanese.

You can use any of these techniques to preinstall Windows XP 64-Bit Edition, the 64-bit version of Windows .NET Enterprise Server, or the 64-bit version of Windows .NET Datacenter Server:

  • Start the computer by using WinPE, locate the distribution share that contains the source files on the network, and run Setup (Winnt32.exe). For more information, see Using WinPE in Your Manufacturing Process and Using Winnt32.exe to Run Setup.
  • Perform a CD-based unattended installation. For more information, see Installing Windows from the Product CD.
  • Use the procedures described in "Using Xcopy, WinPE, and DiskPart to Preinstall the Operating System" and "Creating GPT, EFI, and Primary Partitions on the Destination Computer."

Note

  • To perform a CD-based unattended installation, follow these guidelines:
    • The computer must support the El Torito Bootable CD-ROM Format specification.
    • You must name the answer file Winnt.sif and place it on a floppy disk.

To Use Xcopy, WinPE, and DiskPart to Preinstall the Operating System

  1. The master computer must be an Itanium-based computer with a new operating system installed.
  2. Run Sysprep -factory or Sysprep -reseal.
  3. Make sure that the [SysprepMassStorage] section is included in the Sysprep.inf file.
  4. Insert the WinPE CD into the master computer's CD-ROM drive, restart the master computer, and then choose to start into the Windows Preinstallation Environment.
  5. In WinPE, type diskpart to start the DiskPart utility.
  6. In DiskPart, type these commands:
    select disk 0
list partition
select partition x

    Where x is the EFI system partition.

  7. Assign a drive letter by typing this command:
    Assign letter = x

    Where x is the desired drive letter.

  8. Close DiskPart by typing this command:
    exit
  9. Type the net use command to connect to the server and share where you will store operating system and EFI files.
  10. Optional: To save space, delete Pagefile.sys and the Dllcache folder.

    11. Note

    • Delete the Dllcache folder only if you have mapped a path to the CD-ROM drive or to a local folder where the i386 or ia64 folders and files reside. Deleting the Dllcache folder does not save space if you must copy over the i386 and ia64 folders because the Dllcache folder is smaller than the i386 and ia64 folders. However, if licensing requires that the i386 and ia64 folders be local on the system, you can save space by deleting the Dllcache folder.
  11. Copy files with these commands:
    c:\xcopy *.* \\server\share\OS /cherky
x:\xcopy *.* \\server\share\EFI /cherky

    These switches are necessary to copy all the files.

  12. Start into WinPE on the destination computer.

Creating GPT, EFI, and Primary Partitions on the Destination Computer

  1. Run DiskPart. Type the list partition command to see a listing of partition numbers.

    Note

    • The following steps assume that you have a raw drive (a drive that has not been partitioned, or a drive on which you have run the clean command in Diskpart).
  2. In DiskPart, type these commands:
    select disk 0
convert GPT
select partition 1

    Note the size of this partition before you delete it.

    delete partition
create partition efi size = 1 00
create partition msr size = 32 or 128

    Use the size that you noted.

    create partition pri size = *
select partition x

    Where x is the EFI partition as listed by the list partition command.

    assign letter = x

    Where x is the desired drive letter.

    These commands create an EFI partition 1 of 100 MB, create an MSR partition 2 of 32 or 128 MB, and create a primary partition 3 that fills the rest of the disk.

  3. Close DiskPart by typing this command:
    exit
  4. Type this command:
    format c: /fs:ntfs /q /y

    If the master computer uses NTFS, the destination computer files must use NTFS also.

  5. Type this command:
    format x: /fs:fat32 /q /y

    Where x is the EFI partition drive letter. The EFI partition can use FAT or FAT32; however, FAT32 is recommended.

  6. Use the net use command to connect to the server and share where you stored the operating system and EFI files. Then use these commands:
    xcopy \\server\share\OS\*.* c:\ /cherky
xcopy \\server\share\EFI\*.* x:\ /cherky
  7. To start from the Windows folder next time, type this command:
    EFINVR /add x:\efi\microsoft\winnt5.0\ia64ldr.efi c:\windows /setactive
  8. Exit WinPE.
  9. Start into Factory mode if you ran Sysprep –factory on the original computer before xcopy.

    -OR-

    Start into Mini-Setup if you ran Sysprep –reseal on the original computer before xcopy.


Customizing the Windows Experience

There are many ways you can customize how Microsoft® Windows® appears to the user. You can brand the Windows installation with your company logo and identity, include your support information in Windows, and customize the Most Frequently Used (MFU) list of programs in the Start menu.

  • Adding Your Company Information and Logo to System Properties
  • Customizing the Start Menu and the OEM Link
  • Customizing the Desktop Background
  • Customizing Desktop Cleanup
  • Including Your Information in Help and Support Center
  • Installing Step By Step Interactive in Windows XP
  • Customizing Microsoft Internet Explorer
  • Designing Toolbar Icons for Internet Explorer
  • Customizing Windows Media Player
  • Removing Access to Windows Components

Customization Guidelines and Default Settings

For a summary of changes you can and cannot make to the interface, see the Customization Guidelines.

For a list of the default Windows Desktop settings that the user can change, see Windows Desktop Default Settings. OEMs are not permitted to change these default settings unless otherwise specified in a topic listed on Customization Guidelines or your separate license agreement.


Adding Your Company Information and Logo to System Properties

Under the terms of your OEM license agreement, you must identify the computer manufacturer and specify customer support information, which displays when the user clicks the Support Information button on the General tab in System Properties. You must localize this information into the language of the preinstalled Windows operating system.

You may also add your company logo to System Properties.

To specify your branding and support information

  1. In Setup Manager, go to the OEM Branding Information page.
  2. In the Manufacturer box, type your manufacturer name. This information is required.
  3. In the Model box, type the model for this computer. This information is optional.
  4. In the Provide information on how your customers can get support box, type instructions for the end user to obtain support. This information is required.
    • You must include telephone numbers and hours for your technical support group.
    • You may add a URL for the technical information page of your company Web site.
    • You may include information for several countries or regions with a common language and different support contact information.

Important

  • Do not list Microsoft in the support information section. You are responsible for Windows customer support on all the computers that you manufacture and distribute.
  • You must localize the required [Support Information] section in Oeminfo.ini into the language of the installed operating system for the computers that you manufacture. Microsoft includes only a U.S. English sample in this OPK.
  • Do not include any information, such as the version number of the Windows operating system, that can change if the user upgrades to the next version.
  • Do not include any information in the support section that does not directly pertain to support.

The Setup Manager settings from this page are saved in this location:

Oeminfo.ini
[General]
Manufacturer =
Model =

[Support Information]
Line1 =
Line2 =
Line3 =
Line4 =
etc.

In addition, you can use a text editor to edit the [OEMSpecific] and [ICW] sections in the Oeminfo.ini file. The information in the [OEMSpecific] section does not appear in Windows; however, a support technician can gain access to this information by instructing the user to click Start, click Run, and then type Oeminfo.ini.

Adding Your Logo to System Properties

You can easily customize the General tab in System Properties to display your company logo. After you add your Oemlogo.bmp file to the appropriate folders, Setup inserts the words "Manufactured and supported by:" and your logo in the lower left corner of the General tab, under the existing computer image.

Sample System Properties

To display your logo on the General tab in System Properties

  1. Create a bitmap file, Oemlogo.bmp, that contains your company logo. The bitmap must be 172 x 100 pixels in size.
  2. Place the file in the $OEM$\$$\System32 subfolder of the configuration set.

    Note

    • For the image to display in System Properties, Oeminfo.ini must be in the %WINDIR%\System32 folder.
  3. In Setup Manager, on the Logo Information page, select the Display the following logo in System Properties check box.
  4. Specify the path and file name for the logo bitmap.
  5. To make sure that the logo displays correctly, copy Oemlogo.bmp to the %WINDIR%\System32 subfolder on a test computer running Windows.
  6. Test the logo, using these display and font settings:
    • 640 x 80 pixels, Large Fonts
    • 640 x 480 pixels, Small Fonts
    • 1024 x 68 pixels, Large Fonts
    • 1024 x 768 pixels, Small Fonts

Your logo must map properly to the 16-color standard VGA palette and must display legibly on monochrome LCD monitors. The background color must match the system default (typically gray) of the destination computer.

Important

  • Logo bitmap images that do not use the system default are ignored and not displayed.
  • The logo must be no larger than the Microsoft bitmap image that appears at the top of the General tab.
  • The logo must be a primary logo that represents only your company or this line of computers. No other logos, advertisements, or information can appear.
  • The image file used for the System Properties dialog box must be named Oemlogo.bmp. In contrast, you can use any file name for the Windows Welcome logo file.


Customizing the Start Menu and the OEM Link

On Windows XP, the Start menu contains a set of shortcuts to the most frequently used applications on the computer. Windows XP automatically manages this set of shortcuts over time as end users use their computer. OEMs can pre-populate part of the Most Frequently Used (MFU) list with shortcuts to preinstalled applications.

Additionally, OEMs can specify a location on the Start menu, where they can link to an OEM-specific .htm or .exe file.

Sample Start Menu

To specify programs for the Start menu

  1. In Setup Manager, go to the Start Menu page.
  2. In the Path 1 text box, type the complete path and file name of a shortcut (.lnk) file located in one of the following locations. You can use environment variables like %ALLUSERSPROFILE% as part of the path.
    • The All Users Desktop folder.

      For example: "C:\Documents and Settings\All Users\Desktop"

    • The All Users Programs folder or one of its subfolders.

      For example: "C:\Documents and Settings\All Users\Start Menu\Programs"

      You may also refer to an .lnk file located in one of the following locations. However, unless you know the name of the user account(s) that will be configured on the computer, these options are not available to the end user.

    • A user-specific Desktop folder.

      For example: "C:\Documents and Settings\UserId\Desktop", where UserID is the name of a user account that the end user will use.

    • A user-specific Programs folder or one of its subfolders.

      For example: "C:\Documents and Settings\UserId\Start Menu\Programs", where UserID is the name of a user account that the end user will use.

  3. Repeat for each Path text box.

    You may add up to three items to the MFU applications list on the Start menu.

Notes

  • Although you may specify four shortcuts in the Winbom.ini file, only three items appear in the MFU list. The extra item is available in case of any unintentional duplication between the items that you add to the list with the items that appear by default in the MFU list.
  • The path is not a path to an application (.exe). The location of the corresponding .exe file is specified in the shortcut itself.
  • Sysprep adds these link(s) to the MFU list, located under the separator line on the Start menu. These entries have no effect on the "All Programs" area of the Start menu.
  • For information specific to the Start menu on the Windows .NET Server family, see Start Menu Differences in Servers Running Windows .NET.

The Setup Manager settings from this page are saved in the following location:

Winbom.ini
[StartMenuMFUlist]
Link0
Link1
Link2
Link3

To specify your OEM link

  1. In Setup Manager, go to the OEM Link on the Start Menu page.
  2. Select Enable OEM link.
  3. In the Link text box, type up to one line of text.
  4. In the Infotip text box, type an infotip for your link.
  5. In the Icon for the OEM link box, specify the full path and name of the source icon file.

    The maximum size of this icon is 24 x 24 pixels.

  6. In the Target file box, type the full path and name of the local .htm or .exe file that launches when the user clicks the link on the Start Menu.

Any trade names, trademarks, logos, or brands displayed in connection with the OEM link must be limited to those under which the system is manufactured and distributed.

The Setup Manager settings from this page are saved in this location:

Winbom.ini
[OemLink]
OemBrandIcon
OemBrandLink
OemBrandLinkText
OemBrandLinkInfoTip

Important

  • After you configure an OEM link to appear on the Start menu, you can use the command sysprep -factory to modify the properties of the OEM Link as specified in the [OEMLink] section of Winbom.ini. However, once you create an OEM link, you cannot delete it. Your only alternative is to do a clean installation of Windows XP.


Customizing the Desktop Background

Desktop backgrounds (wallpaper) can be customized using Unattend.txt. Use the [Shell] section of Unattend.txt to set CustomDefaultThemeFile to a theme file referencing your custom background graphic file.

A theme file is an answer file with a .theme extension. The Wallpaper entry in the [Control Panel\Desktop] section of the .theme file controls the desktop. For example:

[Control Panel\Desktop]
Wallpaper=\\servername\foldername\oem_background_graphic.ext

The custom background graphic file must be located in a folder that can be accessed by all users of the computer. For example, place the file in %WINDIR%. Do not place the file in a subfolder of %SYSTEMDRIVE%\Documents and Settings.

To customize the desktop background

  1. Build your theme file either by hand or script with a valid Wallpaper entry in the [Control Panel\Desktop] section.
  2. Set CustomDefaultThemeFile in Unattend.txt to the fully qualified file name of your .theme file.
  3. Put the background graphic file in the location specified in the Wallpaper entry of the .theme file.
  4. Run the unattended preinstallation.


Customizing Desktop Cleanup

Usability testing and customer feedback indicate that a clean Windows desktop, combined with the improved Start menu, create the best end-user PC experience. End users perceive the desktop as their personal working space.

You may use Sysprep in Factory mode to move all items on the Windows desktop, other than the Recycle Bin, to a folder located in %SYSTEMDRIVE%\Program Files. To do so, set DoDesktopCleanup to Yes in the [Shell] section of the Winbom.ini file.

Any shortcuts installed in the desktop folder (for example, C:\Documents and Settings\UserName\Desktop) are placed in the C:\Program files\Shortcuts_Folder folder. To specify a name for the Shortcuts_Folder folder, use the DesktopShortcutsFolderName entry in the [DesktopShortcutsFolder] section of Winbom.ini. If no folder name is specified, the default name "Program Shortcuts" is used for Shortcuts_Folder.

After the first-run experience is complete, the user can add shortcuts directly to the desktop. In addition, a shortcut may be placed on the desktop when the end user installs an application. At periodic intervals, the Desktop Cleanup wizard enables the end user to place unused Windows desktop icons and folders into the "Unused Desktop Shortcuts" folder on the desktop.

If you clean the Windows desktop at the end of your factory preinstallation process, the Desktop Cleanup wizard runs for the first time 60 days after the end-user first-run experience. Otherwise, the Desktop Cleanup wizard runs for the first time 14 days after the end-user first-run experience. Do not disable or change the schedule of the Desktop Cleanup wizard.


Including Your Information in Help and Support Center

Windows Help and Support Center can be extended or modified for OEM customization. Help and Support Center is the help application in Windows XP, replacing traditional HTML Help. This is an HTML-based application that enables users to get help from local help files or remote help repositories. Help and Support Center delivers a user experience that enables users to find information that, in both consumer and business environments, solves their problems and shows them how to use features in Windows.

With Help and Support Center, there are several opportunities to add branding identification and describe processes and information unique to the computers that your company distributes. Your Help information blends seamlessly with the Help and Support Center navigation and content to provide better assistance for your customers.

In addition to adding your own Help information to Help and Support Center, the Step By Step Interactive (SBSI) training program (if required) is also integrated into Help and Support Center. SBSI provides a rich, interactive multimedia learning experience.

For more information, see

  • Installing Step By Step Interactive in Windows XP
  • Requirements for Step by Step Interactive in OEM Licensing Requirements

To add your information to Help and Support Center

  • Add your Company Logo, Name, Model, and Support information to the Help and Support Center home page. When you complete the OEM Branding Information page and Branding Opportunities page in Setup Manager, the information that you specify there for company name, logo, model, and support information are automatically used in the Support overview page in Help and Support Center. This is the same information that displays in System Properties. For more information, see Adding Your Company Information and Logo to System Properties.

    The information is integrated into this page:

    Sample Help and Support Center

  • Create your Help content. Though Help and Support Center replaces the HTML Help viewer, most local Help topics are still created using HTML Help. You can also link to individual Web pages, either locally or on the Internet. For general information about creating HTML Help files, see the white paper Windows XP Help and Support Center Customization Guide, located on the Windows OPK CD.

    Important

    • If you decide to add Help files to Windows Help, the files must include technical support telephone numbers and other support contact information, even if you already specified the same information in Oeminfo.ini to appear in System Properties
      • .
  • Integrate your Help topics and links into Help and Support Center Taxonomy, Search and Index (royalty OEMs only). To accomplish this, package your files in a .cab file, and then have that .cab file signed by Microsoft. For more information, see the white paper Windows XP Help and Support Center Customization Guide, located on the Windows OPK CD.

To change information without reinstalling

It is possible to change the contents of Oeminfo.ini as displayed in Help and Support Center without reinstalling. You can manually edit the registry to change the text that identifies the OEM.

To do this, modify the OEMInfo registry key:

HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\PCHealth\HelpSvc\OEMInfo

Manufacturer = oem_name

Model = model_name

Text = text

[#BR#][text[#BR#]...]

Each #BR# is converted to a new line. For example:

Text = "For support, please call:#BR#USA 1-800-555-1212#BR#Europe 1-800-333-1212#BR#E-mail : Support@oem_name.com#BR#"

To change the logo bitmap without reinstalling

To change the Oemlogo bitmap, replace Oemlogo.bmp in C:\%WINDIR%\System32 with another bitmap of the same name.

Any business partners building applications or content to plug into Help and Support Center can obtain the PC Health SDK (https://oem.microsoft.com/directoem/510659.asp) from the Microsoft Direct OEM Web site. For access to this Web site, contact your account manager.


Installing Step by Step Interactive in Windows XP

Microsoft Windows XP Step by Step Interactive (SBSI) training consists of several multimedia end user simulation training programs that are integrated with Windows XP Help and Support Center.

There are separate versions of SBSI for the Home Edition and Professional editions of Windows XP. SBSI is not available for Windows XP 64-Bit Edition or the Windows .NET Server family.

Users can access Step by Step Interactive through Windows Help and Support Center or by clicking the Start menu, clicking All Programs, pointing to Accessories, and then clicking Microsoft Interactive Training. In addition to using it as end-user Help, you may also use SBSI as a support tool, enabling users to find their own answers to common questions.

If Step by Step Interactive is not available in a particular language, such as Danish, then Help and Support Center does not include any references to Step by Step Interactive in that language version of Windows XP.

Important

  • Step by Step Interactive (SBSI) training is not included in the default installation of Windows XP. However, SBSI is a required component of Windows XP Home Edition and Windows XP Professional preinstallation, and you must specifically preinstall the Step by Step Interactive content for each version and language where a localized version is available. For a complete list of available languages, see Requirements for Step by Step Interactive in OEM Licensing Requirements.
  • In English-language versions of the OPK, Step by Step Interactive content is available on the Windows OPK CD, and Setup Manager automatically includes the appropriate command line in the [OEMRunOnce] section of Winbom.ini.
  • Non-English versions of Windows XP Step by Step Interactive are located on the language-specific Microsoft Windows XP Step by Step Interactive CD that is packaged with the OPK.

Installing the English-Language Version of Step by Step Interactive

If the OPK tools are installed on ComputerName\OPKTools, then the specific command to install the English version of SBSI for Windows XP Home Edition is:

\\ComputerName\OPKTools\Lang\Eng\SBSI\Per\Setup\Setup.exe
-SMS -S -f1\\ComputerName\OPKTools\Lang\Eng\SBSI\Per\Setup\
Silent.iss

The specific command to install the English version of SBSI for Windows XP Professional Edition is:

\\ComputerName\OPKTools\Lang\Eng\SBSI\Pro\Setup\Setup.exe
-SMS -S -f1\\ComputerName\OPKTools\Lang\Eng\SBSI\Pro\Setup\
Silent.iss

For English versions of Windows, Setup Manager automatically includes this command in the [OEMRunOnce] section of Winbom.ini. In Windows XP Home Edition, the syntax of this command in Winbom.ini is:

"Installing Step by Step Interactive", """\\ComputerName\OPKTools\Lang\Eng\SBSI\Per\Setup\Setup.exe"" -SMS -S -f1""\\ComputerName\OPKTools\Lang\Eng\SBSI\Per\Setup\Silent.iss"""

In Windows XP Professional Edition, the syntax of this command in Winbom.ini is:

"Installing Step by Step Interactive", """\\ComputerName\OPKTools\Lang\Eng\SBSI\Pro\Setup\Setup.exe"" -SMS -S -f1""\\ComputerName\OPKTools\Lang\Eng\SBSI\Pro\Setup\Silent.iss"""

Note

  • In the command line, there are three sets of quotation marks after the phrase "Step by Step Interactive" and only two sets of quotation marks following Setup.exe. There are also two sets of quotation marks after -f1 and three sets of quotation marks at the very end. This command line is case-sensitive and the -SMS must be capitalized.

Installing Non-English-Language Versions of Step by Step Interactive

If the language-specific SBSI CD is located in the CD-ROM drive (specified by drive), then the specific command to install a non-English version of SBSI is:

drive\Setup\Setup.exe –SMS –S –f1drive\Setup\Silent.iss

You can include this command in the [OEMRunOnce] section of Winbom.ini, or you can launch a batch file at the root folder to run the command, where the location of the batch file becomes part of the path to Silent.iss.

To remove Step by Step Interactive from your preinstallation

  1. In the %WINDIR%\Help\SBSI\Training folder on the destination computer, double-click Ounins32_s.exe.
  2. Select the installed Step by Step Interactive training program, and then click Remove All.

Note

  • Step by Step Interactive requires a minimum display resolution of 640 x 480 pixels with at least 256 colors. If the system display settings do not meet or exceed these minimum requirements, do not install Step by Step Interactive.


Customizing Microsoft Internet Explorer

Microsoft Internet Explorer customization enables you to modify these URLs:

  • Default run-once page URL
  • Default home page URL
  • Default search page URL
  • Default online support page URL

You can also add:

  • Your own items to the Favorites list, including a custom folder
  • One OEM toolbar button

You must:

  • Display the Microsoft preloaded favorites in the Favorites page of Microsoft Internet Explorer, as loaded during the preinstallation process

However, you may not:

  • Place additional, preloaded URLs or Internet Explorer folders at a level higher than your custom folder.
  • Replace the Internet Explorer symbol that appears in the upper-right corner of the Internet Explorer window and other windows in Windows XP or the Windows .NET Server family.

On Windows XP, you may install and configure an alternative Internet browser as the default browser, where this application is associated with the registered file types of recognized Internet files. You may also configure the Internet icon on the Start menu to use this alternative browser, as described in the Microsoft Knowledge Base (http://support.microsoft.com/support/kb/articles/q297/8/78.asp, article 297878).

On Windows XP, you may remove any visible entry points (shortcuts) to Internet Explorer, as specified in Removing Access to Windows Components. For more information, see Customization Guidelines: Internet Explorer.

Important

  • If the user has an existing ISP and uses automatic configuration, your OEM branding of Internet Explorer is not processed. The automatic configuration settings defined in the ISP Internet settings (.ins) file are processed after the settings you indicate here are processed, and will overwrite your settings.

To set the run-once URL for Internet Explorer

You can set the URL that Internet Explorer connects to the first time the user runs Internet Explorer. Since this does not appear as an option in Setup Manager, you create the needed entry in the Install.ins file after you run Setup Manager.

  • Enter the following entry into the [URL] section of the Install.ins file:
    FirstHomePage = URL

    where:

    URL indicates the Web site that you want to appear the first time Internet Explorer runs.

For more information, see the Internet Explorer Administration Kit (IEAK).

Setting the Home Page, Search Page, and Online Support Page URL

Specify URLs for the default home, search, and support pages through the Important URLS page in Setup Manager.

To specify the home page URL

The home page, sometimes known as a start page, appears when the user opens Internet Explorer or clicks the Home button on the toolbar. Internet Explorer can show a default home page, or you can specify a URL for your own page.

  1. Select When the user clicks Home, go to, and then type the URL for the home page in the box.
  2. Click Test URL to ensure that the URL you specified exists and is accessible by using the exact syntax you specified.

To specify the Search bar URL

The Search bar appears in the Explorer bar on the left side of the browser window when the user clicks the Search button on the Internet Explorer toolbar. This bar displays a search page and enables a user to see the search query and results at the same time. The Search bar comes with a choice of search services.

  1. Select When the user clicks Search, go to, and then type the URL that you want to use in the box.
  2. Click Test URL to ensure that the URL you specified exists and is accessible by using the exact syntax you specified.

To specify the Online Support page URL

In Internet Explorer, support information is available by clicking the Help menu and then clicking Online Support. It is recommended that you develop a support page and make it available to your users.

  1. Select When the user clicks Help and then Online Support, go to, and then type the URL for your custom support page in the box.
  2. Click Test URL to ensure that the URL you specified exists and is accessible by using the exact syntax you specified.

To add and edit URLs and folders in the Favorites and Links lists

  1. Determine which sites you want to include in the lists, and how you want to structure them.
  2. Create the icons that you want to associate with your URLs in the Favorites list, and place them on the master computer where you want them to reside.

    Important

    • The icons must use the 256-color Windows palette, and be 16 x 16 pixels in size.
  3. Create a new or open an existing configuration set in Setup Manager.
  4. On the Favorites and Links page, click the location in the tree where you want the URL to appear. To add a new URL, click Add URL. To add a new folder, click Add Folder. Type the URL or the folder name you want, and then click OK.

    Important

    • You must name the custom folder "OEM" or "OEM Recommended Sites" (where OEM is your manufacturer name).
  5. To edit a URL or folder, select it in the list, and then click Edit.

    If you’re editing a folder, type the folder name you want in the Name box, and then click OK.

    Important

    • You must name the custom folder "OEM" or "OEM Recommended Sites" (where OEM is your manufacturer name).

    If you're editing a URL, fill out the following and then click OK:

    • Display name: This is the text that the end user sees on the Favorites menu. For example, if the URL is New1.url, you replace the "New1" portion of the link with the descriptive name that you want to appear in the Favorites list. You can use long file name conventions, but the descriptive name that you use must end with .url.
    • URL: This must begin with the typical http://www.
    • Icon: The icon appears next to the name text in the Favorites list. To add an icon, click Browse and locate the icon file that you want to use, and then click Open.
  6. Click Test URL to ensure that the URL you specified exists and is accessible by using the exact syntax you specified.

To customize Internet Explorer in Unattend.txt

  1. Edit the Unattend.txt file by using a text editor such as Notepad.
  2. Specify the following sections and entries in the Unattend.txt file:
    [Unattended]
OemPreinstall = Yes

[Branding]
BrandIEUsingUnattended = Yes
  3. Specify the sections and values that you want to customize in the Unattend.txt file.

    For example:

    [FavoritesEx]
Title1 = "Fabrikam, Inc. FAQ.url"
URL1 = "http://www.Fabrikam.com/faq"
Title2 = "Fabrikam, Inc. Downloads.url"
URL2 = "http://www.Fabrikam.com/downloads"
Title3 = "Fabrikam, Inc. Product Support.url"
URL3 = "http://www.Fabrikam.com/ask-us"

[URL]
AutoConfig = 0

To specify a Web site, use a reference like this:

URL3 = http://www.Fabrikam.com

Then, replace http://www.Fabrikam.com with the URL to your support page.

Removing Internet Explorer Shortcuts

On Windows XP, you can remove visible entry points (shortcuts) to Internet Explorer, as specified in Removing Access to Windows Components.


Designing Toolbar Icons for Internet Explorer

To create a toolbar icon, you must provide each image in two sizes for two toolbar states (grayscale for the default state and color for the active state when the user's mouse is pointing to it), and in two color depths.

To create your images

  1. After drawing your images in a graphics program, place the 16-color and 256-color images in separate files.
  2. Index each file to the appropriate palette, either the Windows 16-color palette or the Windows half-tone palette. Reserve a specific color to denote transparency.
  3. Save each file as a .bmp file.

The following is a summary of the required images:

Icon State Size, in pixels Color Depth/Palette Border Appearance Example
Active 20 x 20 256-color Windows half-tone palette Icon-style border: color on the top and left edges, and black on the bottom and right edges
  • Color image
  • More shading and visual depth than 16-color image
  • A light source from the upper left and shading where appropriate
 Active state: 256-color, 20 by 20 pixels
20 x 20 16-color Windows palette Black, except when a border interferes with the readability of the icon
  • Color image
  • Little shading; flat appearance
 Active state: 16-color, 20 by 20 pixels
16 x 16 16-color Windows palette Black, except when a border interferes with the readability of the icon
  • Color image
  • Little shading; flat appearance
 Active state: 16-color, 16 by 16 pixels
Default 20 x 20 256-color Windows half-tone palette Icon-style border: grey tones on the top and left edges, and black on the bottom and right edges
  • Grayscale image
  • More shading and visual depth than 16-color image
  • A light source from the upper left and shading where appropriate
 Default state: 256-color, 20 by 20 pixels
20 x 20 16-color Windows palette Black, except when a border interferes with the readability of the icon
  • Grayscale image
  • Little shading; flat appearance
 Default state: 16-color, 20 by 20 pixels
16 x 16 16-color Windows palette Black, except when a border interferes with the readability of the icon
  • Grayscale image
  • Little shading; flat appearance
 Default state: 16-color, 16 by 16 pixels

Make sure the visual transitions between your default and active images are smooth. An easy way to test this is to create separate layers for the default and active images in a photo imaging program so that you can view the images on top of each other.

Changing Bitmap Images into Icons

Create two .ico files for each icon:

  • The first .ico file contains the active images (color) in both sizes and color depths.
  • The second .ico file contains the default images (grayscale) in both sizes and color depths.

It is recommended that you use a graphics program to draw your icons and a development environment, such as Microsoft Visual C++ Development Studio, to create the .ico files.

Example

The two icon files for the Home icon contain the following images:

Active State | Default State
Icon for active state | Icon for default state

To create your icon files in Visual C++

  1. Open each .bmp file.
  2. On the File menu, click New, and then click Icon. By default, the icon window that opens displays a standard 32 x 32-pixel device image.
  3. In the Icon window, click New Device Image. Click Custom, and then create these image devices:
    • One 22 x 20-pixel 16-color image
    • One 22 x 20-pixel 256-color image
    • One 18 x 16-pixel 16-color image

    Note

    • The device images are two pixels wider than the images. Center your images in the device image area.
  4. Delete the default 32 x 32-pixel device image.
  5. Copy and paste the color images from your .bmp files into the appropriate device image size and color depth.
  6. To make the background transparent, select the transparent color in the color palette and fill the background of each image where you want transparency.
  7. Save the file as an .ico file.

Follow the same procedure to create your default (grayscale) .ico file.


Customizing Windows Media Player

You can modify the following items in Windows Media Player:

  • Provide one or more custom visual styles, or "skins."
  • Configure Windows Media Player to use your custom skin as the default.
  • Set the Windows Media Player as the default application for automatically playing DVDs (DVD AutoPlay).
  • Enable MP3 encoding in Windows Media Player.

You can also remove visible entry points to Windows Media Player, as specified in Removing Access to Windows Components.

For customization guidelines and requirements, see Customization Guidelines: Windows Media Player.

Designing Custom Skins for Windows Media Player

A skin is a customized user interface that overlays Windows Media Player when the player is in compact mode. To see Windows Media Player in compact mode, press CTRL+2. Windows Media Player is available with many skins that users can choose from, or you can develop and distribute your own skins. For more information on creating skins, see the Windows Media Player Software Development Kit (http://www.msdn.microsoft.com/windowsmedia/).

For co-branding opportunities, contact wmpoem@microsoft.com.

To make your custom skins available in Windows Media Player

  1. Create a skin, as described in the Windows Media Player Software Development Kit (http://www.msdn.microsoft.com/windowsmedia/).
  2. Copy the skins to the %SYSTEMDRIVE%\Program Files\Windows Media Player\Skins folder, where %SYSTEMDRIVE% is the drive that contains the Windows installation.

To set the default skin for Windows Media Player

  1. Create a skin, as described in the Windows Media Player Software Development Kit (http://www.msdn.microsoft.com/windowsmedia/).
  2. Copy the skin to the %SYSTEMDRIVE%\Program Files\Windows Media Player\Skins folder, where %SYSTEMDRIVE% is the drive that contains the Windows installation.
  3. On the destination computer, open the registry with Registry Editor or another registry editing tool.
  4. Set the value of HKEY_LOCAL_MACHINE\Software\Microsoft\MediaPlayer\Preferences\OEMSkin equal to the file name of your skin (for example, Oem.wmz).

Setting Windows Media Player as the Default DVD Application

If another DVD player application is already installed and is set as the default playback application for DVDs, you can edit the registry to specify that the Windows Media Player be the default player for DVDs.

To set Windows Media Player as the default DVD application

  1. On the destination computer, open the registry with Registry Editor or another registry editing tool.
  2. Set the value of HKEY_CLASSES_ROOT\DVD\Shell\Play\Command equal to "%SYSTEMDRIVE%\Windows Media Player\wmplayer.exe" /device:DVD "%L", where %SYSTEMDRIVE% is the drive that contains the Windows installation.

Enabling MP3 Encoding for Windows Media Player

Windows Media Player supports MP3 encoding. To enable the Windows Media Player to encode MP3 files, you need to license an MP3 encoder, install the encoder, and then change registry settings.

To set Windows Media Player for MP3 Encoding

  1. On the destination computer, open the registry with Registry Editor or another registry editing tool.
  2. Open the registry key HKEY_LOCAL_MACHINE\Software\Microsoft\MediaPlayer\Settings\MP3Encoding
  3. Set the following values:
    DWORD LowRate
Value <datarate>
DWORD LowRateSample
Value <Sample>
DWORD MediumRate
Value <datarate>
DWORD MediumRateSample
Value <Sample>
DWORD MediumHighRate
Value <datarate>
DWORD MediumHighRateSample
Value <Sample>
DWORD HighRate
Value <datarate>
DWORD HighRateSample
Value <Sample>
String PreferredCodec
Value <codec name>

    For example, to set the LowRate to 56 kbps, set the following keys:

    HKLM,"%KEY_WMP%\Settings\MP3Encoding","LowRate",0x00010001,56000
HKLM,"%KEY_WMP%\Settings\MP3Encoding","LowRateSample",0x00010001,24000
HKLM,"%KEY_WMP%\Settings\MP3Encoding","PreferredCodecName",,"MPEG Layer-3"
HKLM,"%KEY_WMP%\Settings\MP3Encoding","PreferredCodecPath",,"D:\WINDOWS\system32\l3codeca.acm"

    Note

    • The value for PreferredCodec is limited to 255 characters.

Removing Windows Media Player Shortcuts

On Windows XP, you can remove visible entry points to Windows Media Player, as specified in Removing Access to Windows Components.


Removing Access to Windows Components

On Windows XP, you may remove visible entry points to Internet Explorer, Outlook Express, Windows Media Player, or Windows Messenger. These visible entry points can be removed either as part of an unattended Setup or post-Setup through the use of the Sysprep or Factory tools.

Note

  • Options to remove visible entry points for each of these items are also available in the Add or Remove Programs tool, under both Add/Remove Windows Components and Set Program Access and Defaults.

To remove visible entry points during unattended Setup

  1. Use Setup Manager to create an Unattend.txt file, or modify an existing Unattend.txt file.
  2. To remove Internet Explorer visible entry points, in the [Components] section of the Unattend.txt file, set IEAccess equal to Off.
  3. To remove Outlook Express visible entry points, in the [Components] section of the Unattend.txt file, set OEAccess equal to Off.
  4. To remove Windows Media Player visible entry points, in the [Components] section of the Unattend.txt file, set WMPOCM equal to Off.
  5. To remove Windows Messenger visible entry points, in the [Components] section of the Unattend.txt file, set WMAccess equal to Off.
  6. Run an unattended Setup, following the instructions in Winnt32.exe Command-Line Options.

Sample

[Components]
IEAccess = Off
OEAccess = Off
WMPOCM = Off
WMAccess = Off

To remove Internet Explorer, Outlook Express, Windows Media Player, or Windows Messenger visible entry points after you have already installed Windows, complete one of these procedures:

To remove visible entry points by using Sysprep

  1. Create an Unattend.txt file with one or more of the following entries in the [Components] section:
    [Components]
IEAccess = Off
OEAccess = Off
WMPOCM = Off
WMAccess = Off

    You can use the same Unattend.txt file as described previously in "Removing visible entry points during unattended Setup," or you can use a separate file that contains only the [Components] section.

  2. Add the following command line to the [GuiRunOnce] section of Sysprep.inf:
    [GuiRunOnce]
sysocmgr /u:unattend.txt /q /r /c /x
  3. Run Sysprep, following the instructions in Using Sysprep.

To remove visible entry points by using the Winbom.ini file and the Factory tool

  1. Create a Winbom.ini file with one or more of the following entries in the [Components] section:
    [Components]
IEAccess = Off
OEAccess = Off
WMPOCM = Off
WMAccess = Off
  2. Add the following command line to the [GuiRunOnce] section of Sysprep.inf:
    [GuiRunOnce]
sysocmgr /u:winbom.ini /q /r /c /x
  3. Run Sysprep -factory, following the instructions in Using Sysprep in Factory Mode.

Changing the Default Programs

On Windows XP, you may install third-party applications that launch in place of Internet Explorer, Outlook Express, Windows Media Player, or Windows Messenger, as enabled by Windows registry settings and other documented mechanisms. The installation program for these third-party applications can register the application(s) by changing items such as the default file associations for particular extensions, URL protocol handlers, MIME handlers, and autoplay handlers, such that the third party applications are invoked (under equivalent circumstances) instead of Internet Explorer, Outlook Express, Windows Media Player, or Windows Messenger. For more information, see Registering Applications with Client Types (http://msdn.microsoft.com/library/en-us/shellcc/platform/shell/programmersguide/shell_adv/RegisteringApps.asp).

To configure Windows so that an end user can later reinstate the original OEM configuration for these components, add the following entries to the Shell section of the Winbom.ini file.

[Shell]
DefaultClientStartMenuInternet =
DefaultClientMail =
DefaultClientMedia =
DefaultClientIM =
DefaultClientJavaVM =

The default setting for each of these entries is none. You can change these defaults by listing the canonical name of a replacement program, as described in Registering Applications with Client Types (http://msdn.microsoft.com/library/en-us/shellcc/platform/shell/programmersguide/shell_adv/RegisteringApps.asp), on the right side of each equal sign.

Any program specified for any of these entries must be able to change default file associations as described in Registering Applications with Client Types.

If an entry is missing, then the default program associated with that entry does not change when the user chooses to reinstate the original OEM configuration. For example, if there is no DefaultClientJavaVM entry, then the default virtual machine for Java is left unchanged if the user chooses to reinstate the OEM default setting.

Replacing the MSN Explorer Shortcut with an MSN Internet Access Shortcut

If you remove the Internet Explorer visible entry points, you may also replace the MSN Explorer shortcut with a shortcut to MSN Internet Access. Do not change the MSN Explorer icon if the MSN Internet Access sign-up offer is available to the end user in Windows Welcome. Do not remove any MSN code, other than these shortcuts. Various Windows components and third-party applications rely upon MSN code.

Note

  • If MSN Explorer or MSN Internet Access is not available in a particular language version of Windows XP, no further action is required.

To replace the MSN Explorer shortcut with an MSN Internet Access shortcut

  • Include the following entries in Winbom.ini:
    [Components]
IEAccess = No
[Shell]
MSNExplorer = No

Important

  • Do not change the MSN Explorer icon if MSN Internet Access is available to the user in Windows Welcome.
  • The only two Winbom.ini entries required to replace the MSN shortcut with an MSN Internet Access shortcut are the IEAccess entry in the [Components] section and the MSNExplorer entry in the [Shell] section. In the [Components] section of Winbom.ini or Unattend.txt, do not set msnexplr = No.

For more information, see Customization Guidelines: Internet Explorer and Outlook Express.


Configuring Windows Welcome

Windows Welcome is the users' first look at the Microsoft Windows operating system when they first start their new computer.

Note

  • There are two different versions of Windows Welcome: Retail and OEM. The Retail Windows Welcome runs after every fresh installation or upgrade. To ensure that the OEM version runs when customers first start a new computer, you must run Sysprep to reseal the computer before shipping it to the customer.

Through a series of full-screen, HTML-based pages, Windows Welcome quickly and easily takes users through the final steps of setting up their personal computer that is running the Microsoft Windows XP Home Edition or the Microsoft Windows XP Professional operating system. Users are prompted for any additional information that is needed to personalize their settings, which can include regional and language options, network configuration (where applicable), and Internet connection settings.

You, or the user, may skip setting up an Internet connection during Windows Welcome. However, marketing and usability studies show that connecting to the Internet is one of the primary reasons that users buy a computer, so many users want to set up an Internet connection.

You can customize certain aspects of Windows Welcome, combining your own OEM enhancements with its core setup functionality. This includes customizing the ISP sign-up offer, and placing your company name and logo into Windows Welcome.

For more information on Windows Welcome, see these topics:

  • Overview of the Windows Welcome Process
  • Branding Windows Welcome
  • Changing Windows Welcome on All Computers
  • Collecting Registration Data
  • ISP Sign-up Options and Offers
  • Making Changes on a Per-Machine Basis
  • Testing and Debugging Windows Welcome

Also, see the white paper entitled Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.


Overview of the Windows Welcome Process

Even without customizing any pages, there are a minimum number of pages that must display to the user during Windows Welcome. These topics describe the overall process:

  • Windows Welcome Sections That You Can Modify
  • Windows Welcome Full Setup Flowchart
  • Mini-Setup Flowchart

For more information on the requirements and customizations allowed during Windows Welcome, see Customization Guidelines: First-Run Experience.


Windows Welcome Sections That You Can Modify

The following table lists the sections of Windows Welcome that you can modify, and which files and sections to modify them in.

Notes

  • This table lists only the Windows Welcome pages that you can modify, not all of the pages in Windows Welcome.
  • Some of these Windows Welcome files already exist in %WINDIR%\System32\Oobe\Setup; the other files must be placed in the locations noted in the table.

For specific requirements and more information on modifying the content of the pages displayed to users in Windows Welcome, see Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.

For this page of Windows Welcome | You can do this | With these files or tools | Reference sections
Activation activate.htm | Turn on/off | Unattend.txt (Setup Manager) | [UserData] AutoActivate
Administrator Password security.htm | Prepopulate | Oobeinfo.ini | [Options] AdminPW
Computer Name compname.htm | Prepopulate | Sysprep.inf Unattend.txt (Setup Manager) | [UserData] ComputerName
DomainAdmin jndomain.htm | Prepopulate | Sysprep.inf Unattend.txt (Setup Manager) | [Identification] DomainAdmin
DomainAdmin Password security.htm | Prepopulate | Sysprep.inf Unattend.txt (Setup Manager) | [Identification] DomainAdminPassword
Finish fini.htm | Add your company name; may add up to four lines of additional text (must follow any text already on the page) |  |
Hardware Tutorial oemhw.htm | Create the file; turn on/off | Oobeinfo.ini | [Options] OEMHardwareTutorial
IME Tutorial IMETut1.htm | Create the file; turn on/off | Oobeinfo.ini | [Options] IMETutorial
ISP Sign-up Options isp.htm | Turn on/off, as specified in this Windows OPK User's Guide; overwrite the Isp.htm file in %WINDIR%\System32\Oobe\Setup, based on sample Oemisp.htm | Oobeinfo.ini | [Signup] ISPSignup
Join a Domain jndomain.htm | Turn on/off (for example, turn on to install applications from a domain during preinstallation) | Oobeinfo.ini Sysprep.inf Unattend.txt (Setup Manager) | [Options] JoinDomain [Identification] JoinDomain
Mouse Tutorial mouse.htm | Create the file; turn on to specify a custom tutorial (Microsoft provides a sample mouse tutorial) | Oobeinfo.ini | [Options] MouseTutorial
OEM Customization oemcust.htm | Turn on/off; place file in %WINDIR%\System32\Oobe\Html\Oemcust | Oobeinfo.ini | [Options] OemCust
Preconfig Message ispsgnup.htm | Turn on/off, as specified in this Windows OPK User's Guide; then place file in %WINDIR%\System32\Oobe\Html\Ispsgnup | Oobeinfo.ini | [Options] NoIspPreconfig
Product Key prodkey.htm | Prepopulate | Sysprep.inf Unattend.txt Oobeinfo.ini (Setup Manager) | [UserData] ProductKey [Version] ProdKey
Regional and Keyboard Settings keybd.htm | Turn on/off; prepopulate | Oobeinfo.ini | [Options] INTL_Settings
Registration reg1.htm reg3.htm | Prepopulate; may add phone number field to reg3.htm (to include phone number in OEM registration) | Oobeinfo.ini | [UserInfo]
Time Zone timezone.htm | Turn on/off; prepopulate | Oobeinfo.ini | [Options] TimeZone [Options] TimeZoneValue
USB Keyboard Check nousbkm.htm or nousbkbd.htm | Modify files; turn on/off | Oobeinfo.ini | [Options] USBKeyboard
USB Mouse Check nousbkm.htm or nousbms.htm | Modify files; turn on/off | Oobeinfo.ini | [Options] USBMouse
User Accounts ident2.htm | Prepopulate; skip ident2.htm | Oobeinfo.ini | [UserInfo] Identity000
Welcome welcome.htm | Prepopulate with OEM name; add up to four lines of additional text (must follow any text already on the page) | Oobeinfo.ini | [Branding] OEMName


Windows Welcome Full Setup Flowchart

Full Setup Flowchart


Mini-Setup Flowchart


Changing Windows Welcome on All Computers

You can easily design your installation process to set up or configure specific locale, Internet service provider (ISP), and other settings automatically. In addition, you can include custom hardware tutorials. You can make these changes on the master computer, and they will appear on all destination computers.

For more information on customization, see the following topics.

  • Branding Windows Welcome
  • Turning on the USB Check
  • Adding Custom Tutorials
  • Configuring Regional and Keyboard Settings
  • Configuring the Time Zone
  • Creating Reminders for Registration


Branding Windows Welcome

You can brand Windows Welcome by adding:

  • Your company name to the Welcome, Registration, and Finish screens.
  • Text to the Welcome and Finish screens.
  • A logo in the upper-right corner of Windows Welcome.

Add Your Company Name

When you add your company name to Windows Welcome, it appears in the opening screen of Windows Welcome. The text reads as follows:

Thank you for purchasing a OEM name computer with Windows.

On the Registration page, your company name appears in the context of the availability of your company's technical support and information.

You can define this setting in Setup Manager or set it directly in the Oobeinfo.ini file.

When you set a company name in Setup Manager, the following entry and value is set in the [Branding] section in the Oobeinfo.ini file:

[Branding]
OEMName = CompanyName

where:

CompanyName specifies the company name that you want to appear during Windows Welcome.

Customize the Welcome and Finish Screens

To personalize the Windows Welcome user experience, you may add up to four lines of text to the Welcome and Finish pages (Welcome.htm and Fini.htm). This text must appear after any text already on the page.

Add a Logo to Appear in Windows Welcome

You can also add a logo to appear in the upper-right corner of Windows Welcome:

Sample Branded Windows Welcome

To add a logo to Windows Welcome

  1. Create a graphic. You can use any of the following graphics formats, based on the Windows 256-color palette: BMP, GIF, JPG, and PNG. The graphic must have the dimensions of 255 x 40 pixels.
  2. Specify the file name in Oobeinfo.ini:
    • In Setup Manager, specify this file on the Branding Opportunities page.

      —OR—

    • Open Oobeinfo.ini with a text editor, and add this entry:

      [Branding]

        Oemlogo = Filename

      where:

      Filename specifies the name of the image (BMP, GIF, JPG, and PNG). You can use any file name.

    When Setup Manager builds a configuration set, it ensures that this file is placed in the correct location. On the user's computer, this location is the %WINDIR%\System32\Oobe\Images folder, typically C:\Windows\System32\Oobe\Images.

Notes

  • If the image is larger than the specified dimensions, Windows Welcome crops any additional pixels on the right side or bottom of the image. For example, if the computer resolution is 800 x 600 and your image is 275 x 50 pixels, Windows Welcome only displays a 255 x 40 pixels section of your logo.
  • If you use an image smaller than 255 x 40 pixels, the actual size of your image is used, and the unused area is transparent and shows the Windows Welcome background.
  • You can use any file name for the Windows Welcome logo file. In contrast, the image file used for the System Properties dialog box must be named Oemlogo.bmp.


Turning on the USB Check

Windows Welcome enables computer manufacturers to verify the presence of a USB keyboard or mouse. (Windows Welcome does not search for PS/2 and serial mouse devices or keyboards.) This test is important because without a mouse or keyboard attached, the user will not be able to complete Windows Welcome.

If enabled, the USB keyboard and mouse check is performed just before the Welcome screen. If the checks pass, then the Welcome screen appears. If one or both of the checks fail (meaning that no USB keyboard or mouse is connected to the computer), Windows Welcome automatically displays the respective error page:

  • %WINDIR%\System32\Oobe\Setup\Nousbkbd.htm (no keyboard)
  • %WINDIR%\System32\Oobe\Setup\Nousbms.htm (no mouse)
  • %WINDIR%\System32\Oobe\Setup\Nousbkm.htm (no keyboard and no mouse)

To verify the presence of a USB keyboard or mouse

  1. Modify the appropriate error message pages, from the \Samples\Oobe folder on the Windows OPK CD, for the checks selected in Setup Manager:
    • USB keyboard: Nousbkbd.htm (no keyboard)
    • USB mouse: Nousbms.htm (no mouse)
    • Both USB keyboard and mouse: Nousbkm.htm (no keyboard and no mouse)

    You need to modify these pages with information appropriate to each model of computer that you ship. We recommend that on these pages you display a picture or drawing showing the users exactly where they need to plug in the keyboard or mouse.

  2. On the USB Hardware Detection page in Setup Manager, click one or both of these options:
    • Check for USB keyboard

      —OR—

    • Check for USB mouse

Notes

  • When you select the optional USB keyboard or mouse check in Setup Manager, the tool writes entries in the [Options] section in Oobeinfo.ini.
  • If you do not specify these checks in Setup Manager and directly edit the [Options] section in Oobeinfo.ini, then you must manually place the error message page files in the %WINDIR%\System32\Oobe\Setup folder.


Adding Custom Tutorials

You may provide your own OEM mouse, hardware, and IME tutorials, provided that:

  • They are written in HTML.
  • They do not start any programs or download code for execution, except as necessary to operate the hardware relevant to the content of the tutorial(s).
  • The last page in each tutorial contains a call that returns control back to Windows Welcome.
  • You indicate your choice to use your own tutorial(s) by selecting the relevant option in Setup Manager. Any trade names, trademarks, logos, or brands displayed in connection with your custom tutorials must be limited to those under which the system is manufactured and distributed.

Requirements for adding custom tutorials are discussed in Customization Guidelines: First-Run Experience. Detailed instructions for adding custom tutorials are provided in the white paper entitled Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.

Note

  • Windows XP includes a sample mouse tutorial that you can use as a basis for creating your own mouse tutorial. The sample tutorial files are available on the Windows OPK CD, and must be placed in these locations: %WINDIR%\system32\oobe\mousetut.js and %WINDIR%\system32\oobe\html\mouse\*.


Configuring Regional and Keyboard Settings

Windows Welcome displays the Regional and Keyboard Settings page to the user if the page is enabled in the [Options] section in Oobeinfo.ini:

[Options]
INTL_Settings = 1

If the regional and keyboard settings have been preconfigured, then the Regional and Keyboard Settings page in Windows Welcome does not display. If the information specified for either of these values is not valid, then Windows Welcome displays this page to the user.

It is recommended that you either preconfigure the regional and keyboard settings or display the page to the user. Do not ship computers that are not preconfigured AND do not have the Regional and Keyboard Settings page enabled.

To preconfigure the regional and keyboard settings for the end user, you must specify the settings in the answer file that you are using (either Unattend.txt or Sysprep.inf). See [RegionalSettings] for the settings and values to use in these files.


Configuring the Time Zone

Windows Welcome includes an optional page that enables the user to specify a time zone.

To turn on the Time Zone page in Windows Welcome, add the following entry to the [Options] section in Oobeinfo.ini:

[Options]
TimeZone = 1

Setup Manager also contains an option that enables the Time Zone page.

To preconfigure the time zone value, add the following entry to the [Options] section in Oobeinfo.ini:

[Options]
TimeZoneValue = time_zone_index

If the time zone is preconfigured and contains a valid entry, the time zone is automatically set for the user and the Time Zone page does not appear in Windows Welcome. If the preconfigured entry is not valid, Windows Welcome displays the Time Zone page to the user.

Note

  • If you do not configure a specific time zone setting, the default time zone depends on the language version of Windows that is installed. For example, in the Japanese version, the default time zone is "GMT+9 (Osaka, Sapporo, Tokyo)."

Index Values Corresponding to Each Time Zone

Index | Zone
000 | International Dateline
001 | Samoa
002 | Hawaii
003 | Alaskan
004 | Pacific
010 | Mountain (U.S. and Canada)
015 | U.S. Mountain: Arizona
020 | Central (U.S. and Canada)
025 | Canada Central
030 | Mexico
033 | Central America
035 | Eastern (U.S. and Canada)
040 | U.S. Eastern: Indiana (East)
045 | S.A. Pacific
050 | Atlantic (Canada)
055 | S.A. Western
056 | Pacific S.A.
060 | Newfoundland
065 | E. South America
070 | S.A. Eastern
073 | Greenland
075 | Mid-Atlantic
080 | Azores
083 | Cape Verde Islands
085 | GMT (Greenwich Mean Time)
090 | GMT Greenwich
095 | Central Europe
100 | Central European
105 | Romance
110 | W. Europe
113 | W. Central Africa
115 | E. Europe
120 | Egypt
125 | EET (Helsinki, Riga, Tallinn)
130 | EET (Athens, Istanbul, Minsk)
135 | Israel: Jerusalem
140 | S. Africa: Harare, Pretoria
145 | Russian
150 | Arab
155 | E. Africa
160 | Iran
165 | Arabian
170 | Caucasus Pacific (U.S. and Canada)
175 | Afghanistan
180 | Russia Yekaterinburg
185 | W. Asia
190 | India
193 | Nepal
195 | Central Asia
200 | Sri Lanka
201 | N. Central Asia
203 | Myanmar: Rangoon
205 | S.E. Asia
207 | N. Asia
210 | China
215 | Singapore
220 | Taipei
225 | W. Australia
227 | N. Asia East
230 | Korea: Seoul
235 | Tokyo
240 | Sakha Yakutsk
245 | A.U.S. Central: Darwin
250 | Central Australia
255 | A.U.S. Eastern
260 | E. Australia
265 | Tasmania
270 | Vladivostok
275 | W. Pacific
280 | Central Pacific
285 | Fiji Islands
290 | New Zealand
300 | Tonga


Creating Reminders for Registration

The Registration page is required in Windows Welcome. However, during the first month after the user starts working with the computer, you can provide up to three reminders to users who do not register during Windows Welcome. Because these reminders are launched from the Windows desktop, rather than from Windows Welcome, they are called "desktop registration reminders." By default, no registration reminders are configured.

Desktop registration reminders display within a browser window, not full-screen as in Windows Welcome. To activate desktop registration reminders for users who do not complete registration during Windows Welcome, create a folder named "Regsetup" in the master installation at %WINDIR%\System32\Oobe. Copy all of the files in the \OPKTools\Samples\Oobe folder that begin with the letter "R" to the %WINDIR%\System32\Oobe\Regsetup folder of the master installation, with the exception of Regshell.htm. Then copy Regshell.htm to the %WINDIR%\System32\Oobe folder.

Next, manually add the entry RegRemind1 (and optionally, RegRemind2 and RegRemind3) to the [DesktopReminders] section of Oobeinfo.ini.

For example, the following entries in Oobeinfo.ini enable the desktop registration reminders and scheduled reminders to occur 5, 10, and 15 days after the user completes Windows Welcome.

[DesktopReminders]
RegRemind1 = 5
RegRemind2 = 10
RegRemind3 = 15

Note

  • RegRemindX must be set to a positive integer less than or equal to 30.

When Windows Welcome detects these entries in Oobeinfo.ini, it creates tasks in Task Scheduler that start the registration balloon reminder.

When the user selects the desktop registration balloon reminder, Windows Welcome displays the file %WINDIR%\System32\Oobe\Regsetup\Regrmnd.htm. You may add up to four lines of text to Regrmnd.htm to provide the user with an incentive to register the computer. The style sheet for this page is %WINDIR%\System32\Oobe\Regsetup\Regstyl.css.

This page must include a Cancel button and an option that enables users to prevent any future reminders. When the user clicks Cancel, the reminder window must close. This page must also contain a link to your company's privacy statement. For more information, see Collecting Registration Data and Example: Microsoft Windows Registration Privacy Statement. Do not include a Back button on Regrmnd.htm.

To delete reminders and close the reminder window, the script on your page needs to call window.external.DeleteRemind and window.external.Finish.

After finishing registration, the user navigates to the file %WINDIR%\System32\Oobe\Regsetup\Regdone.htm. You may add up to four lines of text to this page congratulating the user on having completed registration and reminding the user of the benefits of registration. Include a Finish button that calls window.external.DeleteRemind to delete any remaining registration reminders and window.external.Finish to close the reminder window.

In contrast to the full-screen registration pages, the dimensions of the desktop registration reminder pages are 640 x 530 pixels. Like the full-screen registration pages, the desktop registration reminder pages must display using HTML, DHTML, ActiveX, or other Internet technologies. They cannot run executable files.


Collecting Registration Data

During Windows Welcome, the user completes a registration page and selects check boxes to specify where to send the registration data. If you choose to configure and maintain your own registration server, the user may choose to send the data to the OEM, to Microsoft, or to both. In your registration pages, the user must be able to make separate decisions about sending information to the OEM and to Microsoft; do not combine these alternatives into a single choice for the user.

For more information on the configuration requirements for collecting registration data, see Infrastructure for Collecting Registration Data.

Incentives for Users to Register

Users may be wary of providing personal information and registering their new purchase on the Internet. If you choose to collect this data, you must also advise the user of your policies about the privacy of that data. In the privacy statement, inform users of:

  • How the data may be used by the OEM, including whether the data may be shared with any third parties.
  • What choices the user has with respect to the use of the data and how those choices may be exercised.
  • How to access or update the data.
  • How to contact you for any inquiries or complaints.

Place the text for your privacy statement in the file Roempriv.htm, located in %WINDIR%\System32\Oobe\Regsetup. For an example, see Example: Microsoft Windows Registration Privacy Statement.

To encourage your customers to register their new computer, you may place up to four lines of text on the first registration page (Reg1.htm). Position this additional text after the first paragraph, over the option buttons where the user specifies whether they want to register. Place the modified registration page file, Reg1.htm, in the master installation at %WINDIR%\System32\Oobe\Setup. A sample of this page is located in the \Samples\Oobe folder on the Windows OPK CD.

For build-to-order computers, you might want to personalize the Windows Welcome experience by using the information provided by the user when the computer was ordered. For more information, see Prepopulating Registration Information.

You can also create reminders for users who skip registration during Windows Welcome. For more information, see Creating Reminders for Users Who Skip Registration.


Infrastructure for Collecting Registration Data

During Windows Welcome, when the user enters registration information and clicks Next, Windows Welcome reads the Oobeinfo.ini file for a dial-up connection user name. If the user chooses to send the data to the OEM, Windows Welcome appends the user data to the URL that you specified for your registration server. Windows Welcome dials the Microsoft Global Network (a private network) to send the registration data. The registration data is identified by a user name specific to your company, which gives the computer access only to the IP address of your company's registration server. The Microsoft Global Network checks the user name against the access list and connects the computer to your registration server, delivering the URL with all the user's registration data.

Receiving a Dial-up Connection User Name from Microsoft

The Microsoft Global Network is a private network that restricts the set of available Web addresses that can be visited and the set of users who can gain access to those Web sites.

To obtain authorization to receive registration data through the Microsoft Global Network, send an e-mail message to regpost@microsoft.com, containing the:

  • OEM company name.
  • Primary contact information (name, address, telephone number, fax number, and e-mail address).
  • Secondary contact information (name, address, telephone number, fax number, and e-mail address).
  • IP address of your OEM registration server.
  • Name of your Microsoft account manager, if applicable.
  • Name of your Microsoft pre-sales engineer, if applicable.

When Microsoft receives your e-mail message, your IP address is added to the access list on the private Microsoft Global Network used for Windows Welcome. Microsoft then assigns you a custom dial-up connection user name and sends it to you in an e-mail message within five business days of receiving your e-mail. You also receive information regarding how your user name interfaces with your registration server. This user name is processed by Windows Welcome the first time it runs.

To enable registration data collection, set the following values in the [OEMRegistrationPage] and [DUN] sections of Oobeinfo.ini:

[OEMRegistrationPage]
PostToOEM = 1
RegPostURL = URL of your registration server

[DUN]
UserName = dial-up connection user name

Important

  • Do not change the dial-up connection user name value to any value that was not assigned by Microsoft. Doing so prevents your customers from connecting to the online Windows Welcome.
  • On the registration page(s) in Windows Welcome, you must include the check boxes that allow the user to specify whether the data is to be sent to Microsoft, to the OEM, or to both. By default, both check boxes are selected, so the user data is sent to both Microsoft and to the OEM.

Designing Your Registration Server

Windows Welcome sends user registration data to the URL that you specify in Setup Manager. Data is sent as an HTTP request to your server. Windows Welcome creates the HTTP request by appending the user data (in name/value pairs) to the end of the URL that you specify for the server. Your registration server must parse the user data out of the HTTP request. The request looks like this:

https://reg.fabrikam.com/reg.asp?FName=chris&LName=preston...

The fields sent are:

FName
MName (middle initial)
LName
CompanyName
Addr1
Addr2
City
State
Zip (zip/postal code)
CountryCode (telephone country/region code)
EmailName
LanguageName
LanguageCode
AreaCode
Phone
ComputerManufacturer (from Oeminfo.ini)

For build-to-order computers, you can personalize the Windows Welcome experience by using the information provided by the user when the computer was ordered. For more information, see Prepopulating Registration Information.

Using a Modem Dial-Up Connection Other Than the Microsoft Global Network

Instead of using the Microsoft Global Network to host the modem connection, you may instead host the modem call to provide the connection to your OEM registration server. If so, and the user has selected to register with Microsoft, you must post the user's Microsoft registration data in real time to the Microsoft registration server, https://register.microsoft.com/reg.asp?. For more information, contact your account manager.


Prepopulating Registration Information

For build-to-order computers, you might want to personalize the Windows Welcome experience by using the information provided by the user when the computer was ordered.

To prepopulate the user information fields that users see during registration, add the following entries and values to the [UserInfo] section in the Oobeinfo.ini file:

[UserInfo]
FirstName = The user's first name
MiddleInitial = The user's middle initial
LastName = The user's last name
FuriganaName = The user's furigana name (Japan)
CompanyName = The user's company
Address1 = Line 1 of the user's mailing address
Address2 = Line 2 of the user's mailing address
City = The user's city
State = The user's state or region
Zip = The user's ZIP or postal code
Country = The user's country/region
PrimaryEmail = The user's e-mail address or temporary Windows ID
SecondaryEmail = The user's secondary e-mail address
AreaCode = The user's area or city code
PhoneNumber = The user's telephone number
Identity000 = Primary user
Identity001 = Secondary user
Identity002 = Secondary user
Identity003 = Secondary user
Identity004 = Secondary user
Identity005 = Secondary user

If you prepopulate the user's first and last names, these are included in the first sentence of the Welcome page. For example: "Welcome, Chris Preston, and thank you for buying a new Fabrikam computer with Microsoft Windows XP."

You must disclose in your privacy statement that this prepopulated information was derived from the end user's order.


Example: Microsoft Windows Registration Privacy Statement

Protecting personal information on the Internet is a major customer concern. If you collect registration information from your customers during Windows Welcome, it is recommended that you inform the user about how you manage and protect the security of that data.

Here is an example of a privacy statement:

Privacy Statement

Thank you for buying and installing Microsoft Windows. We invite you to register your purchase with Microsoft so that we can provide you with better product services, alert you to product upgrades, special offers, and updated information, and make it easier for you to use our Web site at www.microsoft.com.

Your registration will be stored on Microsoft secure servers in the U.S. The information may also be stored on Microsoft secure servers in your country or region, or other countries or regions. If you've already registered, we will use your personal identification number in your cookie file to merge this registration information with any information that you may have already left with us.

If you have not registered previously on our Web site, we will create a new personal identification number (PIN) for your new profile. We will then send this PIN back to your hard disk in the form of a cookie, a very small bit of code. This code is uniquely yours and helps you travel across the Microsoft Web site, allowing you to download free software, order free newsletters, and visit premium sites without having to fill out registration forms with information that you have already provided. When you come to the site for the first time, we will invite you to create a Registration ID. Then, even if you switch computers, you will not have to register again — just use your Registration ID to identify yourself.

At any time, you can visit the Profile Center at our Web site. Click Update Profile, and edit any of the personal information in your profile. If you haven't previously created a Registration ID, we will ask you to do so in order to ensure that only you gain access to your information.

At the Microsoft Web site, tell us what kinds of communications that you want to receive from us. For example, we occasionally allow other companies to offer to our customers information about their products and services, using postal mail only. If you provide us your mailing address and you do not want to receive these offers, you may select the option indicating that you do not want to receive marketing materials from third parties.

Thank you for registering your Microsoft product. Visit our Web site at www.microsoft.com for the most current information about this and our other products.


ISP Sign-up Options and Offers

Internet service provider (ISP) sign-up options define how and when end users select one of the Internet service packages that you offer. In addition to the MSN Internet Access sign-up offer, you may specify and create additional sign-up options. The end user then enrolls in the package of their choice during Windows Welcome, or the first time they access Internet Explorer or Outlook Express from the desktop.

Sign-up Options

On the Internet Sign-up page in Setup Manager, select the ISP sign-up options available to your users, according to the parameters specified in Customization Guidelines: Internet Access and ISP Offers:

  • Use MSN Internet Access integrated ISP sign-up
  • Do not include ISP sign-up in Windows Welcome
  • Display a list of OEM ISP sign-up offers
  • Preconfigure Internet settings at the factory

If you select MSN or include your own ISP offers, you must include these options:

  • Re-establish an existing Internet account by entering ISP settings manually or using the Microsoft Internet Referral Service. For more information, see Accessing an Existing Internet Account.
  • Create a new Internet account after completing Windows Welcome.

Important

  • The appearance and prominence of these options must be equivalent to any OEM ISP offers.
  • You must include these options if you select MSN or include your own ISP offers.
  • Do not change the MSN Explorer icon if MSN Internet Access is available to the user in Windows Welcome.
  • If the user chooses an ISP offer other than MSN, then Microsoft is not responsible for any long-distance telephone charges incurred during ISP sign-up. If the computer is already connected to the Internet through a telephone modem to enable registration or activation, then the ISP sign-up code must terminate that connection and initiate a new phone call to the ISP sign-up server.

When users skip Internet sign-up during Windows Welcome, the result is based on your choice of sign-up options. For more information, see Internet Sign-up After Windows Welcome.

If you do not want to include a sign-up option during Windows Welcome, you can exclude Internet sign-up. For more information, see Excluding ISP Sign-up.

For more information about developing ISP offers, see Developing ISP Offers for the Start Menu, and the white paper entitled Building Custom Windows Welcome Pages in Microsoft Windows XP, located in the \Docs\Whitepapers folder on the Windows OPK CD.

The white paper entitled Building Custom Windows Welcome Pages in Microsoft Windows XP, along with a set of sample files, is located in the \Samples\Oobe\Isp.zip file on the Windows OPK CD. OEMs may redistribute the Isp.zip file to third-party ISP partners who build custom HTML pages to integrate into the OEM's customized version of Windows Welcome.

You can also configure the computer for Internet access through cable or DSL modems. For more information, see Broadband Configuration During Windows Welcome.


MSN Sign-up Option

MSN Internet Access is the easiest way for you to extend an Internet service provider (ISP) offer to your customers because it requires no work on your part. MSN Internet Access is available in the United States and in other countries or regions where Windows XP supports online sign-up and registration. In some countries or regions where Windows XP does not support online sign-up and registration, the default ISP sign-up option is to exclude sign-up during Windows Welcome and use the New Connection Wizard at a later time.

Note

  • You specify your ISP sign-up option in Setup Manager.

With this option, an Internet account is opened with MSN during Windows Welcome. If the computer is not connected to an active telephone line, the ISP sign-up with MSN does not occur.

When you choose MSN Internet Access as your ISP sign-up offer, this value is added to the [Signup] section in the Oobeinfo.ini file:

[Signup]
ISPsignup = MSN

After registration users can connect to the Internet. If users choose to set up an Internet connection, Windows Welcome displays Isp.htm, located in the master installation at %WINDIR%\System32\Oobe\Setup. On this page, users can:

  • Sign up for a new Internet account with MSN.
  • Migrate an existing Internet account (through any ISP who supports this feature in the Microsoft Internet Referral Service).

If users skip ISP sign-up during Windows Welcome and the MSN option was selected by the OEM, then the first time they open Internet Explorer or Outlook Express, users are given another opportunity to view the MSN sign-up offer.

Important

  • On the Connect to the Internet page, include the option for users to migrate an existing account.
  • Do not change the MSN Explorer icon if the MSN Internet Access sign-up offer is available to the end user in Windows Welcome.

For more information on ISP sign-up options, see:

  • ISP Sign-up Options and Offers
  • OEM ISP Sign-up Option
  • Excluding ISP Sign-up
  • Internet Sign-up After Windows Welcome
  • Accessing an Existing Internet Account


OEM ISP Sign-up Option

When you use the OEM ISP sign-up option, you include a list of Internet service provider (ISP) offers on users' computers. This OEM ISP offer list can consist of as many HTML pages as you want, provided the first page meets the requirements outlined in Customization Guidelines: Internet Access and ISP Offers.

After the first page, you may display:

  • One ISP offer per page.
  • Multiple ISP offers on a single page.
  • Other layouts and designs to suit your needs, as long as they are consistent with the rest of Windows Welcome.

Your ISP offer calls the application programming interfaces (APIs) that connect users to the Internet services that they select. Windows Welcome dials the Microsoft toll-free number (where available), posts the registration data, and then opens the ISP sign-up. If the user chooses to sign up for Internet access, the first file of your ISP sign-up offer displays. The first file is isp.htm, located in %WINDIR%\System32\Oobe\Setup. Users select an ISP, and then are connected to that ISP's sign-up server.

Users must provide information and select options to create an ISP account. The information that they provide may include:

  • Name
  • Address
  • Credit card information
  • Billing preference
  • User name and password
  • POP selection

After the user completes the Internet account information, an .ins file is created on the ISP sign-up server. The .ins file downloads to the user's computer by using the ProcessINS function. Once downloaded, the .ins file configures the user's computer with an ISP account. The connection to the ISP sign-up server then closes, and the user completes Windows Welcome. For more information on editing the .ins file for Internet Explorer, see Internet Explorer Administration Kit (IEAK) Help.

Because your ISP offer connects to the ISP sign-up server, it is recommended that you develop your ISP offer with your ISP partner. Many ISPs are familiar with Internet file formats and configuration files such as .isp and .ins files. However, they may not be familiar with the Windows Welcome APIs.

Complete this procedure to create an OEM ISP offer that users run during Windows Welcome or the first time they access Internet Explorer or Outlook Express:

To create an OEM ISP offer

  1. Develop an ISP sign-up offer that consists of as many ISPs as you want.
  2. Create a desktop Internet sign-up offer that can run after Windows Welcome.
  3. Specify the name and location of the ISP sign-up server.
  4. Specify your ISP sign-up option.

Important

  • If the user chooses an ISP offer other than MSN, then Microsoft is not responsible for any long-distance telephone charges incurred during ISP sign-up. If the computer is already connected to the Internet through a telephone modem to enable registration or activation, then the ISP sign-up code must terminate that connection and initiate a new phone call to the ISP sign-up server.

For more information on creating OEM ISP sign-up offers, see the white paper entitled Building Custom Windows Welcome Pages in Microsoft Windows XP, located in the \Docs\Whitepapers folder on the Windows OPK CD.

For more information on ISP sign-up options, see:

  • ISP Sign-up Options and Offers
  • MSN Sign-up Option
  • Excluding ISP Sign-up
  • Internet Sign-up After Windows Welcome
  • Accessing an Existing Internet Account


Excluding ISP Sign-up

You can skip the ISP Internet account setup during Windows Welcome and have your users complete this process later.

If you exclude the Internet sign-up, you do not need to prepare any files in advance. When the user clicks the Internet Explorer or Outlook Express icon on the Start menu, the New Connection Wizard starts.

When you specify in Setup Manager that you are excluding ISP sign-up during Windows Welcome, this value is added to the [Signup] section in the Oobeinfo.ini file:

[Signup]
ISPsignup = None

For more information on ISP sign-up options, see:

  • Sign-up Options and Offers
  • OEM ISP Sign-up Option
  • MSN Sign-up Option
  • Internet Sign-up After Windows Welcome
  • Accessing an Existing Internet Account


Internet Sign-up After Windows Welcome

If users do not open an Internet account during Windows Welcome, they still have two opportunities to connect to the Internet:

  1. The first time they access Internet Explorer or Outlook Express from the Start menu.
  2. When an Internet connection reminder appears.

The Internet connection options available depend on your ISP sign-up offer for Windows Welcome.

Your ISP Option | Result
MSN | The Internet Connection Wizard intercept page starts, giving the user a choice of viewing Internet access offers or the New Connection Wizard. If the user chooses Internet access offers, Isp.htm displays the MSN Internet Access sign-up offer. For more information on the New Connection Wizard, see the Microsoft Windows XP Help and Support Center.
OEM ISP Sign-up Offers | The Internet Connection Wizard intercept page starts, giving the user a choice of viewing Internet access offers or the New Connection Wizard. If the user chooses Internet access offers, Isp.htm displays the list of custom OEM sign-up offers. This OEM ISP offer list can consist of as many HTML pages as you want, provided that the pages meet the requirements outlined in Customization Guidelines: Internet Access and ISP Offers.
Preconfiguration | If preconfiguration fails, the New Connection Wizard starts.
None | New Connection Wizard starts.

Signing Up After Windows Welcome

If you include custom OEM Internet sign-up offers in Windows Welcome, users who skipped sign-up during Windows Welcome can view your offers when they access the Internet the first time. Users can:

  • View the ISP offers provided by your computer manufacturer

    • —OR—

  • Run the New Connection Wizard to select another connection method

When users choose to view your offer, Isp.htm appears. Your OEM ISP offer can be the default choice in Isp.htm. Your OEM ISP offer must provide a clear and conspicuous way for end users to navigate from that offer to the New Connection Wizard.

Creating Reminders for Users Who Skip ISP Sign-up

For users who skip ISP sign-up during Windows Welcome, you can specify up to three desktop ISP reminders. By default, ISP reminders are not configured.

When ISP reminders run, a balloon displays to the user. If the user clicks the balloon reminder, the desktop sign-up pages (starting with Isp.htm) appear in a window, not full-screen.

To create desktop ISP reminders for users who skip Internet sign-up during Windows Welcome, you must manually add entries to the Oobeinfo.ini file. Add ISPremind1 (and optionally, ISPremind2 and ISPremind3) to the [DesktopReminders] section of %WINDIR%\System32\Oobe\Oobeinfo.ini.

For example, the following entries in Oobeinfo.ini enable the desktop ISP reminders and schedule those reminders to occur 5, 10, and 15 days after users complete Windows Welcome.

[DesktopReminders]
ISPremind1 = 5
ISPRemind2 = 10
ISPRemind3 = 15

These entries in Oobeinfo.ini create tasks in Task Scheduler to start the ISP reminders.

For more information on ISP sign-up options, see:

  • Developing ISP Offers for the Start Menu
  • Sign-up Options and Offers
  • MSN Sign-up Option
  • OEM ISP Sign-up Option
  • Excluding ISP Sign-up
  • Accessing an Existing Internet Account


Developing ISP Offers for the Start Menu

At some point after Windows Welcome finishes, users who skip Internet account sign-up during Windows Welcome may start Internet Explorer or Outlook Express from the Start menu. If you configured Windows Welcome to include MSN Internet Access or OEM ISP sign-up offers, then users can choose to view these OEM ISP offers or use the New Connection Wizard to configure Internet access by using a local area network, VPN, or other existing connection. If users select to view the OEM ISP offers, then the desktop ISP sign-up starts and displays Isp.htm, the same file used for the OEM ISP offer(s) in Windows Welcome.

The Online Services folder is available only in the Windows user interface through the New Connection Wizard. It is also available in %SYSTEMDRIVE%\Program Files\Online Services\. By default this folder contains shortcuts to the Microsoft Internet Referral Service and to MSN Internet Access. You may place shortcuts to any additional Internet sign-up programs in this location.

Location of the Shortcut

You can place the shortcut to the ISP offer in the Most Frequently Used (MFU) list of programs on the Start menu. Users can also access the desktop ISP offer from the .htm page or .exe associated with the OEM link, the Windows desktop, or from the Online Services folder. For more information, see Customizing the Start Menu and the OEM Link.

The differences between Windows Welcome ISP offers and desktop ISP offers are:

  • File names and dimensions
  • Function calls
  • Navigation

File Names and Dimensions

Use the same files for your desktop ISP sign-up offer(s) that you used in the Windows Welcome full-screen OEM ISP sign-up offer. Name the first file in your ISP sign-up offer Isp.htm. You may want to name any succeeding files similarly, as part of a series (for example, Isp2.htm, Isp3.htm, and so on). Place these files into the master installation at %WINDIR%\System32\Oobe\Html\Ispsgnup\.

Desktop ISP sign-up displays in a window that is at most 800 x 600 pixels, including the title bar and the taskbar. The HTML pages that you create for the ISP sign-up offer display in the area between the two horizontal dark blue bars. Because there is a slight difference in the size of full-screen Windows Welcome and the desktop ISP window, make sure that you verify the appearance of your custom HTML pages in both full-screen Windows Welcome and from the Windows desktop.

Note

  • If the computer's display resolution is greater than 800 x 600 pixels, the desktop ISP sign-up pages display in a window that is 800 x 600 pixels. If the display resolution is less than 800 x 600 pixels and the text is otherwise hidden, scroll bars enable the user to view the offer text and buttons.

Function Calls

All function calls are in Microsoft JScript.

Navigation

To create general navigation, navigation on the first or last page of your desktop ISP offer, or navigation to the ISP that the users select, follow the guidelines outlined in ISP Sign-up Options and Offers.

Specifying the OEM ISP Option

After you create your ISP desktop offers with MSN and the ISPs, specify your sign-up option in Setup Manager. For more information, see Using Setup Manager. On the Internet Sign-up page, when you select Display a list of OEM ISP sign-up offers, the following value is added to the [Signup] entry of the Oobeinfo.ini file:

[signup]
ISPsignup=Offline

For more information, see OEM ISP Sign-up Option and the white paper entitled Building Custom Windows Welcome Pages in Microsoft Windows XP, in the \Docs\Whitepapers folder on the Windows OPK CD.


Accessing an Existing Internet Account

Many users who receive a new computer have an existing Internet account. Windows Welcome includes a feature that enables these users to access their existing Internet account on the new computer.

When users access an existing Internet account, Windows Welcome contacts the Internet Referral Service (the same service hosted by the New Connection Wizard) and downloads a list of Internet service providers (ISPs) that support automated account restoration. Users can select their ISP from the downloaded list.

Note

  • If users' ISPs are not listed, they can call their ISP for assistance in accessing their existing Internet account.

Users select their ISP and click Next, and then Windows Welcome dials their ISP. To confirm their identity, users must provide:

  • User name and password.
  • Telephone number (POP) dialed to connect to their ISP.
  • Verification information, such as the last four digits of the credit card that was used to create the Internet account (optional).

After users provide this information, the ISP recreates the .ins file that was used to open the Internet account. Once the .ins file is processed, the dial-up networking, Internet Explorer, and Outlook Express settings are configured.

Users can also use their existing ISP account by entering their ISP telephone number, user name, and password. Windows Welcome uses this information to create a connectoid that is used when the user clicks E-mail or Internet from the Start menu.

Migrating User Settings

Proxy, e-mail server, news server, and other settings available from a downloaded .ins file are migrated to the new computer. Accessing an existing Internet account only restores the connection to the ISP; it does not migrate the user's local favorites, address book, or e-mail store.

For more information on ISP sign-up options, see:

  • Sign-up Options and Offers
  • MSN Sign-up Option
  • OEM ISP Sign-up Option
  • Excluding ISP Sign-up
  • Internet Sign-up After Windows Welcome


Broadband Configuration During Windows Welcome

Windows Welcome lets you configure broadband devices using extensions in the .ins file format.

Supported Standards

Windows Welcome is designed to allow for the configuration of cable and DSL modems, whether internal or external. Supported standards include:

  • G.Lite
  • PPP over ATM
  • PPP over Ethernet (PPPoE)
  • RFC1483
  • Cable modems

Satellite and wireless Internet access do not have native support in Windows Welcome, but they will most likely work if you use an external broadband device that connects to the computer with Ethernet.

Driver Installation

Windows includes native support only for PPP over ATM connections. OEMs who ship hardware that uses other protocols (such as PPPoE or RFC1483) need to install a third-party driver to enable that support.

Important

  • If you install a third-party driver for PPPoE or RFC1483, be aware that hardware vendors must rewrite their drivers in order to support broadband provisioning in Windows Welcome.

Unique Requirements for the ISP Sign-up Server

It is the responsibility of the OEM and their partner(s) to include the user qualification and sign-up experience for Windows Welcome. If the user is qualified for broadband service, proceed through the sign-up process. At the end of that process, the Internet service provider (ISP) must pass back a broadband .ins file (containing the broadband device info) that configures the computer for Internet access.

Important

  • If the user signs up for broadband Internet service, frequently a service technician must be dispatched to the end user's location to complete Internet access configuration. In this case, you may provide up to 10 Internet sign-up reminders that ask the user to complete Internet configuration after the service technician has configured the correct wiring.

    We recommend that in your customized version of Windows Welcome you ask the user if the broadband connection is already installed and working. If the user answers Yes, then call the Windows Welcome ProcessINS function to complete the broadband configuration. If the user answers No, then remind the user to finalize the configuration after the service technician has completed the Internet access configuration, and then close the reminder.

For more information, see Internet Settings (.ins entries) for Broadband Connections.


Configuring Internet Settings at the Factory

If you provide build-to-order computers, you can offer Internet access to your users. If an end user selects a specific Internet service provider (ISP) before or during the purchase process, you can preconfigure that Internet access account. An end user can then use that specific account to access the Internet from the Windows desktop without any further sign-up or configuration.

To preconfigure the user's Internet account, collect end-user information when an order is placed, such as the user's name and billing information. Use that information to determine an e-mail name and POP address, and then activate this unique account. Configure the settings for the new Internet account when the computer is built in the factory. Ultimately, this is the best Internet sign-up experience for your users — they turn on the computer and their Internet account is already open.

Important

  • If you collect end-user information through a Web site, the Web page must also contain a link to your company's privacy statement. For more information, see Collecting Registration Data and Example: Microsoft Windows Registration Privacy Statement.
  • If you populate your users' passwords for their ISP accounts, you must alert them to change their password the first time they use the Internet.

To configure computers in this manner, include an Internet settings file on the computer, and create an Internet welcome page to inform users that their Internet account is open. Follow the specific naming conventions for the Internet settings file and welcome page.

Name the Internet settings file Ispcnfg.ins, and store it in the master installation at %WINDIR%\System32\Oobe\Html\Ispsgnup\. Name the Internet welcome page Ispsgnup.htm, and store it in the master installation at %WINDIR%\System32\Oobe\Html\Ispsgnup\.

During the first-run experience, Windows Welcome looks for the Internet settings file. If it is found, Windows Welcome automatically configures the computer for Internet access, according to the information that you provided in the Ispcnfg.ins file. The Internet welcome page file, Ispsgnup.htm, appears after Windows Welcome so that users know that the Internet service is fully configured and ready to use.

If there is an error while processing the Internet settings file, an error message appears to inform users that the Internet connection is not properly configured. Users can then call the ISP to open an account. The screen is populated with the ISP name and support telephone number from entries contained in the Ispcnfg.ins file. This information is also saved to the desktop as an HTML file for later reference.

To configure Internet settings at the factory

  1. Create an Internet settings file with your ISP partner.
  2. Add an Internet account to the installation.
  3. Prepare for Internet account failures.
  4. Add an Internet welcome page to the installation.
  5. Configure telephony settings.

After you create the Internet settings file Ispcnfg.ins and add it to the destination computer, you need to use Setup Manager to specify your ISP sign-up option. This sign-up option is Preconfigure Internet settings at the factory.

For more information on ISP sign-up options, see:

  • Sign-up Options and Offers
  • OEM ISP Sign-up Option


Creating an Internet Settings File with Your ISP Partner

An Internet account is an agreement between an Internet service provider (ISP) and your user. Internet account information is stored in an Internet settings (.ins) file. The Internet settings file is used during Windows Welcome, or the first time users access Internet Explorer or Outlook Express, to open an Internet account.

To open Internet accounts for your users by adding an Internet settings file to a build-to-order computer, you must develop a process with your partner ISPs. This process might involve a pool of accounts that the ISP allocates to you, complete with unique Internet settings files. Or you might connect to the ISP sign-up server, passing on the end-user information needed to create the Internet settings file, and then receiving a unique file from the ISP sign-up server for each user.

Either you or a partner ISP must create a unique Internet settings (.ins) file that contains the appropriate information. The .ins file format is an extension of the Windows dial-up networking (.dun) file format. This format conforms to standard Windows .ini file conventions. For more information, see Standard .ini File Conventions. To view a sample, see Sample .ins File.

For more information on Internet accounts, see:

  • Configuring Internet Settings at the Factory
  • Adding an Internet Account to the Installation
  • Preparing for Internet Account Failures
  • Adding an Internet Welcome Page to Windows Welcome
  • Configuring Telephony Settings


Adding an Internet Account to the Installation

If you provide build-to-order computers and configure Internet accounts for your users, you develop a process with your partner Internet service provider (ISP) for creating the Internet settings (.ins) file. Once generated, store the .ins file, Ispcnfg.ins, on the destination computer in %WINDIR%\System32\Oobe\Html\Ispsgnup\.

During the first-run experience, Windows Welcome searches for the file in %WINDIR%\System32\Oobe\Html\Ispsgnup\. After finding the file, Windows Welcome opens the Internet welcome page that you created to inform your users that their account is open. If Windows Welcome does not find the file, the result is based on your ISPSignup option stored in the [Signup] section of the Oobeinfo.ini file.

For more information on Internet accounts, see:

  • Configuring Internet Settings at the Factory
  • Creating an Internet Settings File with Your ISP Partner
  • Preparing for Internet Account Failures
  • Adding an Internet Welcome Page to Windows Welcome
  • Configuring Telephony Settings


Preparing for Internet Account Failures

You must work with your Internet service provider (ISP) partner to create an Internet settings file, Ispcnfg.ins, that is error-free. You must also test the file at the factory to ensure that errors do not occur. However, if an Internet account failure occurs during the first-run experience, Windows Welcome sets an .ins failure flag in the registry like this:

HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Internet Connection Wizard\INS Processing\

Windows Welcome also records the ISP name and support telephone number from the .ins file in the registry. The Internet Connection Wizard completed bit is not set.

Windows Welcome then proceeds to the ISP sign-up, and a Windows Welcome error message appears. This error message informs users that the factory-set Internet account failed to operate, and asks them to call the ISP support telephone number. When users click Next on the error message, the Internet sign-up phase of Windows Welcome ends.

If users start Internet Explorer or Outlook Express after Windows Welcome finishes, an error message appears. After users click OK, the completed bit is set. If users start Internet Explorer or Outlook Express after the completed bit is set, the standard Internet Explorer or Outlook Express error message appears, stating that they cannot connect to the Internet.

For more information on Internet settings, see:

  • Configuring Internet Settings at the Factory
  • Creating an Internet Settings File with Your ISP Partner
  • Adding an Internet Account to the Installation
  • Adding an Internet Welcome Page to Windows Welcome
  • Configuring Telephony Settings


Adding an Internet Welcome Page to the Installation

banner

Adding an Internet Welcome Page to Windows Welcome

The Internet welcome page, Ispsgnup.htm, appears at the end of Windows Welcome to inform users that their Internet accounts are open. You design the page and the text that appears. Customize the title and text based on your customers' needs. When your page is completed, store it in %WINDIR%\System32\Oobe\Html\Ispsgnup\.

A sample Ispsgnup.htm file is included in the \Samples\Oobe folder on the Windows OPK CD.

During the first-run experience, Windows Welcome accesses the Internet settings file, Ispcnfg.ins, in %WINDIR%\System32\Oobe\. If the file exists, Windows Welcome opens the Internet welcome page. If Windows Welcome does not find the file, the New Connection Wizard appears.

If you prefer to process the Internet settings file without displaying a welcome message to users, add the following setting to Oobeinfo.ini:

[Options]
NoIspPreconfig = 1

For more information on Internet settings, see:

  • Configuring Internet Settings at the Factory
  • Creating an Internet Settings File with Your ISP Partner
  • Preparing for Internet Account Failures
  • Adding an Internet Account to the Installation
  • Configuring Telephony Settings


Configuring Telephony Settings

You can configure telephony settings at the same time that you configure the Internet account settings by adding this section to Oobeinfo.ini:

[Options]
TonePulse = 0 | 1
OutsideLine = number dialed to reach an outside line
DisableCallWaiting = number dialed to turn off call waiting
AreaCode = area code

For more information on Internet settings, see:

  • Configuring Internet Settings at the Factory
  • Creating an Internet Settings File with Your ISP Partner
  • Preparing for Internet Account Failures
  • Adding an Internet Welcome Page to Windows Welcome
  • Adding an Internet Account to the Installation


Making Changes on a Per-Machine Basis

If you build machines to order, you can prepopulate user and computer data from information that you receive from customers when they place their orders.

Prepopulate Network User Data

You can specify this information in the [Identification] section in either Sysprep.inf or Unattend.txt:

  • DomainAdmin
  • DomainAdminPassword
  • JoinDomain

Prepopulate Computer Data

You can specify this information in the [UserData] section in either Sysprep.inf or Unattend.txt:

  • ComputerName

Registration and User Accounts

You can specify this information in the [UserInfo] section of Oobeinfo.ini.

For more information, see Prepopulating Registration Information.

You can also preactivate the Windows installation for the customer.

Note

  • When Windows Welcome runs, the Owner account (in Windows XP Home Edition) or Administrator account (in Windows XP Professional) is copied over the default user profile. For this reason, if you add any files to the default user profile before you run Sysprep -reseal, they will no longer exist after Windows Welcome finishes.

Local Administrator Password and Domain Information

You can specify this information in the [Options] section of Oobeinfo.ini:

  • AdminPW
  • JoinDomain

The AdminPW and JoinDomain options are not available in Windows XP Home Edition.

Important

  • The Product Key that you use to activate the Windows installation on a computer must match the Product Key located on the COA sticker attached to that computer.

For more information, see Prepopulating the Product Key and Preactivating Windows.


Testing and Debugging Windows Welcome

The information here is useful for testing Windows Welcome. You can test Windows Welcome in debug mode, reset it so that it runs in its first-run state, check telephone settings, and manually start the Internet service provider (ISP) and registration portions of Windows Welcome.

Skipping Windows Welcome

You can skip Windows Welcome, except for the End-User License Agreement (EULA), and then go directly to the desktop by pressing the key combination CTRL+SHIFT+F3 when Windows Welcome starts. This enables you to audit the computer, or if you are a value-added reseller, to do additional configuration on the computer before shipping it to the customer.

Debugging Windows Welcome

When you are ready to test your customized Windows Welcome, enter a registry key that puts Windows Welcome into debug mode. With this key, you do not need to restart the computer to test Windows Welcome. Set the value of HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Setup\OOBE\OEMDebug to 0x000001. This value is a DWORD.

Setting the OEMDebug key enables you to debug the script in the pages that you add to Windows Welcome and to exit Windows Welcome by simultaneously pressing the CTRL, ALT, and DELETE keys. Remove this registry key when you no longer need it for debugging; do not include this registry key in any computer that you distribute to customers.

Testing and Resetting User Accounts

When Windows Welcome runs, the Owner account (in Windows XP Home Edition) or Administrator account (in Windows XP Professional) is copied over the default user profile. For this reason, if you add any files to the default user profile before you run Sysprep -reseal, they will no longer exist after Windows Welcome finishes.

If you create additional user accounts during your testing, Sysprep and Windows Welcome do not remove these accounts when you reseal the computer. Therefore, before resealing the computer, remove any additional test user accounts that you created by using User Accounts in Control Panel.

You can also add or remove user accounts by clicking Start, right-clicking My Computer, clicking Properties, clicking the Advanced tab, and then clicking Settings in the User Profiles section.

Important

  • If there is an existing user account named "Owner," Windows Welcome removes it.

Resetting Windows Welcome

To reset Windows Welcome for testing, run Sysprep -reseal on the installation and then use a third-party tool to create an image of the installation. Every time you wish to test Windows Welcome, reinstall that base image on the destination computer, place an updated Oobeinfo.ini file on that destination computer, and then restart the computer.

Preconfiguring Telephony Settings for Testing

You can preconfigure Telephony Application Programming Interface (TAPI) settings for testing purposes. If you do this, remember to remove the telephony settings before shipping the computer.

To preconfigure telephony settings in Windows Welcome, include the following entries in the [Options] section in Oobeinfo.ini:

[Options]
TonePulse = [1 for tone, 0 for pulse]
OutsideLine = [string, number dialed to reach an outside line]
DisableCallWaiting = [string, number dialed to turn off call waiting]
AreaCode = [string, area code]

Starting the Desktop ISP Offers Manually

You can manually start the desktop ISP offers shown to users who skip Internet sign-up during initial startup by running Msoobe.exe with a flag. Desktop ISP offers are available only when using the offline option for ISP offers.

To start the desktop ISP offers manually

  1. On the computer that you are testing, click the Start button, and then click Run.
  2. Type [drive]:\windows\system32\oobe\msoobe.exe /offline, and then click OK.

Starting Reminders Manually

You can start both the registration reminder and the ISP reminder manually by running Msoobe.exe with a flag.

To start the registration reminder manually

  1. On the computer that you are testing, click the Start button, and then click Run.
  2. Type [drive]:\windows\system32\oobe\msoobe.exe /r, and then click OK.

To start the ISP sign-up reminder manually

  1. On the computer that you are testing, click the Start button, and then click Run.
  2. Type [drive]:\windows\system32\oobe\msoobe.exe /s, and then click OK.

Performing Preconfiguration Steps

You can use the Oobe.bat file to perform preconfiguration steps before running Windows Welcome. For more information on modifying the Windows launch experience, see OEM Licensing Requirements.


Preinstalling Hardware Devices

You can preinstall hardware devices, including:

  • Mass-storage devices
  • Plug and Play devices

Other key topics in this section:

  • Use Signed Drivers
  • How Windows Selects a Particular Device Driver
  • Detecting the Correct Video Mode for Laptop Displays
  • Showing Hidden Devices
  • Reducing the Number of Master Images for Computers with Different Mass-Storage Controllers
  • Reducing the Number of Master Images for Computers with Multiprocessors and Uniprocessors

For the most up-to-date information about developing hardware devices to work with computers running Microsoft® Windows®, see the Windows Platform Development Web site (http://www.microsoft.com/hwdev/).


Using Signed Drivers

Microsoft is promoting driver signing for designated device classes as a mechanism to advance the quality of drivers, to provide a better end user experience, and to reduce support costs for vendors and total cost of ownership for customers.

Signed drivers are drivers that have a corresponding digital signature. Digital signatures for Windows drivers enable the operating system to verify the integrity of every file in a driver package. The driver package copies a Microsoft-provided, digitally signed catalog file (.cat) that contains a record of each file in the driver package. Driver signing (sometimes called code signing) consists of the following components:

  • A catalog (.cat) file that is part of the driver package and contains a digital signature issued by Windows Hardware Quality Labs (WHQL).
  • An .inf file that references the catalog file.
  • A driver that has passed Windows Logo Program testing.
  • Operating system policy settings that control whether an unsigned driver can be installed.

To receive a digitally signed catalog file, all drivers must pass the Microsoft-defined testing criteria for that device administered by WHQL. For more information about signed drivers, see Windows Hardware Quality Labs Web site (http://www.microsoft.com/hwtest/).

If you intend to use any updated drivers, you must first verify that the drivers have a valid signature. If they do not, the specific driver that is installed depends on:

  • The driver signing policy you indicate in your answer file.
  • The availability of a compatible signed driver that ships with the operating system.

If you have received a driver from a vendor for testing purposes that is not yet signed and that replaces a Windows XP driver, Windows Setup selects the driver that is included with Windows XP over the unsigned driver. For more information about Windows Setup and drivers, see How Windows Selects a Particular Device Driver.

To test the unsigned driver, install Windows and manually install the new driver after Windows Setup completes.

Important

  • All drivers installed on the system as shipped to the customer must be signed. Drivers submitted for Microsoft Windows Logo Program testing must meet the guidelines for driver signing as defined in the Driver Signing for Windows (http://www.microsoft.com/hwdev/driver/digitsign.htm) white paper, located on the Windows Platform Development Web site (http://www.microsoft.com/hwdev/).

Specifying How to Handle Unsigned Drivers

The DriverSigningPolicy entry in the [Unattended] section specifies how unsigned drivers process during unattended Setup. For testing purposes only, you can set DriverSigningPolicy = Ignore. For computers that you manufacture, you must use the default setting (DriverSigningPolicy = Warn) or the higher policy (DriverSigningPolicy = Block) to ensure that end users who download new or updated unsigned drivers are warned first about the potential problems that can occur.

After Sysprep finishes, DriverSigningPolicy is set automatically to Warn unless Sysprep.inf contains DriverSigningPolicy = Block.

Note

  • A catalog certificate (.cat) file authenticates a driver signature. Microsoft uses certificates to sign drivers for only a finite length of time, generally six months. However, as long as a driver is digitally signed with a valid certificate, the subsequent expiration date of the certificate does not affect the status of the drivers. A driver signature does not expire, even after the certificate used to sign the driver has expired.

Preinstalling Signed Drivers

Once signed, driver files (including .inf files) cannot be modified. Making any changes to any driver file breaks the digital signature of the driver.

These conditions are required when preinstalling signed drivers:

  • All the required files must be placed in the same preinstallation directory as described in Preinstalling Plug and Play Devices.
  • The driver must be installed using an .inf file.
  • The driver must pass the Windows Logo Program testing and have a digital signature from WHQL.
  • The .inf file must not contain signability errors.
  • The driver must not include Microsoft-originated files or runtimes.

Verifying File Signatures

To check for signatures, use the signature verification tool Sigverif.exe included in Windows. By default, this tool scans a default set of system files listed in Corelist.inf, all drivers in Device Manager, and all installed printer drivers. You can also use this tool to scan for individually signed files. Test each factory-preinstalled image that you produce with Sigverif and identify any unsigned .sys or .drv files.

To run Sigverif, click the Start button, click Run, and then type sigverif.

To check a driver's properties after installation, go to the Driver Properties tab in Device Manager on a test computer.

Validating and Debugging Device Driver Signatures

Setupapi.log, in the %SYSTEMROOT% directory, can be used to determine points of failure in driver installation and signature verification. For a clean record of the code Windows uses to install the driver and verify the signature, delete the log before installing a driver.

Turn on verbose Setupapi logging by adding the LogLevel value to the following registry key:

HKEY_Local_Machine\Software\Microsoft\Windows\CurrentVersion\Setup

DWORD LogLevel
Data = FFFF

Restart the system, install the driver you wish to test, and open the Setupapi.log file. The status of each individual driver component, including whether it is properly signed, is described in detail.

For more information, see the Driver Signing for Windows (http://www.microsoft.com/hwdev/driver/digitsign.htm) white paper, located on the Windows Platform Development Web site (http://www.microsoft.com/hwdev/).


Preinstalling Mass-Storage Drivers

Plug and Play installs most hardware drivers, which you can load later in the Setup process. However, you must properly install mass-storage drivers, such as drivers for hard disk controllers, to make full Plug and Play support available during GUI-mode Setup. For this reason, their installation is handled differently from that of other hardware drivers.

When the [MassStorageDrivers] section is used in Unattend.txt, no in-box mass-storage drivers are installed during text-mode Setup unless you specify them in this section. If this section is missing or empty, Setup attempts to detect the devices on the computer and install the corresponding in-box drivers.

To preinstall mass-storage drivers during text-mode Setup, before full Plug and Play support is available, you must provide a Txtsetup.oem file that describes how Setup must install the particular driver.

For more information about Txtsetup.oem, see the Microsoft Windows Driver Development Kit (DDK), which you can order from the Microsoft DDK Web site (http://www.microsoft.com/ddk/). You can also read the DDK documentation in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, and then select Driver Development Kit.

To preinstall a mass-storage device

  1. In the \$OEM$ subfolder of the configuration set, create the \Textmode subfolder.
  2. Copy the files from the disks supplied by the device vendor to the \Textmode subfolder. These files normally include:
    • Driver.sys
    • Driver.dll
    • Driver.inf
    • Driver.cat
    • Txtsetup.oem

    where Driver is the driver name.

    Notes

    • You must also copy the driver files to the location you specified in the OemPnPDriversPath entry in the answer file(s). For example:
      OemPnPDriversPath = drivers\storage
    • Some drivers, such as SCSI miniport drivers, may not include a .dll file.
    • A catalog file (Driver.cat) must be included with mass-storage device drivers if it is listed in Txtsetup.oem.

      For more information about catalog files, see Using Signed Drivers. Also see the Microsoft Windows Driver Development Kit (DDK), which you can read in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, and then select Driver Development Kit.

  3. In the Unattend.txt file, create a [MassStorageDrivers] section, and then type any driver entries in that section. For example, a possible entry in the [MassStorageDrivers] section is:
    "Adaptec 2940..." = "OEM"

    Obtain the information for this section from the [SCSI] section of the Txtsetup.oem file provided by the hardware manufacturer.

    Note

    • You must use signed drivers. Unsigned drivers are not installed during an unattended installation.
  4. In the Unattend.txt file, create an [OEMBootFiles] section, and in it type a list of the files in the \$OEM$\Textmode folder. For example:
    [OEMBootFiles]
Driver.sys
Driver.dll
Driver.inf
Driver.cat
Txtsetup.oem

    where Driver is the driver name.

    Important

    • Add driver entries only to the [MassStorageDrivers] and [OEMBootFiles] sections for bootable mass-storage devices. Do not include secondary mass-storage devices. Instead, add the drivers for secondary mass-storage devices to the folder specified by the OemPnPDriversPath entry in your unattended Setup answer file. Including drivers for non-bootable mass-storage devices in the [MassStorageDrivers] or [OEMBootFiles] sections causes an error during Setup.
  5. If your mass-storage device is a Plug and Play device, verify that a Hardware Identification section and the name of the catalog file for the driver (Driver.cat) exist in the Txtsetup.oem file. For more information, see the Microsoft Windows Driver Development Kit in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, and then select Driver Development Kit.

If the Hardware Identification section does not exist, you must add [HardwareIds.scsi.yyyyy] to the Txtsetup.oem file and verify that the following information is included:

id = "xxxxx" , "yyyyy"

where xxxxx represents the device ID, and yyyyy represents the service associated with the device.

For example, to preinstall the Symc810 driver, which has a device ID of PCI\VEN_1000&DEV_0001, verify that your Txtsetup.oem file contains the following additional section:

[HardwareIds.scsi.symc810]
id = "PCI\VEN_1000&DEV_0001","symc810"

You must remove drive and path references from Txtsetup.oem. For example, instead of this text, use the NTFS or FAT32 examples that follow:

[disks]
d1 = "Windows XP Driver Set v1.00", \w2kdsk1, \win2000\smy810\

For NTFS installations, use this text:

[disks]
d1 = "Windows XP Driver Set v1.00", \w2kdsk1, \

Note the trailing slash at the end of the line.

For FAT32 installations, use this text:

[disks]
d1 = "Windows XP Driver Set v1.00", w2kdsk1, .

Note the lack of a backslash; also note the trailing period at the end of the line.

Note

  • The MSDInst.exe tool enables you to add mass-storage device drivers to an offline image. For details, see the white paper entitled Using the Mass Storage Device Installation Tool (MSDInst.exe) on the Windows OPK CD.

Selecting and Loading the Correct Mass-Storage Driver

If you are including new or updated drivers for mass-storage devices, you must add the new driver to both of these folders:

  • \$OEM$\Textmode
  • The location specified in the OemPnPDriversPath entry in the Unattend.txt file.

    For example: \$OEM$\$1\Pnpdrvrs\storage

Loading Mass-Storage Drivers During Text-mode Setup

If the driver for the mass-storage device is included with Windows XP, the Windows XP driver is chosen before any drivers in \$OEM$\Textmode.

However, the driver you place in \$OEM$\Textmode is the first driver chosen during text-mode Setup only if:

  • The driver that ships with Windows XP does not boot.
  • The driver does not ship with Windows XP.

Loading Mass-Storage Drivers During GUI-Mode Setup

Windows XP loads an updated or new driver during GUI-mode Setup if the following criteria are met.

If you are loading an updated mass-storage device driver for one that ships with Windows XP:

  • The correct mass-storage driver is provided in the location specified by OemPnPDriversPath.
  • The driver is signed and is a more recent version than the one provided with Windows XP.

If you are loading a new mass-storage device driver that did not ship with Windows XP:

  • The driver is new (not included with Windows XP), signed, and installs properly during text-mode Setup.

For information about how Windows chooses the best driver during Plug and Play detection, see How Windows Selects a Particular Device Driver.

For more information about managing operating system images that contain different mass-storage drivers, see Reducing the Number of Master Images for Computers with Different Mass-Storage Controllers.

Note

  • When you run Sysprep -reseal or Sysprep -factory, Sysprep reads the [SysprepMassStorage] section of the Sysprep.inf file and writes the mass storage information into the registry before shutdown. The next time the computer starts, all mass-storage controllers are available.


Preinstalling Plug and Play Devices

To improve the end user experience and reduce the computer start-up time during the first boot, you can include additional Plug and Play device drivers in your master installation. If, at this point in your production cycle, you do not want to make any changes to your master installation, you can use Sysprep to install additional Plug and Play device drivers before delivering the computer to your customer.

Preinstalling Plug and Play Devices During Unattended Setup

During unattended Setup, you can easily preinstall Plug and Play devices that are not mass-storage devices and are not included on the Windows product CD.

To preinstall Plug and Play devices

  1. In the \$OEM$ subfolder of the configuration set, create a subfolder for any special Plug and Play drivers and their associated .cat and .inf files. For example:
    $OEM$\$1\PnPDrvrs
  2. In the Unattend.txt file, add the OEMPnPDriversPath entry to the [Unattended] section. For example:
    OEMPnPDriversPath = "PnPDrvrs"

If you have subfolders in the folder that contains the drivers, you must specify the path to each subfolder. Separate the paths with semicolons. For example, if the \PnPDrvrs folder contains the subfolders \Net and \Audio, place the following line in the Unattend.txt file:

OEMPnPDriversPath = "PnPDrvrs\Net;PnPDrvrs\Audio"

Notes

  • Setup creates the specified folder at the root of the system drive, and the folder remains in that location after Setup completes.
  • To prevent end users from inadvertently deleting driver folders located at the root of the drive, you can instead place drivers under the \$OEM$\$$ folder (for example: $OEM$\$$\PnP\Audio).

For more information, see How Windows Selects a Particular Device Driver.

Preinstalling Plug and Play Devices Using Sysprep

To add alternate paths beyond the scope of the master image, you can include the OemPnPDriversPath entry in Sysprep.inf to specify one or more alternate paths to the drivers. Each path must point to a folder that contains all the files necessary to install the particular devices: catalog files, .inf files, and drivers.

When a computer duplicated with Sysprep starts for the first time, it detects all hardware. If a hardware device is found for which there are no drivers in the default Driver.cab, the computer checks the location specified in OemPnPDriversPath. If the drivers are not in this location, then the end user is prompted for the location of the drivers.

You can also preinstall Plug and Play devices by using Sysprep -factory and the Winbom.ini file. For more information, see Using Sysprep and [PnPDrivers].


How Windows Selects a Particular Device Driver

To determine which driver is the best one for a device, Windows XP ranks the drivers and takes the driver with the lowest rank. The lower the rank, the better the match to the device. If multiple drivers have the same rank, the driver with the newest date is chosen.

To determine the rank, Windows XP checks for a signature and compares the device's Hardware IDs (HW ID) and Compatible IDs with the IDs listed in the [Models] section of the .inf file. The best match for a device is a signed driver that has a Hardware ID match for the first choice Hardware ID specified in the device. Signed drivers are always ranked as a better match than unsigned drivers.

Generally speaking, it is not important to know the exact rank number of your device because the ranking algorithm may change in future releases. However, it is important to know that the lower the rank, the better the match of the driver to the device. A driver with the rank of 0 is the best match.

Driver ranking schemes differ between Windows 2000 and Windows XP. The driver ranking scheme determines which driver to load when multiple drivers are available for a device. Drivers are ranked based on whether they are signed and how closely they match the device's Hardware ID. The following lists summarize the driver ranking schemes for Windows 2000 and Windows XP in order of highest ranking to lowest:

Windows 2000 driver ranking scheme:

  1. Signed driver with a perfect four-part HW ID match to the driver.
  2. Unsigned driver with a perfect four-part HW ID match to the driver.
  3. Signed driver with a two-part HW ID match to the driver.
  4. Unsigned driver with a two-part HW ID match to the driver.

Windows XP driver ranking scheme:

  1. Signed driver with a perfect four-part HW ID match to the driver.
  2. Signed driver with a two-part HW ID match to the driver.
  3. Unsigned driver with a perfect four-part HW ID match to the driver (with an NT-decorated INF section).
  4. Unsigned driver with a two-part HW ID match to the driver (with an NT-decorated INF section).
  5. Unsigned driver with a perfect four-part HW ID match to the driver (with an undecorated INF section).
  6. Unsigned driver with a two-part HW ID match to the driver (with an undecorated INF section).

If the ranks for device drivers are equal, Windows XP compares the drivers' dates, which are located in the DriverVer entry of the .inf file.

For more information about how Windows XP ranks drivers, see the Windows Driver and Hardware Development Web site (http://www.microsoft.com/hwdev/) or the Microsoft Driver Development Kit (DDK). You can order the DDK from the Microsoft DDK Web site (http://www.microsoft.com/ddk/). You can also read the DDK documentation in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, and then select Driver Development Kit.

Using Setupapi.log to Troubleshoot Driver Selection Issues

If you are installing an updated Windows XP driver for a device, but find that the new driver is not used when Windows installation completes, you must:

  • Verify that the driver has a valid signature. For more information about driver signatures, see Driver Signatures.
  • Check the ranking of the new driver.
  • Check the Setupapi.log for information about how Windows processes the driver. To view the Setupapi.log file, go to %WINDIR%\Setupapi.log.

For more information about Setupapi.log, see the Microsoft Windows Driver Development Kit or the Windows Driver and Hardware Development Web site at http://www.microsoft.com/hwdev/setup/setupapi.htm.

Increasing the Verbosity of Setupapi.log

If you need more information than the Setupapi.log currently provides in its default setting to help with diagnosing driver selection issues, you can increase verbosity of the logging (that is, increase the amount of information provided) by using the following procedures.

To increase the verbosity of Setupapi.log by editing the registry

To set the verbose logging level, add a value to the following registry key:

HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Setup

Value Name: LogLevel
Data Type: REG_DWORD
Value: 0xFFFF

You must add this value before GUI-mode Setup begins (just after text-mode Setup ends). Alternatively, you can have Setup add this value for you by completing these steps.

This method requires that you modify the Windows XP installation files. If you do not already have a distribution share on a network server, you must copy the \I386 folder from the Windows XP product CD to a local hard disk. Make a backup copy of the Hivesft.inf file before proceeding.

To increase the verbosity of Setupapi.log by editing Hivesft.inf

  1. On the distribution share or local hard disk containing the Windows XP files, locate the Hivesft.inf file in the \I386 folder.
  2. Using any text editor (such as Notepad), locate the following line in the Hivesft.inf file:
    HKLM,"SOFTWARE\Microsoft\Windows\CurrentVersion\Setup","DriverCachePath",0x00020002,"%SYSTEMROOT%\Driver Cache"
  3. After the line listed in the previous step, add the following line:
    HKLM,"SOFTWARE\Microsoft\Windows\CurrentVersion\Setup","LogLevel",0x00010003,0x0000FFFF

    These two lines can wrap for readability, but each is a separate single line.

  4. When you are done, the file must look like the following example. Verify this before saving the file to disk:
    HKLM,"SOFTWARE\Microsoft\Windows\CurrentVersion\Setup","DriverCachePath",0x00020002,"%SYSTEMROOT%\Driver Cache"
    HKLM,"SOFTWARE\Microsoft\Windows\CurrentVersion\Setup","LogLevel",0x00010003,0x0000FFFF
    HKLM,"SOFTWARE\Microsoft\Windows\CurrentVersion\Setup\BaseWinOptions",,0x00000012

    Save the file and quit the text editor.

Any installation initiated from this share will have verbose logging enabled in the Setupapi.log file. You can verify that this is enabled in GUI-mode Setup by pressing SHIFT+F10 to start a command prompt and using Regedit.exe to verify that the registry value has been created.

Notes

  • To view the Setupapi.log and see how Windows detected and installed the device drivers, go to %WINDIR%\Setupapi.log.
  • For more information about preinstalling Plug and Play devices, see Preinstalling Plug and Play Devices.


Detecting the Correct Video Mode for Laptop Displays

To make sure Setup properly detects the video mode, verify that:

  • Your BIOS supports the set of Video ACPI extensions.
  • The drivers for the video cards and displays are included in the \$1\Pnpdrvrs path.

Important

  • Include the Pnpdrvrs path in the OemPnPDriversPath entry of the Unattend.txt file.

If you want Setup to detect the laptop display resolution automatically (after the previous items are properly handled), specify the optimal settings in the [Display] section of the Unattend.txt file.

To enable ClearType to improve readability for end users, in the [ComputerSettings] section of the Winbom.ini file, set FontSmoothing to On.

For the most up-to-date information about hardware devices with Windows XP, see the Windows Platform Development Web site (http://www.microsoft.com/hwdev/).


Showing Hidden Devices

During preinstallation, you can create a master installation that includes all of the Plug and Play devices that you can provide to an end user. In Windows XP, Device Manager shows only the devices that are present on a delivered computer, not all of the devices that are in the master installation file.

This procedure enables a technical support person or an engineer to instruct Device Manager to show devices that may have been present on the master computer.

To show hidden devices

  1. Click Start, and then click Control Panel.
  2. Double-click System.
  3. Click the Advanced tab, and then click Environment Variables.
  4. Under System Variables, click New.
  5. In the Variable Name field, type
    DEVMGR_SHOW_NONPRESENT_DEVICES
  6. In the Variable Value field, type True.

    Note

    • You can enter any non-zero value in this field.
  7. Click OK twice.
  8. In the System Properties window, click the Hardware tab, and then click Device Manager.
  9. On the View menu, select Show hidden devices.

Note

  • Every time you access Device Manager, you must reselect Show hidden devices to view the hidden devices.

For more information, see How Windows Selects a Particular Device Driver.

Removing Phantom Devices

To remove references to devices that were present in the master computer, run Sysprep -clean. This requires a valid [Cleanup] section in Sysprep.inf. Running this command cleans out unused mass-storage drivers added by the [SysprepMassStorage] section of Sysprep.inf and removes references to phantom devices created by Plug and Play. Otherwise, these entries can cause problems when you attempt to install new devices. Sysprep -clean removes all phantom devices except:

  1. HTREE\ROOT\0 (the root of the Plug and Play tree)
  2. SWENUM devices (software-enumerated devices that don't have any hardware backing them).

    Because these are not installed from the presence of hardware, it is best not to remove them.

  3. Legacy devnodes (devnodes created by the presence of legacy services).

Note

  • If the [SysprepMassStorage] section already exists in your Sysprep.inf file, and you run Sysprep -factory, then Sysprep -reseal automatically cleans Device Manager. (That is, Sysprep removes references to devices that are no longer present.) This saves you the extra step of running Sysprep -clean in the Cmdlines.txt file.


Reducing the Number of Master Images for Computers with Different Mass-Storage Controllers

Sysprep requires that the mass-storage controller on the master installation be identical to the controllers on the destination computers.

If you are using images as part of your manufacturing process, you may want to reduce the number of images you maintain by creating one master image to install Windows on destination computers that may use different mass-storage controllers, as described in the following scenarios:

Controller used to create the master installation | Controller on the destination computer | Sample Scenario
IDE | IDE | Created the master image on a computer that uses a PCI IDE controller; the destination computers use an Intel IDE controller.
IDE | SCSI | Created the master image on a computer that uses a PCI IDE controller; some of the destination computers start from a SCSI controller such as an Adaptec 7800.
SCSI | SCSI | Created the master image on a computer that uses an Adaptec 7800 controller; the destination computers use a Qlogic controller.
SCSI | IDE | Created the master image on a computer that uses an Adaptec 7800 controller; some of the destination computers start from an IDE controller.

Before running Sysprep on the master installation and creating your image, identify the different mass-storage controllers that you can install on each destination computer in the [SysprepMassStorage] section of the Sysprep.inf file. You can do this automatically by following the procedure in "Automatically Identifying the Set of Mass-Storage Drivers." Sysprep prepopulates the necessary driver information so that Windows can load the correct drivers when the operating system starts on a computer that uses one of the predefined mass-storage controllers.

For more information, see Using Sysprep and [SysprepMassStorage].

Note

  • The MSDInst.exe tool enables you to add mass-storage device drivers to an offline image. For details, see the white paper entitled Using the Mass Storage Device Installation Tool (MSDInst.exe) on the Windows OPK CD.

Automatically Identifying the Set of Mass-Storage Drivers

You do not need to manually create the entries in the [SysprepMassStorage] section. Instead, include the [Sysprep] section in the Sysprep.inf file and Sysprep automatically generates the entries in [SysprepMassStorage] from the Plug and Play hardware IDs specified in Machine.inf, Scsi.inf, Pnpscsi.inf, and Mshdc.inf.

Note

  • This procedure works only for drivers that ship with Windows XP. In addition, the [SysprepMassStorage] section must be empty or the procedure fails.

In the [Sysprep] section of the Sysprep.inf file, set the value of BuildMassStorageSection entry equal to Yes. For example:

[Sysprep]
BuildMassStorageSection = Yes

This technique may install more mass-storage drivers than you require, and so it may increase the boot time of the computer. However, this technique is much less likely to generate errors.

Manually Identifying the Set of Mass-Storage Drivers

If you know the exact set of Plug and Play IDs that you require, you may improve the boot time of the operating system if you manually create the [SysprepMassStorage] section in Sysprep.inf.

To identify the potential mass-storage controllers on destination computers

  1. Generate a list of each of the hardware IDs for each of the mass-storage controllers that may be on the destination computers.
  2. Compare the list generated in Step 1 to the hardware IDs listed in the .inf files to determine which references are needed.
  3. For mass-storage controllers that are provided on the Windows product CD, create a Sysprep.inf file with the following section:
    [SysprepMassStorage]
hardware_id = path_to_device_inf

    where:

    hardware_id
    The Plug and Play ID for the device as specified in the device's .inf file.
    path_to_device_inf
    The path to the .inf file that contains the Plug and Play ID of the controller to install.

    For example, to support the different IDE controllers (PCI and Intel) included in Windows XP, the section may look like the following:

    [SysprepMassStorage]
PCI\VEN_8086&DEV_1222 = "%WINDIR%\inf\mshdc.inf"
PCI\VEN_8086&DEV_1230 = "%WINDIR%\inf\mshdc.inf"
PCI\VEN_8086&DEV_7010 = "%WINDIR%\inf\mshdc.inf"
PCI\VEN_8086&DEV_7111 = "%WINDIR%\inf\mshdc.inf"
PCI\VEN_8086&DEV_2411 = "%WINDIR%\inf\mshdc.inf"
PCI\VEN_8086&DEV_2421 = "%WINDIR%\inf\mshdc.inf"
PCI\VEN_8086&DEV_7199 = "%WINDIR%\inf\mshdc.inf"

    For best results, include in this list only the subset of Plug and Play IDs that are required for your environment. Identifying unnecessary hardware IDs in this list causes longer start-up times than is normally required.

  4. For mass-storage controllers that are not provided on the Windows product CD:
    • Copy the driver files for the mass-storage controllers on the destination computers to a folder on your computer—for example, to %SYSTEMDRIVE%\pnpdrvrs\storage on the master computer's hard drive.
  5. Add lines to the [SysprepMassStorage] section in the following format:
    hardware_id = "path_to_device_inf", "disk_directory", "disk_description", "disk_tag"

    where:

    hardware_id
    The Plug and Play ID for the device as specified in the device's .inf file.
    path_to_device_inf
    The path to the .inf file that contains the Plug and Play ID of the controller to install.
    disk_directory
    The name of the folder on the floppy disk provided by the third party that contains the copy of the mass-storage driver.
    disk_description
    The description of the floppy disk as specified in the Txtsetup.oem file provided by the third party.
    disk_tag
    The disk tag of the floppy disk as specified in the Txtsetup.oem file provided by the third party.

    The disk_directory, disk_description, and disk_tag values are required so that the repair process can distinguish between drivers that are included on the Windows product CD and drivers that are not provided on the Windows product CD. If the third-party driver replaces one provided on the Windows product CD, follow the instructions in Step 2.

    Place the driver files in the location specified in the [SysprepMassStorage] section of Sysprep.inf. For example, to support a new Qlogic driver, if you copy the files to the C:\Drivers\Storage folder, add the following:

    [SysprepMassStorage]
PCI\VEN_1077&DEV_1080 = "C:\Drivers\Storage\qlogic\qlogic.inf", "C:\Drivers\Storage\qlogic", "Qlogic Software Disk", "C:\Drivers\Storage\qlogic\qlogic"

    Note

    • Place all of the values for this command in one text line.
  6. Create a Cmdlines.txt file with the following lines at the top of the file:
    [Commands]
"C:\Sysprep\Sysprep -clean"

    This command disables all of the mass-storage controllers that are not installed because they are not present on the destination computer.

    Important

    • If this line is not added to Cmdlines.txt, the start-up process for the destination computers may be slower because the operating system attempts to load each controller driver each time the computer restarts.

    Place the Cmdlines.txt file in an $OEM$ folder in the location specified in the Sysprep.inf file by the InstallFilesPath entry. For example, if:

    InstallFilesPath = "C:\Sysprep\i386"

    copy the Cmdlines.txt file to the
    C:\Sysprep\i386\$OEM$ folder.

    For more information about Cmdlines.txt, see Preinstalling Applications Using Legacy Techniques.

  7. Run Sysprep.

    Note

    • When you use this procedure to preinstall mass-storage controllers, do not provide an updated Sysprep.inf file on a floppy disk. This method does not work and it may cause your installation to fail.

Important

  • For the IDE-to-SCSI and the SCSI-to-SCSI scenarios, the hard disks on the destination computers must be accessible through extended INT13 BIOS functions for Sysprep to function properly. The computers must be able to start with a boot.ini that uses the multi( ) syntax instead of the scsi( ) or signature( ) syntax.

    To ensure that the multi( ) syntax is used, add UseBiosToBoot to your answer file (Unattend.txt).

  • This capability is available only for Plug and Play (PnP) mass-storage controllers or controllers that use Plug and Play mini-ports.
  • The computers' hardware abstraction layers (HALs) between master and destination computers must still be compatible.

For more information about preinstalling these devices, see Preinstalling Mass-Storage Drivers.


Reducing the Number of Master Images for Computers with Multiprocessors

If you are using images as part of your manufacturing process, you can preinstall the same Windows image on both multiprocessor (MP) and uniprocessor (UP) computers, as long as the master computer and the destination computer are both Advanced Programmable Interrupt Controller (APIC) computers or both Advanced Configuration and Power Interface (ACPI) APIC computers.

For more information about ACPI, see Advanced Configuration and Power Interface (ACPI) specification (http://www.acpi.info/index.html).

This table illustrates the type of destination computers where you can install a given master image, depending on the hardware abstraction layer (HAL) type of the computer used to create the master installation.

HAL of Master Installation | HAL of Destination Computer
 | ACPI APIC UP | ACPI APIC MP | Non-ACPI APIC UP | Non-ACPI APIC MP
ACPI APIC UP | X | X |  |
ACPI APIC MP | X | X |  |
Non-ACPI UP |  |  | X | X
Non-ACPI APIC MP |  |  | X | X

Notes

  • Windows XP Home Edition does not support multiprocessors.
  • You can install a master installation only from a ACPI PIC computer on another ACPI PIC destination computer.
  • You can install a master installation only from a non-ACPI UP PIC computer on another non-ACPI UP PIC destination computer.
  • An image created on a computer with a single processor (with no multiprocessor support) cannot be used on a multiprocessor computer.
  • More interrupts are available with APIC systems than with Processor Interrupt Controller (PIC) uniprocessor systems. As a result, a computer with an APIC HAL:
    • Has faster response times.
    • Can support more hardware devices.

There are two techniques for creating images that you can use on both MP and UP systems. Choose the technique that works best for you and your manufacturing environment.

Applying a Multiprocessor Master Installation to a Uniprocessor Destination Computer

In the first technique, you create the master installation on an MP computer. You can then use this image on other MP computers or on UP computers.

Important

  • The HAL type of the computer where the master installation was created determines the type of destination computer where you can use the image:
    • You can use a master installation created on an ACPI APIC MP-based computer on other ACPI APIC MP- or ACPI APIC UP-based computers.
    • You can use a master installation created on a non-ACPI APIC MP-based computer on other non-ACPI APIC MP- or non-ACPI APIC UP-based computers.

To create an MP to UP image

  1. In Sysprep.inf, add:
    [Unattended]
UpdateUPHAL = "hwid,%WINDIR%\Inf\Hal.inf"

    where hwid is either MPS_UP or ACPIAPIC_UP.

    For more information, see UpdateUPHAL.

  2. Install the Windows configuration set to an MP computer.
  3. Run Sysprep in Mini-Setup mode with the Sysprep.inf file.

    Important

    • The HAL type changes only if you run Sysprep in Mini-Setup mode. The HAL does not change if you run Sysprep in Factory or Reseal mode.

    For example, from the Sysprep folder run:

    C:\sysprep\sysprep -mini -quiet -shutdown
  4. Make an image of the installation.
  5. Place the image on comparable MP destination computers.

Applying a Uniprocessor Master Installation to a Multiprocessor Destination Computer

In the second technique, you create the master installation on a UP computer with an APIC HAL. You can then use this image to preinstall Windows on destination computers that use compatible hardware, whether the destination computer uses an APIC UP HAL or an APIC MP HAL.

Important

The HAL type of the computer where the master installation was created determines the type of destination computer where you can use the image:

  • You can use a master installation created on an ACPI APIC UP-based computer on other ACPI APIC UP-based or ACPI APIC MP-based destination computers
  • You can use a master installation created on a non-ACPI APIC UP-based computer on other non-ACPI APIC UP or non-ACPI APIC MP-based destination computers.

To create the UP to MP image

  1. Install Windows on a UP computer.
  2. Make an image of the installation.
  3. In Sysprep.inf, add:
    [Unattended]
UpdateHAL = "hwid,%WINDIR%\Inf\Hal.inf"

    where hwid is either MPS_MP or ACPIAPIC_MP.

    For more information, see UpdateUPHAL.

  4. Run Sysprep in Mini-Setup mode with this Sysprep.inf file.

    Important

    The HAL type changes only if you run Sysprep in Mini-Setup mode. The HAL does not change if you run Sysprep in Factory or Reseal mode.

    For example, from the Sysprep folder run:

    C:\sysprep\sysprep -mini -quiet -shutdown
  5. Make an image of the installation.
  6. Place the image on comparable MP destination computers.

Important

  • Do not use a Sysprep.inf file containing UpdateHAL on destination UP computers because UpdateHAL loads the MP HAL on the destination computer regardless of whether it is a UP or an MP computer. An MP kernel on a UP computer noticeably reduces the computer's performance.

You may use any tools you normally use to manipulate files on the hard disk when creating new computers from an image.


The OPK Toolkit

The following tools are fundamental to the Windows preinstallation process. Install these tools from the Windows OPK CD onto the technican computer, as described in Installing the OPK Tools.

  • Setup Manager
  • Windows Preinstallation Environment (WinPE)
  • Sysprep
  • Additional command-line tools, as described in Helpful Command-Line Tools

For detailed information on each of the tools, see the following topics:

  • Using Setup Manager
    • Setup Manager Settings
    • Setupmgr Command-Line Options
  • Windows Preinstallation Environment (WinPE) Features
    • Order of Operations in WinPE
    • Limitations of WinPE
    • Size of WinPE
    • Creating a Customized Version of WinPE
    • Placing a Bootable Version of WinPE on a Hard Disk
  • Using Sysprep
    • Using Sysprep in Factory Mode
    • Sysprep and Windows Product Activation FAQ
    • Sysprep Components
    • Using the Registry to Control Sysprep in Factory Mode
    • Sysprep Command-Line Options


Setup Manager Settings

Setup Manager consists of the pages listed in this table. For the locations in which settings from each Setup Manager page are saved, click each page in the table. For detailed help with Setup Manager, see the Step-by-Step Guide to OEM Preinstallation of Windows XP white paper on the Windows OPK CD.

Important

  • Because the user name and password that you select to connect to the distribution share are in plain text, it is recommended that you grant this account only the minimum rights needed to make the connection.
Page Title | Description
Configuration Set | Enables you to create a new configuration set or edit an existing one.
Type of Installation | Provides three installation options: reseal when finished, do not reseal, or copy files only.
Product | Prompts you to select the Windows product that you want to install.
OEM Branding Information | Prompts you to provide manufacturer, model, and support information.
Product Key | Prompts you to provide a Product Key.
Preinstalled Applications | Enables you to preinstall applications.
Logo Information | Enables you to display your company logo on the General tab of the System Properties dialog box.
Branding Opportunities | Enables you to add your company name and logo to Windows Welcome screens.
System Settings | Enables you to change the default settings for language, region, keyboard, and time zone.
Hardware Tutorials | Enables you to provide your own mouse tutorial during Windows Welcome.
USB Hardware Detection | Checks for USB hardware devices, if applicable.
Internet Sign-up | Prompts you to select from among several Internet sign-up options.
Browser Toolbar Buttons | Enables you to add toolbar buttons to Internet Explorer.
Important URLs | Enables you to add custom home page, search, and support URLs to Internet Explorer.
Favorites and Links | Enables you to add URLs to the Favorites list and Links bar in Internet Explorer.
Start Menu | Enables you to add programs to the Most Frequently Used section of the Start menu.
OEM Link on the Start Menu | Enables you to add a branded OEM link to the Start menu.
Program Shortcuts Folder | Enables you to change the name of the Program Shortcuts folder.

Configuration Set Page

There are no settings written from this page.

Type of Installation Page

Setup Manager saves settings from this page in this location:

Winbom.ini
[Factory]
Reseal
ResealMode

Product Page

Setup Manager saves settings from this page in this location:

Winbom.ini
[WinPE]
SKU

OEM Branding Information Page

Setup Manager saves settings from this page in this location:

Oeminfo.ini
[General]
Manufacturer
Model
[Support Information]
Line1
Line2
etc.

Product Key Page

Setup Manager saves settings from this page in this location:

Unattend.txt
UserData
ProductKey

Preinstalled Applications Page

Setup Manager saves settings from this page in this location:

Winbom.ini
[OEMRunOnce]

The [OEMRunOnce] section contains multiple entries that configure application preinstallation.

[Factory]
Password
UserName

Logo Information Page

Setup Manager saves settings from this page in this location:

Setup Manager saves the Oemlogo.bmp file to OPKTools\Cfgsets\configsetname\$Oem$\$$\System32. Windows Setup copies the .bmp file to the %WINDIR%\System32 folder on the target computer.

Branding Opportunities Page

Setup Manager saves settings from this page in this location:

Oobeinfo.ini
[Branding]
OEMName

System Settings Page

Setup Manager saves settings from this page in this location:

Oobeinfo.ini
[Options]
DefaultKeyboard
DefaultLanguage
DefaultRegion
INTL_Settings
TimeZone

Hardware Tutorials Page

Setup Manager saves settings from this page in this location:

Oobeinfo.ini
[Options]
MouseTutorial
IMETutorial

USB Hardware Detection Page

Setup Manager saves settings from this page in this location:

Oobeinfo.ini
[Options]
USBMouse
USBKeyboard
[OEMHardwareTutorial]
OEMHWTutorial

Internet Sign-up Page

Setup Manager saves settings from this page in this location:

Oobeinfo.ini
[Signup]
ISPSignup
OEMOfferCode

Browser Toolbar Buttons Page

Setup Manager saves settings from this page in this location:

Unattend.txt
[Branding]
BrandIEUsingUnattended
IEBrandingFile

Install.ins
[BrowserToolbars]
Action0
Caption0
HotIcon0
Icon0
Show0

Important URLs Page

Setup Manager saves settings from this page in this location:

Unattend.txt
[Branding]
BrandIEUsingUnattended
IEBrandingFile

Install.ins
[URL]
Home_Page
Search_Page
Help_Page

Favorites and Links Page

Setup Manager saves settings from this page in this location:

Install.ins
[FavoritesEx]
Title1
URL1

Start Menu Page

Setup Manager saves settings from this page in this location:

Winbom.ini
[StartMenuMFUlist]
Link0
Link1
Link2
Link3

OEM Link on the Start Menu Page

Setup Manager saves settings from this page in this location:

Winbom.ini
[OemLink]
OemBrandIcon
OemBrandLink
OemBrandLinkText

Program Shortcuts Folder Page

Setup Manager saves settings from this page in this location:


Setupmgr Command-Line Options

You can run Setup Manager either from its shortcut on the Start menu or from the command line.

To run the Setup Manager tool from the command line, use this syntax:

setupmgr [/m:configset][/b:batchfile [/a]]

Option | Action
/m:configset | Specifies the name of a configuration set to open in maintenance mode (when editing an existing configuration set).
/b:batchfile | Specifies the name of the batch file to use in batch mode.
/a | Runs Setup Manager in autorun mode (only in conjunction with batch mode).


Windows Preinstallation Environment (WinPE) Features

Windows Preinstallation Environment (WinPE), also known as Windows PE, is a minimal Win32 subsystem with limited services, based on the Windows XP Professional kernel running in protected mode. It contains the minimal functionality that you need to run Windows Setup, install an operating system from a network share, automate basic processes, and perform hardware validation.

The Windows OPK CD is a bootable copy of the Windows Preinstallation Environment (WinPE) (32-bit version) that supports all mass-storage and networking drivers contained on the Windows XP Professional CD.

WinPE provides these features:

  • A hardware-independent Windows environment for both x86-based and Itanium-based architectures, with a small footprint on both the bootable media and in memory.
  • A subset of the Win32 application programming interfaces (APIs), a command-line interface (Cmd.exe) capable of running batch files, and support for Windows Script Host (WSH), HTML Applications (HTA), and ActiveX Data Objects (ADO) used to create custom OEM tools or scripts.
  • Network access and support for standard in-box network drivers that may be required for copying images and test suites from a network using TCP/IP. You can easily add or remove network drivers from a customized version of WinPE.
  • Support for all mass-storage devices that use Windows 2000 or Windows XP drivers. As new devices become available, you can easily remove unneeded drivers or incorporate additional drivers into a customized version of WinPE.
  • Native support to create, delete, format, and manage NTFS file system partitions.
  • Hardware diagnostics can load and test specific hardware drivers.
  • Support for PXE protocol. If the computer supports PXE-booting, then the computer can automatically boot from a WinPE image located on a Remote Installation Server (RIS). The WinPE image is not automatically installed onto the hard disk of the computer.

Incorporating WinPE into your factory preinstallation process allows you to port your existing MS-DOS-based tools to a subset of the 32-bit Windows APIs, so you can more easily maintain these applications in a standard development environment, such as Microsoft Visual Studio®. These hardware diagnostics and other preinstallation utilities can then use the same signed Windows XP drivers in the computers that you manufacture, and you will no longer need to request 16-bit drivers from independent hardware vendors (IHVs).

You can use WinPE on both x86- and Itanium-based computers. For Itanium-based computers, you must build a 64-bit version of WinPE from the Windows XP 64-Bit Edition CD. For more information, see Creating a Customized Version of WinPE.

Important

  • At the time of release, none of the third-party disk-imaging products currently support the new disk-partitioning scheme, GUID Partition Table (GPT), used in Itanium-based computers. The only methods of preinstalling 64-bit editions of Windows are either to use WinPE or perform a CD-based unattended installation. The recommended method is to use WinPE.

For more information on using WinPE, see these topics:

  • Using WinPE in Your Manufacturing Process
  • Order of Operations in WinPE
  • Limitations of WinPE
  • Size of WinPE
  • Creating a Customized Version of WinPE
  • Placing a Bootable Version of WinPE on a Hard Disk
  • Preinstalling 64-Bit Editions of Windows


Order of Operations in WinPE

When you start a computer using WinPE, you run the command factory -winpe, which processes these sections in Winbom.ini in this order:

  • [WinPE.Net]
  • [DiskConfig]
  • [OEMRunOnce]
  • [OEMRun]
  • [WinPE], except for the Restart entry
  • [UpdateSystem]
  • Restart entry in [WinPE]

Initial Startup

WinPE uses the Windows Setup loader instead of the regular boot loader to load Windows. In the initial boot of WinPE, Setup Loader loads the mass-storage device drivers listed in Winpeoem.sif. If no drivers are listed in Winpeoem.sif, Setup Loader loads all of the mass-storage devices normally present in Windows XP Professional or Windows XP 64-Bit Edition.

For more information, see Creating a Customized Version of WinPE and Winpeoem.sif.

While WinPE starts, press F6 to load a particular device that does not have in-box support and is not listed in Winpeoem.sif.

Note

  • For more information on Txtsetup.oem, see the Microsoft Windows Device Driver Kit (DDK), which you can order from the Microsoft DDK Web site (http://www.microsoft.com/ddk/). You can also read the DDK documentation in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, and then select Driver Development Kit.

When you start WinPE from a CD, Plug and Play detects the network card installed on the computer, loads the appropriate driver, and binds the network stack. To reduce the time required to detect the network card, you can customize WinPE to search only for a given set of network drivers, instead of all the network drivers normally present in Windows XP Professional or Windows XP 64-Bit Edition.

WinPE loads the standard hardware abstraction layer (HAL). Press F5 to load a particular HAL.

Win32 Subsystem

When the Win32 subsystem starts, by default WinPE starts the Cmd.exe shell. You can customize WinPE to use an alternative shell or application. If Factory.exe does not find a Winbom.ini file, either in the WinPE image or on a floppy disk, it stops running.

The settings in Winbom.ini provide a wide range of preinstallation tasks. To perform tasks beyond the scope of Winbom.ini, create batch files either to replace or supplement Winbom.ini.

With WinPE running, you can use Winbom.ini or your own batch files in order to:

  • Copy a test harness to the destination computer and run hardware diagnostics.
  • Run programs, such as a utility to partition and format the drives.
  • Establish network connectivity with the NET USE command, and change directories to the location of the preinstalled images.
  • Start the unattended Setup from a network source.

If you start WinPE from read-only media such as a CD, WinPE stores the registry hives in memory so that applications can write to the registry. Any changes made to the registry by the applications do not persist across different WinPE sessions.


Limitations of WinPE

WinPE has these limitations:

  • To reduce its size, WinPE includes only a subset of the available Win32 APIs. Included are I/O (disk and network) and core Win32 APIs.
  • To prevent its use as a pirated operating system, WinPE automatically stops running the shell and reboots after 24 hours of continuous use.
  • No network access to files or folders on a WinPE computer from another location on your network.
  • Distributed File System (DFS) name resolution is not supported.
  • The tested methods of gaining network connectivity to file servers are TCP/IP and NetBIOS over TCP/IP. Other methods, such as the IPX/SPX network protocol, are not supported.
  • The drive letters assigned during WinPE are not saved to any registry that persists when you reboot. The drive letter assignment when you create partitions is in the order of creation, but the drive letter assignments when you reboot will be in the default order.
  • WinPE requires a VGA-compatible device and uses a screen resolution of 800 x 600 pixels. If WinPE cannot detect video settings, the default screen resolution is 640 x 480 pixels.
  • WinPE is too large to fit on a floppy disk. For more information, see Size of WinPE.
  • You cannot build a custom version of WinPE from Windows XP Home Edition.
  • WinPE does not support the Microsoft .NET framework.
  • The "Windows on Windows 32" (WOW32) subsystem was introduced into Windows NT to allow 16-bit applications to run on the Windows NT 32-bit platform. Similarly, a new 32-bit subsystem called "Windows on Windows 64" (WOW64) has been introduced into Windows XP 64-bit versions. This subsystem provides all the 32-bit Windows services needed for 32-bit applications to run properly. However, the WOW32 subsystem is not included in WinPE for i386, so 16-bit applications will not function. And in WinPE for IA64, there is no WOW64 subsystem, so 32-bit applications will also not function.

Windows APIs That Are Not Supported on WinPE

The following categories of functions of the Win32 API set are not present in WinPE. For more information on these categories, see the Microsoft Platform SDK in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, and then select Platform SDK.

  • Windows Management Instrumentation (WMI)
  • Windows Multimedia
  • Still Image
  • OpenGL
  • NetShow Theater Administration
  • Windows Shell
  • Access Control
  • Power Options
  • Printing and Print Spooler
  • Window Station and Desktop
  • Terminal Services
  • User Profile
  • Tape Backup

For information on adding support for Windows Script Host (WSH), HTML Applications (HTA), and ActiveX Data Objects (ADO) to WinPE, see Adding Optional Component Packages to WinPE in the topic Creating a Customized Version of WinPE.


Size of WinPE

The approximate size of a non-customized English version of WinPE is:

Platform | On-disk image size | In-memory size
32-bit x86 computers | ~100 MB | ~35 MB
64-bit Itanium computers | ~200 MB | ~35 MB

These in-memory sizes are computed when networking services are running.

Localized versions of WinPE vary in size between 300-370 MB, depending upon the language.

The size of a custom version of WinPE varies, depending on the set of drivers you choose to include or exclude. The on-disk size of the default WinPE configuration includes all in-box drivers, and many of these drivers are uncompressed.

The approximate size of each directory on the English 32-bit version of WinPE is:

Directory | Approximate size
\System32 | 66 MB
\System32\Drivers | 29 MB
\inf | 4 MB
\fonts | 9 MB
\winsxs | 5 MB

Important

  • When building a custom version of WinPE, do not remove items from any of these directories unless you thoroughly understand their use in WinPE. Removing items from \winsxs causes some Win32 APIs to fail.

While WinPE is too large to fit on a floppy disk, you can place your customized version of WinPE on any bootable media, including a CD-ROM, DVD, hard disk, or a Remote Installation Server (RIS). Royalty OEMs can use WinPE as part of their recovery media solution.

For more information, see these topics:

  • Creating a Customized Version of WinPE
  • Placing a Bootable Version of WinPE on a Hard Disk


Creating a Customized Version of WinPE

The Windows OPK CD is a bootable copy of the basic 32-bit version of Windows Preinstallation Environment (WinPE). However, you may want to create a version of WinPE for 64-bit computers, or configure WinPE to use a different set of drivers. To support these needs, the OPK includes a collection of scripts and utilities that enable you to build a version of WinPE customized for your factory environment.

Important

  • You can build a custom version of WinPE from any version of Windows XP except Windows XP Home Edition, Windows .NET Datacenter Server, and Windows .NET Web Server.
  • A custom version of WinPE is still subject to the conditions listed on Limitations of WinPE.
  • Windows XP 64-Bit Edition and the 64-bit versions of the Windows .NET Server family are available only in English, French, German, and Japanese.

Basic Process: Building a Custom Version of WinPE

Building a custom version of WinPE requires several minutes. This process creates a directory structure of the WinPE files and optionally creates an image file that you can burn to a CD-ROM.

Note

  • You must have backup and restore privileges to use the WinPE build tools.

To create a custom version of WinPE

  1. Create and name a directory on your hard disk, specified by build_location.
  2. Place the Windows OPK CD into the CD-ROM drive, denoted as cd_drive.
  3. Copy cd_drive\Winpe\*.* to build_location.
  4. Copy Factory.exe and Netcfg.exe from the cd_drive\Tools\platform directory into the build_location directory.

    To build a 32-bit version of WinPE, the value of platform is x86.

    To build a 64-bit version of WinPE, the value of platform is ia64, and you also must copy Efinvr.exe into the build_location directory.

  5. Remove the Windows OPK CD from the CD-ROM drive.
  6. To build a 32-bit version of WinPE:

    Place the 32-bit Windows product CD in the CD-ROM drive.

    –OR–

    To build a 64-bit version of WinPE:

    Place the 64-bit Windows product CD in the CD-ROM drive.

  7. To build a 64-bit version of WinPE, place a floppy disk in the A:\ drive of the computer. This disk is used for temporary storage during the build process of the 64-bit WinPE.
  8. Navigate to build_location.
  9. Run this command:

    Mkimg.cmd source_directory destination_directory [image_name]

    source_directory
    Specifies the location of the Windows product CD. If source_directory is a CD-ROM drive, you need only to specify the drive letter. If source_directory is a network path, the path must be to the parent directory of the \i386 directory.

    Note

    • Do not include a trailing slash in source_directory.
    destination_directory
    Specifies the path where the files necessary to create the image are temporarily stored. If this directory does not already exist, Mkimg.cmd creates it.
    image_name
    Optional. Specifies the path and file name of the ISO image file that contains this customized version of WinPE, if you place this version of WinPE onto a CD-ROM.
  10. If you are creating a CD-ROM, use CD creation software to burn the ISO image file directly to the CD media.

Important

  • You must have read/write permissions for build_location. You cannot run the mkimg command from a read-only device such as a CD-ROM drive.

    For more information, see Mkimg Command.

Example

For example, if build_location is C:\Build.x86, this command-line creates an ISO image called x86winpe.iso by using C:\Winpe.tmp as a temporary storage area.

C:\Build.x86\Mkimg.cmd E: C:\Winpe.tmp C:\x86winpe.iso

Note

  • Instead of using the Mkimg tool, you can also use Oscdimg to create an .iso file. Oscdimg requires an existing WinPE fileset to build the .iso from.

If you create an .iso image file, you can burn this version of WinPE to a CD. You can also place the customized version of WinPE on a hard disk, as described in Placing a Bootable Version of WinPE on a Hard Disk, or on a Remote Installation Server (RIS). Although not explicitly discussed in this guide, you can also place WinPE on bootable media other than a CD or a hard disk.

Important

  • To configure the WinPE CD so that it starts from the CD every time, if the WinPE CD is present in the CD-ROM drive, remove the \i386\Bootfix.bin file from the WinPE directory structure before you create an .iso file. Bootfix.bin is the file that provides the "Press any key to boot from CD-ROM" message.

Building a Bootable 64-Bit WinPE CD

You can create a bootable 64-bit WinPE CD that starts automatically without user interaction. This method assumes that the computer you are booting has been configured to boot from CD-ROM.

This process creates a directory structure of the WinPE files which is used to create an ISO file that can be burned to CD-ROM.

To create a custom 64-bit version of WinPE

  1. On an x86 machine running a 32-bit version of Windows 2000 or Windows XP, open a command prompt. This can be done by clicking the Start menu, selecting Run, and typing CMD.EXE.
  2. Create a directory on your hard disk to hold the tools required to create a WinPE CD. For example: MD C:\WINPE.
  3. Place the Windows OPK CD into the CD-ROM drive, denoted as cd_drive.
  4. Type Copy cd_drive\Winpe\*.* C:\WinPE.
  5. Type Copy cd_drive\Tools\IA64\FACTORY.EXE C:\WINPE.
  6. Type Copy cd_drive\Tools\IA64\NETCFG.EXE C:\WINPE.
  7. Type Copy cd_drive\Tools\IA64\EFINVR.EXE C:\WINPE.
  8. Remove the Windows OPK CD from the CD-ROM drive.
  9. Place the Windows XP 64-Bit Edition CD in the CD-ROM drive.
  10. Navigate to the WinPE directory by typing CD \WINPE.
  11. Run this command:

    Mkimg.cmd source_directory destination_directory

    source_directory specifies the location of the CD for the 64-bit Edition of Windows XP and destination_directory specifies the path where the files necessary to create the image are temporarily stored. If this directory does not already exist, Mkimg.cmd creates it.

    If source_directory is a CD-ROM drive, you need to specify only the drive letter. If source_directory is a network path, the path must be to the parent directory of the \i386 directory. Do not include a trailing slash in source_directory.

To build the bootable 64-bit WinPE CD ISO file

  1. Create this directory structure on a blank formatted floppy diskette:
    A:\
|_EFI
  |_BOOT

    Type:

    MD A:\EFI
    MD A:\EFI\BOOT

  2. Copy SETUPLDR.EFI to the A:\EFI\BOOT directory and rename it as BOOTIA64.EFI. For example:

    COPY C:\IA64PE\IA64\SETUPLDR.EFI A:\EFI\BOOT\BOOTIA64.EFI.

  3. Type CD \WINPE.
  4. Type DSKIMAGE A: .\EFISYS.BIN.

To create the bootable ISO image file that can be burned to CD, use this syntax:

OSCDIMG -b.\efisys.bin -n -h destination_directory iso_filename

For example:

OSCDIMG -b.\efisys.bin -n -h C:\IA64PE C:\IA64PE.ISO

The ISO file that is generated can be burned to CD using the CD-burning software of your choice. After burning the ISO file to CD, ensure that the target IA64 computer has been configured so that the CD-ROM drive is the primary boot device. This can be done by using the EFI Shell Boot Menu Editor.

See the documentation that came with your computer for specific details on modifying the EFI Shell Boot Menu.

Commands in the Startnet.cmd File

When you create your own version of WinPE, it uses the commands in the default version of Startnet.cmd. There are more commands in the default version of Startnet.cmd than the factory -winpe command located in Startopk.cmd.

The commands in the default Startnet.cmd file are:

regsvr32 /s netcfgx.dll
factory -minint
netcfg -v -winpe
net start dhcp
net start nla
a:\floppy.cmd

Instead of using the factory -winpe command, this version of Startnet.cmd includes the factory -minint command followed by a netcfg command. This sequence of commands allows for more flexible control over installing and starting network services. For more information on the specific functionality of these commands, see Factory Command-Line Options and Netcfg Command-Line Options.

Floppy.cmd is an optional sample file which you can safely remove entirely from Startnet.cmd. It can contain any commands normally run at a command prompt, such as starting applications or opening additional command windows that run scripts.

Extensions of the Basic Process: More Customizations of WinPE

You can make additional customizations of this version of WinPE before burning it to a CD or copying it to a hard disk.

Adding Support for Other Languages

By default, multi-language WinPE builds are not supported. Use the [RegionalSettings] section to add support for multiple languages.

With multi-language support, you can build WinPE images in various languages without needing localized OPKs for each language. You can use one OPK to build multiple localized WinPE images.

The key to this is using [RegionalSettings] to always match the Language value to the language of the source Windows product CD. You then use LanguageGroup to specify the languages of both the OPK and the source CD.

In this example, the goal is to create a Japanese WinPE image from a Japanese Windows product CD that will support an English OPK:

[RegionalSettings]
LanguageGroup = 1, 7
Language = 0x0411

1 is the LanguageGroup ID for Western Europe and United States, and 7 is the Japanese LanguageGroup ID. 0x0411 is the locale ID (LCID) for Japanese, which matches the locale of the source CD. By adding 1 to the LanguageGroup entry, you add English support so that you can use the English OPK.

In this sample, Japanese language support is added to an English WinPE image.

[RegionalSettings]
LanguageGroup = 1, 7
Language = 0x0409

0x0409 is the LCID for English, which matches the locale of the source CD. By including 7 in the LanguageGroup entry, you add Japanese support so that you can use the English OPK and Japanese tools as well.

You can enable Arabic and Hebrew support by using either of these techniques:

  • Modify the values of LanguageGroup in the [RegionalSettings] section of Config.txt before you build WinPE from an English Windows XP Professional CD.

    To add Arabic support to an English version of WinPE, set LanguageGroup = 1, 13

    To add Hebrew support to an English version of WinPE, set LanguageGroup = 1,12

  • Modify the value of Language in the [RegionalSettings] section of Config.txt before you build WinPE from an Arabic or Hebrew version of Windows XP Professional.

    Set Language = 0x401 if you start from an Arabic Windows XP Professional CD.

    Set Language = 0x40d if you start from a Hebrew Windows XP Professional CD.

Including a specific Winbom.ini file or Startnet.cmd file

You can include a generic Winbom.ini file in a custom WinPE installation that specifies basic information about connecting to your network, formatting the hard disk, and running basic hardware diagnostics.

You can include a generic Winbom.ini file in a custom WinPE installation. Factory uses this file if another Winbom.ini is not located in the floppy drive. After using the settings in [WinPE.Net] to establish network connectivity, the Factory tool can use the NewWinbom entry to point to another Winbom.ini file located on the network.

You can also create your own version of Startnet.cmd to run a specific set of commands, batch files, or scripts.

To gain access to Windows Networking APIs, run the command netcfg -winpe from the WinPE command line, if this command is not already part of your Startnet.cmd. For more information, see Netcfg Command-Line Options.

Including Hardware Diagnostics or Other Basic Tools

If you have created any custom tools that are a core part of your validation process, you may want to include these tools in your custom WinPE installation before preinstalling the operating system.

Adding or Removing Network Drivers

By default, all network drivers on the Windows XP Professional CD or Windows XP 64-Bit Edition are supported. When you create your own WinPE image, you can add or remove the network drivers or replace the network driver list. By keeping the set of drivers to a minimum, you reduce the time required for Plug and Play detection.

To add network drivers to a custom WinPE CD, copy these files as specified:

  • All network driver *.inf files to the \%WINDIR%\inf directory.
  • All *.sys files to the \%WINDIR%\system32\drivers directory.
  • Any related *.dll, .exe, or other files to the \%WINDIR%\system32 directory.

Catalog files are unnecessary, as they are not processed by the WinPE environment.

Adding or Removing Mass-Storage Drivers

To reduce boot time, you may configure a custom version of WinPE to load a limited set of mass-storage drivers, instead of loading the entire set of mass-storage drivers that are natively supported in Windows XP. You may also configure WinPE to load additional third-party drivers.

To control which mass-storage drivers are loaded in WinPE, customize the Winpeoem.sif file. Modifying this file changes the list of drivers that WinPE loads when it boots, which affects the boot time of WinPE.

Changing the Winpeoem.sif file does not remove or add any files into the customized version of WinPE. If, in addition to reducing the boot time, you also want to reduce the size of your WinPE image, you must separately remove the unnecessary driver files from your custom version of WinPE. If you include any third-party drivers in the Winpeoem.sif file, you must manually add any required driver files to your custom version of WinPE.

For more information, see Winpeoem.sif.

Adding Optional Component Packages to WinPE

BuildOptionalComponents.vbs is a script for adding support for optional component packages. The packages include Windows Script Host (WSH), HTML Applications (HTA), and ActiveX Data Objects (ADO) to allow database connectivity from WinPE to a Microsoft SQL Server.

Notes

  • ADO access to Active Directory and Active Directory Service Interface are not supported in WinPE.
  • BuildOptionalComponents.vbs is not supported in the following language versions of WinPE:
    • Brazilian
    • Danish
    • German
    • Italian
    • Norwegian
    • Portuguese
    • Spanish
    • Swedish

If you do not specify components, or you do not run this script from the command prompt, all optional components are installed. If you include HTA, WSH is included automatically, and cannot be removed.

The script uses these command-line options:

Option | Function
/S:location | Alternate source location other than the Windows product CD
/D:location | Alternate destination other than a folder on the desktop
/ADO | Builds ADO for Microsoft SQL Server connectivity
/HTA | Builds HTA
/WSH | Builds WSH
/64 | Builds and checks 64-bit version of WinPE; requires Windows XP 64-Bit Edition
/Q | Runs the script without prompting for inputs; returns any errors
/E | Explores the resulting folder automatically when complete


Creating Bootable WinPE Media

You can place a customized version of the Windows Preinstallation Environment (WinPE) on a hard disk, which can be useful for either preinstalling Windows or creating a hard disk-based recovery solution.

These procedures assume that you have created a custom version of WinPE, as detailed in Creating a Customized Version of WinPE. When you have completed this step, the customized WinPE files are in build_location on your technician computer or other network share.

To create a bootable WinPE disk (32-bit versions of WinPE)

  1. Boot the destination computer into WinPE using a WinPE CD.
  2. Create a formatted and active partition.
  3. On the active partition, create a directory called C:\Minint. You must name the directory "Minint".
  4. Copy the contents of build_location\i386 to C:\Minint.

    For example:

    xcopy "C:\Build.x86\i386\*.*" C:\Minint /S

    where C:\Build.x86 is build_location.

  5. Copy Ntdetect.com from build_location to the root of the destination hard disk.

    For example:

    xcopy "C:\Build.x86\ntdetect.com" C:\

    where C:\Build.X86 is build_location.

  6. On the destination hard disk, copy C:\Minint\setupldr.bin to C:\ntldr.

    For example:

    xcopy "C:\Minint\setupldr.bin" C:\ntldr
  7. Restart the destination computer. The computer starts using WinPE.

For more information on using Diskpart to format and partition the hard disk, see DiskPart Commands.

To create a bootable WinPE disk (64-bit versions of WinPE)

  1. Boot the destination computer into WinPE by using a WinPE CD.
  2. Create a primary data partition, specified by data_partition.
  3. Create a formatted and active EFI partition, specified by efi_partition, by running the following Diskpart.exe commands:
    select disk 0
select partition 1
assign letter = g
exit

    Where efi_partition = G:\

  4. On the data partition, create a directory called data_partition\Winpe\ia64.

    For example:

    C:\Winpe\ia64

    Where data_partition = C:\

  5. Copy the contents of build_location\ia64 to data_partition\Winpe\ia64.

    For example:

    xcopy "C:\Build.ia64\ia64\*.*" C:\Winpe\ia64 /hide

    where C:\Build.ia64 is build_location and C:\Winpe\ia64 is data_partition.

  6. Copy build_location\ia64\Setupldr.efi to efi_partition.

    For example:

    xcopy "C:\Build.ia64\ia64\Setupldr.efi" G:\

    where C:\Build.ia64 is build_location and G:\ is efi_partition.

  7. Create a blank file named $WinPE$.$$$ on the EFI partition in the same location as Setupldr.efi.

    For example:

    echo blank file >> G:\$Winpe$.$$$

    where G:\ is efi_partition.

  8. To start the computer from this version of WinPE that you have placed on the EFI partition, run the Efinvr command.

    For example:

    Efinvr /add G:\Setupldr.efi C:\Winpe\ia64

    where G:\ is efi_partition and C:\Winpe\ia64 is data_partition.

  9. Restart the destination computer. The computer starts using WinPE.

Note

  • You can follow a similar procedure if you start the computer from an operating system located on the hard disk, instead of initially starting the computer with a WinPE CD. When you run Diskpart from a full Windows operating system, Diskpart cannot assign a drive letter to an EFI partition. Instead, in step 2 of this procedure, use the Mountvol command.

    For example:

    mountvol /s g:

    where G:\ is efi_partition.


Using Sysprep

Microsoft Windows System Preparation (Sysprep) tool prepares a personal computer's hard disk for disk duplication, auditing, and customer delivery.

Sysprep configures the computer so that Windows Welcome or Mini-Setup runs the next time the computer starts. This first-run experience is a shortened GUI-mode setup that takes three to 10 minutes instead of the usual 30 to 45 minutes and prompts the end user only for required, user-specific information, such as accepting the End-User License Agreement (EULA), entering the Product Key, and adding their user and company names.

With Sysprep, you can copy fully installed systems when the hardware is similar. It modifies the local computer security identifier (SID) so that it is unique to each computer.

With Sysprep properly configured, you can start the computer, skip Windows Welcome or Mini-Setup, audit the installation, and then return the operating system to a customer-ready state.

For more information on tasks you can accomplish with Sysprep, see:

  • Using Sysprep in Factory Mode
  • Auditing Destination Computers
  • Automating and Preconfiguring Mini-Setup

Important

  • When Windows Welcome runs, the Owner account (in Windows XP Home Edition) or Administrator account (in Windows XP Professional) is copied over the default user profile. For this reason, if you add any files to the default user profile before running sysprep -reseal, they will no longer exist after Windows Welcome finishes.

    To prevent this, add the files to the Owner or Administrator account before running sysprep -reseal.

How Sysprep Prepares the Installation for the End User

Before you deliver the computer to the end user, you must run Sysprep to configure Windows Welcome or Mini-Setup as the end-user first-run experience. If you use Sysprep in Factory mode as part of your manufacturing process, you must include the -reseal command-line option the final time you run Sysprep.

When you run sysprep -reseal, Sysprep:

  1. Clears any registry keys and settings that need to be unique, such as Internet connection settings, Microsoft® Media Player™ IDs, or any items on the Start menu.
  2. Uses Setupcl.exe to reset the security IDs (SIDs) the next time the operating system restarts, before Windows Welcome or Mini-Setup runs.
  3. Sysprep populates the [SysprepMassStorage] section in Sysprep.inf, if the value of BuildMassStorageSection in the [Sysprep] section of Sysprep.inf is Yes and Sysprep.inf has the [SysprepMassStorage] section.
  4. Installs the mass-storage drivers from [SysprepMassStorage] in Sysprep.inf.
  5. Closes network connections.
  6. Configures Windows Welcome or Mini-Setup to run on next boot.
  7. Writes the registry keys in HKEY_LOCAL_MACHINE\SYSTEM\Setup\CloneTag.
  8. Clears any system restore points.
  9. Resets the time clock for Windows Product Activation, if the time clock has not already been reset three times.

Restrictions on Using Sysprep

Running Sysprep without using Sysprep.inf causes entries from Unattend.txt to be reprocessed after Windows Welcome. The entries are added by Unattend.txt to $Winnt$.sif. To prevent the processing of the entries in $Winnt.sif$, either remove the entries or delete the $Winnt.sif$ file.

Sysprep is not for use with Windows XP installations that have been upgraded.

Sysprep can run only on the C: drive.

Sysprep runs only if the computer is a member of a workgroup, not a domain. If the computer is joined to a domain, Sysprep removes it from the domain.

You cannot run Sysprep on a computer that has been configured as a Cluster service server, a Certificate Services server, or a domain controller. You can run Sysprep on a standalone server.

Warning

  • If you run Sysprep on an NTFS file system partition that contains encrypted files or folders, the data in those folders becomes completely unreadable and unrecoverable.

You can use this version of Sysprep only on Windows XP or the Windows .NET Server family. You cannot use this version of Sysprep on a Windows 2000 installation.

For more information, see:

  • Using Sysprep in Factory Mode
  • Sysprep and Windows Product Activation Frequently Asked Questions (FAQ)
  • Sysprep Components
  • Sysprep Command-Line Options
  • Using the Registry to Control Sysprep in Factory Mode


Using Sysprep in Factory Mode

The Factory mode of Sysprep is a method of preconfiguring installation options that can reduce the number of images that an OEM needs to maintain.

You can use Factory mode to install additional drivers and applications after the reboot following Sysprep. Normally, running Sysprep as the last step in the preinstallation process prepares the computer for delivery. When rebooted, the computer displays Windows Welcome or Mini-Setup. By running Sysprep with the -factory option, the computer reboots in a network-enabled state without starting Windows Welcome or Mini-Setup. In this state, Factory.exe performs these actions:

  • Processes its answer file, Winbom.ini
  • Copies drivers from a network source to the computer
  • Starts Plug and Play enumeration
  • Stages, installs, and uninstalls applications on the computer from source files located on either the computer or a network source
  • Adds customer data

In this state, you can audit the computer. When finished, run Sysprep with the -reseal option to prepare the computer for delivery to the customer.

If Factory.exe is not in the same folder as Sysprep.exe, the command sysprep -factory does not run.

For example, you can create a master installation that contains a minimal set of drivers, run sysprep -factory, create an image of the installation, and copy the image to multiple destination computers. If any destination computer requires additional drivers, run sysprep -factory on the destination computer and load those drivers at that time.

Note

  • You can restart the computer after sealing it with Sysprep, without restarting in Windows Welcome, by adding the OEMAuditBoot = 1 entry to the [StartupOptions] section in Oobeinfo.ini.

For more information about other Sysprep options, see Sysprep Command-Line Options.

Modifying Images for Build-to-Order Manufacturing

OEMs that use the build-to-order method can integrate their sales-order systems by using Factory mode to prepopulate customer information such as name, time zone, and so on in the answer file Winbom.ini. You can also update other .ini or answer files, such as Sysprep.inf, Oobeinfo.ini, or .isp and .ins files, during Factory mode.

Managing the Appearance of the Sysprep Dialog Box

You can change registry settings to hide the appearance of the Sysprep dialog box. For more information, see Using the Registry to Control Sysprep in Factory Mode.

This is the Sysprep dialog box:

Sysprep dialog box

Locating a Winbom.ini File

Sysprep searches for a Winbom.ini file in these locations in this order:

  1. The path and file name specified by the registry key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Factory\Winbom.
  2. The root of all removable media drives that are not CD-ROM drives, such as a floppy disk drive.
  3. The root of all CD-ROM drives.
  4. The location of Factory.exe, usually the %SYSTEMDRIVE%\Sysprep folder.
  5. The root of %SYSTEMDRIVE%.

After locating a Winbom.ini file, Sysprep reads the value of the WinbomType entry in the [Factory] section.

If the value of WinbomType does not match the current mode of Factory.exe (Factory, WinPE, or OOBE), then the Winbom.ini file is ignored and the Factory tool continues searching for a Winbom.ini file. If the value of WinbomType does match the current mode, the Factory tool reads the value of the NewWinbom entry in the [Factory] section. If a value is specified for NewWinbom, and a Winbom.ini file is located at the location specified by NewWinBom, then the Factory tool examines that Winbom.ini file for a NewWinbom entry.

This cycle continues until Sysprep locates a Winbom.ini file of the correct type that does not contain a NewWinbom entry or for a maximum of ten times, whichever occurs first. Sysprep then continues to run in Factory mode, using the settings in the last identified Winbom.ini file.

When you run Sysprep in Factory mode, NewWinbom is processed only once at each boot.


Sysprep and Windows Product Activation FAQ

banner

Sysprep and Windows Product Activation Frequently Asked Questions (FAQ)

What is Product Activation?

Microsoft Product Activation is an anti-piracy technology designed to verify that the product has been legitimately licensed.

How does activation work?

To activate their software, customers complete a simple, straightforward, and anonymous activation process that takes less than one minute when completed over the Internet. Activation can also be completed by telephoning Microsoft and speaking with a customer service representative. If activation is completed via the Internet, very little user participation is required. If activation is completed by telephoning Microsoft, a customer service representative will assist with the activation.

To make activation convenient, the products do not require activation immediately after installation. Office XP and its components allows up to 50 launches before requiring activation. Visio 2002 allows up to 10 launches before requiring activation. Windows XP and the Windows .NET Server family allow 30 days from first boot before requiring activation.

How does Sysprep affect activation?

The clock for Windows Product Activation begins its countdown the first time Windows starts. You can use Sysprep for a maximum of three times to reset the clock for Windows Product Activation. After the third time you run Sysprep, the clock can no longer be reset.

How can I limit the number of reseals in Sysprep?

  • You can create a master installation, run sysprep -reseal on it, create an image of that installation, and then safely store that image for more than 30 days. The 30-day countdown for Windows Product Activation does not begin until the next time the operating system starts.
  • If you do not want to reset the clock, or if you want to preserve settings while running Sysprep on an installation that is already activated, use the -activated command-line option. For example, type:
    sysprep -activated -reseal
  • By using the command sysprep -activated, you can avoid resetting the grace period for activation. This requires that the system be preactivated in the factory.
  • You can avoid resetting the grace period by using SLP (System Locked Preinstallation) in your factory installations. SLP is only available to royalty OEMs.
  • By setting the parameter OEMAuditBoot = 1 in the [Startup] [StartupOptions] section of Oobeinfo.ini before resealing, you can specify that the computer restarts in Factory mode. This is equivalent to using the sysprep -factory command.
  • If you need to modify the configuration on the computer before delivering it to the end user, you can press CTRL + SHIFT + F3 at the Windows Welcome Screen to re-enter Audit mode.

Can I activate Windows for my customers?

Most customers can easily manage activation after receiving their PCs. But if you prefer, you can activate the software on behalf of your customers, making it easier for them to get started with their new PCs and adding significant value to your products and services. After activation is completed, most users will never need activate their installation again.

To activate Windows for your customer, prepopulate the unique Product Key from the certificate of authenticity (COA) label that is affixed to the specific computer, and activate the computer on behalf of the end user. Then run sysprep -reseal to shut the computer down.

To activate the Windows installation automatically during Setup, complete this procedure:

  1. In Unattend.txt, set the ProductKey entry in the [UserData] section equal to the Product Key on the COA sticker attached to that particular computer.
  2. In the [Unattended] section, set AutoActivate = Yes.
  3. Install Windows using an unattended Setup.

The destination computer must have physical access to the Internet.

To preserve a successful activation of the installation, you must run Sysprep with the -activated command-line option. For example:

sysprep -activated -reseal

If you do not run Sysprep with the -activated option, Sysprep removes these activation settings and resets the clock on Windows Product Activation.

Is there anything else I should know about activation?

You cannot make an image of an activated Windows installation and duplicate that image to another computer. If you do, Windows fails to recognize the activation and forces the end user to reactivate the installation manually.

System-locked preinstallation (SLP) is an anti-piracy technology that helps prevent the copying of legitimately licensed operating system software. SLP is available only to royalty OEMs.

Where can I find more information about activation?

For more information, see:

  • Prepopulating the Product Key and Preactivating Windows
  • Sysprep Command-Line Options


Sysprep Components

The Sysprep components are:

  • Sysprep.exe: The main tool for preparing hard disks for duplicating and auditing. Required.
  • Setupcl.exe:The tool used by Sysprep to regenerate security IDs. Required.
  • Factory.exe: The tool used when Sysprep is run with the -factory option. Required.
  • Sysprep.inf: The answer file used by Sysprep to automate Mini-Setup, the end-user first-run experience on the Windows .NET Server family and Windows XP Professional. Optional.

The Sysprep files can exist either on a floppy disk or on a hard disk (in the %SYSTEMDRIVE%\Sysprep folder). When you run Sysprep.exe, Sysprep removes the %SYSTEMDRIVE%\Sysprep folder and its contents after it finishes running.

To ensure that the options you specify in Sysprep.inf take effect, you must place Sysprep.inf in the same location as Sysprep.exe.

Without Sysprep.inf, Mini-Setup prompts the end user for a few standard pieces of information required to configure the computer. However, if Sysprep.inf is present and contains values for the required elements, Mini-Setup uses the information from Sysprep.inf instead of prompting the end user.

The syntax of Sysprep.inf is similar to the unattended Setup answer file, Unattend.txt. Sysprep.inf supports a subset of the sections and entries supported by Unattend.txt plus a few Sysprep-specific entries.

Running Sysprep without using Sysprep.inf causes entries from Unattend.txt to be reprocessed after Windows Welcome. The entries are added by Unattend.txt to $Winnt$.sif. To prevent the processing of the entries in $Winnt.sif$, either remove the entries or delete the $Winnt.sif$ file.

Note

  • If you do not include the -nosidgen command-line option, Sysprep invokes Setupcl.exe; you cannot use Setupcl.exe directly. Setupcl.exe must be in the same folder as Sysprep.exe.

If you edit the security permissions on files or in the registry before running Sysprep, you must ensure that the "System" account has read/write permission in all security contexts. If not, the next time the computer starts, the operating system may fail.


Sysprep Command-Line Options

The syntax of the Sysprep tool:

sysprep [-bmsd] | { {[-factory] | [-reseal]} {[-clean] | [-activated] [-audit] [-forceshutdown] [-mini] [-noreboot] [-nosidgen] [-pnp] [-quiet] [-reboot]} }

Option | Action
-activated Does not reset the grace period for Windows Product Activation. Use this option only if you have activated the Windows installation in the factory.

Important

  • The Product Key that you use to activate the Windows installation must match the Product Key located on the COA sticker attached to that particular computer.
-audit Reboots the computer into Factory mode without generating new security IDs (SIDs) or processing any items in the [OEMRunOnce] section of Winbom.ini.

Use this command-line option only if the computer is already in Factory mode.
-bmsd If the [SysprepMassStorage] section header exists in Sysprep.inf and you run the command Sysprep -bmsd, then Sysprep populates [SysprepMassStorage] with the entries Plug_and_Play_ID = path_to_device_inf_file corresponding to the Plug and Play IDs of mass-storage devices specified in Machine.inf, Scsi.inf, Pnpscsi.inf, and Mshdc.inf. Sysprep builds only the list of mass-storage devices; it does not install these devices in the critical device database or complete any other processing.

After using the Sysprep -bmsd command to generate the [SysprepMassStorage] section, you can delete items from this section before running Sysprep -reseal or Sysprep -factory on this installation. Installing a smaller number of items in the critical device database reduces the time required for this image to reboot into the operating system.

Do not use the -bmsd command-line option with any other command-line options.
-clean | Clears unused mass-storage drivers added by the [SysprepMassStorage] section of Sysprep.inf, and removes phantom devices created by Plug and Play. For more information, see Showing Hidden Devices.
-factory Restarts in a network-enabled state without displaying Windows Welcome or Mini-Setup. This option is useful for updating drivers, running Plug and Play enumeration, installing applications, testing, configuring the computer with customer data, or making other configuration changes in your factory environment. For companies that use disk imaging (or cloning) software, Factory mode can reduce the number of images required.

When you finish your set of tasks in Factory mode, run Sysprep with the -reseal option to prepare the computer for end-user delivery.
-forceshutdown Shuts down the computer after Sysprep completes.

Note

  • Use this option with computers with ACPI BIOS that do not shut down properly with Sysprep's default behavior.
-mini | Configures Windows XP Professional to use Mini-Setup instead of Windows Welcome. This option has no effect on Windows XP Home Edition, where the first-run experience is always Windows Welcome. It also has no effect on the Windows .NET Server family, where the first-run experience is always Mini-Setup.
-noreboot Modifies registry keys (SID, OemDuplicatorString, and so on) without the system rebooting or preparing for duplication. This option is mainly used for testing, specifically to see if the registry is modified properly.

This option is not recommended because making changes to a computer after Sysprep has run may invalidate the preparation done by Sysprep. Do not use this option in a production environment.
-nosidgen | Runs Sysprep without generating new SIDs. You must use this option if you are not duplicating the computer or if the computer is a domain controller.
-pnp Runs the full Plug and Play device enumeration and installation during Mini-Setup. This command-line option has no effect if the first-run experience is Windows Welcome.

Use -pnp only when you need to detect and install legacy, non–Plug and Play devices. Do not use sysprep -pnp on computer systems that use only Plug and Play devices. Otherwise, you will increase the time required for the first-run experience, without providing any additional benefit to the user.
-quiet | Runs Sysprep without displaying onscreen confirmation messages. This is useful if you automate Sysprep. For example, if you plan to run Sysprep immediately after unattended Setup, add sysprep -quiet to the [GuiRunOnce] section of the Unattend.txt file.
-reboot | Forces the computer to reboot automatically and then start Windows Welcome Mini-Setup, or Factory mode, as specified. This is useful when you want to audit the system and verify that the first-run experience operates correctly.
-reseal | Clears the Event Viewer logs and prepares the computer for delivery to the customer. Windows Welcome or Mini-Setup is set to start at the next boot. If you run the command sysprep -factory, you must seal the installation as the last step in your preinstallation process, either by running the command sysprep -reseal or by clicking the Reseal button in the Factory dialog box.

For more information, see Using the Registry to Control Sysprep in Factory Mode.


Using the Registry to Control Sysprep in Factory Mode

The easiest way to automate Sysprep is to use the Sysprep command line in a script. However, you can also use registry settings to automate Sysprep or to control the visual appearance of Sysprep in Factory mode.

Sysprep is controlled by the HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\OEMReset_Switch registry key. Sysprep is constantly monitoring this registry key. As soon as this registry key changes, Sysprep processes the new command.

The syntax of this registry key is:

OEMReset_Switch = [{a | p | r | s};[h][;[l]]

Option | Action
a | Reboots into factory mode for auditing. Equivalent to sysprep -audit.
h | Hides the Sysprep dialog box.
l | Logs actions to C:\Reset.txt.
p | Audits powerdown. Equivalent to sysprep -noreboot.
r | Reboots. Equivalent to sysprep -reboot.
s | Shuts down. Equivalent to sysprep -forceshutdown.

This registry key accepts multiple values, separated by a semicolon (;).

This is the Sysprep dialog box that sets the registry key values:

Sysprep dialog box

For more information, see Using Sysprep in Factory Mode and Sysprep Command-Line Options.


Helpful Command-Line Tools

These tools are included on the Windows OPK CD:

  • Cvtarea Command-Line Options
  • Factory Command-Line Options
  • Netcfg Command-Line Options
  • Oformat Command-Line Options
  • Powercfg Command-Line Options

These tools are used when building a customized version of WinPE. They are located in the \Winpe directory on the Windows OPK CD:

  • Dskimage Command-Line Options
  • Mkimg Command
  • Oscdimg Command-Line Options
  • Sys Command-Line Options

These tools are contained in the Windows operating system:

  • Convert Command-Line Options
  • DiskPart Commands
  • DiskPart Scripting
  • Sysocmgr Command-Line Options
  • Winnt32.exe Command-Line Options
  • Winnt.exe Command-Line Options

For more information on the core OPK tools, see The OPK Toolkit.


Convert Command-Line Options

Convert is a command-line tool in Windows XP and the Windows .NET Server family. It converts FAT and FAT32 volumes to the NTFS file system. You cannot convert an NTFS volume back to FAT or FAT32.

The syntax of the Convert tool is:

convert [volume] /fs:ntfs [/v] [/cvtarea:filename] [/nochkdsk] [/nosecurity] [/x]

where:

Option | Action
volume: Specifies the drive letter (followed by a colon), mount point, or volume name to convert to NTFS.
/fs:ntfs | Required. Converts the volume to NTFS, leaving existing files and folders intact.
/v | Specifies verbose mode, that is, all messages display during conversion.
/cvtarea:filename For advanced users only. Specifies that the Master File Table (MFT) and other NTFS metadata files are written to an existing, contiguous placeholder file. This file must be in the root directory of the file system to be converted. For best results, the size of this file must be 1 KB multiplied by the number of files and directories in the file system; however, the Convert tool accepts a file of any size up to 4 GB. 4 GB is the file size limit of FAT. Using the /cvtarea parameter can result in a less fragmented file system after conversion.

For more information on using the /cvtarea parameter, see "Converting Volumes to NTFS" at the Microsoft TechNet site .

Important

  • You must create the placeholder file using the cvtarea command before running Convert. Convert does not create this file for you. Convert overwrites this file with NTFS metadata. After conversion, any unused space in this file is freed. For more information on the cvtarea command, see Windows Help and Support.
/nosecurity | Specifies the converted files and directory security settings are accessible by everyone.
/nochkdsk | Specifies not to run the Chkdsk tool during the conversion of a system volume. This option is suitable only for OEM manufacturing environments, and reduces the time required for the conversion by up to 30 seconds.
/x | Dismounts the volume, if necessary, before it is converted. Any open handles to the volume are no longer valid.

Notes

  • To recreate the behavior of the Convert command in Windows 2000, use this convert switch:
    /nosecurity
  • To recreate the default behavior in Windows 2000 and automatically start Chkdsk after converting a system volume, use the convert command alone.

Comments

  • If Convert cannot lock the drive (for example, the system volume or the current drive), it offers to convert the drive the next time the computer restarts. If you cannot restart the computer immediately to complete the conversion, plan the time of the restart allowing for the fact that the restart requires more time because of the conversion process.
  • For volumes on which the file system is converted from FAT or FAT32 to NTFS, the MFT is in a different location than for a volume initially formatted with NTFS. For optimal performance, consider recreating these NTFS volumes.
  • Volumes converted from FAT to NTFS lack some performance benefits compared to volumes initially formatted with NTFS. On converted volumes, the MFT might become fragmented. In addition, on converted boot volumes, NTFS permissions are not applied after the volume is converted.
  • A converted volume may have somewhat more fragmentation and slower performance than a volume formatted with NTFS. However, it is still advantageous to use NTFS, regardless of whether the volume was formatted with NTFS or converted.

Example

To convert the volume on drive E: to NTFS and display all messages, use this syntax:

convert e: /fs:ntfs /v


Cvtarea Command-Line Options

Cvtarea is a flexible tool for creating files and analyzing the placement of those files on a FAT32 or FAT file system. With the Cvtarea tool, you can create and place a contiguous file in a specific location on the disk.

If your manufacturing processes require you to format the hard disk with the FAT or FAT32 file system before converting the hard disk to NTFS file system, you can use the Cvtarea tool to create a reserved contiguous placeholder file to be used for the NTFS metadata files after the conversion. The result will be a less fragmented and more efficient file system.

For more information, see:

  • Converting FAT/FAT32 Partitions to NTFS
  • NTFS Preinstallation and Windows XP (http://www.microsoft.com/hwdev/)
  • "Converting Volumes to NTFS" at the Microsoft TechNet site

Detecting the Amount of Free Space on a FAT Volume

The syntax of the Cvtarea tool for seeing the clusters of free space on a FAT volume is:

cvtarea drivename /freespace

Option | Action
drivename | Specifies the drive letter, followed by a colon. For example, C:
/freespace | Displays the available areas of free space.

Creating a File

The syntax of the Cvtarea tool for creating a file is:

cvtarea filename size [units] [/contig] [/firstcluster cluster [clusterunits] [/strictlocation]]

Option | Action
filename | Specifies the name of the file to create. This file must be located in the root directory of the drive to convert.
size | Specifies a 32-bit integer for the size of the area to create.
units Specifies the unit of measure for size; valid options are KB, MB, GB, %disk, and %free.
%disk
Indicates that the file size is a percentage of the total disk size.
%free
Indicates that the file size is a percentage of the current free space on the disk.
/contig | Specifies that the file must be created contiguously on the disk.
/firstcluster:cluster [clusterunits] | Specifies the first cluster at which you want to place the file. As an option, you may indicate the size of cluster units (for example, 4 or 8 KB).
/strictlocation | Does not create the file if the specified cluster is already used.

Displaying the Number of Clusters Used by a File

The syntax of the Cvtarea tool for seeing the clusters used by a file is:

cvtarea filename /info

Option | Action
filename | Specifies the name of an existing file.
/info | Displays the number of clusters allocated for a given file.


Dskimage Command-Line Options

You can build a 64-bit version of WinPE from a computer running a 32-bit operating system. However, building a 64-bit WinPE CD requires one additional step. You must copy the file Setupldr.efi to a floppy disk, then use the Dskimage tool to make an image of the floppy disk. After you create an image of the 1.44-MB floppy disk, pass that image file into Oscdimg as an argument, in the same way you pass Etfsboot.com.

For example:

copy C:\Build.ia64\ia64\Setupldr.efi A:
dskimage A: .\Efisys.bin
oscdimg -b.\Efisys.bin -n C:\Build.ia64 C:\64_winpe.iso

The syntax of the Dskimage tool:

dskimage drive_letter image_file

Option | Description
drive_letter | The letter name of the floppy drive containing Setupild.efi.
image_file | The name of the image file to pass to Oscdimg.


DiskPart Commands

DiskPart is a text-mode command interpreter contained in the Windows XP and the Windows .NET Server family. This tool enables you to manage objects (disks, partitions, or volumes) by using scripts or direct input from a command prompt. Before you can use DiskPart commands on a disk, partition, or volume, you must first list and then select the object to give it focus. When an object has focus, any DiskPart commands that you type act on that object.

You can list the available objects and determine an object's number or drive letter by using the list disk, list volume, and list partition commands. The list disk and list volume commands display all disks and volumes on the computer. However, the list partition command displays only partitions on the disk that have focus. When you use the list commands, an asterisk (*) appears next to the object with focus. You select an object by its number or drive letter, such as disk 0, partition 1, volume 3, or volume C.

When you select an object, the focus remains on that object until you select a different object. For example, if the focus is set on disk 0, and you select volume 8 on disk 2, the focus shifts from disk 0 to disk 2, volume 8. Some commands automatically change the focus. For example, when you create a new partition, the focus automatically changes to the new partition.

You can give focus only to a partition on the selected disk. When a partition has focus, the related volume (if any) also has focus. When a volume has focus, the related disk and partition also have focus if the volume maps to a single specific partition. If this is not the case, then focus on the disk and partition is lost.

For more information about DiskPart, see Disk Management at the Microsoft Windows Resource Kits Web site.(http://www.microsoft.com/)

DiskPart Commands

This table identifies the syntax and parameters of the DiskPart commands.

Command | Syntax | Description
active active On basic disks, marks the partition with focus as active. This informs the basic input/output system (BIOS) or Extensible Firmware Interface (EFI) that the partition or volume is a valid system partition or system volume.

Only partitions can be marked as active.

Important

  • DiskPart verifies that only the partition is capable of containing an operating system's startup files. DiskPart does not check the contents of the partition. If you mistakenly mark a partition as "active" and it does not contain the operating system's startup files, your computer might not start.
add disk add disk=n [noerr] Mirrors the simple volume with focus to the specified disk.
n
Specifies the disk to contain the mirror. You can mirror only simple volumes. The specified disk must have unallocated space at least as large as the size of the simple volume that you want to mirror.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
assign assign [{letter=d|mount=path}] [noerr] Assigns a drive letter or mount point to the volume with focus. If no drive letter or mount point is specified, then the next available drive letter is assigned. If the assigned drive letter or mount point is already in use, an error is generated.

Using the assign command, you can change the drive letter associated with a removable drive.

You cannot assign drive letters to system volumes, boot volumes, or volumes that contain the paging file. In addition, you cannot assign a drive letter to an original equipment manufacturer (OEM) partition or any GPT partition other than a basic data partition.

letter=d
Specifies the drive letter that you want to assign to the volume.
mount=path
Specifies the mount point path that you want to assign to the volume.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
break disk break disk=n [nokeep] [noerr] Applies to dynamic disks only. Breaks the mirrored volume with focus into two simple volumes. One simple volume retains the drive letter and any mount points of the mirrored volume, while the other simple volume receives the focus so that you can assign it a drive letter.

By default, the contents of both halves of the mirror are retained; each half becomes a simple volume. Using the nokeep parameter, only one-half of the mirror is retained as a simple volume, while the other half is deleted and converted to free space. Neither volume receives the focus.

n
Specifies the disk that contains the mirrored volume.
nokeep
Specifies that only one of the mirrored volumes is retained; the other simple volume is deleted and converted to free space. Neither volume receives the focus.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
clean clean [all] Removes any and all partition or volume formatting from the disk with focus. On master boot record (MBR) disks, only the MBR partitioning information and hidden sector information are overwritten. On GUID partition table (GPT) disks, the GPT partitioning information, including the Protective MBR, is overwritten; there is no hidden sector information.
all
Specifies that each and every sector on the disk is zeroed, which completely deletes all data contained on the disk.
convert basic convert basic [noerr] Converts an empty dynamic disk into a basic disk.

Important

  • The disk must be empty to convert it to a dynamic disk. Back up your data, and then delete all partitions or volumes before converting the disk.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
convert dynamic convert dynamic [noerr] Converts a basic disk into a dynamic disk. Any existing partitions on the disk become simple volumes.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
convert gpt convert gpt [noerr] On Itanium-based computers, converts an empty basic disk with the master boot record (MBR) partition style into a basic disk with the GUID partition table (GPT) partition style.

Important

  • The disk must be empty to convert it to a GPT disk. Back up your data and then delete all partitions or volumes before converting the disk.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
convert mbr convert mbr [noerr] On Itanium-based computers, converts an empty basic disk with the GUID Partition Table (GPT) partition style to a basic disk with the master boot record (MBR) partition style.

Important

  • The disk must be empty to convert it to an MBR disk. Back up your data and then delete all partitions or volumes before converting the disk.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
create partition efi create partition efi [size=n] [offset=n] [noerr] On Itanium-based computers, creates an Extensible Firmware Interface (EFI) system partition on a GUID Partition Table (GPT) disk. After the partition has been created, the focus is given to the new partition.
size=n
Specifies the size of the partition in megabytes (MB). If no size is given, the partition continues until there is no more free space in the current region.
offset=n
Specifies the byte offset at which to create the partition. If no offset is given, the partition is placed in the first disk extent that is large enough to hold it.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
create partition extended create partition extended [size=n] [offset=n] [noerr] Creates an extended partition on the current drive. After the partition has been created, the focus automatically shifts to the new partition. Only one extended partition can be created per disk. This command fails if you attempt to create an extended partition within another extended partition. You must create an extended partition before you can create logical drives.
size=n
Specifies the size of the extended partition in megabytes (MB). If no size is given, then the partition continues until there is no more free space in the region. The size is cylinder snapped; that is, the size is rounded to the closest cylinder boundary. For example, if you specify a size of 500 MB, the partition size rounds up to 504 MB.
offset=n
Applies to master boot record (MBR) disks only. Specifies the byte offset at which to create the extended partition. If no offset is given, the partition starts at the beginning of the first free space on the disk. The offset is cylinder snapped; that is, the offset is rounded to the closest cylinder boundary. For example, if you specify an offset that is 27 MB and the cylinder size is 8 MB, the offset is rounded to the 24-MB boundary.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
create partition logical create partition logical [size=n] [offset=n] [noerr] Creates a logical drive in the extended partition. After the partition has been created, the focus automatically shifts to the new logical drive.
size=n
The size of the logical drive in megabytes (MB). If no size is given, then the partition continues until there is no more free space in the current region.
offset=n
Applies to master boot record (MBR) disks only. Specifies the byte offset at which to create the logical drive. The offset is cylinder snapped; that is, the offset rounds up to completely fill whatever cylinder size is used. If no offset is given, then the partition is placed in the first disk extent that is large enough to hold it. The partition is at least as long in bytes as the number specified by size=n. If you specify a size for the logical drive, it must be smaller than the extended partition.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
create partition msr create partition msr [size=n] [offset=n] [noerr] On Itanium-based computers, creates a Microsoft reserved (MSR) partition on a GUID Partition Table (GPT) disk.

Caution

  • Be very careful when using the create partition msr command. GPT disks require a specific partition layout, and so creating Microsoft Reserved Partitions can cause the disk to become unreadable. On GPT disks that are used to start Windows XP 64-Bit Edition or the 64-bit versions of the Windows .NET Server family, the EFI system partition is the first partition on the disk, followed by the Microsoft Reserved Partition. GPT disks used only for data storage do not have an EFI system partition; the Microsoft Reserved Partition is the first partition.

    Windows XP and the Windows .NET Server family do not mount Microsoft Reserved Partitions. You cannot store data on them and you cannot delete them.

size=n
Specifies the size of the partition in megabytes (MB). The partition is at least as long in bytes as the number specified by size=n. If no size is given, the partition continues until there is no more free space in the current region.
offset=n
Specifies the byte offset at which to create the partition. The partition starts at the byte offset specified by offset=n. It is sector snapped; that is, the offset rounds up to completely fill whatever sector size is used. If no offset is given, then the partition is placed in the first disk extent that is large enough to hold it.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
create partition primary create partition primary [size=n] [offset=n] [ID={byte|GUID}] [noerr] Creates a primary partition on the current basic disk. After you create the partition, the focus automatically shifts to the new partition. The partition does not receive a drive letter; you must use the assign command to assign a drive letter to the partition.
size=n
Specifies the size of the partition in megabytes (MB). If no size is given, the partition continues until there is no more unallocated space in the current region. The size is cylinder snapped; that is, the size rounds to the closest cylinder boundary. For example, if you specify a size of 500 MB, the partition size rounds up to 504 MB.
offset=n
Specifies the byte offset at which to create the partition. If no offset is given, the partition starts at the beginning of the first free space on the disk. For master boot record (MBR) disks, the offset is cylinder snapped; that is, the offset rounds to the closest cylinder boundary. For example, if you specify an offset that is 27 MB and the cylinder size is 8 MB, the offset rounds to the 24-MB boundary.
ID={byte|GUID}
Intended for original equipment manufacturer (OEM) use only.

Caution

  • Creating partitions with this parameter might cause your computer to crash or be unable to start. Unless you are an OEM or an IT professional experienced with GPT disks, do not create partitions on GPT disks using the ID=byte | GUID parameter. Instead, always use the create partition efi command to create EFI System partitions, the create partition msr command to create Microsoft Reserved Partitions, and the create partition primary command (without the ID=byte | GUID parameter) to create primary partitions on GPT disks.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.

Comments

To partition a GPT disk with an OEM partition

  1. Generate an OEM-GUID.
  2. Use this command to create an EFI partition:
    Create partition efi size=n
  3. Use this command to create a primary partition:
    Create partition primary size=n ID={byte|GUID}
  4. Use this command to create an MSR partition:
    Create partition MSR size=n

Important

  • You must create the OEM partition between the EFI and MSR partitions.
  • Never create the LDM metadata or LDM data partitions explicitly as partitions. Instead, convert the disk to dynamic.

For master boot record (MBR) disks, you can specify a partition type byte, in hexadecimal form, for the partition. If you do not specify a partition type byte on an MBR disk, the create partition primary command creates a partition of type 0x6. Any partition type byte can be specified with the ID=byte | GUID parameter. DiskPart does not check the partition type byte for validity, nor does it perform any other checking of the ID parameter.

For GPT disks, you can specify a partition type GUID for the partition that you want to create:

  • EFI System partition: c12a7328-f81f-11d2-ba4b-00a0c93ec93b
  • Microsoft reserved partition: e3c9e316-0b5c-4db8-817d-f92df00215ae
  • Basic data partition: ebd0a0a2-b9e5-4433-87c0-68b6b72699c7
  • LDM metadata partition on a dynamic disk: 5808c8aa-7e8f-42e0-85d2-e1e90434cfb3
  • LDM data partition on a dynamic disk: af9b60a0-1431-4f62-bc68-3311714a69ad

If you do not specify a partition type GUID, the create partition primary command creates a basic data partition. Any partition type can be specified with the ID=byte | GUID parameter. DiskPart does not check the partition GUID for validity, nor does it perform any other checking of the ID parameter.
create volume raid create volume raid [size=n] [disk=n,n,n[,n,…]] [noerr] Creates a RAID-5 volume on three or more specified dynamic disks. After you create the volume, the focus automatically shifts to the new volume.
size=n
Specifies the amount of disk space, in megabytes (MB), that the volume occupies on each disk. If no size is given, the largest possible RAID-5 volume is created. The disk with the smallest available contiguous free space determines the size for the RAID-5 volume and the same amount of space is allocated from each disk. The actual amount of usable disk space in the RAID-5 volume is less than the combined amount of disk space because some of the disk space is required for parity.
disk=n,n,n[,n,…]
Specifies the dynamic disks on which to create the volume. You need at least three dynamic disks in order to create a RAID-5 volume. An amount of space equal to size=n is allocated on each disk.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
create volume simple create volume simple [size=n] [disk=n] [noerr] Creates a simple volume. After you create the volume, the focus automatically shifts to the new volume.
size=n
Specifies the size of the volume in megabytes (MB). If no size is given, the new volume takes up the remaining free space on the disk.
disk=n
Specifies the dynamic disk on which to create the volume. If no disk is given, the current disk is used.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
create volume stripe create volume stripe [size=n] [disk=n,n[,n,…]] [noerr] Creates a striped volume using two or more specified dynamic disks. After you create the volume, the focus automatically shifts to the new volume.
size=n
Specifies the amount of disk space, in megabytes (MB), that the volume occupies on each disk. If no size is given, the new volume takes up the remaining free space on the smallest disk and an equal amount of space on each subsequent disk.
disk=n,n[,n,…]
Specifies the dynamic disks on which to create the volume. You need at least two dynamic disks to create a striped volume. An amount of space equal to size=n is allocated on each disk.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
delete disk delete disk [noerr] [override] Deletes a missing dynamic disk from the disk list.
noerr
For scripting only. When an error is encountered, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
override
Enables DiskPart to delete all simple volumes on the disk. If the disk contains half of a mirrored volume, the half of the mirror on the disk is deleted. The delete disk override command fails if the disk is a member of a RAID-5 volume.
delete partition delete partition [noerr] [override] On a basic disk, deletes the partition with focus. You cannot delete the system partition, boot partition, or any partition that contains the active paging file or crash dump (memory dump).

Caution

  • Deleting a partition on a dynamic disk can delete all dynamic volumes on the disk, thus destroying any data and leaving the disk in a corrupted state. To delete a dynamic volume, always use the delete volume command instead.

You can delete partitions from dynamic disks, but you must not create them. For example, it is possible to delete an unrecognized GUID Partition Table (GPT) partition on a dynamic GPT disk. However, deleting such a partition does not cause the resulting free space to become available. This command is intended to enable space reclamation on a corrupted offline dynamic disk in an emergency situation where the clean command cannot be used.

noerr
For scripting only. When an error occurs, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
override
Enables DiskPart to delete any partition regardless of type. Normally, DiskPart only enables you to delete known data partitions.
delete volume delete volume [noerr] Deletes the selected volume. You cannot delete the system volume, boot volume, or any volume that contains the active paging file or crash dump (memory dump).
noerr
For scripting only. When an error occurs, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
detail disk | detail disk | Displays the properties of the selected disk and the volumes on that disk.
detail volume | detail volume | Displays the disks on which the current volume resides.
exit | exit | Exits the DiskPart command interpreter.
extend extend [size=n] [disk=n] [noerr] Extends the volume with focus into the next contiguous unallocated space. For basic volumes, the unallocated space must be on the same disk as, and must follow (have a higher sector offset number than) the partition with focus. A dynamic simple or spanned volume can be extended to any empty space on any dynamic disk. Using this command, you can extend an existing volume into newly created space.

If the partition was previously formatted with the NTFS file system, the file system is automatically extended to occupy the larger partition. No data loss occurs. If the partition was previously formatted with any file system format other than NTFS, the command fails with no change to the partition.

You cannot extend the current system or boot partitions.

size=n
Specifies the amount of space, in megabytes (MB), to add to the current partition. If you do not specify a size, the disk is extended to take up all of the next contiguous unallocated space.
disk=n
Specifies the dynamic disk on which to extend the volume. An amount of space equal to size=n is allocated on the disk. If no disk is specified, the volume is extended on the current disk.
noerr
For scripting only. When an error occurs, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
help | help | Displays a list of the available commands.
import import [noerr] Imports a foreign disk group into the local computer's disk group. The import command imports every disk that is in the same group as the disk that has focus.
noerr
For scripting only. When an error occurs, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
inactive inactive On basic master boot record (MBR) disks, marks the system partition or boot partition with focus as inactive. The computer starts from the next option specified in the BIOS such as the CD-ROM drive or a Pre-Boot eXecution Environment (PXE)-based boot environment (such as Remote Installation Services (RIS)) when you restart the computer.

Caution

  • Your computer might not start without an active partition. Do not mark a system or boot partition as inactive unless you are an experienced user with a thorough understanding of the Windows .NET Server family.

    If you are unable to start your computer after marking the system or boot partition as inactive, try repairing the partition using the Fixmbr and Fixboot commands in the Recovery Console.
list disk | list disk | Displays a list of disks and information about them, such as their size, amount of available free space, whether the disk is a basic or dynamic disk, and whether the disk uses the master boot record (MBR) or GUID partition table (GPT) partition style. The disk marked with an asterisk (*) has focus.
list partition | list partition | Displays the partitions listed in the partition table of the current disk. On dynamic disks, these partitions may not correspond to the dynamic volumes on the disk. This discrepancy occurs because dynamic disks contain entries in the partition table for the system volume or boot volume (if present on the disk). Dynamic disks also contain a partition that occupies the remainder of the disk in order to reserve the space for use by dynamic volumes.
list volume | list volume | Displays a list of basic and dynamic volumes on all disks.
online online [noerr] Brings an offline disk or volume with focus online.
noerr
For scripting only. When an error occurs, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
rem rem Provides a way to add comments to a script. For example:
rem These commands set up 3 drives.
create partition primary size=2048
assign d:
create partition extend
create partition logical size=2048
assign e:
create partition logical
assign f:
remove remove [{letter=d|mount=path [all]}] [noerr] Removes a drive letter or mount point from the volume with focus. If the all parameter is used, all current drive letters and mount points are removed. If you do not specify a drive letter or mount point, then DiskPart removes the first drive letter or mount point that it encounters.

You can use the remove command to change the drive letter associated with a removable drive. You cannot remove the drive letters on system, boot, or paging volumes. In addition, you cannot remove the drive letter for an OEM partition, any GPT partition with an unrecognized GUID, or any of the special, non-data, GPT partitions such as the EFI system partition.

letter=d
Specifies the drive letter to remove.
mount=path
Specifies the mount point path to remove.
all
Removes all current drive letters and mount points.
noerr
For scripting only. When an error occurs, specifies that DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
repair disk repair disk=n [noerr] Repairs the RAID-5 volume with focus by replacing the failed RAID-5 member with the specified dynamic disk. The specified dynamic disk must have free space greater than or equal to the total size of the failed RAID-5 member.
n
Specifies the dynamic disk that replaces the failed RAID-5 member. The specified disk must have free space equal to or larger than the total size of the failed RAID-5 member.
noerr
For scripting only. When an error occurs, DiskPart continues to process commands as if the error did not occur. Without the noerr parameter, an error causes DiskPart to exit with an error code.
rescan | rescan | Locates new disks that may have been added to the computer.
retain retain Prepares an existing dynamic simple volume to use as a boot or system volume.

On an x86-based computer, creates a partition entry in the master boot record (MBR) on the dynamic simple volume with focus. To create an MBR partition, the dynamic simple volume must start at a cylinder aligned offset and be an integral number of cylinders in size.

On an Itanium-based computer, creates a partition entry in the GUID partition table (GPT) on the dynamic simple volume with focus.

Note

  • The retain command is intended for use only during unattended Setup or by original equipment manufacturers (OEMs).
select disk select disk=[n] Selects the specified disk and shifts the focus to it.
n
Specifies the disk number of the disk to receive focus. If you do not specify a disk number, the select command lists the disk that currently has the focus. You can view the numbers for all disks on the computer by using the list disk command.
select partition select partition=[{n|d}] Selects the specified partition and gives it focus. If If you do not specify a partition, the select command lists the current partition with focus. You can view the numbers of all partitions on the current disk by using the list partition command.
n
Specifies the number of the partition to receive the focus.
d
Specifies the drive letter or mount point path of the partition to receive the focus.
select volume select volume=[{n|d}] Selects the specified volume and shifts the focus to it. If you do not specify a volume, the select command lists the current volume with focus. You can specify the volume by number, drive letter, or mount point path. On a basic disk, selecting a volume also gives the corresponding partition focus. You can view the numbers of all volumes on the computer by using the list volume command.
n
Specifies the number of the volume to receive the focus.
d
Specifies the drive letter or mount point path of the volume to receive the focus.

For more information, see DiskPart Scripting.


DiskPart Scripting

By using the DiskPart command-line tool, you can create scripts to automate disk-related tasks, such as creating volumes or converting disks to dynamic disks. Scripting these tasks is useful if you deploy Windows by using unattended Setup or Sysprep, which do not support creating volumes other than the boot volume.

For more information about DiskPart scripts, see "Disk Management" in the Microsoft Windows XP Professional Resource Kit.

To start a DiskPart script, at the command prompt, type:

DiskPart /S scriptname.txt

where scriptname.txt is the name of the text file that contains your script.

To redirect DiskPart's scripting output to a file, type:

DiskPart /S scriptname.txt > logfile.txt

where logfile.txt is the name of the text file where DiskPart writes its output.

When DiskPart starts, the DiskPart version and computer name display at the command prompt. By default, if DiskPart encounters an error while attempting to perform a scripted task, DiskPart stops processing the script and displays an error code (unless you specified the noerr parameter). However, DiskPart always returns errors when it encounters syntax errors, regardless of whether you used the noerr parameter. The noerr parameter enables you to perform useful tasks such as using a single script to delete all partitions on all disks regardless of the total number of disks.

This table lists the DiskPart error codes:

Error | Description
0 | No errors occurred. The entire script ran without failure.
1 | A fatal exception occurred. There may be a serious problem.
2 | The parameters specified for a DiskPart command are incorrect.
3 | DiskPart was unable to open the specified script or output file.
4 | One of the services that DiskPart uses returned a failure.
5 | A command syntax error occurred. The script failed because an object was improperly selected or was invalid for use with that command.


Factory Command-Line Options

You can use the Factory tool in two ways: from the command-line tool in the Windows Preinstallation Environment (WinPE), and from within Sysprep.

Use the Factory tool to update drivers, run Plug and Play enumeration, install applications, test, configure the computer with customer data, or make other configuration changes in your factory environment. For companies that use disk imaging (or cloning) software, efficient use of Factory.exe can reduce the number of images you require.

Running the Factory Tool in Sysprep

To run the Factory tool from within Sysprep, use this syntax:

sysprep -factory

This command restarts in a network-enabled state without displaying Windows Welcome or Mini-Setup.

When you have finished your set of tasks in Factory mode, run Sysprep with the -reseal option to prepare the computer for delivery to the end user.

For more information, see Sysprep Command-Line Options and Using Sysprep in Factory Mode.

Running the Factory Tool in WinPE

The syntax of the Factory tool:

factory {-minint | -winpe}

Option | Action
-minint | Uses Plug and Play to install the network interface card (NIC).
-winpe Locates a Winbom.ini file and processes these sections in this order:
  • [WinPE.Net]
  • [DiskConfig]
  • [OEMRunOnce]
  • [OEMRun]
  • [WinPE], except for the Restart entry
  • [UpdateSystem]
  • Restart entry in [WinPE]

Locating a Winbom.ini File

Factory.exe searches for a Winbom.ini file in these locations in this order:

  1. The root of all removable media drives that are not CD-ROM drives, such as a floppy disk drive.
  2. The root of all CD-ROM drives.
  3. The location of Factory.exe, usually the %SYSTEMDRIVE%\Sysprep folder.
  4. The root of %SYSTEMDRIVE%.

Notes

  • If Factory.exe is running in Windows Preinstallation Environment (WinPE), the computer does not have network access until it processes a Winbom.ini file that contains a [WinPE.Net] section.
  • WinPE is licensed to original equipment manufacturers (OEMs) and corporations with Enterprise Agreements or Select Agreements with Software Assurance Membership in the Systems Pool.
  • The last path and file name used by Factory.exe is stored in the registry key HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Factory\Winbom.

After locating a Winbom.ini file, the Factory tool reads the value of the WinbomType entry in the [Factory] section.

If the value of WinbomType does not match the current mode of Factory.exe (Factory, WinPE, or OOBE), then the Winbom.ini file is ignored and the Factory tool continues searching for a Winbom.ini file. If the value of WinbomType does match the current mode, the Factory tool reads the value of the NewWinbom entry in the [Factory] section. If a value is specified for NewWinbom, and a Winbom.ini file is located at the location specified by NewWinBom, then the Factory tool examines that Winbom.ini file for a NewWinbom entry.

This cycle continues for a maximum of 10 times or until the Factory tool locates a Winbom.ini file that does not contain a NewWinbom entry, whichever occurs first. The Factory tool then continues to run, using the settings in the last identified Winbom.ini file.

When you run Sysprep in Factory mode, NewWinbom is processed only once at each boot.

After locating the intended Winbom.ini file, the computer connects to the network as specified in the [WinPE.Net] section. Plug and Play installs only the network adapter, and the Factory tool installs network services and binds the network protocols.


Mkimg Command

This command builds the file set for the Windows Preinstallation Environment (WinPE) from any Windows XP or Windows .NET Server product CD except Windows XP Home Edition, Windows .NET Datacenter Server, and Windows .NET Web Server, and optionally creates an .iso image of the files. You can then burn that .iso file to a CD-ROM. The CD image creation process takes several minutes. The files are placed in the same location as where you run the mkimg command.

The syntax of the Mkimg command:

Mkimg.cmd [/nover] source_directory destination_directory [image_name]

Option | Action
/nover | Disables version checking that would normally prevent the creation of unsupported WinPE images.
source_directory Specifies the location of the CD-ROM containing the Windows product CD. Do not use Windows XP Home Edition. If source_directory is a CD-ROM drive, you need to specify only the drive letter. If source_directory is a network path, the path must be to the parent directory of the \i386 directory.

Note

  • Do not include a trailing slash in source_directory.
destination_directory | Specifies the path where the files necessary to create the image are temporarily stored. If this directory does not already exist, Mkimg creates it.
image_name Specifies the path and file name of an ISO image file (.iso) that contains your customized version of WinPE.

You can burn this .iso file to a CD-ROM to create a bootable WinPE CD.

Alternatively, you can make more customizations of this version of WinPE by using Oscdimg to create an .iso file of a 64-bit version of WinPE.

Important

  • You must run the mkimg command from a location where you have read/write permissions, such as a local directory. You cannot run the mkimg command from a read-only device such as a CD-ROM drive.

Example

This example creates an ISO image called ia64winpe.iso by using C:\Winpe.tmp and the floppy disk as temporary storage areas.

C:\Build.ia64\Mkimg.cmd E: C:\Winpe.tmp C:\ia64winpe.iso


Netcfg Command-Line Options

The network configuration tool (Netcfg) configures network access. When preinstalling Windows, it is most commonly used in a script that runs during WinPE.

For greater flexibility, the default version of Startnet.cmd includes a netcfg command instead of factory -winpe. For more information on Startnet.cmd, see Creating a Customized Version of WinPE.

The syntax of the Netcfg tool relevant to OEMs:

netcfg [-v] [-winpe] [-l path_to_component_inf] [-c {c | p | s}] [-i component_id]

Option | Action
-v | Specifies verbose mode.
-winpe | Installs TCP/IP, NetBIOS, and the Client for Microsoft Networks (MSClient) when running in the Windows Preinstallation Environment (WinPE).
-l path_to_component_inf | Specifies the complete path of the .inf file.
-c Specifies the class of the component to install. Valid options are c, p, and s.
c
Client
p
Protocol
s
Service
component_id | Specifies the component ID of the networking component to install from the .inf file.

Examples

This command line installs the protocol MyProtocol from C:\Oemdir\file.inf:

netcfg -l c:\oemdir\file.inf -c p -i MyProtocol

This command line installs the MS_Server service:

netcfg -c s -i MS_Server

This command line installs TCP/IP, NetBIOS, and MSClient in WinPE:

netcfg -v -winpe

Additional Netcfg Command-Line Options

The syntax of additional Netcfg options:

netcfg [-s {a | n}] [{-b | -q | -u} component_id]
Option | Action
-s Specifies the type of the component to display; valid options are a and n.
a
Displays network adapters.
n
Displays network components.
-b | Displays the binding paths that contain the specified component_id.
-q | Queries if a particular component, specified by component_id, is installed.
-u | Uninstalls a particular component, specified by component_id.
component_id | Specifies the component ID of the relevant component.


Oformat Command-Line Options

Oformat creates a FAT32 volume with clusters that are aligned in an optimal way for the conversion to the NTFS file system.

Important

  • This tool is based on Format from Windows Millennium Edition. As a result, you can only:
    • Run Oformat on the versions of MS–DOS that come with Windows Millennium Edition and Windows XP.
    • Boot using MS–DOS and install Windows XP using Winnt.exe.

Additionally, Oformat has important modifications specifically designed to meet the needs of computer manufacturers:

  • Oformat does not force you to verify sectors if this is the first time you have formatted the disk. As a result, you can do a Quick Format immediately after creating a new partition, which is significantly faster in the manufacturing environment than using the conventional Format.
  • Oformat does not prompt for confirmation before formatting a disk.
  • With the /a command-line option, Oformat aligns FAT data clusters at a specified sector, which prepares the disk to convert efficiently to NTFS.

The syntax of the Oformat tool relevant to OEMs:

oformat driveletter [/a:number] [/autotest|/v:disklabel] [/q]

Option | Action
driveletter | Specifies the drive to format.
/a:number | Aligns system sectors for NTFS-friendly FAT. The value of number can be 2, 4, 8, 16, 32, 64, 128.
/autotest | Runs silently. Do not use with /v.
/q | Performs a Quick Format.
/v:disklabel | Specifies the volume label. Do not use with /autotest.

Important

  • If you do not use the /q option, Oformat requires the same amount of time as Format.
  • The /a:8 command-line option formats the volume so that the FAT data clusters are aligned at 4-KB boundaries. This configuration is recommended because it is the most efficient to convert to NTFS.

Example

To format the volume on drive E: by overwriting the boot sector, FAT, and root folder with clean structures on a newly partitioned hard disk, and optimally configure the disk for NTFS conversion, type:

oformat e: /q /autotest /a:8

For more information, see:

  • Configuring the Hard Disk
  • Convert Command-Line Options
  • Converting FAT32 to NTFS During Windows XP Preinstallation white paper, located on the Windows OPK CD

Additional Oformat Command-Line Options

The complete syntax of the Oformat tool:

oformat driveletter [/a:number] [/autotest|/v:disklabel] [/b | /s] [/c] [/f:size] [/q] [/t:tracks /n:sectors] [/u] [/1] [/4] [/8]

where:

Option | Action
/b | Allocates space on the formatted disk for system files.
/c | Tests clusters that are currently marked "bad."
/f:size | Specifies the size of the floppy disk to format. The value of size can be 160, 180, 320, 360, 720, 1.2, 1.44, 2.88.
/n:sectors | Specifies the number of sectors per track.
/s | Copies system files to the formatted disk.
/t:tracks | Specifies the number of tracks per disk side.
/u | Does not save unformat recovery information.
/l | Formats a single side of a floppy disk.
/4 | Formats a 5.25-inch 360-KB floppy disk in a high-density drive.
/8 | Formats eight sectors per track.

How Oformat Differs From Format

Unlike the Format tool, Oformat gives you the option not to verify disk integrity or overwrite existing data in the data area. To preserve the disk geometry, the values in the BIOS parameter block (BPB) of the original boot sector are inserted into the new boot sector. For an unformatted partition, Oformat uses the BPB values calculated by the MS-DOS initialization code, instead of the values from the existing boot sector. This modification allows a Quick Format to proceed even though the boot sector is not valid immediately after partitioning. Oformat retrieves the parameters for the disk directly from the MS-DOS BIOS, which calculates them from the partition information, so that the boot sector that Oformat eventually places on the disk is correct. These modifications allow a hard disk of any size to be formatted in about five seconds, whether or not the drive has been previously formatted.

Oformat does not verify the disk, and so it is possible that you may not detect any hard-sector errors present on the disk. Evaluate this risk based on the presence of a zero-defect guarantee from the drive manufacturer.


Oscdimg Command-Line Options

This is a command-line tool in the OPK that creates an image (.iso) file of a customized 32-bit or 64-bit version of WinPE. You can then burn that .iso file to a CD-ROM.

The syntax of the Oscdimg tool:

oscdimg [-l labelname] [-t mm/dd/yyyy,hh:mm:ss [-g]] [-h] [-n] [-nt] [-b location] [-x] [-o[i][s]] sourceroot [image_file]

Option | Action
-l labelname | Specifies the volume label. Do not use spaces between the l and the labelname. For example: -lMYLABEL
-t mm/dd/yyyy,hh:mm:ss | Specifies the time stamp for all files and directories. Do not use any spaces. Use the United States date format and a 24-hour clock. You can use any delimiter between the items. For example: -t12/31/2000,15:01:00
-g | Uses the Universal Coordinated Time for all files rather than the local time.
-h | Includes hidden files and directories.
-n | Allows long file names.
-nt | Allows long file names that are compatible with Windows NT 3.51.
-b location | Specifies the location of the El Torito boot sector file. Do not use any spaces. For example: -bc:\directory\Etfsboot.com
-x | Computes and encodes the AutoCRC value in the image.
-o | Optimizes storage by encoding duplicate files only once.
-oi | Optimizes storage by encoding duplicate files only once. When comparing files, ignores diamond compression time stamps.
-os | Optimizes storage by encoding duplicate files only once. Shows duplicate files when creating the image.
-ois | Optimizes storage by encoding duplicate files only once. When comparing files, ignores diamond compression time stamps. Shows duplicate files when creating the image.
sourceroot | Required. Specifies the location of the WinPE files that you want to build into an .iso image.
image_file | Specifies the name of the .iso image file you want to create from the WinPE files.


Powercfg Command-Line Options

By default, desktop computers running on AC power do not go into sleep or standby modes. To meet Energy Star requirements, OEMs can use the Powercfg tool to control power settings and configure computers to default to Hibernate or Standby modes.

The syntax of the Powercfg tool:

powercfg [/change settings] [/create name] [/delete name] [/export name [/file filename]] [/globalpowerflag [on | off][/option:flag]] [/hibernate [on | off]] [/import name [/file filename]] [/list] [/numerical] [/query name] [/setactive name] [/?]

Option | Action
/change, /x Changes settings of the specified power scheme. Additional options specify these changes:
  • /monitor-timeout-ac <minutes>
  • /monitor-timeout-dc <minutes>
  • /disk-timeout-ac <minutes>
  • /disk-timeout-dc <minutes>
  • /standby-timeout-ac <minutes>
  • /standby-timeout-dc <minutes>
  • /hibernate-timeout-ac <minutes>
  • /hibernate-timeout-dc <minutes>
  • /processor-throttle-ac <throttle>
  • /processor-throttle-dc <throttle>

AC settings are used when the system is on AC power. DC settings are used when the system is on battery power. Setting a timeout to zero disables the corresponding timeout feature. Supported throttle settings are none, constant, degrade, and adaptive.
/create, /c | Creates a power scheme with the specified name. The new scheme is created with the properties of the currently active scheme.
/delete, /d | Deletes the power scheme with the specified name.
/export, /e | Exports the power scheme with the specified name to a file. If you do not specify a filename, the default is Scheme.pow. This additional parameter is supported: /file <filename>.
/globalpowerflag, /g Turns one of the global power flags on or off. Valid flags are:
  • batteryicon: Turns the battery meter icon in the notification area on or off.
  • multibattery: Turns multiple battery display in system Power Meter on or off.
  • resumepassword: Prompts for a password on resuming the system.
  • wakeonring: Turns wake on ring support on or off.
  • videodim: Turns support for dimming video display on battery power on or off.
/help, /? | Displays information on command-line parameters.
/hibernate, /h | Turns the hibernation feature on or off. Hibernation timeout is not supported on all systems that support hibernation.
/import, /i | Imports the power scheme from a file under the specified name. If you do not specify a filename, the default is Scheme.pow. If a scheme with that name already exists, it is replaced with the new one. This additional parameter is supported: /file <filename>.
/list, /l | Lists the names of existing power schemes.
/numerical, /n | Allows the power scheme to use to be specified with a numerical identifier. When using this option, instead of the name of the power scheme in the command line, specify its numerical identifier. This option may be used in combination with the /query, /delete, /setactive, /change, /export, and /import options.
/query, /q | Displays the configuration of the specified power scheme. If you do not specify a name, the configuration of the currently active power scheme displays.
/setactive, /s | Makes the power scheme with the specified name active.

Examples

powercfg /list
powercfg /query scheme
powercfg /query
powercfg /create scheme
powercfg /delete scheme
powercfg /setactive scheme
powercfg /change scheme /monitor-timeout-dc 15
powercfg /change scheme /monitor-timeout-dc 0
powercfg /hibernate on
powercfg /export scheme /file file
powercfg /query number /numerical
powercfg /globalpowerflag on /option:batteryicon

For more information on the OPK tools, see The OPK Toolkit.


Sys Command-Line Options

You can use WinPE to preinstall Windows 95, Windows 98, and Windows Millennium Edition. In these cases, the hard disk needs the boot sector common to these operating systems. Use the Sys.exe utility to write the boot sectors for these operating systems.

By default, Sys writes a Windows 95, Windows 98, and Windows Millennium Edition boot sector. Use the /xp option to write a Windows XP boot sector.

The syntax of the Sys tool:

sys [/xp] drive_letter

Option | Action
/xp | Optional. Writes the Windows XP boot sector.
drive_letter | Specifies the letter name of the drive to write the boot sector to.


Sysocmgr Command-Line Options

You can use the Sysocmgr.exe tool at a command prompt to add or remove Windows components.

The syntax of the Sysocmgr tool:

Sysocmgr [/c] [/f] [/i:<master_oc_inf>] [/l] [/n] [/q] [/r] [/u:<unattend_spec>] [/w] [/x] [/z]

Option | Action
/c | Disables the ability to cancel during the final installation phase.
/f | Indicates that all component installation states are initialized as if their installers had never been run.
/i:<master_oc_inf> | Required. Specifies the name of the master INF file, from which the installation source path is derived.
/l | Installs a multi-language aware installation.
/n | Treats the specified master inf file as new.
/q | Runs the unattended installation without a user interface. Requires the /u option.
/r | Suppresses reboot (when reboot is necessary).
/u:<unattend_spec> | Specifies unattended operation parameters.
/w | If a reboot is required, prompts the user before rebooting. Requires the /u option.
/x | Suppresses the "initializing" banner.
/z | Indicates that the arguments which follow are not OC arguments and are passed to components.

For more information on the OPK tools, see The OPK Toolkit.


Winnt32.exe Command-Line Options

From a command prompt, use Winnt32.exe to start Windows Setup from a computer that is running one of these operating systems:

  • Windows Preinstallation Environment (WinPE)
  • Windows .NET Server
  • Windows XP
  • Windows 2000
  • Windows NT, Service Pack 5 or later
  • Windows Millennium Edition
  • Windows 98
  • Windows 95

Notes

  • If you are deploying Windows XP on client computers, you can use the version of Winnt32.exe that comes with Windows XP. Another way to deploy Windows XP is to use Winnt32.msi, which works through Windows Installer, part of the IntelliMirror set of technologies. For more information about client deployments, see the Windows .NET Server Deployment Kit.
  • If you run winnt32 on an Itanium-based computer, the command can be run from the Extensible Firmware Interface (EFI) or from Windows XP (not from an earlier operating system). Also, on an Itanium-based computer, /cmdcons and /syspart are not available, and options relating to upgrades are also not available.
  • Whenever you run Winnt32 on an X86 system from WinPE, you must add the /syspart and /tempdrive command-line options.

The syntax of the Winnt32 command is:

winnt32 [/checkupgradeonly] [/cmd:command_line] [/cmdcons] [/copydir:{i386|ia64}\folder_name] [/copysource:folder_name] [/debug[level]:[filename]] [/dudisable] [/duprepare:pathname] [/dushare:pathname] [/emsport:{com1|com2|usebiossettings|off}] [/emsbaudrate:baudrate] [/m:folder_name] [/makelocalsource] [/noreboot] [/s:sourcepath] [/syspart:drive_letter] [/tempdrive:drive_letter] [/udf:id [,UDB_file]] [/unattend[num]:[answer_file]]

Option | Action
/checkupgradeonly Checks your computer for upgrade compatibility with this version of Windows.

If you use this option with /unattend, no user input is required. Otherwise, the results display on the screen, and you can save them under the file name that you specify. The default file name is Upgrade.txt in the %SYSTEMROOT% folder.
/cmd:command_line | Instructs Setup to execute a specific command before the final phase of Setup. This occurs after your computer restarts and after Setup collects the necessary configuration information, but before Setup finishes.
/cmdcons | Installs the Recovery Console as a startup option on a functioning x86-based computer. The Recovery Console is a command-line interface from which you can perform tasks such as starting and stopping services and accessing the local drive (including drives formatted with NTFS). You can use the /cmdcons option only after normal Setup is finished.
/copydir:{i386|ia64}\folder_name Creates an additional folder within the folder in which the Windows files are installed.

Folder_name refers to a folder that you have created to hold modifications just for your site. For example, for x86-based computers, create a folder called Private_drivers within the i386 source folder for your installation, and place driver files in the folder. Then type /copydir:i386\Private_drivers so that Setup copies that folder to your newly installed computer, making the new folder location %SYSTEMROOT%\Private_drivers. You can use /copydir to create as many additional folders as you want.
/copysource:folder_name Creates a temporary additional folder within the folder in which the Windows files are installed.

Folder_name refers to a folder that you have created to hold modifications just for your site. For example, create a folder called Private_drivers within the source folder for your installation, and place driver files in the folder. Then type /copysource:Private_drivers so that Setup copies that folder to your newly installed computer and use its files during Setup, making the temporary folder location %SYSTEMROOT\Private_drivers. You can use /copysource to create as many additional folders as you want. Unlike the folders /copydir creates, /copysource folders are deleted after Setup completes.
/debug[level]:[filename] | Creates a debug log at the level specified, for example, /debug4:Debug.log. The default log file is C:\%SYSTEMROOT\Winnt32.log, and the default debug level is 2. The log levels are: 0 represents severe errors, 1 represents errors, 2 represents warnings, 3 represents information, and 4 represents detailed information for debugging. Each level includes the levels under it.
/dudisable | Prevents Dynamic Update from running. Without Dynamic Update, Setup runs only with the original Setup files. This option will disable Dynamic Update even if you set DUDisable equal to No in the [Unattended] section of the Unattend.txt file.
/duprepare:pathname | Carries out preparations on an installation share so that it can be used with Dynamic Update files that you downloaded from the Windows Update Web site. You can use this share for installing Windows to multiple clients.
/dushare:pathname | Specifies a share on which you previously downloaded Dynamic Update files (updated files for use with Setup) from the Windows Update Web site, and on which you previously ran /duprepare:pathname. When run on a client, specifies that the client installation will make use of the updated files on the share specified in pathname.
/emsport:{com1|com2|usebiossettings|off} Enables or disables Emergency Management Services (EMS) during Setup and after Windows .NET Standard Server, Enterprise Server, or Windows 2000 Datacenter Server has been installed. With EMS, you can remotely manage a server in emergency situations that typically require a local keyboard, mouse, and monitor, such as when the network is unavailable or the server does not function properly. EMS has specific hardware requirements, and is available only for products in the Windows .NET Server family.

Usebiossettings is the default, and uses the setting specified in the BIOS Serial Port Console Redirection (SPCR) table, or, in Itanium-based systems, through the Extensible Firmware Interface (EFI) console device path. If you specify usebiossettings and there is no SPCR table or appropriate EFI console device path, EMS will not be enabled.

Com1 and com2 are applicable only for x86-based computers (not Itanium-based computers).

If you disable EMS by specifying /emsport:off, you can later enable it by modifying the boot settings. For information about modifying boot settings, see the Windows Resource Kits.
/emsbaudrate:baudrate For x86-based computers, specifies the baud rate for EMS. (The option is not applicable for Itanium-based computers.) Must be used with /emsport:com1 or /emsport:com2 (otherwise, /emsbaudrate is ignored).

baudrate can be 9600, 19200, 57600, or 115200. 9600 is the default.
/m:folder_name | Specifies that Setup copies replacement files from an alternate location. Instructs Setup to look in the alternate location first, and if files are present, to use them instead of the files from the default location.
/makelocalsource | Instructs Setup to copy all installation source files to your local hard disk. Use /makelocalsource when installing from a CD to provide installation files when the CD is not available later in the installation.
/noreboot | Instructs Setup not to restart the computer after the file copy phase of Setup is completed so that you can execute another command.
/s:sourcepath Specifies the location of the Windows files. To copy files simultaneously from multiple servers, type the /s:sourcepath option multiple times (eight maximum). For example:
winnt32 /s:server1 /s:server2

If you type the option multiple times, the first server specified must be available, or Setup fails.
/syspart:drive_letter On an x86-based computer, specifies that you can copy Setup startup files to a hard disk, mark the disk as active, and then install the disk into another computer. When you start that computer, it automatically starts with the next phase of Setup. You must always use the /tempdrive parameter with the /syspart parameter.

You can start Winnt32 with the /syspart option on an x86-based computer running Windows NT 4.0, Windows 2000, or Windows XP. The computer cannot be running Windows 95, Windows 98, or Windows Millennium Edition.
/tempdrive:drive_letter | Directs Setup to place temporary files on the specified partition. For a new installation, Windows also installs on the specified partition. For an upgrade, the /tempdrive option affects the placement of temporary files only; the operating system upgrades in the partition from which you run winnt32.
/udf:id[,UDB_file] Indicates an identifier (id) that Setup uses to specify how a Uniqueness Database (UDB) file modifies an answer file (see the /unattend entry).

The UDB overrides values in the answer file, and the identifier determines which values in the UDB file are used. For example, /udf:RAS_user,Our_company.udb overrides settings specified for the RAS_user identifier in the Our_company.udb file. If no UDB_file is specified, Setup prompts the user to insert a disk that contains the $Unique$.udb file.

If you boot from the Windows CD and run an unattended Setup, you cannot use the /udf command-line option for Winnt32.exe.
/unattend | Upgrades your previous version of Windows 98, Windows Millennium Edition, Windows NT 4.0, or Windows 2000 in unattended Setup mode. Setup downloads the Dynamic Update files from Windows Update and includes these files in the installation. All user settings are taken from the previous installation, so no user intervention is required during Setup.
/unattend[num]:[answer_file] Performs a fresh installation of Windows in unattended Setup mode. Setup downloads the Dynamic Update files from the Windows Update Web site and includes these files in the installation. The specified answer_file provides Setup with your custom specifications.
num
The number of seconds between the time that Setup finishes copying the files and the time Setup restarts. You can use num on any computer running Windows 98, Windows Millennium Edition, Windows NT, Windows 2000, or Windows XP.
answer_file
The name of the answer file. For more information about answer files, see the Microsoft Windows XP Deployment Guide.

Using the /unattend command-line option to automate Setup affirms that you have read and accepted the End-User License Agreement (EULA) for Windows. Before using this command-line option to install Windows on behalf of an organization other than your own, you must confirm that the end user (whether an individual or a single entity) has received, read, and accepted the terms of the Microsoft End-User License Agreement for Windows. OEMs may not specify this key on computers being sold to end users.

For more information about Winnt32.exe, see Using Winnt32.exe to Run Setup.


Winnt.exe Command-Line Options

From a command prompt, use Winnt.exe to start Windows Setup from a computer that is running one of these operating systems:

  • MS-DOS
  • Windows 3.1
  • Windows for Workgroups

The syntax of the Winnt command:

winnt [/s:[sourcepath]] [/t:[tempdrive]] [/u:[answer_file]] [/udf:id [,UDB_file]] [/r:folder] [/rx:folder] [/e:command] [/a]

Option | Action
/s:sourcepath | Specifies the source location of the Windows files. The location must be a full path of the form x:\[path] or \\server\share[\path]. The default is the current folder.
/t:tempdrive | Directs Setup to place temporary files on the specified drive and to install Windows on that drive. If you do not specify a location, Setup attempts to locate a drive for you.
/u:answer_file | Performs unattended Setup with an answer file. The answer file provides answers to some or all of the prompts that the end user normally responds to during Setup. If you use /u, you must also use /s.
/udf:id [,UDB_file] | Indicates an identifier (id) that Setup uses to specify how a Uniqueness Database (UDB) file modifies an answer file (see /u). The UDB overrides values in the answer file, and the identifier determines which values in the UDB file to use. If no UDB_file is specified, Setup prompts the user to insert a disk that contains the $Unique$.udb file. For example, /udf:RAS_user, Our_company.udb overrides settings specified for the identifier RAS_user in the Our_company.udb file.
/r:folder | Specifies an optional folder to install. The folder remains after Setup finishes.
/rx:folder | Specifies an optional folder to copy. The folder is deleted after Setup finishes.
/e:command | Specifies a command to execute at the end of GUI-mode Setup.
/a | Enables accessibility options.

For more information on Winnt.exe, see Using Winnt.exe to Run Setup and Converting Short File Names to Long File Names.


Technical Support

The support options available to you depend on the type of your OEM license agreement.

Technical Support for System Builders

Technical support for preinstalling Windows XP and the Windows .NET Server family is provided through both monitored and unmonitored newsgroups on the Microsoft OEM System Builder Web site (http://oem.microsoft.com/general/bbs/). The types of questions answered on the OEM system builder newsgroups Web site are:

  • Preinstallation tools and techniques
  • Licensing issues
  • General product information

These newsgroups do not address questions on distributor issues, end-user technical support, or royalty OEM information.

The Microsoft for Partners Web site (http://www.microsoft.com/partner/support/) contains an online helpdesk that provides general technical support to computer manufacturers and independent IT consultants regarding the full range of Microsoft products.

Proactive Services and Technical Support for Royalty OEMs

You can receive support for the OPK through your Premier and Professional accounts. Professional accounts provide per-incident pricing.

For Premier account information in the United States or Canada, please contact Microsoft Premier and Alliance Support Sales at 1-800-936-3200.

For Professional OEM account information in the United States or Canada, please contact Microsoft Support Services at 1-800-936-3500.

Deaf customers can reach Microsoft text telephone (TT/TDD) services at 1-800-892-5234 in the United States or 1-905-568-9641 in Canada.

For support offerings outside the United States, contact your Microsoft account manager.

For information about requesting assistance from Product Support and for current support offerings, see the Microsoft Product Support Services Web site at http://www.microsoft.com/support/.

Adapting your hardware technologies and component prototypes to operate successfully with Microsoft products is key to meeting production deadlines. Proactive services provided through Microsoft Premier Support for OEMs include troubleshooting assistance, adaptation services, and ad-hoc consulting to help avoid problems and accelerate your production and testing cycles.

Type of support | Description
General Consulting | Your technical account manager (TAM) can answer your "how to" questions and recommend ways to address technical issues and reduce potential problems. General Consulting may also be used to review your existing service planning, support readiness, and preinstallation processes.
Adaptation Services | Your TAM can assist you with planning and installing Microsoft products on your manufactured systems and help coordinate installation activities between third-party equipment or software suppliers and Microsoft. In addition, support for the OEM Preinstallation Kit (OPK) is provided by your TAM and knowledgeable support engineers.
Prototype Compatibility | When you are planning a major product release, make sure that your hardware components are fully tested and compatible with Microsoft products. Your TAM can facilitate distributing your device prototypes to the appropriate product groups within the Microsoft organization for testing purposes.

The amount of TAM services you receive for account management and proactive services varies based upon the service level purchased. A Microsoft representative can advise you on the most suitable level of TAM services for your organization. Additional proactive services may be added during the term of your contract, as required.


Troubleshooting FAQ

The most frequently asked questions about:

  • Networking
  • Windows Updates
  • WinPE
  • Imaging
  • Windows Welcome
  • Hardware
  • Activation
  • Branding
  • Other

Networking

How do I build a Windows XP–based peer-to-peer network?

You can find more information about peer-to-peer networking at http://oem.microsoft.com/worldwide/513212.asp http://oem.microsoft.com/worldwide/513212.asp.

I had my configuration set working before, but now that I have shared the OPK tools directory, it does not work. What might be the issue?

Go to the sharing properties and make sure that "Files can be changed by users" is selected. Also make sure that you do not have "Internet Firewall" enabled if working in a peer-to-peer workgroup, because this will make the two computers unable to connect with each other.

I keep getting a "Cannot Authenticate to Server" error. What should I look for?

Ensure that the OPK Tools folder is shared with administrator rights. Also verify that the \\computer_name\user_name and password are correct for the technician computer. Make sure that you have connectivity to the technician computer by pinging it from the master computer using the CMD from the OPK CD in a WinPE session.

I want to install applications using the Guest Account. How can I do this?

Copy and stage the application on a network server or locally, and then share the folders and make sure you add the appropriate user name and password. Because the Guest Account is not enabled by default, you will need to enable this on your technician computer.

However, we do not recommend using the Guest account. A better solution is to create a limited user that is used only for installations (called OPKUSER, for example) and then give that user access to install.

If I want to do a preinstallation using static Internet Protocol (IP) addresses in a workgroup and not DHCP, how do I do this? What is the syntax?

First make sure that all of the computers are in the same workgroup. Then change the technician computer to have a static address in the TCPIP configuration as:

ipconfig=169.172.0.1
subnetmask=255.255.0.0

On the master computer's Winbom.ini on the floppy disk, add a static address with the syntax in the [WinPE.net] section of the Winbom.ini file add:

ipconfig=169.172.0.2
subnetmask=255.255.0.0

How do I configure Setup Manager to build configuration sets that use a user name and password that is different from the user name and password that I used when I first installed the OPK?

If a different account has been set up on your technician computer to complete preinstallation (different from what was used when you first installed \OPKtools), then proceed to the \OPKtools folder, open Setupmgr.ini, and change the account name and password. This will input the proper account information into any of the new accounts you may create.

If I change the permissions to the folder that I'm sharing, do I need to make any changes to my Winbom.ini file?

No, unless your effective permissions are Read or better.

Windows Updates

Where do I get the latest patches and fixes for Windows XP or the Windows .NET Server family?

You can find support for preinstallation of Windows on the Microsoft OEM System Builder Web site. We offer free technical support through the newsgroups, staffed by experts on the OPK.

http://oem.microsoft.com/general/bbs/ http://oem.microsoft.com/general/bbs/

Microsoft Product Support Services : http://www.microsoft.com/support/

Where do I get the latest updates for Windows XP or the Windows .NET Server family?

Go to the Windows Update page at http://v4.windowsupdate.microsoft.com/en/default.asp .

WinPE

How do I create a custom WinPE CD with my own set of network drivers on it?

Completed the previously outlined steps for replacing the Winbom.ini file. Please see http://oem.microsoft.com/worldwide/512502.asp. However, in step 2 (step 4 in the example), place the INF for the Network Interface Card in the C:\Winpe.tmp\i386\INF directory and the driver file(s) in the C:\Winpe.tmp\i386\System32\Drivers directory.

How do I capture error logging using my Winbom.ini file?

To assist in troubleshooting errors that occur while WinPE is processing your Winbom.ini file, you can enable error logging in your Winbom.

Under [Factory] in your Winbom.ini file, add the following lines:

Logfile = a:\winbom.log
Logging=Yes
LogPerf=Yes

This will create a Winbom.log file on your floppy disk.

If I change my password in Winbom.ini on the floppy disk, do I need to change the Winbom.ini file that resides in the \cfgsets folder?

Yes. If you change either the user name or password that is used to connect to the distribution share, you must update the UserName and Password entries in the [Factory] section of the Winbom.ini file associated with each existing configuration set.

To change the default value of these entries in all subsequently created configuration sets, change the UserName and Password entries in the [DistShare] section of the Setupmgr.ini file, located in the directory where you installed the OPK tools.

I want to copy my Winbom.ini file to the root of the CD for preinstallation. Does this work? If so, how?

Create a custom WinPE ISO file using MKIMG. Overwrite the existing Winbom.ini file that is located in the root of the temporary folder that was created. Recreate the image from that temporary folder using OSCDIMG –b etfsboot.com –h –n temporary_folder iso_image_file.

Example:

  1. Copy the WINPE folder from the tools CD to your hard disk.
  2. Copy Factory.exe and Netcfg.exe from \tools\x86 to C:\WINPE.
  3. From a command prompt, change to the C:\WINPE folder and execute MKIMG D: C:\Winpe.tmp C:\Winpe.iso.
  4. Replace C:\Winpe.tmp\winbom.ini with the customized version.
  5. Change back to the C:\WINPE folder and execute OSCDIMG –b etfsboot.com –h –n c:\Winpe.tmp c:\Winpe.iso.

When I'm using Mkimg.cmd, does the drive path or fully qualified paths need to be correct?

When using Mkimg.cmd, you must use fully qualified paths such as C:\Winpe.tmp and C:\Winpe.iso rather than \Winpe.tmp and \Winpe.iso. The drive letter and colon are required as well as the absolute path. Relative paths are not allowed.

How do I set up a Windows 2000 Server RIS and at the same time as the Windows XP installation?

You must use a Pre-boot Execution Environment (PXE)–enabled network interface card (NIC) on the remote workstation or a PXE-compliant card (which most PCI NICs are). See Microsoft Knowledge Base article ID Q242920 for a list of compliant cards.

Imaging

How do I modify an existing image once I've resealed it without activating it?

Start with an original image and add your hardware in audit mode. Configure the image just the way you like it, and then reseal, image, and apply to other computers. Use SysPrep to reseal the image after you have added your custom applications and hardware. You can then use the image on multiple computers of the same configuration.

Why doesn't Sysprep work when I insert the floppy disk with Sysprep.inf?

Because Sysprep.inf must be in the C:\Sysprep directory. If it is anywhere else you cannot enter Audit mode or use CTRL-SHIFT-F3.

Windows Welcome

Why am I getting "Windows was unable to determine which Network Connection to use for Internet Access" during Windows Welcome?

If you have two network adapters or a network adapter and a 1394 card in the computer (or equivalent onboard components), Windows Welcome may display the following message: "An Internet connection could not be chosen."

After Windows Welcome has completed, follow these steps to set up your networking configuration:

  1. Open Control Panel from the Windows Start menu.
  2. Double-click Network and Internet Connections.
  3. Click Setup to change your home or small office network.

Can I still press CTRL+SHIFT+F3 to enter audit mode during Windows Welcome?

Yes, during the first screen of Windows Welcome where Qmark, the question mark character, appears, you can enter audit mode by pressing CTRL+SHIFT+F3. However, this does not work on any other screen in Windows Welcome. Click Back to return to the first screen.

Hardware

I have a device that fails or I have replaced a driver and get a failure. What can I do?

The driver is not signed.

Run Sigverif.exe from a command prompt to verify that all the drivers are signed. If a device fails and its driver is not signed, replace the driver with the original and retest. If you determine that the problem is the result of a recent driver or hardware change to the system, undo that change.

For more information about the File Signature Verification tool, see http://www.microsoft.com/hwdev/desinit/digitsign.htm http://www.microsoft.com/hwdev/desinit/digitsign.htm.

The preinstallation process begins but then stops with the command prompt window open and the cursor at the D:\i386\System32> prompt. What's happening?

Incompatible hardware. The most common cause of this problem is a NIC that is not on the Hardware Compatibility List (HCL) (http://www.microsoft.com/hcl/) for Windows XP or the Windows .NET Server family. Test for possible NIC failure by verifying that the Transmission Control Protocol/Internet Protocol (TCP/IP) is bound to the NIC. At a command prompt, type Ipconfig /all and then press ENTER. This should list all IP configuration information. If no information is listed or an error message is displayed, then the NIC probably is not on the HCL.

If DiskPart fails, can I use WipeDisk to clean the drive?

You should use WipeDisk by adding the following entries in the [DiskConfig] section of the Winbom.ini file, where N is the partition number to be activated:

WipeDisk=Yes
SetActiveN=Yes

The [DiskConfig] section should appear as follows:

[DiskConfig]
Disk1 = First.Config

[First.Config]
WipeDisk=Yes
Size1 = *
FileSystem1 = NTFS
SetActive1 = Yes
PartitionType1 = Primary

I want to do a preinstallation using a 1394 FireWire/USB hard drive that I can move from computer to computer. Can I do this?

You can install the OPK tools to a FireWire/USB hard drive, create your configuration sets on this hard drive, and then remove the hard drive from the technician's computer. Then you can connect the drive to your target computer, boot the computer using WinPE, and install your configuration set.

All you need to do is modify the SourceRoot entry in your Winbom.ini file as follows:

SourceRoot=D:\opktools

Activation

I would like to prepopulate the product Key number off of the Certificate of Authenticity (COA) label and preactivate Windows in my factory. How can I do this?

This has to be done on a per-machine basis. Open the Oobeinfo.ini file on the finished computer, and add the product key in the following section:

[Version]
ProductKey=Place your valid Product Key number

You must activate the product key on the finished computer immediately before you run SysPrep. The end user will not be asked for their product key. You must prepopulate the product key separately on each computer to ensure that the genuine product key and activation has taken place before you reseal and ship the computer. You will not be able to make an image of this if you preactivate.

For more information about activation, see Sysprep and Activation FAQ.

Branding

Can I put my logo on the splash screen at startup? If so, how do I do this?

No, you cannot brand the BIOS startup page. This is not supported. However, you can have your logo appear during Windows Welcome. This is done using the Oobeinfo.ini file created by Setup Manager.

Other

How do I add support for a PS/2 mouse to a computer that was preinstalled without a mouse?

Add the following to the [Sysprep] section of the Sysprep.inf:

[Sysprep]
BuildMassStorageSection = Yes

This entry automatically populates the [SysprepMassStorage] section with the appropriate Plug and Play IDs from Machine.inf, Scsi.inf, Pnpscsi.inf, and Mshdc.inf.

The preinstallation process begins but then stops with the command prompt window open and the cursor at the D:\i386\System32> prompt and I have confirmed that TCP/IP is bound to the NIC. What else could be wrong?

There are several possibilities.

You have a network connectivity error.

Ensure that the computer is connected to the network and that the network cable is in working order.

The technician computer was not available.

Verify that the technician computer is working by typing ping IP_address (where IP_address is the IP address of the technician computer) at a command prompt. If you receive four replies, the technician computer is working and the NICs on both computers are configured correctly.

The UNC path in the Winbom.ini file is not correct.

Correct the UNC path in the Winbom.ini file.

The user account specified in the Winbom.ini file is not valid or does not have access to the Distribution folder.

Correct the user account in the Winbom.ini file and give the user account access to the Distribution folder.

How do I preinstall the Step by Step Interactive (SBSI) training program? Do I have to do this manually in audit mode or is this preinstalled automatically?

In the English version of Windows XP, SBSI is installed automatically by default. For other languages, it must be run manually using the localized CD in your OEM 3-pack from the local distributor. The Application Preinstallation page is a good place to run this if you need to install a localized version.

I want to preinstall Microsoft Office XP during my installation. Any samples or ideas on how to do this?

You can use Setup Manager to point to the Universal Naming Convention (UNC) path, such as \\servername\sharename, and then copy the Office XP setup.exe file to this location. Make sure you share it with a user name other than the one you are using for the configuration set, such as office installer. Then copy all of the Office XP files to your network share. In your Setup Manager configuration set in the Application Preinstall wizard page, add the network share pointing to the Office XP Setup.exe file, using /q for quiet installation.

Are there localized versions of the OPK? If so, where do I obtain them?

Localized versions of the Windows OPK are available from the OEM distributor in your region.

Available languages:

  • German
  • Japanese
  • Korean
  • Traditional Chinese
  • Simplified Chinese
  • French
  • Spanish
  • Italian
  • Swedish
  • Dutch
  • Brazilian (Portuguese)
  • Norwegian
  • Danish
  • Finnish
  • Czech
  • Polish
  • Hungarian
  • Russian
  • Portuguese
  • Greek
  • Turkish
  • Arabic
  • Hebrew

How do I install the Windows Recovery Console?

http://support.microsoft.com/support/kb/articles/q216/4/17.asp


For More Information

If you are a royalty OEM, consult the Microsoft Royalty OEM Web site at https://oem.microsoft.com/directoem/. For access to this Web site, contact your account manager.

If you are a system builder, consult the Microsoft OEM System Builder Web site at:
https://oem.microsoft.com/

Also see the white paper entitled "Step-by-Step Guide to OEM Preinstallation of Windows XP" on the OPK CD.

For a list of authorized Microsoft OEM Distributors in your area, consult the Authorized Distributors page on the Microsoft OEM Web site at:
https://oem.microsoft.com/authdist.htm

For current information about Microsoft anti-piracy policies, see the Microsoft Protecting Against Software Piracy Web sites at:
http://www.microsoft.com/piracy/
http://www.microsoft.com/piracy/howtotell/

For ideas on improving ease of use, see the white papers located at the Ease of Use/PC Quality Roundtable Web site (http://http://www.eouroundtable.com).

Obtaining Support Information

For product support, consult the Microsoft Knowledge Base at:
http://support.microsoft.com/directory/

Microsoft for Partners Support Web site (http://www.microsoft.com/partner/support/)

Obtaining More Information on Microsoft Windows XP

Use these resources to learn more about Microsoft Windows XP:

  • The Microsoft Windows XP Professional Resource Kit will familiarize you with the concepts and functionality of Windows, especially Windows Setup.
  • The Microsoft Windows XP Start Here Guide
  • Readme.txt, located on the Windows OPK CD.
  • Read1st.txt, located on the Windows product CD.

Developing Microsoft Windows XP Software

Any business partners building applications or content to plug into Help and Support Center can obtain the PC Health Software Development Kit (https://oem.microsoft.com/directoem/510659.asp) from the Microsoft Direct OEM Web site. For access to this Web site, contact your account manager.

For information about creating your own Help system, see the Official Microsoft HTML Help Authoring Kit, published by Microsoft Press.

Consult documentation for Microsoft Agent at:
http://msdn.microsoft.com/workshop/imedia/agent/documentation.asp

For more information about InstallShield for Windows Installer, see the InstallShield Web site at:
http://www.installshield.com/iswi/

Windows Media Player Software Development Kit (http://www.msdn.microsoft.com/windowsmedia/)

For global software development issues, consult the Microsoft Global Software Development Web site at:
http://www.microsoft.com/globaldev/

Consult the MSDN independent software vendor (ISV) Software Vendor site at:
http://msdnisv.microsoft.com/msdn_isv/

Developing Hardware for Microsoft Windows XP and the Windows .NET Server Family

For information on driver signing, send your questions to whqlds@microsoft.com.

For information on requirements for the Microsoft logo, send your questions to hwlogo@microsoft.com.

For information about creating third-party device drivers and .inf files, see the Microsoft Windows Device Driver Kit (DDK), which you can order from the Microsoft DDK Web site (http://www.microsoft.com/ddk/). You can also read the DDK documentation in the MSDN Library (http://msdn.microsoft.com/library/): Select Windows Development, then Driver Development Kit.

Driver Signing for Windows Operating Systems (http://www.microsoft.com/hwdev/driver/digitsign.asp)

Windows Hardware Quality Labs Web site (http://www.microsoft.com/hwtest/)

Windows Platform Development Web site (http://www.microsoft.com/hwdev/)

Advanced Configuration and Power Interface (ACPI) specification (http://www.acpi.info/index.html)

For hardware compatibility information, see the Hardware Compatibility List (HCL) (http://www.microsoft.com/hcl/).

Consult the Microsoft Windows Logo Program at:
http://www.microsoft.com/winlogo/

Consult the Certified for Windows Program Web site at:
http://msdn.microsoft.com/certification/

Obtaining Other Information on Microsoft Products

Consult the Microsoft Windows Web site at:
http://www.microsoft.com/windows/

Consult the MSDN Online Library at:
http://msdn.microsoft.com/library/

Consult the MSDN Online Web Workshop at:
http://msdn.microsoft.com/workshop/

Consult Microsoft TechNet at:
http://www.microsoft.com/technet/

For more information about the GUID partition table (GPT), see the Windows XP Resource Kit.

For more information about the extensible firmware interface (EFI), see the manufacturer's documentation that came with your computer, or the Intel Web site (http://www.intel.com).

For information about Microsoft Press books, visit the Microsoft Press Web site at:
http://mspress.microsoft.com/


Glossary

Symbols A B C D E F G H I J K L M N O P Q R S T U V W X YZ

Symbols

$$Rename.txt

A file that lists all files contained in a particular folder that need to be renamed from an 8.3 format name to a long file name during Setup. All file names must be in 8.3 format if you run Setup using Winnt.exe, or if you are copying a set of files from one computer to another using MS-DOS.

%windir%

The default directory where Windows is installed, most commonly C:\winnt.

.adm

The file name extension for Administrative Templates files.

.cab file

Cabinet file. A single cabinet file that stores multiple compressed files. These files are commonly used in software installation and to reduce the file size and the associated download time for Web content.

.dll file

See definition for: dynamic-link library (DLL)

.inf file

Information file. A file created for a particular adapter that provides the operating system with information required to set up a device, such as a list of valid logical configurations for the device, the names of driver files associated with the device, and so on. An .inf file is provided typically on a disk by the device manufacturer or may be included in the operating system.

.ini file

Initialization file. Commonly used under Windows 3.x and earlier, .ini files have been used by both the operating system and individual applications to store persistent settings related to an application, driver, or piece of hardware. In Windows 32-bit operating systems, .ini files are supported for backward compatibility, but the registry is the preferred location for storing such settings.

.ins file

Internet settings file. A file that provides Windows Update Setup with Internet settings that configure the browser and associated components. You can create multiple versions of your browser package by changing the .ins file used by each package. Use the Profile Manager to create, save, and load .ins files.

100baseT

The Ethernet standard for local area networks using twisted-pair cable carrying data at 100 megabits per second (Mbps).

8.3

The standard format for file names in MS-DOS and Windows 3.1. A file name with eight or fewer characters, followed by a period (dot), followed by a three-character file name extension.

A

account manager

A Microsoft employee who is the primary contact for the business relationship between the OEM and Microsoft.

ACPI

See definition for: Advanced Configuration and Power Interface (ACPI)

activation

See definition for: Windows Product Activation (WPA)

Active Directory

The directory service that stores information about objects on a network and makes this information available to users and network administrators. Active Directory gives network users access to permitted resources anywhere on the network using a single logon process. It provides network administrators with an intuitive, hierarchical view of the network and a single point of administration for all network objects.

See also: domain; forest

Active Directory Users and Computers

An administrative tool used by an administrator to perform day-to-day Active Directory administration tasks. The tasks that can be performed with this tool include creating, deleting, modifying, moving, and setting permissions on objects stored in the directory. Examples of objects in Active Directory are organizational units, users, contacts, groups, computers, printers, and shared file objects.

See also: Active Directory; object; permission

active partition

A partition from which an x86-based computer starts up. The active partition must be a primary partition on a basic disk. If you use Windows exclusively, the active partition can be the same as the system volume.

See also: basic disk; primary partition; system partition; x86

active volume

The volume from which the computer starts up. The active volume must be a simple volume on a dynamic disk. You cannot mark an existing dynamic volume as the active volume, but you can upgrade a basic disk containing the active partition to a dynamic disk. After the disk is upgraded to dynamic, the partition becomes a simple volume that is active.

See also: active partition; basic disk; dynamic disk; dynamic volume; simple volume

adapter

See definition for: device

add-on devices

Devices that are traditionally added to the base PC system to increase functionality, such as audio, networking, graphics, or SCSI controller. Add-on devices fall into two categories: devices built onto the system board, and devices on expansion cards, added to the system through a system board connector, such as PCI.

administrator

In Windows XP Professional and Windows XP Home Edition, a person responsible for making system changes on the local computer. For example, an administrator, on the local computer, can install software, maintain local user and group accounts, assign passwords and permissions, and manage local files.

In Windows XP Professional, administrators are members of the local administrators group and have full control over the local computer.

See also: domain controller; group account; password; permission; user account

Advanced Configuration and Power Interface (ACPI)

An open industry specification that defines power management on a wide range of mobile, desktop, and server computers and peripherals. ACPI is the foundation for the OnNow industry initiative that allows system manufacturers to deliver computers that start at the touch of a keyboard. ACPI design is essential to take full advantage of power management and Plug and Play.

See also: Plug and Play

agent character

An interactive animated character who guides users through Windows Welcome. The character interacts with the user in ways similar to the natural aspects of human social communication. Characters can respond using synthesized speech, recorded audio, or text in a cartoon word balloon.

See also: Windows Welcome

allocation unit

The smallest amount of disk space that can be allocated to hold a file. All file systems used by Windows organize hard disks based on allocation units. The smaller the allocation unit size, the more efficiently a disk stores information. If you do not specify an allocation unit size when formatting the disk, Windows picks default sizes based on the size of the volume. These default sizes are selected to reduce the amount of space that is lost and the amount of fragmentation on the volume. Also called a cluster.

See also: file system

American Standard Code for Information Interchange (ASCII)

A standard single-byte character encoding scheme used for text-based data. ASCII uses designated 7-bit or 8-bit number combinations to represent either 128 or 256 possible characters. Standard ASCII uses 7 bits to represent all uppercase and lowercase letters, the numbers 0 through 9, punctuation marks, and special control characters used in U.S. English. Most current x86-based systems support the use of extended (or "high") ASCII. Extended ASCII allows the eighth bit of each character to identify an additional 128 special symbol characters, foreign-language letters, and graphic symbols.

See also: Unicode

answer file

A text file that scripts the answers for a series of graphical user interface (GUI) dialog boxes. The answer file for Setup is commonly called Unattend.txt, but for a network preinstallation, you can name the file anything you like. For a CD-based Setup, the answer file must be named Winnt.sif. The answer files for Sysprep are Sysprep.inf and Winbom.ini. You can create or modify these answer files in a text editor or through Setup Manager.

See also: Unattend.txt

anti-aliasing

A software technique for smoothing the jagged appearance of curved or diagonal lines caused by poor resolution on a display screen. Methods of anti-aliasing include surrounding pixels with intermediate shades and manipulating the size and horizontal alignment of the pixels.

API

See definition for: application programming interface (API)

APIC

Advanced Programmable Interrupt Controller. A distributed set of devices that form an interrupt controller.

AppleTalk

See definition for: AppleTalk Protocol

AppleTalk Protocol

The set of network protocols on which AppleTalk network architecture is based. The AppleTalk Protocol is installed with Services for Macintosh to help users access resources on a network.

See also: protocol; resource

application programming interface (API)

A set of routines that an application uses to request and carry out lower-level services performed by a computer's operating system. These routines usually carry out maintenance tasks such as managing files and displaying information.

aspect ratio

The relationship of width and height for an image. When an image is displayed on different screens, the aspect ratio must be kept the same to avoid either vertical or horizontal distortion.

assigned configuration

The resources contained in the device node that are allocated for the device. For Plug and Play cards, the assigned resources for a device can change dynamically or from one system start-up to the next.

asynchronous

Not dependent on timing. Each application or command runs in the specified order, but the specified item does not wait for any previously started processes to finish before application or command runs.

ATM adaptation layer (AAL)

The layer of the ATM protocol stack that parses data into the payload portion of the ATM cell for transport across an ATM network.

attach

Run the Setup program for an application that is already staged on the destination computer.

See also: destination computer; detach; stage

attribute

For files, information that indicates whether a file is read-only, hidden, ready for archiving (backing up), compressed, or encrypted, and whether the file contents should be indexed for fast file searching.

In Active Directory, a property of an object. For each object class, the schema defines which attributes an instance of the class must have and which additional attributes it might have.

See also: object

audit mode

Verifying, before it is delivered to the end user, that the fully-manufactured computer functions as expected. After auditing, always reseal the operating system to reset the first-run experience for the user.

authentication

The process for verifying that an entity or object is who or what it claims to be. Examples include confirming the source and integrity of information, such as verifying a digital signature or verifying the identity of a user or computer.

See also: smart card

authorized distributor

An independent company licensed by Microsoft Licensing, Inc. to manage the production and distribution of multipacks of Windows XP OEM products to system builders. If you purchase Microsoft software from someone other than a Microsoft authorized distributor, you run the risk of purchasing counterfeit software, which usually has many of the following problems: missing drivers, missing documentation, viruses, bugs, and other defects. Installing legitimate Microsoft products prevents customer problems and reduces requests for customer support.

authorized replicator

An independent company licensed by Microsoft Licensing, Inc. to manage the production and distribution of Microsoft OEM products for royalty OEMs. Microsoft Licensing, Inc. supplies the authorized replicator with the master components, manufacturing and assembly specifications, and other pertinent instructions. The authorized replicator manufactures and assembles genuine Microsoft products to exact specifications. The benefits of using an authorized replicator include protection against piracy, consistent high-quality software, and competitive prices.

autologon

Automatically logging on to the computer using the Administrator account when the computer restarts.

Automatic Private IP Addressing (APIPA)

A TCP/IP feature in Windows XP and products in the Windows .NET Server family that automatically configures a unique IP address from the range 169.254.0.1 through 169.254.255.254 and a subnet mask of 255.255.0.0 when the TCP/IP protocol is configured for dynamic addressing and a Dynamic Host Configuration Protocol (DHCP) server is not available. The APIPA range of IP addresses is reserved by the Internet Assigned Numbers Authority (IANA), and IP addresses within this range are not used on the Internet.

See also: DHCP server; Dynamic Host Configuration Protocol (DHCP); IP address; Transmission Control Protocol/Internet Protocol (TCP/IP)

B

bandwidth

In analog communications, the difference between the highest and lowest frequencies in a specific range. For example, an analog telephone line accommodates a bandwidth of 3,000 hertz (Hz), the difference between the lowest (300 Hz) and highest (3,300 Hz) frequencies it can carry. In digital communications, bandwidth is expressed in bits per second (bps).

See also: bits per second (bps)

base character

A character that has meaning independent of other characters, or any graphical character that is not a diacritical mark.

basic disk

A physical disk that can be accessed by MS-DOS and all Windows-based operating systems. Basic disks can contain up to four primary partitions, or three primary partitions and an extended partition with multiple logical drives. If you want to create partitions that span multiple disks, you must first convert the basic disk to a dynamic disk using Disk Management or the Diskpart.exe command-line tool.

See also: dynamic disk; extended partition; logical drive; primary partition

basic input/output system (BIOS)

On x86-based computers, the set of essential software routines that test hardware at startup, start the operating system, and support the transfer of data among hardware devices. The BIOS is stored in read-only memory (ROM) so that it can be executed when you turn on the computer. Although critical to performance, the BIOS is usually invisible to computer users.

See also: Extensible Firmware Interface (EFI); read-only memory (ROM); x86

basic volume

A primary partition or logical drive that resides on a basic disk.

See also: basic disk; logical drive; primary partition

bidi

Bi-Directional text. A mixture of characters that are read from left to right and characters that are read from right to left. For example, most Arabic, Hebrew, Farsi, and Urdu characters are read from right to left, but numbers and quoted Western terms within these languages' text are read from left to right.

BIOS

See definition for: basic input/output system (BIOS)

BIOS enumerator

Responsible in a non-ACPI Plug and Play system for identifying all hardware devices on the motherboard of the computer. The BIOS supports an API that allows all Plug and Play computers to be queried in a common manner.

bit (binary digit)

The smallest unit of information handled by a computer. One bit expresses a 1 or a 0 in a binary numeral, or a true or false logical condition. A group of 8 bits makes up a byte, which can represent many types of information, such as a letter of the alphabet, a decimal digit, or other character. Also known as a binary digit.

bit specifications

Numbers of colors or levels of gray that can be displayed at one time. Controlled by the amount of memory in the computer's graphics controller card. An 8-bit controller can display 256 colors or levels of gray; a 16-bit controller, 64,000 colors; and a 24-bit controller, 16.8 million colors.

bitmap

A file format for images used to customize the graphics in an Internet Explorer Administration Kit (IEAK) package.

bits per second (bps)

The number of bits transmitted every second, used as a measure of the speed at which a device, such as a modem, can transfer data.

See also: modem (modulator/demodulator)

boot partition

The partition that contains the Windows operating system and its support files. The boot partition can be, but does not have to be, the same as the system partition.

See also: partition; Primary disk; system partition

bootstrap loader

A program that is run automatically when a computer is turned on, or booted. After first performing a few basic hardware tests, the bootstrap loader loads and passes control to a larger loader program, which typically then loads the operating system. The bootstrap loader typically resides in the computer's read-only memory (ROM).

See also: read-only memory (ROM)

branding

To incorporate a company name, logo, support information, and Help files into the Microsoft Windows installation.

broadband

Of or relating to communications systems in which the medium of transmission (such as a wire or fiber-optic cable) carries multiple messages at a time, each message modulated on its own carrier frequency by a modem.

browser

Software that interprets the markup of files in HTML, formats them into Web pages, and displays them to the end user. Some browsers also permit end users to send and receive e-mail, read newsgroups, and play sound or video files embedded in Web documents.

See also: World Wide Web

build-to-order

To manufacture a computer according to a customer's specification.

build-to-plan

To manufacture computers according to a general specification.

built-in groups

The default security groups installed with the operating system. Built-in groups have been granted useful collections of rights and built-in abilities.

In most cases, built-in groups provide all the capabilities needed by a particular user. For example, members of the built-in Backup Operators group can back up and restore files and folders. To provide a needed set of capabilities to a user account, assign it to the appropriate built-in group.

bus

A communication line used for data transfer among the components of a computer system. A bus essentially allows different parts of the system to share data. For example, a bus connects the disk-drive controller, memory, and input/output ports to the microprocessor.

See also: expansion slot; universal serial bus (USB)

C

cable modem

A modem that sends and receives data through a coaxial cable television network instead of telephone lines.

cache

A special memory subsystem in which frequently used data values are duplicated for quick access.

See also: cache file

cache file

A file used by Domain Name System (DNS) servers and clients to store responses to DNS queries. For Windows DNS servers, the cache file is named Cache.dns by default.

See also: cache

caching

The process of temporarily storing recently accessed information in a special memory subsystem for quicker access.

See also: cache

CAL

See definition for: client access license (CAL)

CD boot

Starting a computer from the retail product CD-ROM and then installing Windows on the hard disk using the Setup program on the CD. This method is much slower than installing Windows from a network and is not recommended. For an unattended Setup using the CD boot method, the Unattend.txt file must be named Winnt.sif. The user can select in the winnt.sif if they want to manually select the partition or have it automatically selected.

CD-ROM

Compact disc read-only memory. A form of storage characterized by high capacity (roughly 650 MB) and the use of laser optics rather than magnetic means for reading data.

certificate

A digital document that is commonly used for authentication and to secure information on open networks. A certificate securely binds a public key to the entity that holds the corresponding private key. Certificates are digitally signed by the issuing certification authority and can be issued for a user, a computer, or a service. The most widely accepted format for certificates is defined by the ITU-T X.509 version 3 international standard.

See also: certification authority (CA); private key; public key; service

certificate of authenticity (COA)

A label with sophisticated anti-counterfeiting features that helps the end user identify that the computer is using a validly licensed copy of Microsoft Windows. The product name and a unique product key appear in the center of the label. The OEM must physically attach the COA label to the computer chassis, and it should never be removed from the computer.

certificate revocation list (CRL)

A document maintained and published by a certification authority that lists certificates that have been revoked.

See also: certificate; certification authority (CA)

certificate template

A Windows construct that specifies the format and content of certificates based on their intended usage. When requesting a certificate from a Windows enterprise certification authority (CA), certificate requestors can select from a variety of certificate types that are based on certificate templates.

See also: certificate; certification authority (CA)

certificate trust list (CTL)

A signed list of root certification authority certificates that an administrator considers reputable for designated purposes, such as client authentication or secure e-mail.

See also: certificate; certification authority (CA); root certificate

certification authority (CA)

An entity responsible for establishing and vouching for the authenticity of public keys belonging to subjects (usually users or computers) or other certification authorities. Activities of a certification authority can include binding public keys to distinguished names through signed certificates, managing certificate serial numbers, and certificate revocation.

See also: certificate; public key; root certification authority

character

The simplest element used to represent written languages. The appearance of a character is not constant; a character's appearance depends on the font used, as well as the context of surrounding text.

checkpoint

An identifier for a specific page or a conceptually related set of pages that tracks the user's navigation through Windows Welcome.

child object

An object that resides in another object. A child object implies relation. For example, a file is a child object that resides in a folder, which is the parent object.

See also: object; parent object

clean system

An installation of Windows that has not been modified and has not had any additional software installed on it.

ClearType

A font display technology that dramatically improves font display resolution so that letters on the computer screen appear smooth, not jagged. ClearType dramatically improves the readability of text on color LCD monitors with a digital interface, such as those found in laptops and high-quality flat-panel desktop displays.

client

Any computer or program connecting to, or requesting the services of, another computer or program. Client can also refer to the software that enables the computer or program to establish the connection.

For a local area network (LAN) or the Internet, a computer that uses shared network resources provided by another computer (called a server).

See also: server

client access license (CAL)

A license that specifies the number of client computers that can connect to and use software located on a server.

cluster

In data storage, the smallest amount of disk space that can be allocated to hold a file. All file systems used by Windows organize hard disks based on clusters, which consist of one or more contiguous sectors. The smaller the cluster size, the more efficiently a disk stores information. If no cluster size is specified during formatting, Windows picks defaults based on the size of the volume. These defaults are selected to reduce the amount of space that is lost and the amount of fragmentation on the volume. Also called an allocation unit.

In computer networking, a group of independent computers that work together to provide a common set of services and present a single-system image to clients. The use of a cluster enhances the availability of the services and the scalability and manageability of the operating system that provides the services.

See also: client; file system

Cmdlines.txt

A text file that GUI-mode Setup executes when installing optional components, such as applications.

COA

See definition for: certificate of authenticity (COA)

code page

A means of providing support for character sets and keyboard layouts for different countries or regions. A code page is a table that relates the binary character codes used by a program to keys on the keyboard or to characters on the display.

codec

Hardware that can convert audio or video signals between analog and digital forms (coder/decoder); hardware or software that can compress and uncompress audio or video data (compression/decompression); or the combination of coder/decoder and compression/decompression. Generally, a codec compresses uncompressed digital data so that the data uses less memory.

collateral

The end-user manual and any other items the OEM packages with a new computer.

compatible ID

An ID used by the Plug and Play Manager. If Plug and Play does not locate a match for the device hardware ID, Plug and Play installs the driver .inf file associated with the compatible ID.

composite character

A text element consisting of a base character and a diacritic or accent mark. Although most common in the Latin script, other scripts (including Greek, Devanagari, and Tamil) also have composite characters.

config set

See definition for: configuration set

Configuration Manager

The Windows Plug and Play system component that drives the process of locating devices, setting up their nodes in the hardware tree, and running the resources allocation process. Each of the three phases of configuration management--boot time, real mode, and protected mode--have their own configuration managers.

configuration set

A file and folder structure that contain the necessary configuration settings that control the preinstallation process and define the manufacturers' custom information.

configure-to-order

To manufacture a computer according to a customer's specification by customizing a pre-existing image of a master installation.

Connection Manager

A client dialer used to obtain Internet access.

console tree

The left pane in Microsoft Management Console (MMC) that displays the items contained in the console. The items in the console tree and their hierarchical organization determine the capabilities of a console.

See also: Microsoft Management Console (MMC)

cookie

A block of data that a Web server stores on a client system. When a user returns to the same Web site, the browser sends a copy of the cookie back to the server. Cookies identify users, instruct the server to send a customized version of the requested Web page, and submit account information for the user.

counterfeit software

Software that a system builder does not obtain from an authorized distributor, or that a royalty OEM does not obtain from an authorized replicator. Counterfeit software usually has many of the following problems: missing drivers, missing documentation, viruses, bugs, and other defects. Installing legitimate Microsoft products helps ensure the quality of your products, prevents customer problems, and reduces requests for customer support.

customer

The purchaser of a new computer.

D

debug

To detect, locate, and correct logical or syntactical errors in a program.

desktop

The on-screen work area on which windows, icons, menus, and dialog boxes appear.

desktop ISP sign-up offer

A set of HTML pages that offer the end user the opportunity to sign up for Internet access. To view the offer, the end user clicks a link from the OEM link on the Start menu.

desktop registration

The opportunity given to the end user to register with Microsoft and the OEM, if the user failed to register during Windows Welcome.

destination computer

The computer on which you preinstall Windows that will be distributed to customers. You can either run Setup on the destination computer or copy a master installation onto a destination computer.

detach

Remove uninstalled application files from a destination computer.

See also: attach; destination computer; stage

device

Any piece of equipment that can be attached to a network or computer; for example, a computer, printer, joystick, adapter, or modem card, or any other peripheral equipment. Devices normally require a device driver to function with Windows.

See also: device driver

device driver

A program that allows a specific device, such as a modem, network adapter, or printer, to communicate with the operating system. Although a device might be installed on your system, Windows cannot use the device until you have installed and configured the appropriate driver.

If a device is listed in the Hardware Compatibility List (HCL), a driver is usually included with Windows. Device drivers load automatically (for all enabled devices) when a computer is started, and thereafter run invisibly.

See also: Hardware Compatibility List (HCL)

device ID

A unique ASCII string for the device created by enumerators to identify a hardware device and used to cross-reference data about the device stored in the registry. Distinguishes each logical device and bus from all others on the system.

Device Manager

An administrative tool that you can use to manage the devices on your computer. Using Device Manager, you can view and change device properties, update device drivers, configure device settings, and uninstall devices.

See also: device

DHCP

See definition for: Dynamic Host Configuration Protocol (DHCP)

DHCP server

A computer running the Microsoft DHCP service that offers dynamic configuration of IP addresses and related information to DHCP-enabled clients.

See also: Dynamic Host Configuration Protocol (DHCP); IP address

diacritic

Any mark placed over, under, or through a character, usually to indicate a change in phonetic value from the unmarked state. A character that is attached to it is a base character. Most diacritics are non-spacing characters that do not increase the width of the base character.

dial-up connection

The connection to your network if you are using a device that uses the telephone network. This includes modems with a standard phone line, ISDN cards with high-speed ISDN lines, or X.25 networks.

If you are a typical user, you might have one or two dial-up connections, for example, to the Internet and to your corporate network. In a more complex server situation, multiple network modem connections might be used to implement advanced routing.

See also: modem (modulator/demodulator)

dial-up networking (DUN)

Connecting to a remote network or the Internet through a dial-up connection, such as a modem.

digital signature

A means for originators of a message, file, or other digitally encoded information to bind their identity to the information. The process of digitally signing information entails transforming the information, as well as some secret information held by the sender, into a tag called a signature. Digital signatures are used in public key environments, and they provide nonrepudiation and integrity services.

See also: service; time stamp

direct OEM

See definition for: royalty OEM

disk

A storage device that is attached to a computer.

See also: basic disk; dynamic disk

disk duplication

Using third-party hardware or software to copy a full master Windows XP installation onto the hard disks of multiple destination computers. The master computer and destination computers must have compatible hardware abstraction layers (HALs). The destination computer can be delivered directly to customers, or it might require additional processing on the factory production line.

See also: hardware abstraction layer (HAL)

diskpart.exe

A command line utility for formatting and managing disk partitions and volumes.

distribution share

A network folder that contains the source files for Windows products you are preinstalling. It may also contain the OPK tools and your configuration sets. This folder can be manually created or created by Setup Manager.

dock

To connect a laptop or notebook computer to a docking station.

See also: docking station

docking station

A unit for housing a portable computer that contains a power connection, expansion slots, and connections to peripherals, such as a monitor, printer, full-sized keyboard, and mouse. The docking station turns the portable computer into a desktop computer.

See also: dock

domain

In Active Directory, a collection of computer, user, and group objects defined by the administrator. These objects share a common directory database, security policies, and security relationships with other domains.

In DNS, any tree or subtree within the DNS namespace. Although the names for DNS domains often correspond to Active Directory domains, DNS domains should not be confused with Active Directory domains.

See also: Active Directory; object

domain controller

In an Active Directory forest, a server that contains a writable copy of the Active Directory database, participates in Active Directory replication, and controls access to network resources. Administrators can manage user accounts, network access, shared resources, site topology, and other directory objects from any domain controller in the forest.

See also: Active Directory; authentication; forest

domain name

The name given by an administrator to a collection of networked computers that share a common directory. Part of the Domain Name System (DNS) naming structure, domain names consist of a sequence of name labels separated by periods.

See also: domain; label

domain naming master

A domain controller that holds the domain naming operations master role in Active Directory. The domain naming master controls the addition or removal of domains in the forest. At any time, the domain naming master role can be assigned to only one domain controller in the forest.

See also: Active Directory; domain controller

domain tree

In DNS, the inverted hierarchical tree structure that is used to index domain names. Domain trees are similar in purpose and concept to the directory trees used by computer filing systems for disk storage. For example, when numerous files are stored on disk, directories can be used to organize the files into logical collections. When a domain tree has one or more branches, each branch can organize domain names used in the namespace into logical collections.

In Active Directory, a hierarchical structure of one or more domains, connected by transitive, bidirectional trusts, that forms a contiguous namespace. Multiple domain trees can belong to the same forest.

See also: Active Directory; domain; domain name; forest

double-byte characters

A set of characters in which each character is represented by two bytes. Some languages, such as Japanese, Chinese, and Korean, require double-byte character sets.

driver

Kernel-mode code used either to control or emulate a hardware device.

Driver.cab

A file containing all of the device drivers that ship with Windows XP.

DUN

See definition for: dial-up networking (DUN)

DVD

Digital video disk. A form of storage characterized by high capacity (roughly 650 MB) and the use of laser optics rather than magnetic means for reading data. Optical disk storage commonly used for audio, video, and computer data. DVDs range in capacity from 4.7 GB to 17 GB, and can store significantly more than a CD-ROM.

DWORD

A data type composed of hexadecimal data with a maximum allotted space of 4 bytes.

dynamic disk

A physical disk that provides features that basic disks do not, such as support for volumes that span multiple disks. Dynamic disks use a hidden database to track information about dynamic volumes on the disk and other dynamic disks in the computer. You convert basic disks to dynamic by using the Disk Management snap-in or the DiskPart command-line tool. When you convert a basic disk to dynamic, all existing basic volumes become dynamic volumes.

See also: active volume; basic disk; basic volume; dynamic volume; partition

Dynamic Host Configuration Protocol (DHCP)

A TCP/IP service protocol that offers dynamic leased configuration of host IP addresses and distributes other configuration parameters to eligible network clients. DHCP provides safe, reliable, and simple TCP/IP network configuration, prevents address conflicts, and helps conserve the use of client IP addresses on the network.

DHCP uses a client/server model where the DHCP server maintains centralized management of IP addresses that are used on the network. DHCP-supporting clients can then request and obtain lease of an IP address from a DHCP server as part of their network boot process.

See also: IP address; lease; service; Transmission Control Protocol/Internet Protocol (TCP/IP)

dynamic volume

A volume that resides on a dynamic disk. Windows supports five types of dynamic volumes: simple, spanned, striped, mirrored, and RAID-5. A dynamic volume is formatted by using a file system, such as FAT or NTFS, and has a drive letter assigned to it.

See also: basic disk; basic volume; dynamic disk; mirrored volume; RAID-5 volume; simple volume; spanned volume; striped volume

dynamic-link library (DLL)

An operating system feature that allows executable routines (generally serving a specific function or set of functions) to be stored separately as files with .dll extensions. These routines are loaded only when needed by the program that calls them.

E

EFI

See definition for: Extensible Firmware Interface (EFI)

EFI system partition

On Itanium-based computers, a portion on a GUID partition table (GPT) disk that is formatted with the FAT file system and contains the files necessary to start the computer. Every Itanium-based computer must have at least one GPT disk with an EFI system partition. The EFI system partition serves the same purpose as the system volume found on x86-based computers.

See also: Extensible Firmware Interface (EFI); GUID partition table (GPT); Itanium; Microsoft Reserved (MSR) partition; x86

embedded controller

The general class of microcontrollers used to support OEM-specific implementation, mainly in mobile environments. The embedded controller performs complex low-level functions through a simple interface to the host microprocessor(s).

embedded controller interface

ACPI defines a standard hardware and software communications interface between an operating system driver and an embedded controller, such as Smart Battery and AML code. This allows any operating system to provide a standard driver that can directly communicate with an embedded controller in the system, thus allowing other drivers to communicate with and use the resources of the system embedded controllers.

See also: Advanced Configuration and Power Interface (ACPI); driver

encryption

The process of disguising a message or data in such a way as to hide its substance.

See also: public key encryption

end user

The person who ultimately receives the computer manufactured by the OEM.

End-User License Agreement (EULA)

A legal agreement between a software or hardware manufacturer and the end user, with regard to the terms of use and transfer of the software.

EULA

See definition for: End-User License Agreement (EULA)

event

Any significant occurrence in the system or an application that requires users to be notified or an entry to be added to a log.

Event Viewer

A component you can use to view and manage event logs, gather information about hardware and software problems, and monitor security events. Event Viewer maintains logs about program, security, and system events.

See also: event

expansion slot

A socket in a computer, designed to hold expansion boards and connect them to the system bus.

See also: bus

extended partition

A type of partition that you can create only on basic master boot record (MBR) disks. Extended partitions are useful if you want to create more than four volumes on a basic MBR disk. Unlike primary partitions, you do not format an extended partition with a file system and then assign a drive letter to it. Instead, you create one or more logical drives within the extended partition. After you create a logical drive, you format it and assign it a drive letter. An MBR disk can have up to four primary partitions or three primary partitions, one extended partition, and multiple logical drives.

See also: basic disk; logical drive; master boot record (MBR); partition; primary partition; unallocated space

Extensible Firmware Interface (EFI)

In computers with the Intel Itanium processor, the interface between a computer's firmware, hardware, and the operating system. The Extensible Firmware Interface (EFI) defines a new partition style called GUID partition table (GPT). EFI serves the same purpose for Itanium-based computers as the BIOS found in x86-based computers. However, it has expanded capabilities that provide a consistent way to start any compatible operating system and an easy way to add EFI drivers for new bootable devices without the need to update the computer's firmware.

See also: basic input/output system (BIOS); GUID partition table (GPT); Itanium; x86

F

factory mode

A mode of running Sysprep that postpones the first-run experience and allows OEMs to install additional drivers and applications, incorporate build-to-order customer information, and test the Windows installation. To run Sysprep in factory mode, use the command line Sysprep -factory.

FAT

See definition for: file allocation table (FAT)

FAT32

A derivative of the file allocation table (FAT) file system. FAT32 supports smaller cluster sizes and larger volumes than FAT, which results in more efficient space allocation on FAT32 volumes.

See also: file allocation table (FAT)

fault tolerance

The ability of computer hardware or software to ensure data integrity when hardware failures occur. Fault-tolerant features appear in many server operating systems and include mirrored volumes, RAID-5 volumes, and server clusters.

See also: cluster; mirrored volume; RAID-5 volume

file allocation table (FAT)

A file system used by MS-DOS and other Windows operating systems to organize and manage files. The file allocation table (FAT) is a data structure that Windows creates when you format a volume by using the FAT or FAT32 file systems. Windows stores information about each file in the FAT so that it can retrieve the file later.

See also: FAT32; file system; NTFS file system

file copy

The first of the three stages of Setup, where the Windows program files and any additional files specified are copied to the computers hard disk.

file system

In an operating system, the overall structure in which files are named, stored, and organized. NTFS, FAT, and FAT32 are types of file systems.

See also: FAT; FAT32; NTFS file system

File Transfer Protocol (FTP)

A member of the TCP/IP suite of protocols, used to copy files between two computers on the Internet. Both computers must support their respective FTP roles: one must be an FTP client and the other an FTP server.

See also: Transmission Control Protocol/Internet Protocol (TCP/IP)

firmware

Software routines and low-level input/output instructions stored in read-only memory (ROM). Unlike random-access memory (RAM), read-only memory stays intact even in the absence of electrical power.

See also: random access memory (RAM); read-only memory (ROM)

first-run experience

The software the end user sees the first time they start a new computer. The first-run experience is known as Windows Welcome in Windows XP and Mini-Setup in the Windows Server family of operating systems.

See also: Windows Welcome

flash the BIOS

The process of updating the computer’s BIOS software with a new version.

See also: basic input/output system (BIOS)

font

A graphic design applied to a collection of numbers, symbols, and characters. A font describes a certain typeface, along with other qualities such as size, spacing, and pitch.

See also: OpenType fonts

foreground program

The program that runs in the active window (the uppermost window with the highlighted title bar). The foreground program responds to commands issued by the user.

forest

One or more Active Directory domains that share the same class and attribute definitions (schema), site and replication information (configuration), and forest-wide search capabilities (global catalog). Domains in the same forest are linked with two-way, transitive trust relationships.

See also: Active Directory; domain

free space

Available space that you use to create logical drives within an extended partition.

See also: extended partition; logical drive; unallocated space

furigana name

Tiny Japanese kana characters written above or next to kanji characters. The kana characters indicate the correct pronunciation of the word written in kanji.

G

glyph

A graphical representation of either a character, a part of a character, or a sequence of characters.

GPT

See definition for: GUID partition table (GPT)

graceful recovery

Termination of a process that allows the operating system or parent process to regain normal control. Does not crash the machine or result in a general protection default (GPF) or blue screen. The user is not required to close the application, and can continue to use the other functionality.

graphical user interface (GUI)

A display format, like that of Windows, that represents a program's functions with graphic images such as buttons and icons. GUIs allow a user to perform operations and make choices by pointing and clicking with a mouse.

group account

A collection of user accounts. By making a user account a member of a group, you give the related user all the rights and permissions granted to the group.

See also: user account

Group Policy

The infrastructure within Active Directory directory service that enables directory-based change and configuration management of user and computer settings, including security and user data. You use Group Policy to define configurations for groups of users and computers. With Group Policy, you can specify policy settings for registry-based policies, security, software installation, scripts, folder redirection, remote installation services, and Internet Explorer maintenance. The Group Policy settings that you create are contained in a Group Policy object (GPO). By associating a GPO with selected Active Directory system containers—sites, domains, and organizational units—you can apply the GPO's policy settings to the users and computers in those Active Directory containers. To create an individual GPO, use the Group Policy Object Editor.

See also: Active Directory

GUI-mode Setup

The third of the three stages of Setup, during which the computers hardware and network settings are configured, you are prompted to provide an Administrator password, and you can personalize the installation.

GUID partition table (GPT)

A disk-partitioning scheme that is used by the Extensible Firmware Interface (EFI) in Itanium-based computers. GPT offers more advantages than master boot record (MBR) partitioning because it allows up to 128 partitions per disk, provides support for volumes up to 18 exabytes in size, allows primary and backup partition tables for redundancy, and supports unique disk and partition IDs (GUIDs).

See also: Extensible Firmware Interface (EFI); Itanium; master boot record (MBR)

H

HAL

See definition for: hardware abstraction layer (HAL)

hardware abstraction layer (HAL)

A thin layer of software provided by the hardware manufacturer that hides, or abstracts, hardware differences from higher layers of the operating system. By means of the filter provided by the HAL, different types of hardware look alike to the rest of the operating system. This allows the operating system to be portable from one hardware platform to another. The HAL also provides routines that allow a single device driver to support the same device on all platforms.

hardware branch

The hardware archive root key in the registry that is a superset of the memory-resident hardware tree. Although the hardware tree contains information only about those devices currently detected and running in the system, the registry contains a complete list of all hardware ever installed on the particular computer. The hardware root key is \\HKEY-LOCAL-MACHINE\Hardware.

Hardware Compatibility List (HCL)

A hardware list that Microsoft compiles for a specific product. The Windows HCL, which is posted on the Web, lists the hardware devices and computer systems that are compatible with specific versions of Windows.

See also: device

hardware ID

A vendor-defined string used by the Plug and Play Manager to find the correct .inf file to install a particular device.

See also: .inf file; Plug and Play

hardware tree

A record in RAM of the current system configuration based on the information for all devices in the hardware branch of the registry. The hardware tree is created each time the system is started or whenever a dynamic change occurs to the system configuration.

See also: hardware branch

hardware type

A classification for similar devices. For example, Imaging Device is a hardware type for digital cameras and scanners.

See also: device

hash

A fixed-size result that is obtained by applying a one-way mathematical function (sometimes called a hash algorithm) to an arbitrary amount of data. If there is a change in the input data, the hash changes. The hash can be used in many operations, including authentication and digital signing. Also called a message digest.

See also: authentication; hash algorithm

hash algorithm

An algorithm used to produce a hash value of some piece of data, such as a message or session key. A good hash algorithm has a quality where changes in the input data can change every bit in the resulting hash value; for this reason, hashes are useful in detecting any modification in a large data object, such as a message. Furthermore, a good hash algorithm makes it computationally infeasible to construct two independent inputs that have the same hash. Typical hash algorithms include MD2, MD4, MD5, and SHA-1. Also called a hash function.

HCL

See definition for: Hardware Compatibility List (HCL)

HCT

Hardware Compatibility Tests. A suite of tests from WHQL to verify hardware and device driver operations under a specific operating environment. These tests exercise the combination of a device, a software driver, and an operating system under controlled conditions to verify that all components operate properly.

See also: Windows Hardware Quality Labs (WHQL)

Help and Support Center

A unified place where a user can access all Help and Support content and services from both Microsoft and the OEM.

hidden partition

A partition that is not visibly exposed to the user. To create a hidden partition, set the partition type to one not recognized by Windows.

hive

A file in which the system stores a portion of the registry (named for their resemblance to the cellular structure of a beehive). A hive is backed by a single file and a .log file, which are in either the systemroot\System32\Config folder or the systemroot\Profiles\username folder.

By default, most hive files (Default, SAM, Security, and System) are stored in the systemroot\System32\Config folder. The systemroot\Profiles folder contains the user profile for each user of the computer. Because a hive is a file, it can be moved from one system to another. However, you must use the Registry Editor, Regedit.exe, to edit the file.

See also: key; registry; systemroot

hotfix

An update to address an issue identified after a software product has been distributed. Hotfix distribution is limited by its licensing terms.

hub

A common connection point for devices in a network. Typically used to connect segments of a local area network (LAN), a hub contains multiple ports. When data arrives at one port, it is copied to the other ports so that all segments of the LAN can see the data.

See also: local area network (LAN); port

Hypertext Markup Language (HTML)

A simple markup language used to create hypertext documents that are portable from one platform to another. HTML files are simple ASCII text files with codes embedded (indicated by markup tags) to denote formatting and hypertext links.

See also: American Standard Code for Information Interchange (ASCII)

I

I/O

See definition for: input/output (I/O) port

I/O request packet (IRP)

Data structures that drivers use to communicate with each other.

IA-PC

Intel Architecture Personal Computer. A general descriptive term for computers built with processors conforming to the architecture defined by the Intel processor family based on the 486 instruction set and having an industry-standard PC architecture.

icon character

The animated icon from the Help and Support Center that guides users through their first-run experience, or Windows Welcome.

See also: Windows Welcome

IDE

See definition for: integrated device electronics (IDE)

IEEE

Institute of Electrical and Electronics Engineers, founded in 1963. IEEE is an organization composed of engineers, scientists, and students, best known for developing standards for the computer and electronics industry.

IEEE 1394

A standard for high-speed serial devices such as digital video and digital audio editing equipment.

See also: device

IHV

See definition for: independent hardware vendor (IHV)

IIS

See definition for: Internet Information Services (IIS)

image

A collection of files and folders (sometimes compressed into one file) that duplicates the original file and folder structure of an operating system. It often contains other files added by the OEM or corporation.

image resolution

The fineness or coarseness of an image as it is digitized, measured in dots per inch (DPI), typically ranging from 200 to 400 DPI.

in-box driver

A driver contained in the Driver.cab file, located in the i386 folder on the Windows CD. The Plug and Play hardware IDs for in-box drivers are specified in Machine.inf, Scsi.inf, Pnpscsi.inf, and Mshdc.inf.

independent hardware vendor (IHV)

A company that manufactures hardware devices and the associated device drivers.

independent software vendor (ISV)

A third-party software developer; an individual or an organization that independently creates computer software.

Input language

A Regional and Language Options setting that specifies the combination of the language being entered and the keyboard layout, Input Method Editor (IME), speech-to-text converter, or other device being used to enter it. Formerly known as input locale.

See also: Input Method Editor (IME)

input locale

See definition for: Input language

Input Method Editor (IME)

Programs used to enter the thousands of different characters in written Asian languages with a standard 101-key keyboard. An IME consists of both an engine that converts keystrokes into phonetic and ideographic characters and a dictionary of commonly used ideographic words. As the user enters keystrokes, the IME engine attempts to identify which character or characters the keystrokes should be converted into.

input/output (I/O) port

A channel through which data is transferred between a device and the microprocessor. The port appears to the microprocessor as one or more memory addresses that it can use to send or receive data.

See also: device; memory address; port

install

When referring to software, to add program files and folders to your hard disk and related data to your registry so that the software runs properly. Installing contrasts with upgrading, where existing program files, folders, and registry entries are updated to a more recent version.

When referring to hardware, to physically connect the device to your computer, to load device drivers onto your computer, and to configure device properties and settings.

See also: device driver; registry

integrated device electronics (IDE)

A type of disk-drive interface in which the controller electronics reside on the drive itself, eliminating the need for a separate adapter card. IDE offers advantages such as look-ahead caching to increase overall performance.

internet

internet. Two or more network segments connected by routers. Another term for internetwork.

Internet. A worldwide network of computers. If you have access to the Internet, you can retrieve information from millions of sources, including schools, governments, businesses, and individuals.

See also: World Wide Web

Internet address

An address for a resource on the Internet that is used by Web browsers to locate Internet resources. An Internet address typically starts with a protocol name, followed by the name of the organization that maintains the site; the suffix identifies the kind of organization it is. For example, the address http://www.yale.edu/ provides the following information:

  • http: This Web server uses the Hypertext Transfer Protocol.
  • www: This site is on the World Wide Web.
  • edu: This is an educational institution.
Internet address is also called Uniform Resource Locator (URL).

See also: protocol; Web server

Internet Information Services (IIS)

Software services that support Web site creation, configuration, and management, along with other Internet functions. Internet Information Services include Network News Transfer Protocol (NNTP), File Transfer Protocol (FTP), and Simple Mail Transfer Protocol (SMTP).

See also: File Transfer Protocol (FTP); Network News Transfer Protocol (NNTP); Simple Mail Transfer Protocol (SMTP)

Internet Protocol (IP)

A routable protocol in the TCP/IP protocol suite that is responsible for IP addressing, routing, and the fragmentation and reassembly of IP packets.

See also: Transmission Control Protocol/Internet Protocol (TCP/IP)

Internet service provider (ISP)

A company that provides individuals or companies access to the Internet and the World Wide Web. An ISP provides a telephone number, a user name, a password, and other connection information so users can connect their computers to the ISP's computers. An ISP typically charges a monthly or hourly connection fee.

See also: Web server

Internetwork Packet Exchange (IPX)

A network protocol native to NetWare that controls addressing and routing of packets within and between LANs. IPX does not guarantee that a message will be complete (no lost packets).

See also: Internetwork Packet Exchange/Sequenced Packet Exchange (IPX/SPX); local area network (LAN)

Internetwork Packet Exchange/Sequenced Packet Exchange (IPX/SPX)

Transport protocols used in Novell NetWare networks, which together correspond to the combination of TCP and IP in the TCP/IP protocol suite. Windows implements IPX through NWLink.

See also: Internetwork Packet Exchange (IPX); NWLink IPX/SPX/NetBIOS Compatible Transport Protocol (NWLink); Transmission Control Protocol/Internet Protocol (TCP/IP)

interrupt request (IRQ)

A signal sent by a device to get the attention of the processor when the device is ready to accept or send information. Each device sends its interrupt requests over a specific hardware line. Each device must be assigned a unique IRQ number.

interrupt request (IRQ) lines

Hardware lines over which devices can send signals to get the attention of the processor when the device is ready to accept or send information. Each device must have a unique IRQ line.

See also: device; interrupt request (IRQ)

IP address

A 32-bit address used to identify a node on an IP internetwork. Each node on the IP internetwork must be assigned a unique IP address, which is made up of the network ID, plus a unique host ID. This address is typically represented with the decimal value of each octet separated by a period (for example, 192.168.7.27). You can configure the IP address statically or dynamically by using DHCP.

See also: Dynamic Host Configuration Protocol (DHCP); IP address; node

IRP

See definition for: I/O request packet (IRP)

IRQ

See definition for: interrupt request (IRQ)

isochronous

Time dependent. Refers to processes where data must be delivered within certain time constraints. Multimedia streams require an isochronous transport mechanism to ensure that data is delivered as fast as it is displayed, and to ensure that the audio is synchronized with the video.

isolation

The Plug and Play process by which cards on an ISA bus are distinguished from each other after system startup.

ISP

See definition for: Internet service provider (ISP)

ISP sign-up server

An HTTP server that automates the task of adding new customers to an ISP's customer database. The Internet sign-up server collects information from each customer, adds the information to the ISP's customer database, and then passes a configuration packet back to the customer's desktop computer. The configuration packet contains information that is used to configure the customer's Internet browser for subsequent connection to the ISP's services.

ISP signup offer

A set of HTML pages in Windows Welcome that allows end users to sign up for Internet access from a particular Internet service provider.

ISV

See definition for: independent software vendor (ISV)

Itanium

An Intel microprocessor that uses explicitly parallel instruction set computing and 64-bit memory addressing.

J

There are no glossary terms that begin with this letter.

K

kernel

The core of layered architecture that manages the most basic operations of the operating system and the computer's processor. The kernel schedules different blocks of executing code, called threads, for the processor to keep it as busy as possible and coordinates multiple processors to optimize performance. The kernel also synchronizes activities among Executive-level subcomponents, such as I/O Manager and Process Manager, and handles hardware exceptions and other hardware-dependent functions. The kernel works closely with the hardware abstraction layer.

kernel mode

A highly privileged mode of operation where program code has direct access to all memory, including the address spaces of all user-mode processes and applications, and to hardware. Also known as supervisor mode, protected mode, or Ring 0.

kernel-mode driver

Driver for a logical, virtual, or physical device.

key

In Registry Editor, a folder that appears in the left pane of the Registry Editor window. A key can contain subkeys and entries. For example, Environment is a key of HKEY_CURRENT_USER.

In IP security (IPSec), a value used in combination with an algorithm to encrypt or decrypt data. Key settings for IPSec are configurable to provide greater security.

See also: registry; subkey

L

label

Each part of a full DNS domain name that represents a node in the domain namespace tree. Domain names are made up of a sequence of labels, such as the three labels (example, microsoft, and com) that make up the DNS domain name example.microsoft.com. Each label used in a DNS name must be 63 bytes or less in character length.

See also: domain name; node

LAN

See definition for: local area network (LAN)

Language for non-Unicode programs

A Regional and Language Options setting that specifies the default code pages and associated bitmap font files for a specific computer that affects all of that computer's users. The default code pages and fonts enable a non-Unicode application written for one operating system language version to run correctly on another operating system language version. Formerly known as system locale.

language group

A term used to describe the supported script families in Microsoft Windows.

Language ID

A 16-bit value which consists of a primary and a secondary language ID. Bits 0-9 make up the primary language ID and bits 10-15 comprise the sub-language ID.

Layer Two Tunneling Protocol (L2TP)

An industry-standard Internet tunneling protocol that provides encapsulation for sending Point-to-Point Protocol (PPP) frames across packet-oriented media. For IP networks, L2TP traffic is sent as User Datagram Protocol (UDP) messages. In Microsoft operating systems, L2TP is used in conjunction with Internet Protocol security (IPSec) as a virtual private network (VPN) technology to provide remote access or router-to-router VPN connections. L2TP is described in RFC 2661.

See also: Point-to-Point Protocol (PPP)

layered driver

One of a collection of drivers that responds to the same IRPs. Layered driver describes the highest-level and lowest-level drivers in a chain of layered drivers that process the same IRPs, along with all intermediate drivers in the chain.

LBA

Logical block addressing. A method used with SCSI and IDE disk drives to translate the cylinder, head, and sector specifications of the drive into addresses that can be used by an enhanced BIOS. LBA is used with drives that are larger than 528MB.

lease

The length of time for which a DHCP client can use a dynamically assigned IP address configuration. Before the lease time expires, the client must either renew or obtain a new lease with DHCP.

See also: Dynamic Host Configuration Protocol (DHCP); IP address

legacy

Any feature in the computer system based on older technology for which compatibility continues to be maintained in other system components.

license

The right of a person or company to use software in a particular way, as described in the terms of the license agreement. Copyright law also limits how a person may use the software. A person needs a license agreement for each software program they use.

Lightweight Directory Access Protocol (LDAP)

The primary access protocol for Active Directory. LDAP is an industry-standard protocol, established by the Internet Engineering Task Force (IETF), that allows users to query and update information in a directory service. Active Directory supports both LDAP version 2 and LDAP version 3.

See also: Active Directory; protocol

local area network (LAN)

A communications network connecting a group of computers, printers, and other devices located within a relatively limited area (for example, a building). A LAN allows any connected device to interact with any other on the network.

See also: NetBIOS Extended User Interface (NetBEUI); network basic input/output system (NetBIOS); workgroup

local bus

Usually refers to a system bus directly connected to the microprocessor on a system board. Local bus is used colloquially to refer to system board buses located closer to the microprocessor than ordinary expansion buses (thus requiring less buffering), which make them capable of greater throughput.

Locale

A group of user preference information, such as date and time formatting, represented as a list of values related to the user's language and sublanguage.

Locale ID

A 32-bit value which consists of the language ID in the low word (bits 0-15) and the sorting ID (bits 16-19) and a reserved value (bits 20-31) in the high word.

logical drive

A volume that you create within an extended partition on a basic master boot record (MBR) disk. Logical drives are similar to primary partitions, except that you are limited to four primary partitions per disk, whereas you can create an unlimited number of logical drives per disk. A logical drive can be formatted and assigned a drive letter.

See also: basic disk; basic volume; extended partition; master boot record (MBR); primary partition

long file name

A folder or file name longer than the 8.3 file name standard (up to eight characters followed by a period and an extension of up to three characters). Most versions of Windows, including Windows XP, Windows 2000, Window NT, Windows 95, and Windows 98 support long file names up to 255 characters.

LPT device

See definition for: parallel device

M

mass-storage controller

A device on which mass-storage devices rely for access to a computer subsystem. For example, a SCSI card or IDE functionality lon the motherboard is a mass-storage controller; the physical hard drive is a mass-storage device.

mass-storage device

A generic term for disk, optical disk, or other device that provides persistent storage for computer data.

master boot record (MBR)

The first sector on a hard disk, which begins the process of starting the computer. The MBR contains the partition table for the disk and a small amount of executable code called the master boot code.

See also: partition boot sector; Recovery Console

master computer

A fully-assembled computer containing a master installation.

See also: master installation

master file table (MFT)

An NTFS system file on NTFS-formatted volumes that contains information about each file and folder on the volume. The MFT is the first file on an NTFS volume.

See also: file allocation table (FAT); NTFS file system

master installation

A customized installation of Windows that an OEM plans to duplicate onto one or more destination computers.

memory address

A portion of computer memory that can be allocated to a device or used by a program or the operating system. Devices are usually allocated a range of memory addresses.

See also: device

Message Queuing

A message queuing and routing system for Windows that enables distributed applications running at different times to communicate across heterogeneous networks and with computers that may be offline. Message Queuing provides guaranteed message delivery, efficient routing, security, and priority-based messaging. Formerly known as MSMQ.

See also: MSMQ

MFU list

Most-frequently used list. A list of applications that the end user has recently used.

Microsoft Management Console (MMC)

A framework for hosting administrative tools called snap-ins. A console might contain tools, folders or other containers, World Wide Web pages, and other administrative items. These items are displayed in the left pane of the console, called a console tree. A console has one or more windows that can provide views of the console tree. The main MMC window provides commands and tools for authoring consoles. The authoring features of MMC and the console tree itself might be hidden when a console is in User Mode.

See also: console tree; snap-in

Microsoft OEM System Builder Agreement

The license agreement between a system builder and Microsoft Licensing, Inc., affixed to the side of every OEM Distribution Pack. By opening the package, you agree to all the terms of the Microsoft OEM System Builder Agreement. If you do not agree to all the terms of the agreement, contact the Microsoft OEM authorized distributor it was purchased from and make arrangements to return the software.

Microsoft Reserved (MSR) partition

A required partition on every GUID partition table (GPT) disk. System components can allocate portions of the MSR partition into new partitions for their own use. For example, when you convert a basic GPT disk to dynamic, the system allocates a portion of the MSR partition to be used as the Logical Disk Manager (LDM) metadata partition. The MSR partition varies in size based on the size of the GPT disk. For disks smaller than 16 GB, the MSR partition is 32 MB. For disks larger than 16 GB, the MSR partition is 128 MB. The MSR partition is not visible in Disk Management, and you cannot store data on the MSR partition or delete it.

See also: GUID partition table (GPT); partition

MIDI

Musical Instrument Digital Interface. An industry-standard connection for computer control of musical instruments and devices. A hardware and data standard for communication between hardware. Most references involve only the data standard, which is a byte stream used for controlling musical instruments and storing the output of such instruments.

Mini-Setup

A subset of GUI-mode Setup, Mini-Setup is the first-run experience on the Windows Server family of products. Mini-Setup prompts for user-specific information, detects new hardware, and regenerates system IDs.

MIPS

Millions of instructions per second. A common measure of processor speed.

mirrored volume

A fault-tolerant volume that duplicates data on two physical disks. A mirrored volume provides data redundancy by using two identical volumes, which are called mirrors, to duplicate the information contained on the volume. A mirror is always located on a different disk. If one of the physical disks fails, the data on the failed disk becomes unavailable, but the system continues to operate in the mirror on the remaining disk. You can create mirrored volumes only on dynamic disks on computers running the Windows 2000 Server or Windows .NET Server families of operating systems. You cannot extend mirrored volumes.

See also: dynamic disk; dynamic volume; fault tolerance; RAID-5 volume

mixed mode

In a Windows 2000 domain, the default domain mode setting. Mixed mode allows Windows NT-based backup domain controllers to coexist with Windows 2000-based domain controllers. Mixed mode does not support universal groups or the nesting of groups. You can change the domain mode setting to native mode when all Windows NT-based domain controllers are removed from a domain.

In Windows .NET domains, mixed mode is referred to as Windows 2000 mixed, and it is one of three domain functional levels available.

See also: Active Directory; native mode

modem (modulator/demodulator)

A device that allows computer information to be transmitted and received over a telephone line. The transmitting modem translates digital computer data into analog signals that can be carried over a phone line. The receiving modem translates the analog signals back to digital form.

See also: port; Telephony API (TAPI)

monochrome

A monitor that displays images in only one color, or displays only variable levels of a single color, such as a gray-scale monitor.

monolithic driver

A driver that contains many different classes of functionality.

motherboard

The main circuit board of a microcomputer. The motherboard contains the connectors for attaching additional boards.

mount point

See definition for: volume mount point

MP3

Acronym for MPEG Audio Layer-3. A digital audio coding scheme used to distribute recorded music over the Internet. MP3 shrinks the size of an audio file by a factor of 10 to 12 without degrading the quality (CD-recording level) of the sound.

MPEG Audio Layer-3

A digital audio coding scheme used to distribute recorded music over the Internet. MP3 shrinks the size of an audio file by a factor of 10 to 12 without degrading the quality (CD-recording level) of the sound.

MSDN

Microsoft Developer Network.

MSMQ

The message queuing and routing system for Windows NT 4.0, Windows 95, and Windows 98. For Windows 2000, Windows XP, and the Windows .NET Server family, this feature is called Message Queuing.

See also: Message Queuing

Multi-Language User Interface (MUI)

A separate, stand-alone release of Windows that includes user interface resources for each supported language. MUI allows users to set the user-interface language according to their preferences, provided the required language files are present on the computer. It is designed to allow large corporations to deploy a single version of Windows worldwide, while allowing their local users or groups to select the user-interface language. The following items are not localized in MUI versions: all 16-bit code, bitmaps, registry keys and values, folders and file names, and .inf files.

MultiByte Character Set (MBCS)

A mixed-width character set, in which some characters consist of more than 1 byte. A double byte character set (DBCS), which is a specific type of multibyte character set, includes some characters that consist of 1 byte and some characters that consist of 2 bytes.

multimedia

Refers to the delivery of information that combines different content formats, such as video, audio, still images, graphics, animation, and text.

multiprocessor

Two or more connected and roughly equal processors that can each carry out one or more processes (programs or sets of instructions) in tandem.

N

name resolution

The process of having software translate between names that are easy for users to work with and numerical IP addresses, which are difficult for users but necessary for TCP/IP communications. Name resolution can be provided by software components such as DNS or WINS.

See also: Transmission Control Protocol/Internet Protocol (TCP/IP); Windows Internet Name Service (WINS)

native mode

In Windows 2000 domains, the domain mode in which all domain controllers in a domain are running Windows 2000 and a domain administrator has switched the domain operation mode from mixed mode to native mode. Native mode supports universal groups and nesting of groups. In native mode, domain controllers running Windows NT 4.0 or earlier are not supported.

In Windows .NET domains, native mode is referred to as Windows 2000 native, and it is one of three domain functional levels available.

See also: Active Directory; mixed mode

NCW

See definition for: New Connection Wizard (NCW)

NetBEUI

See definition for: NetBIOS Extended User Interface (NetBEUI)

NetBIOS Extended User Interface (NetBEUI)

A network protocol native to Microsoft Networking. It is usually used in small, department-size local area networks (LANs) of 1 to 200 clients. It can use Token Ring source routing as its only method of routing. It is the Microsoft implementation of the NetBIOS standard.

See also: local area network (LAN); network basic input/output system (NetBIOS); protocol

network adapter

A device that connects your computer to a network. Sometimes called an adapter card or network interface card.

network basic input/output system (NetBIOS)

An application programming interface (API) that can be used by programs on a local area network (LAN). NetBIOS provides programs with a uniform set of commands for requesting the lower-level services required to manage names, conduct sessions, and send datagrams between nodes on a network.

See also: application programming interface (API); basic input/output system (BIOS); local area network (LAN); node; service

network card

See definition for: network interface card (NIC)

network card driver

A device driver that works directly with the network card, acting as an intermediary between the card and the protocol driver.

network interface card (NIC)

An expansion card or other device used to provide network access to a computer or other device, such as a printer. Network interface cards mediate between the computer and physical media, such as cabling, over which transmissions travel. Also called network adapter or network card.

Network News Transfer Protocol (NNTP)

A member of the TCP/IP suite of protocols used to distribute network news messages to NNTP servers and clients (newsreaders) on the Internet. NNTP is designed so that news articles are stored on a server in a central database, thus enabling a user to select specific items to read.

See also: Transmission Control Protocol/Internet Protocol (TCP/IP)

New Connection Wizard (NCW)

A tool that helps users sign up for Internet service and automatically handles the software configuration steps necessary for gaining access to the Internet.

NIC

See definition for: network interface card (NIC)

node

For tree structures, a location on the tree that can have links to one or more items below it.

For local area networks (LANs), a device that is connected to the network and is capable of communicating with other network devices.

For server clusters, a computer system that is an active or inactive member of a cluster.

See also: local area network (LAN); server cluster

non-spacing character

A character, such as diacritic, that has no meaning by itself, but overlaps a base character to modify it, sometimes referred to as a "combining character".

NTFS file system

An advanced file system that provides performance, security, reliability, and advanced features that are not found in any version of FAT. For example, NTFS guarantees volume consistency by using standard transaction logging and recovery techniques. If a system fails, NTFS uses its log file and checkpoint information to restore the consistency of the file system. NTFS also provides advanced features such as file and folder permissions, encryption, disk quotas, and compression.

See also: FAT32; file allocation table (FAT); file system

NWLink

See definition for: NWLink IPX/SPX/NetBIOS Compatible Transport Protocol (NWLink)

NWLink IPX/SPX/NetBIOS Compatible Transport Protocol (NWLink)

An implementation of the Internetwork Packet Exchange (IPX), Sequenced Packet Exchange (SPX), and NetBIOS protocols used in Novell networks. NWLink is a standard network protocol that supports routing and can support NetWare client-server applications, where NetWare-aware Sockets-based applications communicate with IPX/SPX Sockets-based applications.

See also: Internetwork Packet Exchange/Sequenced Packet Exchange (IPX/SPX); network basic input/output system (NetBIOS)

O

object

An entity, such as a file, folder, shared folder, printer, or Active Directory object, described by a distinct, named set of attributes. For example, the attributes of a File object include its name, location, and size; the attributes of an Active Directory User object might include the user's first name, last name, and e-mail address.

For OLE and ActiveX, an object can also be any piece of information that can be linked to, or embedded into, another object.

See also: attribute; child object; parent object

OEM

See definition for: original equipment manufacturer (OEM)

OEM branding

To incorporate a company name, logo, support information, and Help files into the Microsoft Windows installation.

OEM ISP sign-up offer

A set of HTML pages created by either the OEM or a third-party company that lets end users sign up for Internet access from a particular Internet service provider (ISP). You can incorporate these pages into Windows Welcome, or include a shortcut to the first page of the OEM link on the Start menu.

See also: OEM link; Windows Welcome

OEM License Agreement

A legal agreement between Microsoft Licensing, Inc., and OEMs regarding the terms of preinstalling, customizing, and distributing Microsoft Windows. For System Builders, the corresponding agreement is affixed to the side of every OEM Distribution Pack. By opening the package you agree to all the terms of the Microsoft OEM System Builder Agreement. For royalty OEMs, the license agreement is a signed contract. The specific requirements and customization options that apply to either or both license agreements is documented in the OPK User's Guide.

See also: Microsoft OEM System Builder Agreement; royalty OEM; system builder

OEM link

A link on the Start menu where OEMs can place any desired links or shortcuts.

OEM Preinstallation Kit (OPK)

A set of tools, documentation, and samples that enable OEMs to efficiently preinstall Windows on new computers according to the terms of the OEM Licensing Agreement.

Oem.chm

The HTML Help file that you customize to provide OEM-specific support information in Windows Help.

Oeminfo.ini

A file used to provide required OEM information, such as company name, computer model, company telephone number, and customer support information.

OnNow

See definition for: Advanced Configuration and Power Interface (ACPI)

OOBE

See definition for: Windows Welcome

OpenType fonts

Outline fonts that are rendered from line and curve commands, and can be scaled and rotated. OpenType fonts are clear and readable in all sizes and on all output devices supported by Windows. OpenType is an extension of TrueType font technology.

See also: font

OPK

See definition for: OEM Preinstallation Kit (OPK)

original equipment manufacturer (OEM)

A company that typically purchases computer components from other manufacturers, uses the components to build a personal computer, preinstalls Windows onto that computer, and then sells the computer to the public.

Out-Of-Box Experience (OOBE)

See definition for: Windows Welcome

P

paging file

A hidden file or files on the hard disk that Windows uses to hold parts of programs and data files that do not fit in memory. The paging file and physical memory, or RAM, comprise virtual memory. Windows moves data from the paging file to memory as needed and moves data from memory to the paging file to make room for new data. Also known as a swap file.

parallel device

A device that uses a parallel connection.

parent object

An object in which another object resides. For example, a folder is a parent object in which a file, or child object, resides. An object can be both a parent and a child object. For example, a subfolder that contains files is both the child of the parent folder and the parent folder of the files.

See also: child object; object

partition

A portion of a physical disk that functions as though it were a physically separate disk. After you create a partition, you must format it and assign it a drive letter before you can store data on it.

On basic disks, partitions are known as basic volumes, which include primary partitions and logical drives. On dynamic disks, partitions are known as dynamic volumes, which include simple, striped, spanned, mirrored, and RAID-5 volumes.

See also: basic disk; basic volume; dynamic volume; extended partition; primary partition; system partition

partition boot sector

A portion of a hard disk partition that contains information about the disk's file system and a short machine language program that loads the Windows operating system.

See also: partition

passport

A single sign-in service that lets you use a single name and password on multiple participating Web sites.

password

A security measure used to restrict logon names to user accounts and access to computer systems and resources. A password is a string of characters that must be provided before a logon name or an access is authorized. A password can be made up of letters, numbers, and symbols, and it is case sensitive.

See also: user account

PC Card

A removable device, approximately the size of a credit card, that can be plugged into a Personal Computer Memory Card International Association (PCMCIA) slot in a portable computer. PCMCIA devices can include modems, network cards, and hard disk drives.

See also: modem (modulator/demodulator)

PC Health

A suite of technologies and features focused on providing end users with improved technical support by enabling web-based support solutions. PC Health also provides better operating system reliability, and an enhanced end-user experience, by providing easier access to help content and support services.

PCMCIA device

A removable device, approximately the size of a credit card, that can be plugged into a PCMCIA slot in a portable computer. PCMCIA devices can include modems, network adapters, and hard disk drives.

Some PCMCIA cards can be connected to and disconnected from your computer without restarting it. Before you remove the PCMCIA card, however, you should use the Add Hardware Wizard to notify Windows that you are doing so. Windows will then notify you when you can remove the device.

permission

A rule associated with an object to regulate which users can gain access to the object and in what manner. Permissions are granted or denied by the object's owner.

See also: object

PIC

Programmable Interrupt Controller. This type of hardware cannot be used in computers with multiple processes, and the processing speed is slower than similar APIC hardware.

piracy

Unauthorized copying, distribution, and use of computer software, or software theft.

pixels

An abbreviation for picture elements. The minimum raster display element, represented as a point, with a specified color or intensity level. One way to measure picture resolution is by the number of pixels used to create images.

Plug and Play

A set of specifications developed by Intel Corporation that allows a computer to automatically detect and configure a device and install the appropriate device drivers.

See also: universal serial bus (USB)

Plug and Play BIOS

A BIOS with responsibility for configuring Plug and Play cards and system-board devices during system power up. Provides runtime configuration services for system board devices after startup.

See also: Advanced Configuration and Power Interface (ACPI); BIOS; system board

Point-to-Point Protocol (PPP)

An industry standard suite of protocols for the use of point-to-point links to transport multiprotocol datagrams. PPP is documented in RFC 1661.

See also: remote access; Transmission Control Protocol/Internet Protocol (TCP/IP)

Point-to-Point Tunneling Protocol (PPTP)

Networking technology that supports multiprotocol virtual private networks (VPNs), enabling remote users to access corporate networks securely across the Internet or other networks by dialing into an Internet service provider (ISP) or by connecting directly to the Internet. PPTP tunnels, or encapsulates, IP, IPX, or NetBEUI traffic inside of IP packets. This means that users can remotely run applications that are dependent upon particular network protocols.

See also: Internet Protocol (IP); Internetwork Packet Exchange (IPX); NetBIOS Extended User Interface (NetBEUI)

populate

To import prepared data using a software procedure rather than the end user entering the information.

port

A connection point on your computer where you can connect devices that pass data into and out of a computer. For example, a printer is typically connected to a parallel port (also called an LPT port), and a modem is typically connected to a serial port (also called a COM port).

See also: universal serial bus (USB)

POST

See definition for: power-on self test (POST)

power management

Mechanisms in software and hardware to minimize system power consumption, manage system thermal limits, and maximize system battery life. Power management involves trade-offs among system speed, noise, battery life, processing speed, and power consumption.

power-on self test (POST)

A set of routines stored in read-only memory (ROM) that tests various system components such as RAM, the disk drives, and the keyboard, to see if they are properly connected and operating. If problems are found, these routines alert the user with a series of beeps or a message, often accompanied by a diagnostic numeric value. If the POST is successful, it passes control to the bootstrap loader.

See also: bootstrap loader

Preboot Execution Environment

DHCP-based remote boot technology used to boot or install an operating system on a client computer from a remote server. A RIS Server is an example of a PXE Server.

precached ISP signup offer

See definition for: OEM ISP sign-up offer

precomposed character

A single character that represents a sequence of characters, usually a combination of a base character and one or more diacritics.

preconfigured ISP signup

Configuring the operating system during the manufacturing process to use a specific account for access to the Internet.

predefined key

A key that represents one of the main divisions of the registry. Each predefined key is displayed in a separate Registry Editor window, with the key's name appearing in the window's title bar. For example, HKEY_CLASSES_ROOT is a predefined key.

See also: hive; key; registry

preinstall

To install and configure Windows XP on new computers that are then distributed to end users.

preinstallation

The act of installing and configuring Windows XP on new computers that are then distributed to end users.

Primary disk

The hard disk drive that contains the system and boot partitions used to start Windows.

See also: boot partition; system partition

primary partition

A type of partition that you can create on basic disks. A primary partition is a portion of a physical disk that functions as though it were a physically separate disk. On basic master boot record (MBR) disks, you can create up to four primary partitions on a basic disk, or three primary partitions and an extended partition with multiple logical drives. On basic GPT disks, you can create up to 128 primary partitions. Also known as a volume.

See also: basic disk; extended partition; GUID partition table (GPT); logical drive; master boot record (MBR); partition

private key

The secret half of a cryptographic key pair that is used with a public key algorithm. Private keys are typically used to decrypt a symmetric session key, digitally sign data, or decrypt data that has been encrypted with the corresponding public key.

See also: public key; public key encryption

product activation

See definition for: Windows Product Activation (WPA)

Product Key

A 25-character, alpha-numeric string. Customers must enter this string to activate their installation of Windows. The product key is located on the certificate of authenticity, which is attached to the computer chassis.

property set

A method defined to set and get properties on a driver. Each property set has a unique identifier, which represents types of related information and is used to access the property set.

Protective MBR

The first sector of a GUID partition table (GPT) disk that is structured like the first sector of a master boot record (MBR) disk to prevent x86-based disk utilities from destroying GPT partitions. The Protective MBR contains one partition that reserves the entire space used on the disk by GPT partitions.

See also: Extensible Firmware Interface (EFI); GUID partition table (GPT); master boot record (MBR); x86

protocol

A set of rules and conventions for sending information over a network. These rules govern the content, format, timing, sequencing, and error control of messages exchanged among network devices.

See also: Internet Protocol (IP); Transmission Control Protocol/Internet Protocol (TCP/IP)

proxy

A firewall and content cache server that provides Internet security and improves network performance.

public key

The nonsecret half of a cryptographic key pair that is used with a public key algorithm. Public keys are typically used when encrypting a session key, verifying a digital signature, or encrypting data that can be decrypted with the corresponding private key.

See also: key; private key; public key encryption

public key encryption

A method of encryption that uses two encryption keys that are mathematically related. One key is called the private key and is kept confidential. The other is called the public key and is freely given out to all potential correspondents. In a typical scenario, a sender uses the receiver's public key to encrypt a message. Only the receiver has the related private key to decrypt the message. The complexity of the relationship between the public key and the private key means that, provided the keys are long enough, it is computationally infeasible to determine one from the other. Also called asymmetric encryption.

See also: encryption; private key; public key

public key infrastructure (PKI)

The laws, policies, standards, and software that regulate or manipulate certificates and public and private keys. In practice, it is a system of digital certificates, certification authorities, and other registration authorities that verify and authenticate the validity of each party involved in an electronic transaction. Standards for PKI are still evolving, even though they are being widely implemented as a necessary element of electronic commerce.

See also: certificate; certification authority (CA); public key

PXE

See definition for: Preboot Execution Environment

PXE protocol

An extension to the DHCP protocol that allows information to be sent to network-bootable systems and allows these systems to find RIS servers.

Q

QFE

Quick-Fix Engineering. This is usually referred to as a hotfix.

See also: hotfix

Qmark character

The animated Microsoft agent character in Windows Welcome.

quiet mode

Running a command-line application so that it does not display confirmation messages or any other user interface items that normally appear on screen. The switch for quiet mode is typically /q.

R

RAID-5 volume

A fault-tolerant volume with data and parity striped intermittently across three or more physical disks. Parity is a calculated value that is used to reconstruct data after a failure. If a portion of a physical disk fails, Windows recreates the data that was on the failed portion from the remaining data and parity. You can create RAID-5 volumes only on dynamic disks on computers running the Windows 2000 Server or Windows .NET Server families of operating systems. You cannot mirror or extend RAID-5 volumes. In Windows NT 4.0, a RAID-5 volume was known as a striped set with parity.

See also: dynamic disk; dynamic volume; fault tolerance

RAM

See definition for: random access memory (RAM)

random access memory (RAM)

Memory that can be read from or written to by a computer or other devices. Information stored in RAM is lost when the computer is turned off.

ranking

Windows XP ranks drivers to determine which is the best for a device. The lower the rank, the better the match of the driver to the device.

read-only memory (ROM)

A semiconductor circuit that contains information that cannot be modified.

rebinding state

A state used by DHCP clients to extend and renew their address lease when the current lease is close to expiring. In this state, the client broadcasts to the network to locate any DHCP server that can either renew or replace its currently leased configuration. The rebinding state begins when 87.5 percent of the client's lease time has elapsed.

See also: Dynamic Host Configuration Protocol (DHCP); lease

reboot

To restart a computer by reloading the operating system. This can be done by performing either a cold boot, such as turning the computer off and then back on, or a warm boot, such as turning the computer off by typically pressing CTRL + ALT + DEL, clicking Shut Down, and then clicking Restart.

Recovery Console

A command-line interface that provides a limited set of administrative commands that are useful for repairing a computer.

See also: NTFS file system

recovery media

Media provided by the OEM to the customer that allows the customer to repair or reinstall their installation of Windows.

reduced instruction set computing

A type of microprocessor design that focuses on rapid and efficient processing of a relatively small set of instructions. RISC architecture limits the number of instructions that are built into the microprocessor, but optimizes each so it can be carried out very rapidly{bmct emdash.bmp}usually within a single clock cycle.

Redundant Array of Independent Disks (RAID)

A method used to standardize and categorize fault-tolerant disk systems. RAID levels provide various mixes of performance, reliability, and cost. Some servers provide three of the RAID levels: Level 0 (striping), Level 1 (mirroring), and Level 5 (RAID-5).

See also: fault tolerance; RAID-5 volume

reference computer

See definition for: technician computer

registration

Providing the user's name, address, and other demographic information to Microsoft or to both Microsoft and the OEM. Registration information is commonly used for marketing purposes. Registration is different from activation; a user may activate their installation of Windows without providing any identification or demographic information.

See also: Windows Product Activation (WPA)

registry

A database repository for information about a computer's configuration. The registry contains information that Windows continually references during operation, such as:

  • Profiles for each user
  • The programs installed on the computer and the types of documents each can create
  • Property settings for folders and program icons
  • What hardware exists on the system
  • Which ports are being used

The registry is organized hierarchically as a tree, and it is made up of keys and their subkeys, hives, and entries.

See also: hive; key; subkey

registry key

An identifier for a record or group of records in the registry.

remote access

Part of the integrated Routing and Remote Access service that provides remote networking for telecommuters, mobile workers, and system administrators who monitor and manage servers at multiple branch offices. Users can use Network Connections to dial in to remotely access their networks for services such as file and printer sharing, electronic mail, scheduling, and SQL database access.

See also: remote access server; service

remote access server

A Windows-based computer running the Routing and Remote Access service and configured to provide remote access.

See also: remote access

Remote Installation Server (RIS)

An optional component that remotely installs Windows XP Professional. RIS installs the operating system on remote boot-enabled client computers by connecting the computer to the network, starting the client computer, logging on with a valid user account, and copying an operating system image to the client computer.

replica

In Active Directory replication, one instance of a logical Active Directory partition that is synchronized by means of replication between domain controllers that hold copies of the same directory partition. Replica can also refer to an instance of an object or attribute in a distributed directory.

In the File Replication service (FRS), a computer that has been included in the configuration of a specific replica set.

reseal

To prepare the operating system for delivery to the end user, after completing any additional processing or validation in the factory. Run Sysprep -reseal at the end of your Factory processing to seal the computer.

resource

Generally, any part of a computer system or network, such as a disk drive, printer, or memory, that can be allotted to a running program or a process.

For Device Manager, any of four system components that control how the devices on a computer work. These four system resources are interrupt request (IRQ) lines, direct memory access (DMA) channels, input/output (I/O) ports, and memory addresses.

For server clusters, a physical or logical entity that is capable of being managed by a cluster, brought online and taken offline, and moved between nodes. A resource can be owned only by a single node at any point in time.

See also: input/output (I/O) port; interrupt request (IRQ) lines; memory address; node; server cluster

RIS

See definition for: Remote Installation Server (RIS)

RISC

See definition for: reduced instruction set computing

root

The highest or uppermost level in a hierarchically organized set of information. The root is the point from which further subsets are branched in a logical sequence that moves from a broad or general focus to narrower perspectives.

See also: root certificate; root certification authority

root certificate

A self-signed certification authority certificate. It is called a root certificate because it is the certificate for the root authority. The root authority must sign its own certificate because by definition there is no higher certifying authority in the certification hierarchy.

See also: certificate; certification authority (CA); root certification authority

root certification authority

The most trusted certification authority (CA), which is at the top of a certification hierarchy. The root CA has a self-signed certificate. Also called the root authority.

See also: certification authority (CA); root

routing

The process of forwarding a packet through an internetwork from a source host to a destination host.

royalty OEM

A computer original equipment manufacturer who has signed a license agreement directly with Microsoft Licensing, Inc. Royalty OEMs receive a "golden master" copy of Windows from Microsoft. The royalty OEM may customize Windows as described in the OPK, their license agreement, or a signed addendum.

RunOnce application

An application that is configured to run the next time the computer is restarted. The application does not run after any subsequent reboots of the system.

S

SBSI

See definition for: Step-by-Step Interactive (SBSI)

script

A type of program consisting of a set of instructions to an application or tool program. A script usually expresses instructions by using the application's or tool's rules and syntax, combined with simple control structures such as loops and if/then expressions. "Batch program" is often used interchangeably with "script" in the Windows environment.

SCSI

See definition for: small computer system interface (SCSI)

seal

See definition for: reseal

security ID (SID)

A data structure of variable length that identifies user, group, and computer accounts. Every account on a network is issued a unique SID when the account is first created. Internal processes in Windows refer to an account's SID rather than the account's user or group name.

See also: group account; user account; user name

serial (COM) device

A string of up to 256 characters with five mandatory fields and ten optional fields, as defined in Section 3 of the Plug and Play External COM Device Specification, v. 1.0.

server

In general, a computer that provides shared resources to network users.

See also: client

server cluster

A group of independent computer systems, known as nodes, working together as a single system to ensure that mission-critical applications and resources remain available to clients. A server cluster is the type of cluster that Cluster service implements.

See also: cluster; node

service

A program, routine, or process that performs a specific system function to support other programs, particularly at a low (close to the hardware) level. When services are provided over a network, they can be published in Active Directory, facilitating service-centric administration and usage. Some examples of services are the Security Accounts Manager service, File Replication service, and Routing and Remote Access service.

service mark

A mark used in the sale or advertising of services to identify and distinguish them from services provided by another company.

Service Pack

A software upgrade to an existing software distribution that contains updated files consisting of patches and hot fixes.

Setup Manager

A utility for creating and modifying answer files and configuration sets.

See also: answer file; configuration set

Setupapi.log

A log file provides valuable information for troubleshooting and debugging Setup, device installation, and related issues. The information stored in the log file includes errors, warnings, and related information from Windows Setup, including time information.

Setupcl.exe

An executable program invoked by Sysprep.exe that recognizes security IDs (SIDs). It must reside in the same folder as Sysprep.exe.

See also: security ID (SID); Sysprep.exe

signature

See definition for: digital signature

signed driver

A driver that meets the criteria of the Windows Logo Program. For performance and stability, Microsoft strongly recommends that you use only signed drivers for new or updated drivers.

Simple Mail Transfer Protocol (SMTP)

A member of the TCP/IP suite of protocols that governs the exchange of electronic mail between message transfer agents.

See also: protocol; Transmission Control Protocol/Internet Protocol (TCP/IP)

Simple TCP/IP Services

Four TCP/IP services: Character Generator, Daytime Discard, Echo, and Quote of the Day.

See also: service; Transmission Control Protocol/Internet Protocol (TCP/IP)

simple volume

A dynamic volume made up of disk space from a single dynamic disk. A simple volume can consist of a single region on a disk or multiple regions of the same disk that are linked together. If the simple volume is not a system volume or boot volume, you can extend it within the same disk or onto additional disks. If you extend a simple volume across multiple disks, it becomes a spanned volume. You can create simple volumes only on dynamic disks. Simple volumes are not fault tolerant, but you can mirror them to create mirrored volumes on computers running the Windows 2000 Server or Windows .NET Server families of operating systems.

See also: dynamic disk; dynamic volume; fault tolerance; mirrored volume; spanned volume

single sign-on

A process that allows a user with a domain account to log on to a network once, using a password or smart card, and to gain access to any computer in the domain.

See also: domain; smart card

single-byte character set

A character encoding in which each character is represented by 1 byte. Single byte character sets are mathematically limited to 256 characters.

skin

A customized user interface that overlays an existing user interface.

SKU

Shelf keeping unit. A particular product; in this case, a particular edition of Windows XP.

small computer system interface (SCSI)

A standard high-speed parallel interface defined by the American National Standards Institute (ANSI). A SCSI interface is used for connecting microcomputers to peripheral devices, such as hard disks and printers, and to other computers and local area networks (LANs).

See also: device; local area network (LAN)

smart card

A credit card–sized device that is used with an access code to enable certificate-based authentication and single sign-on to the enterprise. Smart cards securely store certificates, public and private keys, passwords, and other types of personal information. A smart card reader attached to the computer reads the smart card.

See also: authentication; single sign-on; smart card reader

smart card reader

A device that is installed in computers to enable the use of smart cards for enhanced security features.

See also: smart card

snap-in

A type of tool you can add to a console supported by Microsoft Management Console (MMC). A stand-alone snap-in can be added by itself; an extension snap-in can only be added to extend the function of another snap-in.

See also: Microsoft Management Console (MMC)

spacing character

A character with a non-zero width.

spanned volume

A dynamic volume consisting of disk space on more than one physical disk. You can increase the size of a spanned volume by extending it onto additional dynamic disks. You can create spanned volumes only on dynamic disks. Spanned volumes are not fault tolerant and cannot be mirrored.

See also: dynamic disk; dynamic volume; fault tolerance; mirrored volume; simple volume

stage

Copy the directories and files to be installed to a destination computer, but do not configure any registry settings.

See also: attach; destination computer; detach

standalone server

A computer that runs Windows 2000 Server but does not participate in a domain. A standalone server has only its own database of end users, and it processes logon requests by itself. It does not share account information with any other computer and cannot provide access to domain accounts.

See also: domain

Standards and formats

A Regional and Language Options setting that determines the formats used to display dates, times, currency, numbers, and the sorting order of text. Formerly known as user locale.

Step-by-Step Interactive (SBSI)

Interactive training published by Microsoft Press that is integrated into Windows XP Help and Support Center.

striped volume

A dynamic volume that stores data in stripes on two or more physical disks. Data in a striped volume is allocated alternately and evenly (in stripes) across the disks. Striped volumes offer the best performance of all the volumes that are available in Windows, but they do not provide fault tolerance. If a disk in a striped volume fails, the data in the entire volume is lost. You can create striped volumes only on dynamic disks. Striped volumes cannot be mirrored or extended.

See also: dynamic disk; dynamic volume; fault tolerance; mirrored volume

subkey

An element of the registry that contains entries or other subkeys. A tier of the registry that is immediately below a key or a subtree (if the subtree has no keys).

See also: key; registry; subtree

subtree

Any node within a tree, along with any selection of connected descendant nodes.

The highest level of the registry (for example, HKEY_LOCAL_MACHINE).

See also: key; node; registry; subkey

SVGA

Super VGA. A video standard established by BESA to provide high-resolution color display on IBM-compatible computers.The most commonly implemented SVGA standard is 1024x768 pixels resolution.

synchronous

Each application or command runs in the order listed, and each item must finish before the next command is run.

Syspart

A process that executes through an optional parameter of Winnt32.exe. Used for clean installations to computers that have dissimilar hardware. This automated installation method reduces deployment time by eliminating the file-copy phase of Setup.

Sysprep

A tool that prepares the hard disk on a source computer for duplication to target computers and then runs a non-Microsoft disk-imaging process. This automated installation method is used when the hard disk on the master computer is identical to those of the target computers.

See also: destination computer; first-run experience; security ID (SID)

Sysprep.exe

The System Preparation utility that uses the Sysprep.inf answer file to prepare a system disk image for duplication.

Sysprep.inf

An optional answer file used by Sysprep that automates Mini-Setup and further customizes the installed operating system.

See also: answer file

system board

Also called a motherboard or planar. The primary circuit board in a PC that contains most of the basic components of the system.

system builder

Anyone who purchases an OEM Distribution Pack of Windows (available from distributors) and preinstalls Windows onto new computers. System Builders are subject to the terms of the Microsoft OEM System Builder Agreement attached to the outside of the OEM Distribution Pack.

See also: Microsoft OEM System Builder Agreement

system context

The state of Windows after it first starts when some system services are loaded but no user is logged in and per-user settings are not available.

system devices

Devices on a system board, such as interrupt controllers, keyboard controller, real-time clock, DMA page registers, DMA controllers, memory controllers, FDC, IDE ports, serial and parallel ports, PCI bridges, and so on. In today's PCs, these devices are typically integrated in the supporting chip set.

system drive

The drive letter of the mass-storage device (usually a hard disk) where Windows is installed.

system engineer

A Microsoft employee who assists one or more specific royalty OEMs as they prepare to manufacture computers that will use the version of Microsoft Windows that is currently under development.

System File Protection

See definition for: Windows File Protection (WFP)

system locale

See definition for: Language for non-Unicode programs

system partition

The partition that contains the hardware-specific files needed to load Windows (for example, Ntldr, Osloader, Boot.ini, Ntdetect.com). The system partition can be, but does not have to be, the same as the boot partition.

See also: boot partition; partition

System Restore

A tool that tracks changes to your computer and creates a restore point when it detects the beginning of a change. You can use the System Restore Wizard to select a restore point to restore your computer to an earlier state when your computer was functioning the way you like.

system-locked preinstallation (SLP)

Technology related to Windows Product Activation (WPA) that helps restrict legitimately licensed operating system software to use with the computer system upon which it was originally distributed by a royalty OEM, all in accordance with the license rights granted in the applicable End User License Agreement. Details regarding system-locked preinstallation are available to royalty OEMs in a separate white paper.

systemroot

The path and folder name where the Windows system files are located. Typically, this is C:\Windows, although you can designate a different drive or folder when you install Windows. You can use the value %systemroot% to replace the actual location of the folder that contains the Windows system files. To identify your systemroot folder, click Start, click Run, type %systemroot%, and then click OK.

T

TAM

See definition for: technical account manager (TAM)

TAPI

See definition for: Telephony API (TAPI)

target computer

See definition for: destination computer

taxonomy

In the Windows XP Help and Support Center, the classification system that organizes Help topics into specific categories.

TCP/IP

See definition for: Transmission Control Protocol/Internet Protocol (TCP/IP)

technical account manager (TAM)

A Microsoft employee who provides technical assistance to one or more specific royalty OEMs as they manufacture computers installed with a released version of Microsoft Windows.

technician computer

The computer that you install Setup Manager on. Normally, the configuration sets and the distribution share are also located on this computer.

See also: configuration set; distribution share; Setup Manager

telephony

Telephone technology; voice, fax, or modem transmissions based on either the conversion of sound into electrical signals or wireless communication by means of radio waves.

Telephony API (TAPI)

An application programming interface (API) used by communications programs to work with telephony and network services. Communications programs like HyperTerminal and Phone Dialer use TAPI to dial, answer, and route telephone calls on conventional telephony devices, including PBXs, modems, and fax machines. TAPI 3.0 also provides Internet Protocol (IP) telephony support, which Phone Dialer and other programs use to transmit, route, and control real-time audio and video signals over IP-based networks such as the Internet.

See also: application programming interface (API); Internet Protocol (IP); modem (modulator/demodulator); service

text-mode Setup

The second of the three stages of Setup, where the basic hardware of the computer (CPU, motherboard, hard disk controllers, file systems, and memory) is determined, the base operating system necessary to continue is installed, and specified folders are created.

third-party drivers

Device drivers that are not included in Driver.cab.

See also: Driver.cab

time stamp

A certification by a trusted third party specifying that a particular message existed at a specific time and date. In a digital context, trusted third parties generate a trusted time stamp for a particular message by having a time stamping service append a time value to a message and then digitally signing the result.

See also: digital signature; service

topology

In Windows, the relationships among a set of network components. In the context of Active Directory replication, topology refers to the set of connections that domain controllers use to replicate information among themselves.

See also: Active Directory; domain controller

trail byte

The byte value that is the second half of a double-byte character.

Transmission Control Protocol/Internet Protocol (TCP/IP)

A set of networking protocols widely used on the Internet that provides communications across interconnected networks of computers with diverse hardware architectures and various operating systems. TCP/IP includes standards for how computers communicate and conventions for connecting networks and routing traffic.

See also: Internet Protocol (IP); protocol

Txtsetup.oem

A text file identifying supported hardware components, the files to copy from the distribution disk for the hardware component, and listing the registry keys and values to create for the hardware component. This is used only during text-mode Setup.

U

UCS Transformation Format 8 (UTF-8)

A character set for protocols evolving beyond the use of ASCII. The UTF-8 protocol provides for support of extended ASCII characters and translation of UCS-2, an international 16-bit Unicode character set. UTF-8 enables a far greater range of names than can be achieved using ASCII or extended ASCII encoding for character data.

See also: American Standard Code for Information Interchange (ASCII); Unicode

unallocated space

Available disk space that is not allocated to any volume. The type of volume that you can create on unallocated space depends on the disk type. On basic disks, you can use unallocated space to create primary or extended partitions. On dynamic disks, you can use unallocated space to create dynamic volumes.

See also: basic disk; dynamic disk; extended partition; logical drive; object; partition; primary partition

unattach

See definition for: detach

Unattend.txt

The generic name for the Windows Setup answer file. In the CD boot preinstallation method, Unattend.txt must be named Winnt.sif.

See also: answer file; CD boot; Windows Setup; Winnt.exe

unattended Setup

An automated, hands-free method of installing Windows. During installation, unattended Setup uses an answer file to supply data to Setup instead of requiring that an administrator or end user interactively provide the answers.

UNC

See definition for: Universal Naming Convention (UNC)

uni-processor

A computer with a single processor.

See also: multiprocessor

Unicode

A character encoding standard developed by the Unicode Consortium that represents almost all of the written languages of the world. The Unicode character repertoire has multiple representation forms, including UTF-8, UTF-8, and UTF-32. Most Windows interfaces use the UTF-16 form.

See also: American Standard Code for Information Interchange (ASCII); UCS Transformation Format 8 (UTF-8)

Universal Naming Convention (UNC)

A convention for naming files and other resources beginning with two backslashes (\), indicating that the resource exists on a network computer. UNC names conform to the \\servername\sharename syntax, where servername is the server's name and sharename is the name of the shared resource. The UNC name of a directory or file can also include the directory path after the share name, by using the following syntax: \\servername\sharename\directory\filename.

universal serial bus (USB)

An external bus that supports Plug and Play installation. Using USB, you can connect and disconnect devices without shutting down or restarting your computer. You can use a single USB port to connect up to 127 peripheral devices, including speakers, telephones, CD-ROM drives, joysticks, tape drives, keyboards, scanners, and cameras. A USB port is usually located on the back of your computer near the serial port or parallel port.

See also: bus; Plug and Play; port

USB

See definition for: universal serial bus (USB)

user account

In Active Directory, an object that consists of all the information that defines a domain user, which includes user name, password, and groups in which the user account has membership. User accounts can be stored in either Active Directory or on your local computer.

For computers running Windows XP Professional and member servers running Windows .NET, use Local Users and Groups to manage local user accounts. For domain controllers running Windows .NET, use Active Directory Users and Computers to manage domain user accounts.

See also: Active Directory; object; password; user name

user interface language

The language in which the operating system displays its menus, help files, and dialog boxes.

user locale

See definition for: Standards and formats

user mode

The processing mode in which applications run.

user name

A unique name identifying a user account to Windows. An account's user name must be unique among the other group names and user names within its own domain or workgroup.

See also: domain; user account; workgroup

user password

The password stored in each user's account. Each user generally has a unique user password and must type that password when logging on or accessing a server.

See also: password; user account

user principal name (UPN)

A user account name (sometimes referred to as the user logon name) and a domain name identifying the domain in which the user account is located. This is the standard usage for logging on to a Windows domain. The format is as follows: someone@fabrikam.com (as for an e-mail address).

See also: domain; domain name; user account

user rights

Tasks that a user is permitted to perform on a computer system or domain. There are two types of user rights: privileges and logon rights. An example of a privilege is the right to shut down the system. An example of a logon right is the right to log on to a computer locally. Both types are assigned by administrators to individual users or groups as part of the security settings for the computer.

See also: domain

UTF-8

See definition for: UCS Transformation Format 8 (UTF-8)

V

value added reseller (VAR)

A company that resells hardware and software packages to developers and/or end users.

VAR

See definition for: value added reseller (VAR)

VGA

Video graphics array. A video adapter that supports 640 x 480 pixels color resolution. VGA is the video display standard for boot devices under Windows operating systems and provides medium-resolution text and graphics.

volume mount point

A point of access to a volume that users and applications can use to unify disparate file systems into one logical system.

volume set

A volume that consists of disk space on one or more physical disks. A volume set is created by using basic disks and is only supported in Windows NT 4.0 or earlier. Volume sets were replaced by spanned volumes, which use dynamic disks.

See also: basic disk; dynamic disk; partition; spanned volume

W

WDL

See definition for: Windows Driver Library (WDL)

Web server

A computer that is maintained by a system administrator or Internet service provider (ISP) and that responds to requests from a user's browser.

See also: Internet service provider (ISP)

WHQL

See definition for: Windows Hardware Quality Labs (WHQL)

wide area network (WAN)

A communications network connecting geographically separated computers, printers, and other devices. A WAN allows any connected device to interact with any other on the network.

See also: device; local area network (LAN)

Windows Driver Library (WDL)

A distribution point on www.microsoft.com for third-party drivers that meet the Windows Logo requirements.

Windows File Protection (WFP)

A feature that runs in the background and protects your system files from being overwritten. When a file in a protected folder is modified, WFP determines whether the new file is the correct Microsoft version or whether the file is digitally signed. If not, the modified file is replaced with a valid version.

Windows Hardware Quality Labs (WHQL)

Provides compatibility testing services to test hardware and drivers for Windows operating systems.

Windows Installer

An operating system service that allows the operating system to manage the installation process. Windows Installer technologies are divided into two parts that work in combination: a clientside installer service (Msiexec.exe) and a package (.msi) file. Windows Installer uses the information contained within a package file to install the application.

Windows Internet Name Service (WINS)

A software service that dynamically maps IP addresses to computer names (NetBIOS names). This allows users to access resources by name instead of requiring them to use IP addresses that are difficult to recognize and remember.

See also: IP address; network basic input/output system (NetBIOS); resource; service

Windows Logo Program

A certification program to help customers identify systems, hardware, and software that meet a baseline definition of platform features and quality goals and ensure a good user experience of Windows.

Windows Management Instrumentation (WMI)

A management infrastructure in Windows that supports monitoring and controlling system resources through a common set of interfaces and provides a logically organized, consistent model of Windows operation, configuration, and status.

See also: resource

Windows Preinstallation Environment (WinPE)

A minimal Win32 operating system with limited services, built on the Windows XP Professional kernel. WinPE is used only in the preinstallation and deployment of Windows.

Windows Product Activation (WPA)

A technology that reduces software piracy by requiring that each installation of a Windows product be activated with Microsoft, either through the Internet or by telephone. A unique product key is required for each installation of Windows, but Microsoft does not request or collect any information other than the Product Key during the installation. The end user may reinstall Windows using the same Product Key on the same computer as many times as necessary, but it cannot be used to install Windows on another computer. The end user can make incremental hardware upgrades to the computer. However, if the hardware is significantly altered, the end user will be required to reactivate the installation of Windows.

Windows Setup

The program that installs the Windows operating system.

Windows Welcome

The end user's first experience of Microsoft Windows in Windows XP Home Edition and Windows XP Professional. Through a series of full-screen, HTML-based pages, Windows Welcome quickly and easily takes end users through the final steps of setting up their personal computer. End users are then prompted for any additional information that is needed to personalize their settings, which can include regional settings, network configuration (where applicable), and Internet connection settings. Windows Welcome is formerly known as Out-Of-Box Experience (OOBE).

Winnt.exe

A command line utility used to start an unattended Windows XP Setup from computers running MS-DOS, Windows 3.1, or Windows for Workgroups.

Winnt.sif

The answer file that contains information used by Setup when you install Windows using the CD boot method.

See also: answer file; CD boot

Winnt32.exe

A command-line utility used to start an unattended Windows XP Setup from computers running Windows 95, Windows 98, Windows NT, Windows 2000, or Windows XP.

WinPE

See definition for: Windows Preinstallation Environment (WinPE)

WINS

See definition for: Windows Internet Name Service (WINS)

Winsock

Windows Sockets. An application programming interface (API) standard for software that provides a TCP/IP interface under Windows.

See also: application programming interface (API); Transmission Control Protocol/Internet Protocol (TCP/IP)

WMI

See definition for: Windows Management Instrumentation (WMI)

workgroup

A simple grouping of computers, intended only to help users find such things as printers and shared folders within that group. Workgroups in Windows do not offer the centralized user accounts and authentication offered by domains.

See also: authentication; domain; user account

World Wide Web

A system for exploring the Internet by using hyperlinks. When you use a Web browser, the Web appears as a collection of text, pictures, sounds, and digital movies.

See also: internet

X

x86

Refers to microprocessors that have or emulate the 32-bit Intel processor architecture.

Y

There are no glossary terms that begin with this letter.

Z

There are no glossary terms that begin with this letter.


Legal Notices

Information in this document, including URL and other Internet Web site references, is subject to change without notice. Unless otherwise noted, the example companies, organizations, products, domain names, e-mail addresses, logos, people, places and events depicted herein are fictitious, and no association with any real company, organization, product, domain name, e-mail address, logo, person, place or event is intended or should be inferred. Complying with all applicable copyright laws is the responsibility of the user. Without limiting the rights under copyright, no part of this document may be reproduced, stored in or introduced into a retrieval system, or transmitted in any form or by any means (electronic, mechanical, photocopying, recording, or otherwise), or for any purpose, without the express written permission of Microsoft Corporation.

Microsoft may have patents, patent applications, trademarks, copyrights, or other intellectual property rights covering subject matter in this document. Except as expressly provided in any written license agreement from Microsoft, the furnishing of this document does not give you any license to these patents, trademarks, copyrights, or other intellectual property.

© 2001 Microsoft Corporation. All rights reserved.

Active Desktop, ActiveX, Authenticode, BackOffice, ClearType, DirectX, FrontPage, Hotmail, JScript, Microsoft, Microsoft Press, MS-DOS, MSDN, MSN, Visual Basic, Win32, Win64, Windows, Windows logo, Windows Media, Windows NT, and Windows Start logo are either registered trademarks or trademarks of Microsoft Corporation in the U.S.A. and/or other countries/regions.

TrueType is a registered trademark of Apple, Inc.

The names of actual companies and products mentioned herein may be the trademarks of their respective owners.